//jemoon : 060310
//for GlassData Delete and Recovery

#if !defined(AFX_DAOLOST_GLASS_LIST_SET_H__B8422E45_4917_4CFF_AEB5_51130FD4C1C0__INCLUDED_)
#define AFX_DAOLOST_GLASS_LIST_SET_H__B8422E45_4917_4CFF_AEB5_51130FD4C1C0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DaoLostGlassListSet.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDaoLostGlassListSet DAO recordset

class CDaoLostGlassListSet : public CDaoRecordset
{
public:
	CDaoLostGlassListSet(CDaoDatabase* pDatabase = NULL);
	DECLARE_DYNAMIC(CDaoLostGlassListSet)

// Field/Param Data
	//{{AFX_FIELD(CDaoLostGlassListSet, CDaoRecordset)
	long	m_NO;
	long	m_GLASS_DATA1;
	long	m_GLASS_DATA2;
	long	m_GLASS_DATA3;
	long	m_GLASS_DATA4;
	long	m_GLASS_DATA5;
	long	m_GLASS_DATA6;
	long	m_GLASS_DATA7;
	long	m_GLASS_DATA8;
	long	m_GLASS_DATA9;
	long	m_GLASS_DATA10;
	//}}AFX_FIELD

	BOOL AddGlassData(CGlassInfo& glsInfo);
	BOOL DelGlassData(int no);
	int GetLostGlassListRowCount();
	void GetLostGlassInfo(int nNo, CGlassInfo& glsInfo);
	BOOL FindLostGlassList(int no);
	
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDaoLostGlassListSet)
	public:
	virtual CString GetDefaultDBName();		// Default database name
	virtual CString GetDefaultSQL();		// Default SQL for Recordset
	virtual void DoFieldExchange(CDaoFieldExchange* pFX);  // RFX support
	//}}AFX_VIRTUAL

// Implementation
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DAOLOST_GLASS_LIST_SET_H__B8422E45_4917_4CFF_AEB5_51130FD4C1C0__INCLUDED_)
