#if !defined(AFX_DAORECIPESET_H__E123DA85_4B36_44E6_8C32_82BB9EC17E31__INCLUDED_)
#define AFX_DAORECIPESET_H__E123DA85_4B36_44E6_8C32_82BB9EC17E31__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// daorecipeset.h : header file
//

//--------------------------------------------------------------
//--- 24 Slot̶ ̰ ״ 25  ξ Ѵ.
#define MAX_FIXED_SLOT_NO	25
//--------------------------------------------------------------

/////////////////////////////////////////////////////////////////////////////
// CDaoRecipeSet DAO recordset

 class CDaoRecipeSet : public CDaoRecordset
{
public:
	CDaoRecipeSet(CDaoDatabase* pDatabase = NULL);
	DECLARE_DYNAMIC(CDaoRecipeSet)

	RECIPE_INFO GetRecipeInfo(int nRow);
	int SetRecipeInfo(CString sID, RECIPE_INFO& RecipeInfo);
	BOOL FindRecipe(CString sID);
	int GetRecipeRowCount();
	void AddRecipeId(CString sID);
	void DeleteRecipeId(CString sID);

public:
	enum rcpITEM_INDEX
	{
		rcpID,
		rcpTIME,
		rcpCOMMENT,
		rcpTACT_TIME,
		rcpCV_SPEED,
		rcpJOB_PROCESS,

		rcpSWR2_UP_RB1_USE,
		rcpSWR2_LO_RB1_USE,
		rcpSWR2_UP_RB2_USE,
		rcpSWR2_LO_RB2_USE,
		rcpSWR3_UP_RB1_USE,
		rcpSWR3_LO_RB1_USE,
		rcpSWR3_UP_RB2_USE,
		rcpSWR3_LO_RB2_USE,

		rcpSWR2_UP_RB1_DIR,
		rcpSWR2_LO_RB1_DIR,
		rcpSWR2_UP_RB2_DIR,
		rcpSWR2_LO_RB2_DIR,
		rcpSWR3_UP_RB1_DIR,
		rcpSWR3_LO_RB1_DIR,
		rcpSWR3_UP_RB2_DIR,
		rcpSWR3_LO_RB2_DIR,

		rcpSWR2_UP_RB1_SPEED,
		rcpSWR2_LO_RB1_SPEED,
		rcpSWR2_UP_RB2_SPEED,
		rcpSWR2_LO_RB2_SPEED,
		rcpSWR3_UP_RB1_SPEED,
		rcpSWR3_LO_RB1_SPEED,
		rcpSWR3_UP_RB2_SPEED,
		rcpSWR3_LO_RB2_SPEED,

		rcpSWR2_UP_RB1_GAP,	
		rcpSWR2_LO_RB1_GAP,
		rcpSWR2_UP_RB2_GAP,	
		rcpSWR2_LO_RB2_GAP,		
		rcpSWR3_UP_RB1_GAP,	
		rcpSWR3_LO_RB1_GAP,
		rcpSWR3_UP_RB2_GAP,	
		rcpSWR3_LO_RB2_GAP,
	};

// Field/Param Data
	//{{AFX_FIELD(CDaoRecipeSet, CDaoRecordset)
	CString	m_ID;
	COleDateTime	m_CHANGE_TIME;
	CString	m_COMMENT;
	long	m_TACT_TIME;
	long	m_CONV_SPEED;
	BOOL	m_JOB_PROCESS_ON_OFF;
	BOOL	m_SWR2_UPPER_RB1_ON_OFF;
	BOOL	m_SWR2_LOWER_RB1_ON_OFF;
	BOOL	m_SWR2_UPPER_RB2_ON_OFF;
	BOOL	m_SWR2_LOWER_RB2_ON_OFF;
	BOOL	m_SWR3_UPPER_RB1_ON_OFF;
	BOOL	m_SWR3_LOWER_RB1_ON_OFF;
	BOOL	m_SWR3_UPPER_RB2_ON_OFF;
	BOOL	m_SWR3_LOWER_RB2_ON_OFF;
	BOOL	m_SWR2_UPPER_RB1_DIRECTION;
	BOOL	m_SWR2_LOWER_RB1_DIRECTION;
	BOOL	m_SWR2_UPPER_RB2_DIRECTION;
	BOOL	m_SWR2_LOWER_RB2_DIRECTION;
	BOOL	m_SWR3_UPPER_RB1_DIRECTION;
	BOOL	m_SWR3_LOWER_RB1_DIRECTION;
	BOOL	m_SWR3_UPPER_RB2_DIRECTION;
	BOOL	m_SWR3_LOWER_RB2_DIRECTION;
	long	m_SWR2_UPPER_RB1_SPEED;
	long	m_SWR2_LOWER_RB1_SPEED;
	long	m_SWR2_UPPER_RB2_SPEED;
	long	m_SWR2_LOWER_RB2_SPEED;
	long	m_SWR3_UPPER_RB1_SPEED;
	long	m_SWR3_LOWER_RB1_SPEED;
	long	m_SWR3_UPPER_RB2_SPEED;
	long	m_SWR3_LOWER_RB2_SPEED;
	float	m_SWR2_UPPER_RB1_GAP;
	float	m_SWR2_LOWER_RB1_GAP;
	float	m_SWR2_UPPER_RB2_GAP;
	float	m_SWR2_LOWER_RB2_GAP;
	float	m_SWR3_UPPER_RB1_GAP;
	float	m_SWR3_LOWER_RB1_GAP;
	float	m_SWR3_UPPER_RB2_GAP;
	float	m_SWR3_LOWER_RB2_GAP;
	//}}AFX_FIELD

// Overrides
	// ClassWizard generated virtual function overridesz
	//{{AFX_VIRTUAL(CDaoRecipeSet)
	public:
	virtual CString GetDefaultDBName();		// Default database name
	virtual CString GetDefaultSQL();		// Default SQL for Recordset
	virtual void DoFieldExchange(CDaoFieldExchange* pFX);  // RFX support
	//}}AFX_VIRTUAL

// Implementation
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DAORECIPESET_H__E123DA85_4B36_44E6_8C32_82BB9EC17E31__INCLUDED_)
