// Dics.h : main header file for the DICS application
//

#if !defined(AFX_DICS_H__96961169_73EF_441A_8147_A4A0E63CD255__INCLUDED_)
#define AFX_DICS_H__96961169_73EF_441A_8147_A4A0E63CD255__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

#include ".\TwinCAT\TcSystemServer_i.h"

#include "ddeml.h"

#include "DicsDoc.h"
#include "DicsView.h"
/////////////////////////////////////////////////////////////////////////////
// CDicsApp:
// See Dics.cpp for the implementation of this class
//

HDDEDATA CALLBACK DdeCallback(WORD, WORD, HCONV, HSZ, HSZ, HDDEDATA, DWORD, DWORD);

class CDicsApp : public CWinApp
{
public:
	CDicsApp();
	CDicsView* m_pMainView;
	CMultiDocTemplate* m_pSystemTemplate;
	CMultiDocTemplate* m_pServoTemplate;
	CMultiDocTemplate* m_pRecipesTemplate;
	CMultiDocTemplate* m_pSetupTemplate;
	CMultiDocTemplate* m_pAlarmsTemplate;
	CMultiDocTemplate* m_pDatalogTemplate;
	CMultiDocTemplate* m_pHelpTemplate;

private:
	BOOL m_bIsRun;
	DWORD m_dwIdInst;
	HSZ m_hszCppServer, m_hszCppTopic;
	HCONV m_hconvCppServer;
	DWORD m_dwDdeResult;
public:
	HDDEDATA AppDdeCallback(WORD, WORD, HCONV, HSZ, HSZ, HDDEDATA, DWORD, DWORD);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDicsApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation
	//{{AFX_MSG(CDicsApp)
	afx_msg void OnAppAbout();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DICS_H__96961169_73EF_441A_8147_A4A0E63CD255__INCLUDED_)
