// DlgAddUser.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "DlgAddUser.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgAddUser dialog


CDlgAddUser::CDlgAddUser(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgAddUser::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgAddUser)
	m_sUserID = _T("");
	m_sPass1 = _T("");
	m_sPass2 = _T("");
	//}}AFX_DATA_INIT
}


void CDlgAddUser::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgAddUser)
	DDX_Control(pDX, IDC_COMBO_GROUP, m_cbGroup);
	DDX_Text(pDX, IDC_EDIT_ID, m_sUserID);
	DDX_Text(pDX, IDC_EDIT_PASS1, m_sPass1);
	DDX_Text(pDX, IDC_EDIT_PASS2, m_sPass2);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgAddUser, CDialog)
	//{{AFX_MSG_MAP(CDlgAddUser)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgAddUser message handlers

BOOL CDlgAddUser::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	VERIFY( m_Ok.AutoLoad( IDOK, this ) );
	VERIFY( m_Cancel.AutoLoad( IDCANCEL, this ) );

	m_cbGroup.SetCurSel( CDicsData::idOP );
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgAddUser::OnOK() 
{
	// TODO: Add extra validation here
	int nUserLevel = m_cbGroup.GetCurSel();

	UpdateData( TRUE );

	if( m_sPass1 != m_sPass2 ) 
	{
		AfxMessageBox( "Password is not matched each other" );
		return;
	}
	
	if( !m_pDicsData->AddUser( nUserLevel, m_sUserID, m_sPass1 ) )
	{
		AfxMessageBox( "Failed To Create New User" );
		return;
	}
	
	CDialog::OnOK();
}
