#if !defined(AFX_DLGALIGN_H__61C1E659_E586_480B_8625_99B1AF2893EF__INCLUDED_)
#define AFX_DLGALIGN_H__61C1E659_E586_480B_8625_99B1AF2893EF__INCLUDED_

#include "..\X\XCtlDevice.h"	// Added by ClassView
#include "..\X\MacButtons.h"	// Added by ClassView
#include "..\X\ColorStatic.h"
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgAlign.h : header file
//
#include "..\FactoryLib\EqpAssy.h"

/////////////////////////////////////////////////////////////////////////////
// CDlgAlign dialog

class CDlgAlign : public CDialog
{
// Construction
public:
	CDlgAlign(CWnd* pParent = NULL);   // standard constructor

	CBitmapButton	m_Ok;
	CMacRadioButton m_macAlignFw;
	CMacRadioButton m_macAlignBw;
	XCtlDevice*		m_pDevice;

	CColorStatic	m_stcAlign[6];

	void SetDevice( XCtlDevice* pDevice ){ m_pDevice = pDevice;	}
	CEqpAssy*	m_pEqpAssy;
	void SetEqpAssy( CEqpAssy* pEqpAssy ){ m_pEqpAssy = pEqpAssy; }
	CFaCylinder* m_Cylinder;
	void SetCylinderAssy( CFaCylinder* Cylinder ){ m_Cylinder = Cylinder; }
// Dialog Data
	//{{AFX_DATA(CDlgAlign)
	enum { IDD = IDD_DIALOG_ALIGN6 };

		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgAlign)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgAlign)
	virtual BOOL OnInitDialog();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	afx_msg void OnRadioFw();
	afx_msg void OnRadioBw();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGALIGN_H__61C1E659_E586_480B_8625_99B1AF2893EF__INCLUDED_)
