// DlgFishRib.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "DlgFishRib.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgFishRib dialog


CDlgFishRib::CDlgFishRib(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgFishRib::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgFishRib)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDlgFishRib::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgFishRib)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_RADIO_UP, m_macFishRibUp );
	DDX_Control(pDX, IDC_RADIO_DN, m_macFishRibDn );
	DDX_Control(pDX, IDC_LD_FISH_RIB_L, m_ocxFishRib[0] );
	DDX_Control(pDX, IDC_LD_FISH_RIB_R, m_ocxFishRib[1] );
}


BEGIN_MESSAGE_MAP(CDlgFishRib, CDialog)
	//{{AFX_MSG_MAP(CDlgFishRib)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_RADIO_UP, OnRadioUp)
	ON_BN_CLICKED(IDC_RADIO_DN, OnRadioDn)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgFishRib message handlers

BOOL CDlgFishRib::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	int m_nOldFishRibState[2] = { 0, };
	// Set button
	VERIFY( m_Ok.AutoLoad( IDOK, this ) );

	MAC_COLOR_SET color_set;
	m_macFishRibUp.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macFishRibUp.SetColorSetting( color_set );
	m_macFishRibUp.SetBold();

	m_macFishRibDn.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_ORANGE_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macFishRibDn.SetColorSetting( color_set );
	m_macFishRibDn.SetBold();
	
	// TODO: Add extra initialization here
	SetTimer( TIMER_MANUAL, 100, NULL );
		
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgFishRib::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	IsFishRibStatus();

	CDialog::OnTimer(nIDEvent);
}

void CDlgFishRib::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	
}

void CDlgFishRib::OnRadioUp() 
{
/*	// TODO: Add your control notification handler code here
	if( m_nDlgUnitNo == IF_UNIT_LD_FISH )
	{
#ifndef _MY_DEBUG
		if( diLD_FISH_UNIT_GLS_EXIST )
		{
			AfxMessageBox( "INTERLOCK : Ld Fish Unit Glass Exist!! Cannot Move" ); return;
		}
#endif	
		doLD_FISH_UNIT_RIB_UP( ON );
		doLD_FISH_UNIT_RIB_DN( OFF );
	}*/
}

void CDlgFishRib::OnRadioDn() 
{
	// TODO: Add your control notification handler code here
/*	if( m_nDlgUnitNo == IF_UNIT_LD_FISH )
	{
#ifndef _MY_DEBUG
		if( diLD_FISH_UNIT_GLS_EXIST )
		{
			AfxMessageBox( "INTERLOCK : Ld Fish Unit Glass Exist!! Cannot Move" ); return;
		}
		if( ( digPOSITION_SENSOR( 0 ) || digPOSITION_SENSOR( 1 ) ) && 
			( !diTR_UNIT_RECV_POS_SENSOR && !diTR_UNIT_WAIT_POS_SENSOR && !diTR_UNIT_X_HOME_POS ) )
		{
			AfxMessageBox( "INTERLOCK : Ld Fish Unit can't Move" ); return;
		}
#endif
		doLD_FISH_UNIT_RIB_DN( ON );		
		doLD_FISH_UNIT_RIB_UP( OFF );
	}*/
}

void CDlgFishRib::IsFishRibStatus()
{
/*	// TODO: Add your control notification handler code here
	if( m_nDlgUnitNo == IF_UNIT_LD_FISH )
	{
		for( int i = 0; i < 2; i++ )
		{
#ifndef _MY_DEBUG
			if( ( m_nOldFishRibState[i] != 1 ) && digFISH_RIB_SENSOR_UP( i ) && !digFISH_RIB_SENSOR_DN( i ) )
#else
			if( ( m_nOldFishRibState[i] != 1 ) && dosLD_FISH_UNIT_RIB_UP )
#endif
			{
				m_nOldFishRibState[i] = 1;
				m_ocxFishRib[i].SetUp();
			}
#ifndef _MY_DEBUG
			else if( ( m_nOldFishRibState[i] != 2 ) && !digFISH_RIB_SENSOR_UP( i ) && digFISH_RIB_SENSOR_DN( i ) )
#else
			else if( ( m_nOldFishRibState[i] != 2 ) && dosLD_FISH_UNIT_RIB_DN )
#endif
			{
				m_nOldFishRibState[i] = 2;
				m_ocxFishRib[i].SetDown();
			}
#ifndef _MY_DEBUG
			else if( m_nOldFishRibState[i] != 3 && 
					( !digFISH_RIB_SENSOR_UP( i ) && !digFISH_RIB_SENSOR_DN( i ) ) )
#else
			else if( m_nOldFishRibState[i] != 3 && 
					( !dosLD_FISH_UNIT_RIB_UP && !dosLD_FISH_UNIT_RIB_DN ) )
#endif
			{
				m_nOldFishRibState[i] = 3;
				m_ocxFishRib[i].SetNone();
			}
		}
	}*/
}
