#if !defined(AFX_DLGGRIDROLLBRUSH_H__CB803045_A782_4C2F_9F9F_ECEF0320E4F2__INCLUDED_)
#define AFX_DLGGRIDROLLBRUSH_H__CB803045_A782_4C2F_9F9F_ECEF0320E4F2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgGridRollBrush.h : header file
//
#include "..\X\XCtlDevice.h"
#include "..\X\MacButtons.h"
#include "..\msflexgrid.h"
#include "..\FactoryLib\IniData.h"	// Added by ClassView
#include "..\FactoryLib\EqpAssy.h"
/////////////////////////////////////////////////////////////////////////////
// CDlgGridRollBrush dialog

class CDlgGridRollBrush : public CDialog
{
// Construction
public:
	CDlgGridRollBrush(CWnd* pParent = NULL);   // standard constructor

	void SetDevice(XCtlDevice* pDevice) { m_pDevice = pDevice; }
	void SetMainSeq(CMainSeq* pMainSeq) { m_pMainSeq = pMainSeq; }
	void SetRbSeq(CRbSeq* pRbSeq) { m_pRbSeq = pRbSeq; }
	void SetEqpAssy( CEqpAssy* pEqpAssy) { m_pEqpAssy = pEqpAssy; }

	XCtlDevice* m_pDevice;
	CMainSeq* m_pMainSeq;
	CRbSeq* m_pRbSeq;
	CEqpAssy*		m_pEqpAssy;

public:
	void SetButtonState();
	void SetSpeedRange(int nBottom, int nTop, int nInterval);

	CBitmapButton	m_Ok;
	int				m_nAction;
	int				m_nRbType;
	int				m_nDirection[MAX_RB_NO];
					// -1 : BW, 0 : Stop, 1 : FW
					// for RB Dialog Button Setting...

	int	m_nOldRbDirStatus[MAX_RB_NO];
	int	m_nOldRbAlarmStatus[MAX_RB_NO];
	int	m_nOldRbCpStatus[MAX_RB_NO];
	int m_nOldRbCvSpeed[MAX_RB_NO];
	int m_nMotorEA;
	int m_nBottomSpeed;
	int m_nTopSpeed;
	int m_nIntervalSpeed;
	BOOL	m_bMotorReset[MAX_RB_NO];
	CString m_sMotorName;

	CMSFlexGrid		m_gridRbMotor;
	enum columnTYPE{ colNAME, colSTOP, colCW, colCCW, colSPEED, colALARM, colCPDOWN, colMAX };
//	enum columnTYPE{ colNAME, colSTOP, colCW, colCCW, colSPEED, colALARM, colCPDOWN, colRESET, colMAX };
	enum RB_DIRECTION{ rbSTOP, rbCW, rbCCW };
	
// Dialog Data
	//{{AFX_DATA(CDlgGridRollBrush)
	enum { IDD = IDD_DLG_GRID_ROLL_BRUSH };
		// NOTE: the ClassWizard will add data members here
	CComboBox	m_comboRbRpm;
	CMacRadioButton	m_macRbAllCw;
	CMacRadioButton	m_macRbAllCcw;
	CMacRadioButton	m_macRbAllStop;
	//}}AFX_DATA

	void	GridInit_RBMotor();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgGridRollBrush)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgGridRollBrush)
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnClickGridRbMotor();
	afx_msg void OnSelchangeComboRbRpm();
	afx_msg void OnAllStop();
	afx_msg void OnAllCw();
	afx_msg void OnAllCcw();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGGRIDROLLBRUSH_H__CB803045_A782_4C2F_9F9F_ECEF0320E4F2__INCLUDED_)
