#if !defined(AFX_INIT_STATUS_H__599817BA_45EC_4AA8_96D0_26848EBC089A__INCLUDED_)
#define AFX_INIT_STATUS_H__599817BA_45EC_4AA8_96D0_26848EBC089A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgInitStatus.h : header file
//
#include "DicsData.h"
#include "msflexgrid.h"
#include "X\MsgBox.h"
#include "X\MacButtons.h"

/////////////////////////////////////////////////////////////////////////////
// CDlgInitStatus dialog
class CDlgInitStatus : public CDialog
{
// Construction
public:
	CDlgInitStatus(CWnd* pParent = NULL);   // standard constructor
	CDlgInitStatus(CGlassInfo mask, CWnd* pParent = NULL );
	
	CMSFlexGrid		m_gridInitStatusMain;
	CMSFlexGrid		m_gridInitStatusPump;
	CMacButton		m_macSetPos;
	int				m_nMaxRowsMain;
	int				m_nMaxRowsPump;
	int				m_nMaxCols;

	BOOL			m_bExtendWndPos;	
	static CString	sItemsMain;
	static CString  sItemsPump;

// Dialog Data
	//{{AFX_DATA(CDlgInitStatus)
	enum { IDD = IDD_DLG_INIT_STATUS };
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgInitStatus)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
public:
	void GridInit_StatusMain();
	void GridInit_StatusPump();
	void SetStatusMain( CString sData );
	void SetStatusPump( CString sData );
	void ResetStatusMain();
	void ResetStatusPump();
// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CDlgInitStatus)
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	afx_msg void PostNcDestroy();
	afx_msg void OnBtnHide();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_INIT_STATUS_H__599817BA_45EC_4AA8_96D0_26848EBC089A__INCLUDED_)
