// DlgKeyPad.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "DlgKeyPad.h"
#include <MATH.H>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgKeyPad dialog

CDlgKeyPad::CDlgKeyPad(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgKeyPad::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgKeyPad)
	//}}AFX_DATA_INIT
	m_sEdit[0] = _T("");
	m_sEdit[1] = _T("");
	m_sEdit[2] = _T("");
	m_sEdit[3] = _T("");
	m_sEdit[4] = _T("");
	m_sEdit[5] = _T("");
	m_nCurEditBox = 0 ;
}

void CDlgKeyPad::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgKeyPad)
	//}}AFX_DATA_MAP
	DDX_Text(pDX, IDC_EDIT1, m_sEdit[0]);
	DDX_Text(pDX, IDC_EDIT2, m_sEdit[1]);
	DDX_Text(pDX, IDC_EDIT3, m_sEdit[2]);
	DDX_Text(pDX, IDC_EDIT4, m_sEdit[3]);
	DDX_Text(pDX, IDC_EDIT5, m_sEdit[4]);
	DDX_Text(pDX, IDC_EDIT6, m_sEdit[5]);
}

BEGIN_MESSAGE_MAP(CDlgKeyPad, CDialog)
	//{{AFX_MSG_MAP(CDlgKeyPad)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgKeyPad message handlers

int CDlgKeyPad::HexaStringToNumber(CString sValue)
{
//	sValue.MakeReverse();
	int nRv = 0, nV;
	CString sTemp;

	for( int i=0; i<sValue.GetLength(); i++ )
	{
		nV = sValue.GetAt( i );
		if( nV >= 'A' && nV <= 'F' )
		{
			nRv += (int) pow( (float)0x10, ( sValue.GetLength() - ( i + 1 ) ) ) * ( nV - 'A' + 0xA );
		}
		else if( nV >= 'a' && nV <= 'f' )
		{
			nRv += (int) pow( (float)0x10, ( sValue.GetLength() - ( i + 1 ) ) ) * ( nV - 'a' + 0xA );
		}
		else if( nV >= '0' && nV <= '9' )
		{
			nRv += (int) pow( (float)0x10, ( sValue.GetLength() - ( i + 1 ) ) ) * ( nV - '0' );
		}
	}
	return nRv;
}

BOOL CDlgKeyPad::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	for( int i=0; i<6; i++ )
	{
		// hskwak 191016
		//m_sEdit[i].Format( "%04X", m_nGlassData[i] );
		if( i!=4 )	m_sEdit[i].Format( "%d", m_nGlassData[i] );
	}

	UpdateData( FALSE );
	
	GetDlgItem( IDC_EDIT1 )->SetFocus();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgKeyPad::OnOK() 
{
	UpdateData( TRUE );

	for( int i=0; i<6; i++ )
	{
/*
		short nRv = HexaStringToNumber( m_sEdit[i] );
		if( nRv > (0xFFFF) ) 
		{
			CString sTemp;
			sTemp.Format( "Data Format Error:" );
			sTemp += m_sEdit[i];
			AfxMessageBox( sTemp );
			return;
		}
		m_nGlassData[i] = nRv;
		nRv = 0;
*/
		// hskwak 191016 Glass iD String  .
		//m_nGlassData[i] = atoi(m_sEdit[i]);	// hskwak 20191010 10 Data .
		if (i!=4)	m_nGlassData[i] = atoi(m_sEdit[i]);
		m_sGlassData[i] = m_sEdit[i];
	}
	
	CDialog::OnOK();
}
