#if !defined(AFX_DLGLISTCVMOTOR_H__A87BED84_91C7_469A_B370_95BBBB293C28__INCLUDED_)
#define AFX_DLGLISTCVMOTOR_H__A87BED84_91C7_469A_B370_95BBBB293C28__INCLUDED_

#include "..\View\SetupItems.h"	// Added by ClassView
#include "..\X\MacButtons.h"	// Added by ClassView
#include "..\X\XCtlDevice.h"	// Added by ClassView
#include "..\X\PointListCtrl.h"
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgListCvMotor.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDlgListCvMotor dialog

class CDlgListCvMotor : public CDialog
{
// Construction
public:
	void SetSpeedRange(int nBottom, int nTop, int nInterval);

	CSetupItems*	m_pSetupItems;
	XCtlDevice*		m_pDevice;
	CCvSeq*			m_pCvSeq;

	int m_nMotorEA;
	int m_nBottomSpeed;
	int m_nTopSpeed;
	int m_nIntervalSpeed;

	CString m_sMotorName;
	CDlgListCvMotor(CWnd* pParent = NULL);   // standard constructor

	enum columnTYPE{ colNAME, colDIR, colSPEED, colALARM, colCPON, colMAX };

	void SetDevice(XCtlDevice* pDevice){ m_pDevice = pDevice; }
	void SetSetupItem(CSetupItems* pSetupItems){m_pSetupItems = pSetupItems;}
	void SetCvSeq(CCvSeq* pCvSeq){m_pCvSeq = pCvSeq;}

// Dialog Data
	//{{AFX_DATA(CDlgListCvMotor)
	enum { IDD = IDD_DLG_LV_CV_MOTOR };
	CComboBox	m_cbSpeed;
	CPointListCtrl	m_lcMotor;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgListCvMotor)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgListCvMotor)
	afx_msg void OnButtonFw();
	afx_msg void OnButtonBw();
	afx_msg void OnButtonStop();
	afx_msg void OnButtonAllStop();
	virtual BOOL OnInitDialog();
	afx_msg void OnClickListCv(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	afx_msg void OnCheckAll();
	afx_msg void OnSelchangeComboSpeed();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	int	m_nOldDirStatus[MAX_CV_MOTOR_NO];
	int	m_nOldAlarmStatus[MAX_CV_MOTOR_NO];
	int	m_nOldCpStatus[MAX_CV_MOTOR_NO];
	int m_nOldCvSpeed[MAX_CV_MOTOR_NO];

	CMacButton	m_macFw;
	CMacButton	m_macBw;
	CMacButton	m_macStop;
	CMacButton	m_macAllStop;
	CMacCheckBox	m_macCheckAll;
	CBitmapButton	m_Ok;
	void ListInit();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGLISTCVMOTOR_H__A87BED84_91C7_469A_B370_95BBBB293C28__INCLUDED_)
