// DlgSelSensor.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "DlgSelSensor.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgSelSensor dialog


CDlgSelSensor::CDlgSelSensor(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgSelSensor::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgSelSensor)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDlgSelSensor::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgSelSensor)
	DDX_Control(pDX, IDC_LIST_SENSOR, m_lbSensorType);
	//}}AFX_DATA_MAP
	DDX_Control( pDX, IDOK, m_macOk );
}


BEGIN_MESSAGE_MAP(CDlgSelSensor, CDialog)
	//{{AFX_MSG_MAP(CDlgSelSensor)
	ON_LBN_SELCHANGE(IDC_LIST_SENSOR, OnSelchangeListSensor)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgSelSensor message handlers

void CDlgSelSensor::OnSelchangeListSensor() 
{
	// TODO: Add your control notification handler code here
	m_nNo = m_lbSensorType.GetCurSel();
}

BOOL CDlgSelSensor::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_nNo = 0;

	MAC_COLOR_SET color;
	m_macOk.GetColorSetting( &color );
	color.crFace = LIGHT_GREEN_COLOR;
	color.crLiteShadow = MAGENTA_COLOR;
	m_macOk.SetColorSetting( color );
	m_macOk.SetBold();
	
	// TODO: Add extra initialization here
	for( int i = 0 ; i < XCtlDevice::enMAX_SENSOR_TYPE ; i ++ )
	{
		m_lbSensorType.AddString( (LPCTSTR)m_pDevice->m_aiPreSet[i].sName );
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

