// DlgSelectID.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "DlgSelectID.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgSelectID dialog


CDlgSelectID::CDlgSelectID(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgSelectID::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgSelectID)
	m_sCurVal = _T("");
	m_sOldVal = _T("");
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_sTitle = "SELECT ID";
	m_nType = typeSELECT;
}


void CDlgSelectID::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgSelectID)
	DDX_Control(pDX, IDC_CUR_VAL, m_cboCurVal);
	DDX_Text(pDX, IDC_CUR_VAL, m_sCurVal);
	DDX_Text(pDX, IDC_OLD_VAL, m_sOldVal);
	//}}AFX_DATA_MAP
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgSelectID, CDialog)
	//{{AFX_MSG_MAP(CDlgSelectID)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgSelectID message handlers
BOOL CDlgSelectID::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetWindowText( m_sTitle );
	
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();

	VERIFY( m_Ok.AutoLoad( IDOK, this ) );
	VERIFY( m_Cancel.AutoLoad( IDCANCEL, this ) );
	
	GetDlgItem( IDC_STATIC_OLD_VAL )->ShowWindow( SW_SHOW );
	GetDlgItem( IDC_OLD_VAL )->ShowWindow( SW_SHOW );

	// Make Recipe IDs list
	CDicsDoc* pDoc = m_pView->GetDocument();
	for( int nRow=0; nRow<pDoc->m_nMaxRow; nRow++ )
	{
		m_cboCurVal.AddString( pDoc->m_pRecipeInfo[nRow].sValue[0] );
	}
	
	if( m_nType == typeCOPY )
	{
		m_sTitle = "COPY RECIPE DATA";
		SetWindowText( m_sTitle );
		GetDlgItem( IDC_STATIC_OLD_VAL )->SetWindowText( "FROM : " );
		GetDlgItem( IDC_STATIC_CUR_VAL )->SetWindowText( "TO : " );
	}
	
	// Set the initial window position
	CRect r;
	GetWindowRect( &r );
	MoveWindow( 300, 400, r.right - r.left, r.bottom - r.top );

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgSelectID::OnOK() 
{
	UpdateData( TRUE );
	
	CDialog::OnOK();
}
