#if !defined(AFX_DLGSEMIAUTOTRTOSS_H__6779DFAB_8A77_44AD_B4C1_0DE983A4F115__INCLUDED_)
#define AFX_DLGSEMIAUTOTRTOSS_H__6779DFAB_8A77_44AD_B4C1_0DE983A4F115__INCLUDED_

#include "..\X\XCtlDevice.h"	// Added by ClassView
#include "..\X\XCtlMelsec.h"	// ljy_050131 : Use Melsec
#include "..\X\colorstatic.h"	// Added by ClassView
#include "..\DicsData.h"	// Added by ClassView

#include "..\X\MacButtons.h"	// ljy_050118 : Use Mac BTN
#include "..\X\Led.h"	// Added by ClassView

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgSemiAutoTrToSs.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDlgSemiAutoTrToSs dialog

class CDlgSemiAutoTrToSs : public CDialog
{
// Construction
public:
	XCtlMelsec*		m_pMelsec;
	CDicsData*		m_pDicsData;
	XCtlDevice*		m_pDevice;
	CDlgSemiAutoTrToSs(CWnd* pParent = NULL);   // standard constructor

public:
	void SetMelsec( XCtlMelsec * pMelsec ) { m_pMelsec = pMelsec; }
	void SetDevice( XCtlDevice * pDevice ) { m_pDevice = pDevice; }
	CBitmapButton	m_Ok;

// Dialog Data
	//{{AFX_DATA(CDlgSemiAutoTrToSs)
	enum { IDD = IDD_DIALOG_SEMI_TR_SS };
		// NOTE: the ClassWizard will add data members here
		CMacButton m_macIFstateON[MAX_LOADER_IF_NO];
		CMacButton m_macIFstateOFF[MAX_LOADER_IF_NO];
	//}}AFX_DATA
	CLed	m_ledIFstate[MAX_LOADER_IF_NO];

// Attributes
public:	
	void MonitorInterface();
	static CString m_sIFstateSignalName[MAX_LOADER_IF_NO];

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgSemiAutoTrToSs)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgSemiAutoTrToSs)
	virtual BOOL OnInitDialog();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	afx_msg void OnIFstateOn(UINT nID);
	afx_msg void OnIFstateOff(UINT nID);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGSEMIAUTOTRTOSS_H__6779DFAB_8A77_44AD_B4C1_0DE983A4F115__INCLUDED_)
