//{{AFX_INCLUDES()
#include "..\handposition.h"
//}}AFX_INCLUDES
#if !defined(AFX_DLGSERVOHELP_H__441BC6ED_00C1_405C_9D93_B80438F81EAC__INCLUDED_)
#define AFX_DLGSERVOHELP_H__441BC6ED_00C1_405C_9D93_B80438F81EAC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgServoHelp.h : header file
//
#include "..\X\XMmc.h"
#include "..\AniDialog.h"
/////////////////////////////////////////////////////////////////////////////
// CDlgServoHelp dialog

class CDlgServoHelp : public CAniDialog
{
// Construction
public:
	void SetText();
	BOOL GetHelpFile(LPCTSTR lpszFileName);
	void CloseDialog();
	CDlgServoHelp(CPoint pt, CWnd* pParent = NULL);   // standard constructor
	void SetMmc( XMmc* pMmc ) { m_pMmc = pMmc; }

// Dialog Data
	//{{AFX_DATA(CDlgServoHelp)
	enum { IDD = IDD_DLG_SERVO_HELP };
	XMmc*			m_pMmc;
	CEdit			m_editHelp;
	CPoint			m_pntStart;

	int				m_nRbtType;			// Rbt Hand Number
	int				m_nPointNo;			// Teaching Point Number
	int				m_nUnitPosition;	// Left of Right
	int				m_nUnitType;		// LD or UL
	int				m_nCurPos;			// Current Pos
	int				m_nHandType;		// UP or LO Hand

	BOOL			m_bMovePossible;
	CString			m_sHelp;
	CString			m_sRbtName;
	CString			m_sPosName;
	CString			m_sHelpText;

	CColorStatic	m_stcFrame;
	HBRUSH			m_hbrBkColor;
	HBRUSH			m_hbrWhite;
	CHandPosition	m_ocxHandPosition;
	
	//}}AFX_DATA
	static	CString	m_sUnitName[MAX_RBT_NO];


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgServoHelp)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgServoHelp)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	virtual BOOL OnInitDialog();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnClose();
	afx_msg void OnDestroy();
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGSERVOHELP_H__441BC6ED_00C1_405C_9D93_B80438F81EAC__INCLUDED_)
