// DlgTargetCv.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "DlgTargetCv.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgTargetCv dialog

CString CDlgTargetCv::m_sCvName[MAX_IF_NO*2] = 
{ 
	"LD UNIT CV1",		"LD UNIT CV2", 
	"SWR1 UNIT CV1",	"SWR1 UNIT CV2",
	"SWR2 UNIT CV1",	"SWR2 UNIT CV2",
	"SWR3 UNIT CV1",	"SWR3 UNIT CV2",
	"SWR4 UNIT CV1",	"SWR4 UNIT CV2",
	"AK UNIT CV1",		"AK UNIT CV2",
	"BUF UNIT CV1",		"BUF UNIT CV2",
	"UL UNIT CV1",		"UL UNIT CV2",
};


CDlgTargetCv::CDlgTargetCv(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgTargetCv::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgTargetCv)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_nTargetCv = -1;
}

void CDlgTargetCv::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgTargetCv)
	DDX_Control(pDX, IDC_TARGET_CV, m_cbTargetCv);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgTargetCv, CDialog)
	//{{AFX_MSG_MAP(CDlgTargetCv)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgTargetCv message handlers
BOOL CDlgTargetCv::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	VERIFY( m_Ok.AutoLoad( IDOK, this ) );
	VERIFY( m_Cancel.AutoLoad( IDCANCEL, this ) );
	
	CString sTemp = "";
	for( int i=0; i < MAX_IF_NO * 2 ; i++ ) 
	{
		if( sTemp != m_sCvName[i] )
			m_cbTargetCv.AddString( m_sCvName[i] );
		sTemp = m_sCvName[i];
	}
	m_cbTargetCv.SetCurSel( m_nTargetCv );
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgTargetCv::OnOK() 
{
	int i = m_cbTargetCv.GetCurSel();
	
	if( i<IF_UNIT_LD || i>MAX_IF_NO * 2 ) return;

	CString sBuf;
	int n = m_cbTargetCv.GetLBTextLen( i );
	m_cbTargetCv.GetLBText( i, sBuf.GetBuffer( n ) );
	sBuf.ReleaseBuffer();
	for( i = 0 ; i < MAX_IF_NO * 2 ; i ++ )
	{
		if( sBuf == m_sCvName[i] )
			break;
	}
	m_nTargetCv = i;

	CDialog::OnOK();
}
