#if !defined(AFX_DLGTILT_H__3A610F39_4DD5_432B_AC40_26896AC75E0C__INCLUDED_)
#define AFX_DLGTILT_H__3A610F39_4DD5_432B_AC40_26896AC75E0C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgTilt.h : header file
//
#include "..\FactoryLib\EqpAssy.h"

/////////////////////////////////////////////////////////////////////////////
// CDlgTilt dialog

class CDlgTilt : public CDialog
{
// Construction
public:
	CDlgTilt(CWnd* pParent = NULL);   // standard constructor

	CBitmapButton	m_Ok;
	CMacRadioButton m_macTiltCylinderUp;
	CMacRadioButton m_macTiltCylinderDn;

	CDicsCylinder	m_ocxTiltCylinder[2];


	int				m_nCurCylNo;	
	int				m_nOldTiltCylinderState[2];

	CString			m_sTiltCylTitle[2];

	XCtlDevice*		m_pDevice;
	void SetDevice( XCtlDevice* pDevice ){ m_pDevice = pDevice; }
	CEqpAssy*	m_pEqpAssy;
	void SetEqpAssy( CEqpAssy* pEqpAssy ){ m_pEqpAssy = pEqpAssy; }

	void IsTiltCylinderStatus();
// Dialog Data
	//{{AFX_DATA(CDlgTilt)
#ifndef _LTYPE
	enum { IDD = IDD_DIALOG_TILT };
#else
	enum { IDD = IDD_DIALOG_TILT_L };
#endif
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgTilt)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgTilt)
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	afx_msg void OnRadioUp();
	afx_msg void OnRadioDn();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGTILT_H__3A610F39_4DD5_432B_AC40_26896AC75E0C__INCLUDED_)
