// DigitalOutputs.h: interface for the CDigitalOutputs class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DIGITALOUTPUTS_H__CAD3E1A8_C273_48CD_BBFA_DD862070456E__INCLUDED_)
#define AFX_DIGITALOUTPUTS_H__CAD3E1A8_C273_48CD_BBFA_DD862070456E__INCLUDED_

#include "..\X\XDigitalOutput.h"	// Added by ClassView
#include "Channels.h"
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CDigitalOutputs : public CChannels
{
public:
	XDigitalOutput* GetInstance(CString sName);
	BOOL Create(XCtlDevice * pDevice);
	CDigitalOutputs(int nChannelSize);
	CDigitalOutputs();
	virtual ~CDigitalOutputs();

//private:
	XDigitalOutput * m_pDo;
	XDigitalOutput * m_pDoSpare;
};

#endif // !defined(AFX_DIGITALOUTPUTS_H__CAD3E1A8_C273_48CD_BBFA_DD862070456E__INCLUDED_)
