// FaAnalogInput.h: interface for the CFaAnalogInput class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FAANALOGINPUT_H__1F53BED8_BC2B_4879_98C6_99DE2FDCCA13__INCLUDED_)
#define AFX_FAANALOGINPUT_H__1F53BED8_BC2B_4879_98C6_99DE2FDCCA13__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Device.h"

class CFaAnalogInput : public CDevice  
{
public:
	CFaAnalogInput();
	virtual ~CFaAnalogInput();

	BOOL ReadConfiguration();
	WORD GetAdcVal( int nNo=0 );
	int GetAddress( int nNo=0 );
	float GetRealVal( int nNo=0 );
	int	GetAiSize() { return m_nAiCount; }

	AI_SET * m_aiSet;	// View Ocx   о  ־ д.
	int m_nMaxApdAiNo;
	int m_nMaxEdcAiNo;
	int m_nMaxIntrAiNo;

protected:
	XAnalogInput ** m_pAi;
	int m_nAiCount;
};

#endif // !defined(AFX_FAANALOGINPUT_H__1F53BED8_BC2B_4879_98C6_99DE2FDCCA13__INCLUDED_)
