// FaAnalogOutput.h: interface for the CFaAnalogOutput class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FAANALOGOUTPUT_H__1A731E2A_4114_4875_9784_224A296DCEF7__INCLUDED_)
#define AFX_FAANALOGOUTPUT_H__1A731E2A_4114_4875_9784_224A296DCEF7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Device.h"

class CFaAnalogOutput : public CDevice  
{
public:
	CFaAnalogOutput();
	virtual ~CFaAnalogOutput();

	BOOL ReadConfiguration();
	void Set( int nNo=0, WORD wVal=0 );
	float Get( int nNo=0 );
	int	GetAoSize() { return m_nAoCount; }

protected:
	XAnalogOutput ** m_pAo;
	int m_nAoCount;
	
};

#endif // !defined(AFX_FAANALOGOUTPUT_H__1A731E2A_4114_4875_9784_224A296DCEF7__INCLUDED_)
