// FaDigitalOutput.h: interface for the CFaDigitalOutput class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FADIGITALOUTPUT_H__326C71C5_9912_4A3A_BED9_123D9436E58B__INCLUDED_)
#define AFX_FADIGITALOUTPUT_H__326C71C5_9912_4A3A_BED9_123D9436E58B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Device.h"

class CFaDigitalOutput : public CDevice  
{
public:
	CFaDigitalOutput();
	virtual ~CFaDigitalOutput();

	BOOL ReadConfiguration();
	void Set( int nNo=0, BOOL bVal=FALSE );
	void SetAll( BOOL bVal=FALSE );
	BOOL GetState( int nNo=0 );
	int	GetDoSize() { return m_nDoCount; }
protected:
	XDigitalOutput ** m_pDo;
	int	m_nDoCount;
};

#endif // !defined(AFX_FADIGITALOUTPUT_H__326C71C5_9912_4A3A_BED9_123D9436E58B__INCLUDED_)
