// FaGlassExist.h: interface for the CFaGlassExist class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FAGLASSEXIST_H__A270135E_99FA_4074_A2BC_C2615E6576E7__INCLUDED_)
#define AFX_FAGLASSEXIST_H__A270135E_99FA_4074_A2BC_C2615E6576E7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Device.h"
#include "..\DicsData.h"	// SanghoCho 2015.04.30

class CFaGlassExist : public CDevice  
{
public:
	CFaGlassExist();
	virtual ~CFaGlassExist();

	BOOL ReadConfiguration();
	void SetMaxSectionNo( int nNo=0 );
	int	GetMaxSectionNo();
	BOOL GetAnd( int nUnit=0 );
	BOOL GetOr( int nUnit=0 );
	BOOL DualGetOr(int nUnit= 0 , int nNo = 0 );	// SanghoCho 2015.04.30 FOR DUAL SENSOR
	void Set( int nUnit, BOOL bVal );
	BOOL Get( int nUnit=0, int nNo=0 );
	void Set( int nUnit, int nNo, BOOL bVal );
	
protected:
	XDigitalInput***	m_pDi;
	int*	m_nDiCount;
	int		m_nMaxSectionNo;
};

#endif // !defined(AFX_FAGLASSEXIST_H__A270135E_99FA_4074_A2BC_C2615E6576E7__INCLUDED_)
