// FaInterfaceSignal.h: interface for the CFaInterfaceSignal class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FAINTERFACESIGNAL_H__E39B1FA5_B893_4523_A5CE_D375435F234B__INCLUDED_)
#define AFX_FAINTERFACESIGNAL_H__E39B1FA5_B893_4523_A5CE_D375435F234B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Device.h"

class CFaInterfaceSignal : public CDevice  
{
public:
	CFaInterfaceSignal();
	virtual ~CFaInterfaceSignal();

	BOOL ReadConfiguration();
	BOOL Get( int nNo );
	void Set( int nNo, BOOL bVal );
	BOOL GetState( int nNo );	// Get Output State
	void SetState( int nNo, BOOL bVal );	// Set Input State
	int	GetDiSize() { return m_nDiCount; }
	int	GetDoSize() { return m_nDoCount; }

protected:
	XDigitalInput ** m_pDi;
	XDigitalOutput ** m_pDo;
	
	int m_nDiCount;
	int m_nDoCount;
};

#endif // !defined(AFX_FAINTERFACESIGNAL_H__E39B1FA5_B893_4523_A5CE_D375435F234B__INCLUDED_)
