// Host1.cpp: implementation of the CHost1 class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "dics.h"
#include "Host1.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CHost1::CHost1()
{
	m_flagS7F25Received = FALSE;
	m_flagS1F79Received = FALSE;
	m_flagS1F77Received = FALSE;
	m_flagONLINE_FAIL	= FALSE;

	m_dS1F3SampleTime = 0.0;
	m_dS1F3SampleTime1 = 0.0;
	m_dS1F3RecvSampTime = 0.0;
	m_dS1F3SendSampTime = 0.0;
	m_dS2F23SampleTime = 0.0;
	m_dS2F23SampleTime1 = 0.0;

	for( int i=0; i<MAX_PORT_NO; i++ )
	{
		m_flagS7F65Received[i] = FALSE;
		m_flagS2F27Received[i] = FALSE;
		m_flagS2F21Received[i] = FALSE;
	}
	m_nPortNo			= 0;

	for( int i=0; i<MAX_CEID_NO; i++ )
	{
		m_bCeidEnable[i] = TRUE;
		m_bEventReportReq[i] = FALSE;
	}
	for( int i = 0; i < MAX_TRACE_MULTI_NO ; i++ )
	{
		m_uTraceNoKey[i] = -1;
	}
}

CHost1::~CHost1()
{
}
/*
CString CHost::m_TraceDataName[] = 
{
	"LOT_ID",			"SLOT_NO",			"GLASS_ID",			"RECIPE_ID",
	"TACT_TIME",		"CONV_SPD",			"JOB_USE",			"EUV1_ON_OFF",
	"EUV2_ON_OFF",		"EUV3_ON_OFF",		"EUV4_ON_OFF",		"EUV5_ON_OFF",
	"EUV6_ON_OFF",		"EUV7_ON_OFF",		"EUV8_ON_OFF",		"UP_RB1_ON_OFF",
	"LO_RB1_ON_OFF",	"UP_RB2_ON_OFF",	"LO_RB2_ON_OFF",	"UP_RB1_DIR",
	"LO_RB1_DIR",		"UP_RB2_DIR",		"LO_RB2_DIR",		"UP_RB1_SPD",
	"LO_RB1_SPD",		"UP_RB2_SPD",		"LO_RB2_SPD",		"UP_RB1_GAP",
	"LO_RB1_GAP",		"UP_RB2_GAP",		"LO_RB2_GAP",		"EUV1_ILLUMIN",
	"EUV2_ILLUMIN",		"EUV3_ILLUMIN",		"EUV4_ILLUMIN",		"EUV5_ILLUMIN",
	"EUV6_ILLUMIN",		"EUV7_ILLUMIN",		"EUV8_ILLUMIN",		"EUV_H_EXT",	
	"EUV_A_EXT",		"EUV_CDA_PRS",		"CLN_EXT1",			"CLN_EXT2",
	"FR_EXT1",			"FR_EXT2",			"CLN_UP_SH_FLOW",	"CLN_LO_SH_FLOW",	
	"SBJ1_DI_FLOW",		"SBJ2_DI_FLOW",		"SBJ3_DI_FLOW",		"SBJ_LO_SH_FLOW",
	"SBJ_SH_FLOW",		"AQK_SH_FLOW",		"TANK_DI_RESIST",	"FR_DI_RESIST",
	"AK_UP_EXT",		"AK_LO_EXT",		"AK_UP_PRS",    	"AK_LO_PRS",
	"AK_UP_FLOW",		"AK_LO_FLOW",		"SBJ1_CDA_PRS",		"SBJ2_CDA_PRS",	
	"SBJ3_CDA_PRS",		"DRV_AIR_PRS",	
};
CString CHost1::m_S1F5ItemName[] = 
{
	"EUV_A_EXT",		"RB_EXT1",			"RB_EXT2",			"FR_EXT1",			
	"FR_EXT2",			"RB_UP_SH_FLOW",	"RB_LO_SH_FLOW",	"SBJ1_DI_FLOW",		
	"SBJ2_DI_FLOW",		"SBJ3_DI_FLOW",		"SBJ_LO_SH_FLOW",	"SBJ_SH_FLOW",		
	"AQK_SH_FLOW",		"TANK_DI_RESIST",	"FR_DI_RESIST",		"AK_UP_EXT1",		
	"AK_UP_EXT2",		"AK_LO_EXT",		"AK_UP_PRS",    	"AK_LO_PRS",		
	"AK_UP_FLOW",		"AK_LO_FLOW",		"SBJ1_CDA_PRS",		"SBJ2_CDA_PRS",		
	"SBJ3_CDA_PRS",		"SBJ1_CDA_FLOW",	"SBJ2_CDA_FLOW",	"SBJ3_CDA_FLOW",	
	"DRV_AIR_PRS",	
};*/
CString CHost1::m_S6F65GlsApdName[] = 
{
/*		// 20100528 ssm L8A
	"GLS_START_T",		"GLS_END_T",		"EUV1_ILLUMIN",		"EUV2_ILLUMIN",
	"EUV3_ILLUMIN",		"EUV4_ILLUMIN",		"EUV_A_EXT",		"CLN_AC_CDA_PRS"
	"CLN_EXT1",			"CLN_EXT2",			"FR_EXT1",			"FR_EXT2",							
	"CLN_UP_SH_FLOW",	"CLN_LO_SH_FLOW",	"SBJ1_DI_FLOW",		"SBJ2_DI_FLOW",		
	"SBJ3_DI_FLOW",		"SBJ_LO_SH_FLOW",	"SBJ_SH_FLOW",		"AQK_SH_FLOW",		
	"TANK_DI_RESIST",	"FR_DI_RESIST",		"AK_UP_EXT1",		"AK_UP_EXT2",		
	"AK_LO_EXT",		"AK_UP_PRS",    	"AK_LO_PRS",		"AK_UP_FLOW",		
	"AK_LO_FLOW",		"SBJ1_CDA_PRS",		"SBJ2_CDA_PRS",		"SBJ3_CDA_PRS",		
	"SBJ1_CDA_FLOW",	"SBJ2_CDA_FLOW",	"SBJ3_CDA_FLOW",	"DRV_AIR_PRS",	
*/
/*
	// 20100528 ssm  L8B
	"GLS_START_T",			"GLS_END_T",			"EUV1_ILLUMIN",		"EUV2_ILLUMIN",
	"EUV3_ILLUMIN",			"EUV4_ILLUMIN",			"EUV_A_EXT",		"RB_AC_CDA_FLOW",
	"RB_AC_CDA_PRS",		"RB_EXT1",				"RB_EXT2",			"RB_LO_SWR_FLOW",							
	"RB_UP_SWR_FLOW",		"RB_MJ1_DI_FLOW",		"FR_MJ3_DI_FLOW",	"FR_MJ1_CDA_PRS",		
	"FR_MJ1CDA_FLOW",		"FR_MJ2CDA_FLOW",		"FR_MJ3CDA_FLOW",	"FR_MJ4CDA_FLOW",
	"FR_EXT1",				"FR_EXT2",				"FR_MJ2_CDA_PRS",	"FR_MJ3_CDA_PRS",
	"FR_MJ4_CDA_PRS",		"MJ_LO_SWR_FLOW",   	"FR_MJ4_DI_FLOW",	"FR_UP_SWR_FLOW",		
	"FR_LO_SWR_FLOW",		"FR_AQASWR_FLOW",		"FR_TANK_DI_RES",	"FR_DI_RES",		
	"AK_UP_EXT1",			"AK_UP_EXT2",			"AK_LO_EXT",		"AK_LO_CDA_PRS",
	"AK_UP_CDA_PRS",		"AK_LO_CDA_FLOW",		"AK_UP_CDA_FLOW",	"DRIV_AIR_PRS",
	"TANK_TOTAL_FLOW",		"FR_TOTAL_FLOW",		"UL_WAIT_TIME",	// 110609 halesu
*/
	// SanghoCho 2015.04.22 L6A
	"GLS_START_TIME",			"GLS_END_TIME",			"AK_EXH1",			"AK_EXH2",
	"AK_LO_CDA_FLW",			"AK_UP_CDA_FLW",		"SWR2_MJ1_CDA_FLW",	"SWR2_MJ2_CDA_FLW",
	"SWR2_AQK_DI_WTR_REGISTR",	"AK_LO_CDA_PRESS",		"AK_UP_CDA_PRESS",	"SWR2_MJ1_CDA_PRESS",
	"SWR2_MJ2_CDA_PRESS",		"DRIV_AIR_PRESS",		"IONZR_CDA_PRESS",	"SWR1_AC_CDA_PRESS",
	"SWR1_EXH",					"SWR1_LO_DI_FLW",		"SWR1_UP_DI_FLW",	"SWR2_EXH",
	"SWR2_MJ1_DI_FLW",			"SWR2_MJ2_DI_FLW",		"SWR2_LO_DI_FLW",	"AK_AQK_DI_FLW",
	"AK_UP_DI_FLW",				"SWR2_TNK_WTR_REGISTR",	"UL_WAIT_TIME",
};
/*
CString CHost1::m_S7F25ItemName[] = 
{
	"TACT_TIME",	"CONV_SPD",		"EUV1_ON_OFF",		"EUV2_ON_OFF",
	"EUV3_ON_OFF",	"U_BR1_ON_OFF",	"U_BR2_ON_OFF",		"L_BR1_ON_OFF",
	"L_BR2_ON_OFF",	"U_BR1_DIR",	"U_BR2_DIR",		"L_BR1_DIR",
	"L_BR2_DIR",	"U_BR1_RPM",	"U_BR2_RPM",		"L_BR1_RPM",
	"L_BR2_RPM",	"SBJ_ON_OFF",	"IJ_ON_OFF",		"SBJ_F_MAX_V",
	"SBJ_F_MIN_V",	"SBJ_F_W_MX_V",	"SBJ_F_W_MN_V",		"SW1_F_MAV_V",
	"SW1_F_MIN_V",	"SW1_F_W_MX_V",	"SW1_F_W_MN_V",		"SW2_F_MAX_V",
	"SW2_F_MIN_V",	"SW2_F_W_MX_V",	"SW2_F_W_MN_V",		"AQK_F_MAX_V",
	"AQK_F_MIN_V",	"AQK_F_W_MX_V",	"AQK_F_W_MN_V",		"GLS_I_C_MX_V",
	"G_I_C_W_MX_V",	"UAK_F_MX_V",	"UAK_F_MN_V",		"UAK_F_W_MX_V",	
	"UAK_F_W_MN_V",	"LAK_F_MX_V",	"LAK_F_MN_V",		"LAK_F_W_MX_V",
	"LAK_F_W_MN_V",	"UAK_P_MX_V",	"UAK_P_MN_V",		"UAK_P_W_MX_V",	
	"UAK_P_W_MN_V",	"LAK_P_MX_V",	"LAK_P_MN_V",		"LAK_P_W_MX_V",
	"LAK_P_W_MN_V",	"UAK_E_MX_V",	"UAK_E_MN_V",		"UAK_E_W_MX_V",	
	"UAK_E_W_MN_V",	"LAK_E_MX_V",	"LAK_E_MN_V",		"LAK_E_W_MX_V",	
	"LAK_E_W_MN_V",	"UAK_B_MX_V",	"UAK_B_MN_V",		"UAK_B_W_MX_V",	
	"UAK_B_W_MN_V",	"LAK_B_MX_V",	"LAK_B_MN_V",		"LAK_B_W_MX_V",
	"LAK_B_W_MN_V",	"SBJ_E_MX_V",	"SBJ_E_MN_V",		"SBJ_E_W_MX_V",
	"SBJ_E_W_MN_V",	"RB_E_MX_V",	"RB_E_MN_V",		"RB_E_W_MX_V",
	"RB_E_W_MN_V",	"EUV_E_MX_V",	"EUV_E_MN_V",		"EUV_E_W_MX_V",
	"EUV_E_W_MN_V",	"CDA_M_P_MX_V",	"CDA_M_P_MN_V",		"C_M_P_W_MX_V",
	"C_M_P_W_MN_V",	"SJ_C_P_MX_V",	"SJ_C_P_MN_V",		"S_C_P_W_MX_V",
	"S_C_P_W_MN_V",	"MS_C_P_MX_V",	"MS_C_P_MN_V",		"MS_C_W_MX_V",
	"MS_C_W_MN_V",	"DA_C_P_MX_V",	"DA_C_P_MN_V",		"D_C_P_W_MX_V",
	"D_C_P_W_MN_V",	"DI_T_R_MX_V",	"AQK_R_MN_V",		"AQK_R_W_MN_V",
	"UIJ_P_MX_V",	"UIJ_P_MN_V",	"UIJ_P_W_MX_V",		"UIJ_P_W_MN_V",	
	"LIJ_P_MX_V",	"LIJ_P_MN_V",	"LIJ_P_W_MX_V",		"LIJ_P_W_MN_V",
	"DT1_O_T_V",	"DT1_A_T_MX_V",	"DT1_W_T_MX_V",		"DT1_A_T_MN_V",
	"DT1_W_T_MN_V",	"DT2_O_T_V",	"DT2_A_T_MX_V",		"DT2_W_T_MX_V",
	"DT2_A_T_MN_V",	"DT2_W_T_MN_V",	"SW2_P_Max_V",		"SW2_P_Min_V",
	"SW2_P_W_MX_V",	"SW2_P_W_MN_V",	"DET_F_Max_V",		"DET_F_Min_V",
	"DET_F_W_MX_V",	"DET_F_W_MN_V",	"SBJ_P_Max_V",		"SBJ_P_Min_V",
	"SBJ_P_W_MX_V",	"SBJ_P_W_MN_V",	"IJ_F_Max_V",		"IJ_F_Min_V",
	"IJ_F_W_MX_V",	"IJ_F_W_MN_V",	"AQK_P_Max_V",		"AQK_P_Min_V",
	"AQK_P_W_MX_V",	"AQK_P_W_MN_V",	
};

CString CHost1::m_S6F3GlassApdName[] = 
{
	"EUV1_ON_OFF",	"EUV2_ON_OFF",	"EUV3_ON_OFF",		"EUV1_USE_T",	
	"EUV2_USE_T",	"EUV3_USE_T",	"GLS_START_T",		"GLS_END_T",
	"DET_USE_T",	"DET_GLS_CNT",	"DET_REP_CNT",		"SHW1_F_AVE",
	"SHW2_F_AVE",	"SHW2_P_AVE",	"MTNK_USE_T",		"MTNK_GLS_CNT",
	"MTNK_REP_CNT",	"MTNK_TMP",		"MTNK_NO",			"AQK_F_AVE",
	"AQK_DI_REST",	"AQK_P_AVE",	"DI_TK_REST",		"GLS_ION_CHK",
	"GLS_P_JUDGE",	"SHW_F_DET_AV",	"SHW_F_DI_AVE",		"AK_U_F_AVE",
	"AK_L_F_AVE",	"AK_U_P_AVE",	"AK_L_P_AVE",		"SBJ_CDA_P_AV",
	"SBJ_DI_F_AVE",	"SBJ_DI_P_AVE",	"IJ_U_P_AVE",		"IJ_L_P_AVE",
	"IJ_F_AVE",		"EUV_EXT_AVE",	"AK_U_EXT_AVE",		"AK_L_EXT_AVE",
	"AK_U_BLW_AVE",	"AK_L_BLW_AVE",	"RB_EXT_AVE",		"SBJ_EXT_AVE"
};

CString CHost1::m_S6F3LotApdName[] = 
{
	"LOT_P_JUDGE",	"EUV_EXT_MAX",	"EUV_EXT_MIN",		"EUV_EXT_AVE",
	"EUV1_ON_OFF",	"EUV2_ON_OFF",	"EUV3_ON_OFF",		"EUV1_USE_MAX",
	"EUV1_USE_MIN",	"EUV2_USE_MAX",	"EUV2_USE_MIN",		"EUV3_USE_MAX",
	"EUV3_USE_MIN",	"SHW1_F_MAX",	"SHW1_F_MIN",		"SHW1_F_AVE",	
	"SHW2_F_MAX",	"SHW2_F_MIN",	"SHW2_F_AVE",		"SHW2_P_MAX",
	"SHW2_P_MIN",	"SHW2_P_AVE",	"DET_F_MAX",		"DET_F_MIN",
	"DET_F_AVE",	"SBJ_DI_F_MAX",	"SBJ_DI_F_MIN",		"SBJ_DI_F_AVE",
	"SBJ_DI_P_MAX",	"SBJ_DI_P_MIN",	"SBJ_DI_P_AVE",		"SBJ_CDA_P_MA",
	"SBJ_CDA_P_MI",	"SBJ_CDA_P_AV",	"SBJ_EXT_MAX",		"SBJ_EXT_MIN",
	"SBJ_EXT_AVE",	"RB_EXT_MAX",	"RB_EXT_MIN",		"RB_EXT_AVE",
	"IJ_DI_F_MAX",	"IJ_DI_F_MIN",	"IJ_DI_F_AVE",		"IJ_U_P_MAX",
	"IJ_U_P_MIN",	"IJ_U_P_AVE",	"IJ_L_P_MAX",		"IJ_L_P_MIN",
	"IJ_L_P_AVE",	"AQK_F_MAX",	"AQK_F_MIN",		"AQK_F_AVE",
	"AQK_P_MAX",	"AQK_P_MIN",	"AQK_P_AVE",		"AK_U_F_MAX",
	"AK_U_F_MIN",	"AK_U_F_AVE",	"AK_U_P_MAX",		"AK_U_P_MIN",
	"AK_U_P_AVE",	"AK_L_F_MAX",	"AK_L_F_MIN",		"AK_L_F_AVE",
	"AK_L_P_MAX",	"AK_L_P_MIN",	"AK_L_P_AVE",		"GLS_ION_MAX",
	"GLS_ION_MIN",	"GLS_ION_AVE",	"AK_U_EXT_MAX",		"AK_U_EXT_MIN",
	"AK_U_EXT_AVE",	"AK_L_EXT_MAX",	"AK_L_EXT_MIN",		"AK_L_EXT_AVE",
	"AK_U_BLW_MAX",	"AK_U_BLW_MIN",	"AK_U_BLW_AVE",		"AK_L_BLW_MAX",	
	"AK_L_BLW_MIN",	"AK_L_BLW_AVE"
};

CString CHost1::m_S6F3LotApdDvType[] = 
{
	"X  ", "MAX", "MIN", "AVG",
	"X  ", "X  ", "X  ", "MAX",
	"MIN", "MAX", "MIN", "MAX",
	"MIN", "MAX", "MIN", "AVG",
	"MAX", "MIN", "AVG", "MAX",
	"MIN", "AVG", "MAX", "MIN", 
	"AVG", "MAX", "MIN", "AVE", 
	"MAX", "MIN", "AVG", "MAX", 
	"MIN", "AVG", "MAX", "MIN", 
	"AVG", "MAX", "MIN", "AVE", 
	"MAX", "MIN", "AVG", "MAX", 
	"MIN", "AVG", "MAX", "MIN", 
	"MAX", "MIN", "AVG", "AVE", 
	"MAX", "MIN", "AVG", "MAX", 
	"MIN", "AVG", "MAX", "MIN", 
	"AVG", "MAX", "MIN", "AVE", 
	"MAX", "MIN", "AVG", "MAX", 
	"MIN", "AVG", "MAX", "MIN", 
	"AVG", "MAX", "MIN", "AVG", 
	"MAX", "MIN", "AVG", "MAX", 
	"MIN", "AVG",
};
*/
//---------------------------------------------------------------------------
// Primary Message : ECS ===> HDC
//---------------------------------------------------------------------------
int CHost1::OnPrimaryRcvd(XSecsTranxThread1 *pTranx)
{
	static char cRCODE = '0';
	CString szBuf;
	char buf[256];

	switch( pTranx->Primary.GetSFCode() )
	{
	case _S1F1 :	// Online Request
		{
			SYSTEMBYTES1 sysBytes;
			pTranx->Primary.GetSystemBytes( &sysBytes );

#ifndef _MY_DEBUG
			if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE ) 
#else
			if( 0 )
#endif
			{
				SYSTEMBYTES1 sysBytes;
				pTranx->Primary.GetSystemBytes( &sysBytes );

				XSecsTranxThread1* pTranx = Transaction("S1F0");
				if( pTranx == NULL ) return -1;
				pTranx->Primary.SetSystemBytes( sysBytes );
				pTranx->PrimaryOut( FALSE );
			}
			else
			{
				pTranx->Secondary.SetItemData( "MDLN", "ITO");
				pTranx->Secondary.SetItemData( "SOFTREV", "VERSION 0.01" );
				pTranx->Secondary.SetItemData( "RMS", m_pDicsData->m_EqpInfo.cCtlMode );
				pTranx->SecondaryOut();
			}
		}
		break;

	case _S1F3 : // Formatted Status Report
#ifndef _MY_DEBUG
			if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE ) 
#else
			if( 0 )
#endif
		{
			SYSTEMBYTES1 sysBytes;
			pTranx->Primary.GetSystemBytes( &sysBytes );
			
			XSecsTranxThread1* pTranx = Transaction( "S1F0" );
			pTranx->Primary.SetSystemBytes( sysBytes );
			pTranx->PrimaryOut( FALSE );
			
		}
		else
		{

			CDicsDoc* pDoc = ( (CDicsView *) m_pOwner )->GetDocument();

			int nLength = pTranx->Primary.GetListSize( 0 );		// Depth = 1
//			if( nLength == 0 ) nLength = MAX_SV_NO;
			
			//pTranx->Secondary.SetListSize( 1, nLength, 67 );
			pTranx->Secondary.SetListSize( 1, nLength, MAX_TRACE_DATA_NO );	// shcho 230207

			for( int k=0; k<MAX_IF_NO*2; k++ )
			{
				if( m_pDicsData->m_GlsInfo[k].bIsValid )
				{
					m_pDicsData->m_IfCim.sTraceDataValue[0] = m_pDicsData->m_GlsInfo[k].sGlassId;
					m_pDicsData->m_IfCim.sTraceDataValue[1] = m_pDicsData->m_GlsInfo[k].sRecipeId;
					m_pDicsData->m_IfCim.sTraceDataValue[2] = m_pDicsData->m_GlsInfo[k].sLotId;
					m_pDicsData->m_IfCim.sTraceDataValue[3].Format( "%d", m_pDicsData->m_GlsInfo[k].nSlotNo );


//					m_pDicsData->m_IfCim.sTraceDataValue[4] = m_pDicsData->m_GlsInfo[k].sGlassHeadPos;//2008.11.07 kimgun
//					m_pDicsData->m_IfCim.sTraceDataValue[5] = m_pDicsData->m_GlsInfo[k].sGlassTailPos;//2008.11.07 kimgun
					int nRecipeId = atoi( m_pDicsData->m_GlsInfo[k].sRecipeId );

					CString sRecipeId;
					sRecipeId.Format("%d",nRecipeId );
					int nRow = pDoc->GetRowfromID( sRecipeId );

					for( int i=0; i<MAX_TOTAL_RECIPE_BODY_NO - 3; i++ )
					{
						m_pDicsData->m_IfCim.sTraceDataValue[i+4] = pDoc->m_pRecipeInfo[nRow].sValue[i + 3];
//#ifdef _NO_RB
// 						for( int i=7; i<MAX_TOTAL_RECIPE_BODY_NO - 3; i++ )
// 						{
// 							m_pDicsData->m_IfCim.sTraceDataValue[i+6] = "";
// 						}
//#endif
					}
					break;
				}
				else 
				{
					m_pDicsData->m_IfCim.sTraceDataValue[0] = "";
					m_pDicsData->m_IfCim.sTraceDataValue[1] = "";
					m_pDicsData->m_IfCim.sTraceDataValue[2] = "";
					m_pDicsData->m_IfCim.sTraceDataValue[3] = "";
//					m_pDicsData->m_IfCim.sTraceDataValue[4] = "";//2008.11.07 kimgun
//					m_pDicsData->m_IfCim.sTraceDataValue[5] = "";//2008.11.07 kimgun
					int nRecipeId = 1;/*atoi( m_pDicsData->m_GlsInfo[k].sRecipeId );*/

					for( int i=0; i<MAX_TOTAL_RECIPE_BODY_NO - 3; i++ )
					{
						CDicsDoc* pDoc = ( (CDicsView *) m_pOwner )->GetDocument();
						m_pDicsData->m_IfCim.sTraceDataValue[i+4] = pDoc->m_pRecipeInfo[nRecipeId - 1].sValue[i + 3];
//#ifdef _NO_RB
// 						for( int i=7; i<MAX_TOTAL_RECIPE_BODY_NO - 3; i++ )
// 						{
// 							m_pDicsData->m_IfCim.sTraceDataValue[i+6] = "";
// 						}
//#endif
					}
				}
			}

			for( int i=0; i<nLength; i++ )
			{
				
				CString sData;
				CString sString;
				
				sData.Format( "SVID%d", i + 1 );
				pTranx->Primary.GetItemData( (char*)(LPCTSTR) sData, buf ); buf[14] = 0;
				
//				int nSVID = ( buf[0] << 24 ) + ( buf[1] << 16 ) + ( buf[2] << 8 ) + buf[3];
				int nSVID = ( buf[0] << 24 ) + ( buf[1] << 16 ) + ( buf[2] << 8 ) + (unsigned char)buf[3];

				CString sData1;
				sData1.Format( "SV%d", i + 1 );
				if(nSVID <= MAX_TRACE_DATA_NO )//2008.12.03 kimgun nSVID   .
					pTranx->Secondary.SetItemData( sData1, m_pDicsData->m_IfCim.sTraceDataValue[nSVID-1] );
				else//2008.12.26 kimgun
					pTranx->Secondary.SetItemData( sData1, "" );
			} 
			SYSTEMTIME SystemTime;
			GetLocalTime(&SystemTime);
			CString sDateTime;
			sDateTime.Format("%04d%02d%02d%02d%02d%02d.%01d",
				SystemTime.wYear, 
				SystemTime.wMonth, 
				SystemTime.wDay, 
				SystemTime.wHour, 
				SystemTime.wMinute, 
				SystemTime.wSecond, 
				SystemTime.wMilliseconds );

			pTranx->Secondary.SetItemData( "DSPER", sDateTime );
//*****************************************************************************************
			pTranx->SecondaryOut();
		}
		break;

	case _S2F23 :
#ifndef _MY_DEBUG
			if( 0 ) // 160216 halesu no host m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE ) 
#else
			if( 0 )
#endif
		{
			SYSTEMBYTES1 sysBytes;
			pTranx->Primary.GetSystemBytes( &sysBytes );

			XSecsTranxThread1* pTranx = Transaction("S2F0");
			if( pTranx == NULL ) return -1;
			pTranx->Primary.SetSystemBytes( sysBytes );
			pTranx->PrimaryOut( FALSE );
		}
		else
		{
//*************************************** TRACE ID *********************************************************
			CString sString;
			pTranx->Primary.GetItemData( "TRID", buf );		
			UINT uTraceId = (WORD)( buf[0] << 8 ) + (UCHAR)(buf[1]);//2008.10.22 KIMGUN
		//	static int nTraceNoKey[MAX_TRACE_MULTI_NO] = {-1,-1,-1,-1,-1,-1};
			int nTraceCount = 0;
			int nTraceNo = 0;
			
			BOOL bduplicateTraceId = FALSE;
			BOOL bEmptyTraceCount = FALSE;
			BOOL bTridWrong = FALSE;
			BOOL bSamplingError = FALSE;
			BOOL bGroupSizeError = FALSE;
			BOOL bSystemOverFlow = FALSE;	// 20200406 ssm
			int i;
		
			if( uTraceId > 65535 )
			{
				bTridWrong = TRUE;
			//	uTraceId = MAX_TRACE_DATA_NO - 1; 
			}
///////////////////Trace Id duplicate check///////////////////////////////////////////////////////
			for( i = 0; i < MAX_TRACE_MULTI_NO; i++ )
			{		
				if( m_uTraceNoKey[i] == uTraceId && !bduplicateTraceId)//duplicate check
				{
					bduplicateTraceId = TRUE;
					nTraceNo = i;
				}
				if( m_uTraceNoKey[i] == -1 && !bEmptyTraceCount)//empty
				{
					bEmptyTraceCount = TRUE;
					nTraceCount = i;
				}
			}//Trace data Multi Over
			if( !bduplicateTraceId && !bEmptyTraceCount ) bTridWrong = TRUE;
			else if( bduplicateTraceId )
			{
			//	bduplicateTraceId = FALSE;
				bEmptyTraceCount = FALSE;
				m_pDicsData->m_TraceData[ nTraceNo ].uTraceIdCount = nTraceNo;
			}
			else
			{
				bduplicateTraceId = FALSE;
				bEmptyTraceCount = FALSE;
				nTraceNo = nTraceCount;
				m_pDicsData->m_TraceData[ nTraceNo ].uTraceIdCount = nTraceCount;
			}

	//		m_pDicsData->m_TraceData[uTraceId -1 ].uTraceId = uTraceId;
			
			m_pDicsData->m_TraceData[ nTraceNo ].uTraceId = uTraceId;
			
//*************************************** DATA SAMPLE PERIOD ***********************************************
			pTranx->Primary.GetItemData( "DSPER", buf );	buf[9] = 0; 
			sString.Format( "%s", buf );

			int nFind = sString.Find(".");
			
//			if( nFind != -1 ) 
//			{//翡 ° úʴ ° з..2008.10.08 kimgun
				int nLength = sString.GetLength();
				if( nLength == 9)	// 160215 halesu 9 --> 6 spec change
				{
					double dHH = 0;
					double dMM = 0;
					double dSS = 0;
					//		m_dS2F23SampleTime = atof( sString.Mid( 0, nFind ) );2008.10.08 kimgun ʿ.
					dHH = atof( sString.Mid( 0, 2 )) * 3600;
					dMM = atof( sString.Mid( 2, 2 )) * 60;
					dSS = atof( sString.Mid( 4, 2 ));
				
					// 160216 halesu spec change HHMMSS.ss --> HHMMSS
 					m_dS2F23SampleTime1 = atof( sString.Mid( nFind+1, 2 ) );					
 					m_dS2F23SampleTime1 = m_dS2F23SampleTime1/100.;
//					m_dS2F23SampleTime1 = 0.0;

					m_dS2F23SampleTime = dHH +dMM + dSS;
					if( (m_dS2F23SampleTime + m_dS2F23SampleTime1 ) >= 1 )
					{
						int nSamplingError2 = 0;	// 20200406 ssm Report Time ߺ  
//						for( i = 0; i < MAX_TRACE_MULTI_NO; i++ )	// shcho 220525
//						{	
//							if( m_pDicsData->m_TraceData[i].dSamplePeriod == (m_dS2F23SampleTime + m_dS2F23SampleTime1 ))
//							{
//								nSamplingError2++;
//							}
//						}
						if(nSamplingError2 > 0) bSystemOverFlow = TRUE;	// ߺ Ƚ 
						else
						{
							m_pDicsData->m_TraceData[/*uTraceId -1*/ nTraceNo ].dSamplePeriod = m_dS2F23SampleTime + m_dS2F23SampleTime1;
						}
					}
					else bSamplingError = TRUE;//2008.10.08 kimgun 
				}
				else bSamplingError = TRUE;
// 			}
// 			else 
// 			{
// 				bSamplingError = TRUE;
// 				//	pTranx->Secondary.SetItemData( "TIAACK", 0x03 );//2008.10.08 kimgun 
// 			}

//*************************************** SAMPLE COMMAND ***************************************************

			pTranx->Primary.GetItemData( "SMPCOM", buf );	// 160216 halesu SAMCOM --> TOTSMP	// TOTAL NUMBER OF SAMPLE  ( 0 : STOP, 1 : START )			
			
			int nSampleCommand = ( buf[0] << 8 );// + buf[1];
			if( buf[1] >= 0 ) 
				nSampleCommand += buf[1];
			else
				nSampleCommand += buf[1] + 256;

// 			if( nSampleCommand == 1 ) m_pDicsData->m_TraceData[uTraceId -1 ].bTraceDataStartReq = TRUE;
// 			else m_pDicsData->m_TraceData[uTraceId -1 ].bTraceDataStopReq = TRUE; 

//*************************************** GROUP SIZE *******************************************************

			pTranx->Primary.GetItemData( "REPGSZ", buf );	
			UINT uGroupSize = ( buf[0] << 8 ) + buf[1];
			//if( uGroupSize == 1)
			if( uGroupSize > 0 && uGroupSize < 5) // 101013 halesu test
				m_pDicsData->m_TraceData[/*uTraceId -1*/nTraceNo  ].uGroupSize = uGroupSize;
			else
			{
				bGroupSizeError = TRUE;
			}

//**********************************************************************************************************
			if( nSampleCommand == 1/*999  *//*1 --> 999*/)	// 160216 halesu spec change [0] : stop [999] : start		// 20100611 ssm(hanjun)
			{
				for( int i = 0 ; i < MAX_TRACE_DATA_NO ; i ++ )
				{
					m_pDicsData->m_TraceData[/*uTraceId -1*/ nTraceNo].nTraceList[i] = -1;
				}
			}
//			int nListSize = pTranx->Primary.GetListSize( 1 );
			m_pDicsData->m_TraceData[/*uTraceId -1*/nTraceNo ].nS2F23ListSize = pTranx->Primary.GetListSize( 1 );

			BOOL bSvidWrong = FALSE;
			BOOL bSvidDuplicate = FALSE;
			
			int nOldSvid[ MAX_TRACE_DATA_NO ] = {0,};

			if( m_pDicsData->m_TraceData[nTraceNo ].nS2F23ListSize == 0)
			{
				for(int i=0; i< MAX_TRACE_DATA_NO; i++ )
				{
					m_pDicsData->m_TraceData[nTraceNo ].nTraceList[i] = i+1;
				}

				m_pDicsData->m_TraceData[/*uTraceId -1*/nTraceNo ].nS2F23ListSize = MAX_TRACE_DATA_NO;
				pTranx->Secondary.SetItemData( "TIAACK", 0x0 );				// Everything Correct
			}
			else
			{
				for( int i = 0 ; i < m_pDicsData->m_TraceData[nTraceNo ].nS2F23ListSize ; i ++ )
				{
					CString sBuf;
					sBuf.Format( "SVID%d", i+1 );
					pTranx->Primary.GetItemData( (char*)(LPCTSTR)sBuf, buf );
//					int nSvId = ( buf[0] << 24 ) + ( buf[1] << 16 ) + ( buf[2] << 8 ) + buf[3];
					int nSvId = ( buf[0] << 24 ) + ( buf[1] << 16 ) + ( buf[2] << 8 ) + (unsigned char)buf[3];

					//2008.10.08 kimgun SVID ߺ üũ///////////////////////////////////////
					//int* nOldSvid;//[ MAX_TRACE_DATA_NO ] = {0,};
					//nOldSvid = new int[m_pDicsData->m_TraceData[nTraceNo ].nS2F23ListSize];
					for( int j = 0; j < i; j ++ )
					{
						if( nOldSvid[j] == nSvId ) bSvidDuplicate = TRUE;
					}
					//////////////////////////////////////////////////////////////////////////

					nOldSvid[i] = nSvId;
					if( nSvId > 0 && nSvId <= MAX_TRACE_DATA_NO )
					{
						m_pDicsData->m_TraceData[nTraceNo ].nTraceList[i] = nSvId;
					}
					else
					{
						//					pTranx->Secondary.SetItemData( "TIAACK", 0x80 );		// SVID does Not exist
						bSvidWrong = TRUE;
						break;
					}
					pTranx->Secondary.SetItemData( "TIAACK", 0x0 );				// Everything Correct
					//delete []nOldSvid;//2008.11.18 kimgun
				}
			}

			if( bTridWrong )
			{
				bTridWrong = FALSE;
				pTranx->Secondary.SetItemData( "TIAACK", 0x77 );			// TRID is not correct
			}
			else if( bSvidWrong )
			{
				pTranx->Secondary.SetItemData( "TIAACK", 0x80 );			// SVID does Not exist
				bSvidWrong = FALSE;
			}
			else if( bSvidDuplicate )//2008.10.08 kimgun
			{
				pTranx->Secondary.SetItemData( "TIAACK", 0x73 );			// SVID does Not exist
				bSvidDuplicate = FALSE;
			}
			else if( bSamplingError )
			{
				bSamplingError = FALSE;
				pTranx->Secondary.SetItemData( "TIAACK", 0x03 );//2008.10.08 kimgun 
			}
			else if( bGroupSizeError )
			{
				bGroupSizeError = FALSE;
				pTranx->Secondary.SetItemData( "TIAACK", 0x02 );//2008.10.08 kimgun 
			}
			else if( bSystemOverFlow )	// 20200406 ssm
			{
				bSystemOverFlow = FALSE;
				pTranx->Secondary.SetItemData( "TIAACK", 0x64 );
			}
			else
			{
				if( nSampleCommand == 1/*999*//*1 --> 999 160216 halesu*/ ) 
				{
					if( !bduplicateTraceId )
					{
						m_pDicsData->m_TraceData[/*uTraceId -1*/nTraceNo ].bTraceDataStartReq = TRUE;
						m_uTraceNoKey[nTraceNo] = uTraceId;
					}
					
//					if( nTraceCount < MAX_TRACE_DATA_NO )
//					    nTraceCount++;
				}
				else if( nSampleCommand == 0 ) 
				{
					if( bduplicateTraceId )
					{
						m_pDicsData->m_TraceData[/*uTraceId -1*/ nTraceNo].bTraceDataStopReq = TRUE; 
						m_uTraceNoKey[nTraceNo] = -1;
					}
					else //2009.01.07 kimgun    s6f1߿  TRID NG ó
					{
						pTranx->Secondary.SetItemData( "TIAACK", 0x77 );			// TRID is not correct
					}
				}
				else
				{
					//ng ľߵǴµ..2008.10.08 kimgun
					pTranx->Secondary.SetItemData( "TIAACK", 0x02 );			// SVID does Not exist
				}
			}
			pTranx->SecondaryOut();
		}
		break;

	case _S2F37 :
#ifndef _MY_DEBUG
			if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE ) 
#else
			if( 0 )
#endif
		{
			SYSTEMBYTES1 sysBytes;
			pTranx->Primary.GetSystemBytes( &sysBytes );

			XSecsTranxThread1* pTranx = Transaction("S2F0");
			if( pTranx == NULL ) return -1;
			pTranx->Primary.SetSystemBytes( sysBytes );
			pTranx->PrimaryOut( FALSE );
		}
		else
		{
			int nLength = pTranx->Primary.GetListSize( 1 );

			pTranx->Primary.GetItemData( "CEED", buf );	

//			BOOL bEnable = ( buf[0] == '0' ) ? FALSE : TRUE;
			int bEnable =  buf[0];// format ̻ؼ TRUE  255 ͼ..int ϸ -1 ´.
			BOOL bEnableStatus = FALSE;
			if( bEnable == -1 ) bEnable = 1;
			if( bEnable == 0 || bEnable == 1) bEnableStatus = TRUE;//2008.12.01 kimgun Ʋ NG
		

			for( int i=0; i<nLength; i++ )
			{
				CString sData;
				sData.Format( "CEID%d", i + 1 );
				pTranx->Primary.GetItemData( (char*) (LPCTSTR)sData, buf ); 

				int nCEID = ( buf[0] << 24 ) + ( buf[1] << 16 ) + ( buf[2] << 8 ) + buf[3];

				if( nCEID < 0 )
				{
					nCEID = 128 + ( 128 - ABS( nCEID ) );
				}

				
				//if( ( nCEID == 200 || nCEID == 204 ) && bEnableStatus )//2008.12.01 kimgun 200 204ۿ .
				if( ( nCEID >= 200 && nCEID <= 215 ) && bEnableStatus ) // hskwak 2020/01/03 200~215
				{
					//int nIndex = nCEID - 195;//2008.11.27 kimgun
					int nIndex = nCEID - 200;// hskwak 2020/01/03
					m_bCeidEnable[nIndex] = bEnable;
				}
				else 
				{
					pTranx->Secondary.SetItemData( "ERACK", 0x01 ); // Specified CEID does Not exist
					break;
				}
				pTranx->Secondary.SetItemData( "TIAACK", 0x00 );				// Everything Correct
			}
			pTranx->SecondaryOut();
		}
		break;

	case _S6F15 :
#ifndef _MY_DEBUG
			if( m_pDicsData->m_EqpInfo.cCtlMode == CDicsData::modeOFFLINE ) 
#else
			if( 0 )
#endif
		{
			SYSTEMBYTES1 sysBytes;
			pTranx->Primary.GetSystemBytes( &sysBytes );

			XSecsTranxThread1* pTranx = Transaction("S6F0");
			if( pTranx == NULL ) return -1;
			pTranx->Primary.SetSystemBytes( sysBytes );
			pTranx->PrimaryOut( FALSE );
		}
		else
		{// 濡   .2008.12.03 kimgun
		 // unit euv~Ul unit ==>200~204 
		 //In out  ʴ´.
			CString sString;
			CString sLotId = "              ";
			CString sSlotNo = "  ";
			CString sGlassId = "              ";
			CString sRcpId = "  ";

			CString sBuf;
			sBuf.Format( "CEID" );
			pTranx->Primary.GetItemData( (char*)(LPCTSTR)sBuf, buf );

			pTranx->Primary.GetItemData( "CEID", buf );		// CEID ID

			int nCeid = ( buf[0] << 24 ) + ( buf[1] << 16 ) + ( buf[2] << 8 ) + buf[3];

			if( nCeid < 0 )
			{
				nCeid = 128 + ( 128 - ABS( nCeid ) );
			}

			UINT uCeid = nCeid;

			pTranx->Secondary.SetItemData( "CEID", uCeid );

			if( m_pDicsData->uDataId > 999 ) m_pDicsData->uDataId = 0;
			m_pDicsData->uDataId++;
			int nGlassPos = ( uCeid - 195 ) * 2;
			//if( uCeid >= 200 && uCeid <= 204 ) 
			if( uCeid >= 200 && uCeid <= 215 ) // hskwak 2020/01/03 
			{
				
				if( m_pDicsData->m_GlsInfo[nGlassPos].bIsValid ) 
				{
					pTranx->Secondary.SetItemData( "DATAID", m_pDicsData->uDataId );
					pTranx->Secondary.SetItemData( "RPTID", m_pDicsData->uRptId );
					
					sLotId = m_pDicsData->m_GlsInfo[nGlassPos].sLotId;
					sSlotNo.Format( "%d", m_pDicsData->m_GlsInfo[nGlassPos].nSlotNo );
					sGlassId = m_pDicsData->m_GlsInfo[nGlassPos].sGlassId;
					sRcpId = m_pDicsData->m_GlsInfo[nGlassPos].sRecipeId;
					
					pTranx->Secondary.SetItemData( "LOT_ID", sLotId );
					pTranx->Secondary.SetItemData( "SLOT_NO", sSlotNo );
					pTranx->Secondary.SetItemData( "GLASS_ID", sGlassId );
					pTranx->Secondary.SetItemData( "RECIPE_ID", sRcpId );
				}
				else if( m_pDicsData->m_GlsInfo[nGlassPos + 1].bIsValid ) 
				{
					pTranx->Secondary.SetItemData( "DATAID", m_pDicsData->uDataId );
					pTranx->Secondary.SetItemData( "RPTID", m_pDicsData->uRptId );
					
					sLotId = m_pDicsData->m_GlsInfo[nGlassPos + 1].sLotId;
					sSlotNo.Format( "%d", m_pDicsData->m_GlsInfo[nGlassPos + 1].nSlotNo );
					sGlassId = m_pDicsData->m_GlsInfo[nGlassPos + 1].sGlassId;
					sRcpId = m_pDicsData->m_GlsInfo[nGlassPos + 1].sRecipeId;
					
					pTranx->Secondary.SetItemData( "LOT_ID", sLotId );
					pTranx->Secondary.SetItemData( "SLOT_NO", sSlotNo );
					pTranx->Secondary.SetItemData( "GLASS_ID", sGlassId );
					pTranx->Secondary.SetItemData( "RECIPE_ID", sRcpId );
				}	
				/*
				else if( uCeid == 208 && m_pDicsData->m_GlsInfo[uCeid - 199].bIsValid )
				{
					pTranx->Secondary.SetItemData( "DATAID", m_pDicsData->uDataId );
					pTranx->Secondary.SetItemData( "RPTID", m_pDicsData->uRptId );

					sLotId = m_pDicsData->m_GlsInfo[uCeid - 199].sLotId;
					sSlotNo.Format( "%d", m_pDicsData->m_GlsInfo[uCeid - 199].nSlotNo );
					sGlassId = m_pDicsData->m_GlsInfo[uCeid - 199].sGlassId;
					sRcpId = m_pDicsData->m_GlsInfo[uCeid - 199].sRecipeId;

					pTranx->Secondary.SetItemData( "LOTID", sLotId );
					pTranx->Secondary.SetItemData( "SLOTNO", sSlotNo );
					pTranx->Secondary.SetItemData( "GLSID", sGlassId );
					pTranx->Secondary.SetItemData( "RCPID", sRcpId );
				}
				else if( ( uCeid >= 209 ) && m_pDicsData->m_GlsInfo[uCeid - 201].bIsValid )
				{
					pTranx->Secondary.SetItemData( "DATAID", m_pDicsData->uDataId );
					pTranx->Secondary.SetItemData( "RPTID", m_pDicsData->uRptId );

					sLotId = m_pDicsData->m_GlsInfo[uCeid - 201].sLotId;
					sSlotNo.Format( "%d", m_pDicsData->m_GlsInfo[uCeid - 201].nSlotNo );
					sGlassId = m_pDicsData->m_GlsInfo[uCeid - 201].sGlassId;
					sRcpId = m_pDicsData->m_GlsInfo[uCeid - 201].sRecipeId;

					pTranx->Secondary.SetItemData( "LOTID", sLotId );
					pTranx->Secondary.SetItemData( "SLOTNO", sSlotNo );
					pTranx->Secondary.SetItemData( "GLSID", sGlassId );
					pTranx->Secondary.SetItemData( "RCPID", sRcpId );
				}*/
				else 
				{
					pTranx->Secondary.SetItemData( "DATAID", m_pDicsData->uDataId );
					pTranx->Secondary.SetItemData( "RPTID", m_pDicsData->uRptId );

					sLotId = "              ";
					sSlotNo = "  ";
					sGlassId = "              ";
					sRcpId = "  ";

					pTranx->Secondary.SetItemData( "LOT_ID", sLotId );
					pTranx->Secondary.SetItemData( "SLOT_NO", sSlotNo );
					pTranx->Secondary.SetItemData( "GLASS_ID", sGlassId );
					pTranx->Secondary.SetItemData( "RECIPE_ID", sRcpId );
				}
				pTranx->SecondaryOut();
			}
			else
			{
				SYSTEMBYTES1 sysBytes;
				pTranx->Primary.GetSystemBytes( &sysBytes );
				pTranx->ResetSystemByte(XSecsHSMS::smSecondaryOut);

				XSecsTranxThread1* pTranx2 = Transaction( "S6F15_2" );
				if( pTranx2 == NULL ) return -1;

				pTranx2->m_ArraySecondarySystemByte.Add( sysBytes );
				pTranx2->Secondary.SetItemData( "DATAID", m_pDicsData->uDataId );
			//	pTranx2->Secondary.SetItemData( "RPTID", m_pDicsData->uRptId );
				pTranx2->Secondary.SetItemData( "CEID", uCeid ); 
				pTranx2->SecondaryOut( );
			}
		} 
		break;

	case _S10F5 :	// 'Terminal Message(VMN:Terminal Display Multiblock)'
		pTranx->Primary.GetItemData( "TID", buf );
		pTranx->Primary.GetItemData( "TEXT", buf+1 );
		buf[80] = '\x0';
		if( buf[0] == 1 ) 
		{
			m_szHostMsg.Format( "%s", buf+1 ); // RED Color
			// Send Message
			Msg( WM_JOBS_VIEW, (WPARAM) MSG_TERMINAL_WARNING, (LPARAM) (LPARAM)(LPCTSTR)m_szHostMsg );
		}
		else 
		{
			m_szHostMsg.Format( "%s", buf+1 );	// BLACK Color
			// Send Message
			Msg( WM_JOBS_VIEW, (WPARAM) MSG_TERMINAL_MESSAGE, (LPARAM) (LPARAM)(LPCTSTR)m_szHostMsg );
		}

		// Set Tab
		( (CDicsView*) m_pOwner )->SendMessage( WM_JOBS_VIEW_SELECT_TAB, 1, NULL );
		break;
	}

	return 0;
}

//---------------------------------------------------------------------------
// Secondary Message : ECS ===> HDC
//---------------------------------------------------------------------------
int CHost1::OnSecondaryRcvd(XSecsTranxThread1 *pTranx)
{
	char buf[256];

	switch( pTranx->Secondary.GetSFCode() )
	{
	case _S1F66:
	case _S1F68:
	case _S1F70:
		pTranx->Secondary.GetItemData( "GRANT", buf );
		m_pDicsData->m_IfCimTag.nAck1 = buf[0];
		break;
	case _S1F74:
	case _S1F76:
		pTranx->Secondary.GetItemData( "ACKC1", buf );
		m_pDicsData->m_IfCimTag.nAck1 = buf[0];
		break;
	case _S2F18:
		pTranx->Secondary.GetItemData( "TIME", buf );
		m_pDicsData->m_EqpInfo.sHostTime.Format( "%s", buf );
		break;

	case _S6F12:
		pTranx->Secondary.GetItemData( "ACK6", buf );
		m_pDicsData->m_IfCimTag.nS6F11Ack6 = buf[0];
		break;

	case _S5F66:
		pTranx->Secondary.GetItemData( "ACKC5", buf );
		m_pDicsData->m_IfCimTag.nAck5 = buf[0];
		break;

	case _S6F64:
	case _S6F66:
	case _S6F68:
	case _S6F70:
		pTranx->Secondary.GetItemData( "ACKC6", buf );
		m_pDicsData->m_IfCimTag.nAck6 = buf[0];
		break;

	case _S7F22:
		pTranx->Secondary.GetItemData( "ACKC7", buf );
		m_pDicsData->m_IfCimTag.nAck7 = buf[0];
		break;
	case _S7F72:
	case _S7F74:
		pTranx->Secondary.GetItemData( "GRANT", buf );
		m_pDicsData->m_IfCimTag.nAck7 = buf[0];
		break;

	default:
		#ifdef __LOG__
		m_pHexLog->TextOut( "Received not registered message" );
		#endif
		break;
	}

	return 0;
}

//---------------------------------------------------------------------------
// Check whether the secondary message is recevided ? 
//---------------------------------------------------------------------------
BOOL CHost1::SecondaryRcvd(LPCTSTR lpszName, BOOL bLock)
{
	//if( !m_bConnected ) return 0;

	BOOL bRv;

	XSecsTranxThread1* pTranx = Transaction( (char*)lpszName, XSecsMessage1::toHost );
	if( pTranx == NULL ) return FALSE; // But, Error!!!

	//if( bLock ) bRv = pTranx->IsSecondaryRcvd( bLock );
	//else bRv = pTranx->IsSecondaryRcvd();

	bRv = pTranx->IsSecondaryRcvd( bLock );
	return bRv;
}


//---------------------------------------------------------------------------
// Primary :  HOST <=== CIM
//---------------------------------------------------------------------------
int CHost1::S1F1()
{
	if( !m_bConnected ) return -1; //0;

	XSecsTranxThread1* pTranx = Transaction( "S1F1" );
	if( pTranx == NULL ) return -1;

	pTranx->Primary.SetItemData( "MDLN", "D-HDC" );
	pTranx->Primary.SetItemData( "SOFTREV", "VER1.0" );

	return pTranx->PrimaryOut();
}

//---------------------------------------------------------------------------
// Primary : ECS <=== HDC : TRACE Data Report
//---------------------------------------------------------------------------
int CHost1::S6F1( int nTrId )
{
	if( !m_bConnected ) return -1;//0;
	if( !m_bTransComp ) return -100;//2008.10.20 kimgun

	m_bTransComp = FALSE;//2008.10.20 kimgun
	XSecsTranxThread1* pTranx = Transaction( "S6F1" );
	if( pTranx == NULL ) 
	{
		m_bTransComp = TRUE;//2008.10.20 kimgun
		return -1;
	}

	pTranx->Primary.SetItemData( "TRID", m_pDicsData->m_TraceData[nTrId  ].uTraceId );
	pTranx->Primary.SetItemData( "SMPLN", m_pDicsData->m_TraceData[nTrId ].uSampleNo );
/*Ҷ ҷ..2008.12.01 kimgun	
	SYSTEMTIME SystemTime;
	GetLocalTime(&SystemTime);
	CString sDateTime;
	sDateTime.Format("%04d%02d%02d%02d%02d%02d.%02d",
		SystemTime.wYear, 
		SystemTime.wMonth, 
		SystemTime.wDay, 
		SystemTime.wHour, 
		SystemTime.wMinute, 
		SystemTime.wSecond, 
		SystemTime.wMilliseconds );
*/
	pTranx->Primary.SetItemData( "STIME", m_pDicsData->m_IfCim.sTraceDataTime );//2008.12.01 kimgun

	CDicsDoc* pDoc = ( (CDicsView *) m_pOwner )->GetDocument();
	BOOL bDataExist = FALSE;

	// hskwak 2020/01/03 Clear
	for( int k = 0 ; k < MAX_IF_NO ; k++ )
	{
		m_pDicsData->m_IfCim.sTraceDataValue[k*4+0] = "";
		m_pDicsData->m_IfCim.sTraceDataValue[k*4+1] = "";
		m_pDicsData->m_IfCim.sTraceDataValue[k*4+2] = "";
		m_pDicsData->m_IfCim.sTraceDataValue[k*4+3] = "";
	}

	for( int k = TRACE_START_UNIT * 2 ; k < MAX_IF_NO * 2 ; k++ )
	{
		if( m_pDicsData->m_GlsInfo[k].bIsValid &&
			 nTrId == m_pDicsData->m_GlsInfo[k].nMultiTraceKey )//2008.11.07 kimgun
		{
			bDataExist = TRUE;

			// hskwak 2020/01/03 Set
			m_pDicsData->m_IfCim.sTraceDataValue[(k*4)/2+0] = m_pDicsData->m_GlsInfo[k].sGlassId;
			m_pDicsData->m_IfCim.sTraceDataValue[(k*4)/2+1] = m_pDicsData->m_GlsInfo[k].sRecipeId;
			m_pDicsData->m_IfCim.sTraceDataValue[(k*4)/2+2] = m_pDicsData->m_GlsInfo[k].sLotId;
			m_pDicsData->m_IfCim.sTraceDataValue[(k*4)/2+3].Format( "%d", m_pDicsData->m_GlsInfo[k].nSlotNo );

//			m_pDicsData->m_IfCim.sTraceDataValue[0] = m_pDicsData->m_GlsInfo[k].sLotId;
//			m_pDicsData->m_IfCim.sTraceDataValue[1].Format( "%d", m_pDicsData->m_GlsInfo[k].nSlotNo );
//			m_pDicsData->m_IfCim.sTraceDataValue[2] = m_pDicsData->m_GlsInfo[k].sGlassId;
//			m_pDicsData->m_IfCim.sTraceDataValue[3] = m_pDicsData->m_GlsInfo[k].sRecipeId;
//			m_pDicsData->m_IfCim.sTraceDataValue[4] = m_pDicsData->m_GlsInfo[k].sGlassHeadPos;//2008.11.07 kimgun
//			m_pDicsData->m_IfCim.sTraceDataValue[5] = m_pDicsData->m_GlsInfo[k].sGlassTailPos;//2008.11.07 kimgun


			int nRow = pDoc->GetRowfromID( m_pDicsData->m_GlsInfo[k].sRecipeId );
//			int nRecipeId = atoi( m_pDicsData->m_GlsInfo[k].sRecipeId );

			for( int i=0; i<MAX_TOTAL_RECIPE_BODY_NO - 3; i++ )
			{
// #ifdef _NO_RB //2008.11.07 kimgun 
// 				if( i >= 7) continue;
// #endif
//				m_pDicsData->m_IfCim.sTraceDataValue[i+6] = ((pDoc->m_pRecipeInfo[nRow].sValue[i + 3] == "ON" ) ? "1" : "0" );
//				m_pDicsData->m_IfCim.sTraceDataValue[i+6] = pDoc->m_pRecipeInfo[nRow].sValue[i + 3];
				// 110221 halesu
				m_pDicsData->m_IfCim.sTraceDataValue[i+MAX_IF_NO*4] = ((pDoc->m_pRecipeInfo[nRow].sValue[i + 3] == "ON" ) ? "1" :
																	(pDoc->m_pRecipeInfo[nRow].sValue[i + 3] == "OFF" )? "0" :
																	(pDoc->m_pRecipeInfo[nRow].sValue[i + 3] == "CW" ) ? "1" :
																	(pDoc->m_pRecipeInfo[nRow].sValue[i + 3] == "CCW" )? "0" : pDoc->m_pRecipeInfo[nRow].sValue[i + 3] );
			}
//			break;
		}
	}

/*	// hskwak 2020/01/03 skip
	if( !bDataExist )
		{
			m_pDicsData->m_IfCim.sTraceDataValue[0] = "";
			m_pDicsData->m_IfCim.sTraceDataValue[1] = "";
			m_pDicsData->m_IfCim.sTraceDataValue[2] = "";
			m_pDicsData->m_IfCim.sTraceDataValue[3] = "";
//			m_pDicsData->m_IfCim.sTraceDataValue[4] = "";//2008.11.07 kimgun
//			m_pDicsData->m_IfCim.sTraceDataValue[5] = "";//2008.11.07 kimgun
			int nRecipeId = 1;//atoi( m_pDicsData->m_GlsInfo[k].sRecipeId );

			for( int i=0; i<MAX_TOTAL_RECIPE_BODY_NO - 3; i++ )
			{
				CDicsDoc* pDoc = ( (CDicsView *) m_pOwner )->GetDocument();
//				m_pDicsData->m_IfCim.sTraceDataValue[i+6] = ((pDoc->m_pRecipeInfo[nRecipeId - 1].sValue[i + 3] == "ON" ) ? "1" : "0" );
//				m_pDicsData->m_IfCim.sTraceDataValue[i+6] = pDoc->m_pRecipeInfo[nRecipeId - 1].sValue[i + 3];
				// 110221 halesu
				m_pDicsData->m_IfCim.sTraceDataValue[i+4] = ((pDoc->m_pRecipeInfo[nRecipeId - 1].sValue[i + 3] == "ON" ) ? "1" : 
															 (pDoc->m_pRecipeInfo[nRecipeId - 1].sValue[i + 3] == "OFF" )? "0" :
															 (pDoc->m_pRecipeInfo[nRecipeId - 1].sValue[i + 3] == "CW" ) ? "1" :
															 (pDoc->m_pRecipeInfo[nRecipeId - 1].sValue[i + 3] == "CCW" )? "0" : pDoc->m_pRecipeInfo[nRecipeId - 1].sValue[i + 3] );
// #ifdef _NO_RB
// 				for( int i=7; i<MAX_TOTAL_RECIPE_BODY_NO - 3; i++ )
// 				{
// 					m_pDicsData->m_IfCim.sTraceDataValue[i+6] = "";
// 				}
// #endif
			}
		}
*/
	UINT uTraceCount = m_pDicsData->m_TraceData[ nTrId  ].uTraceIdCount;
	UINT uTraceId = m_pDicsData->m_TraceData[ nTrId  ].uTraceId;

	int nGroupSize = m_pDicsData->m_TraceData[ /*uTraceCount*/nTrId ].uGroupSize;
	
	
	pTranx->Primary.SetListSize( 1, nGroupSize, 5 );

	CString sBuf;

	for( int j = 0 ; j < nGroupSize ; j ++ )
	{
		pTranx->Primary.SetListSize( j + 2, m_pDicsData->m_TraceData[/*uTraceId -1*//*uTraceCount*/nTrId ].nS2F23ListSize, MAX_TRACE_DATA_NO/*33*/ );

		for( int i = 0 ; i < MAX_TRACE_DATA_NO ; i ++ )
		{
			if( m_pDicsData->m_TraceData[nTrId ].nTraceList[i] != -1 )
			{
				sBuf.Format( "SV%d_%d",j + 1, i + 1 );
	//			sString.Format( "%8.3f", m_pDevice->GetCalAI( m_pAI1->m_aiSet[m_pDicsData->m_IfCim.nTraceList[i]].nReal ) );
	//			pTranx->Primary.SetItemData( (LPCTSTR)sBuf, sString );
				pTranx->Primary.SetItemData( (LPCTSTR)sBuf, m_pDicsData->m_IfCim.sTraceDataValue[m_pDicsData->m_TraceData[nTrId ].nTraceList[i]-1] );
			}
	/*		else
			{
				sBuf.Format( "SV%d", i + 1 );
				sString.Format( "              " );
				pTranx->Primary.SetItemData( (LPCTSTR)sBuf, sString );
			}*/
		}
	}
/*
	SYSTEMTIME SystemTime;
	GetLocalTime(&SystemTime);
	CString sDateTime1;
	sDateTime1.Format("%04d%02d%02d%02d%02d%02d.%02d",
		SystemTime.wYear, 
		SystemTime.wMonth, 
		SystemTime.wDay, 
		SystemTime.wHour, 
		SystemTime.wMinute, 
		SystemTime.wSecond, 
		SystemTime.wMilliseconds );

	pTranx->Primary.SetItemData( "DATETIME", sDateTime1 );
*/
	return pTranx->PrimaryOut();
}

//---------------------------------------------------------------------------
// Primary : ECS <=== HDC : TRACE Data Report
//---------------------------------------------------------------------------
int CHost1::S6F11( int i , BOOL bDelete )
{
//	return -1;
	if( !m_bConnected ) return -1;//0;

	XSecsTranxThread1* pTranx = Transaction( "S6F11" );
	if( pTranx == NULL ) return -1;

	CString sLotId = "";
	CString sSlotNo = "";
	CString sPortNo = "";
	CString sGlassId = "";
	CString sRcpId = "";

	if( m_pDicsData->uDataId > 999 ) m_pDicsData->uDataId = 0;
	m_pDicsData->uDataId++;

	pTranx->Primary.SetItemData( "DATAID", m_pDicsData->uDataId );
	pTranx->Primary.SetItemData( "RPTID", m_pDicsData->uRptId );
	
//	if( bDelete ) m_pDicsData->uCeid = 204;//2008.11.07 kimgun
//	else m_pDicsData->uCeid = i+196;	//2008.11.07 kimgun
	if( bDelete ) m_pDicsData->uCeid = 215;	// hskwak 2020/01/03 
	else m_pDicsData->uCeid = i+200;		// hskwak 2020/01/03 
	//******************** 150901 halesu
	// BUF3 : 200
	// SWR1 : 201
	// SWR2 : 202
	// AK	: 203
	// UL	: 204
	//*********************
	pTranx->Primary.SetItemData( "CEID", m_pDicsData->uCeid );

	/////////////////////// 110128 halesu ///////////////////////
	SYSTEMTIME SystemTime;
	GetLocalTime(&SystemTime);
	CString sDateTime1;
	sDateTime1.Format("%04d%02d%02d%02d%02d%02d.%02d",
		SystemTime.wYear, 
		SystemTime.wMonth, 
		SystemTime.wDay, 
		SystemTime.wHour, 
		SystemTime.wMinute, 
		SystemTime.wSecond, 
		SystemTime.wMilliseconds );

//	pTranx->Primary.SetItemData( "DATETIME", sDateTime1 );
	////////////////////////////////////////////////////////////
	
	CDicsDoc* pDoc = ( (CDicsView *) m_pOwner )->GetDocument();
	
	// hskwak 2020/01/03 
/*	if( !bDelete )
	{
		if( m_pDicsData->uCeid == 200 ) i = i * 2;//2008.11.07 kimgun
		else if( m_pDicsData->uCeid >= 204 ) i = i * 2 + 1;//2008.11.07 kimgun
	}
*/
//	if( !bDelete )
//	{
//		if( (int)(m_pDicsData->uCeid/2) == 0 )	i = i * 2;
//		else									i = i * 2 + 1;
//	}
	// hskwak 200407 add
	if( m_pDicsData->m_GlsInfo[i].bIsValid )
	{
		sLotId = m_pDicsData->m_GlsInfo[i].sLotId;
		sSlotNo.Format( "%d", m_pDicsData->m_GlsInfo[i].nSlotNo );
		sGlassId = m_pDicsData->m_GlsInfo[i].sGlassId;
		sRcpId = m_pDicsData->m_GlsInfo[i].sRecipeId;
		sPortNo.Format( "%d", m_pDicsData->m_GlsInfo[i].nPortNo );

		pTranx->Primary.SetItemData( "LOT_ID", sLotId );
		pTranx->Primary.SetItemData( "SLOT_NO", sSlotNo );
		pTranx->Primary.SetItemData( "GLASS_ID", sGlassId );
		pTranx->Primary.SetItemData( "RECIPE_ID", sRcpId );
	}
	else	// hskwak 200407 add
	{
		sLotId = m_pDicsData->m_GlsInfo[i].sLotId;
		sSlotNo.Format( "%d", m_pDicsData->m_GlsInfo[i].nSlotNo );
		sGlassId = m_pDicsData->m_GlsInfo[i].sGlassId;
		sRcpId = m_pDicsData->m_GlsInfo[i].sRecipeId;

		pTranx->Primary.SetItemData( "LOT_ID", sLotId );
		pTranx->Primary.SetItemData( "SLOT_NO", sSlotNo );
		pTranx->Primary.SetItemData( "GLASS_ID", sGlassId );
		pTranx->Primary.SetItemData( "RECIPE_ID", sRcpId );
	}
	return pTranx->PrimaryOut(); 
}

//---------------------------------------------------------------------------
// Primary : ECS <=== HDC : Lot Process Data Request
//---------------------------------------------------------------------------
int CHost1::S10F1(CString sText)
{
	if( !m_bConnected ) return -1;//0;

	XSecsTranxThread1* pTranx = Transaction("S10F1");
	if( pTranx == NULL ) return -1;

	pTranx->Primary.SetItemData( "TID", 0 );
	pTranx->Primary.SetItemData( "TEXT", sText );
	return pTranx->PrimaryOut();
}

int CHost1::S9F13(CString sMEXP, CString sEDID)
{
	if( !m_bConnected ) return -1;

	XSecsTranxThread1* pTranx = Transaction("S9F13");
	if( pTranx == NULL ) return -1;

	pTranx->Primary.SetItemData( "MEXP", sMEXP );
	pTranx->Primary.SetItemData( "EDID", sEDID );
	return pTranx->PrimaryOut();
}