///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
#ifndef _PIDCONTROL_H_
#define _PIDCONTROL_H_

class CPIDControl
{
public:
	int m_iDeltaT;
	int m_iDeltaTf;

	double m_dPrevX;

	double m_dKp;
	double m_dKd;
	double m_dKi;
	double m_dXSum;
	double m_dDelta;
	double m_dKpFactor;
	double m_dKdFactor;
	double m_dKiFactor;
	double m_dDigitalFiltarK;
	double m_dVelSum;
	int m_iVelCount;
	double m_dVelAvg;
	double m_PreviousdFinalX;

public:
	CPIDControl();
	double PIDCalc(double dX,double dFinalX);
	void SetCoefficients(double dKp, double dKd, double dKi);
};

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
#endif
