// DicsCimSeq.cpp: implementation of the CDicsCimSeq class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Dics.h"
#include "DicsCimSeq.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDicsCimSeq::CDicsCimSeq()
{

}

CDicsCimSeq::~CDicsCimSeq()
{

}

void CDicsCimSeq::SetOwnerPointer(CWnd* pWnd)
{
	SetTimer( (( CDicsView* )pWnd)->m_pTimer );
	SetData( (( CDicsView* )pWnd)->m_pDicsData );
	SetEqpStateSequence( (( CDicsView* )pWnd)->m_pEqpStateSeq );
	SetSetupItems( (( CDicsView* )pWnd)->GetDocument()->m_pSetupItems );
	SetMelsec( (( CDicsView* )pWnd)->m_pMelsec );
	SetDevice( (( CDicsView* )pWnd)->m_pDevice );
#ifdef _CIM_SKIP
	SetFileMap( ((CDicsView*)pWnd)->m_pFileMap );
#endif
	SetEqpAssy( ((CDicsView*)pWnd)->m_pEqpAssy );
}

BOOL CDicsCimSeq::Initialize()
{
	return TRUE;
}

BOOL CDicsCimSeq::Sequence()
{
	Sleep( 100 );

	return TRUE;
}

void CDicsCimSeq::InitParameter()
{

}


//---------------------------------------------------------------------------
// Set the Log
//---------------------------------------------------------------------------
void CDicsCimSeq::SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage )
{
	// Log
	CString sLog("");
	CString sPortNo;
	if( nPortNo <= 0 ) sPortNo = "";
	else sPortNo.Format( "%d", nPortNo );

	CString sSlotNo;
	if( nSlotNo <= 0 ) sSlotNo = "";
	else sSlotNo.Format( "%d", nSlotNo );

	sLog.Format( "CIM     \t%s\t%s\t%s\t%s", sSeqName, sPortNo, sSlotNo, sMessage );
	Log.TextOut( sLog );
	if( m_pDicsData->m_GenInfo.bEnableCommLog )//2008.12.17 KIMGUN
	{
	sLog.Format( "%s : %s", sSeqName, sMessage );
	Msg( WM_HOST_LOG, 0, (LPARAM)(LPCTSTR) sLog );
	}
}

