// DicsInterfaceSeq.cpp: implementation of the CDicsInterfaceSeq class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "DicsInterfaceSeq.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDicsInterfaceSeq::CDicsInterfaceSeq()
{

}

CDicsInterfaceSeq::~CDicsInterfaceSeq()
{

}


void CDicsInterfaceSeq::SetOwnerPointer(CWnd* pWnd)
{
	SetDicsView( ( CDicsView* )pWnd );
	SetSeqTimer( m_pDicsView->m_pTimer );
	SetDevice( m_pDicsView->m_pDevice );
	SetMelsec( m_pDicsView->m_pMelsec );
	SetSetupItems( m_pDicsView->GetDocument()->m_pSetupItems );
	SetData( m_pDicsView->m_pDicsData );
	SetMmc( m_pDicsView->m_pMmc );
	SetEqpStateSequence( m_pDicsView->m_pEqpStateSeq );
	SetEqpAssy( m_pDicsView->m_pEqpAssy );
#ifdef _CIM_SKIP
	SetFileMap( m_pDicsView->m_pFileMap );
#endif
}

void CDicsInterfaceSeq::InitParameter()
{
}

BOOL CDicsInterfaceSeq::Initialize()
{
	return TRUE;
}

BOOL CDicsInterfaceSeq::Sequence()
{
	return TRUE;
}

void CDicsInterfaceSeq::SetLog(CString sSeqName, int nPortNo, int nSlotNo, CString sMessage)
{
	// Log
	CString sLog("");
	CString sPortNo;
	if( nPortNo <= 0 ) sPortNo = "";
	else sPortNo.Format( "%d", nPortNo );

	CString sSlotNo;
	if( nSlotNo <= 0 ) sSlotNo = "";
	else sSlotNo.Format( "%d", nSlotNo );

	sLog.Format( "IF      \t%s\t%s\t%s\t%s", sSeqName, sPortNo, sSlotNo, sMessage );
	Log.TextOut( sLog );

	if( m_pDicsData->m_GenInfo.bEnableCommLog )
	{
		sLog.Format( "%s : %s", sSeqName, sMessage );
		Msg( WM_HOST_LOG, 0, (LPARAM)(LPCTSTR) sLog );
	}
}

