// EuvSeq.cpp: implementation of the CEuvSeq class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "EuvSeq.h"

#include "..\Dics.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CEuvSeq::CEuvSeq()
{

}

CEuvSeq::~CEuvSeq()
{

}

BOOL CEuvSeq::Initialize()
{
	CUshioEuvSeq::Initialize();
	
	InitParameter();
	
	return TRUE;
}

void CEuvSeq::InitParameter()
{
	CUshioEuvSeq::InitParameter();
	m_nSeqEuvTestNo = 0;
	m_bEuvTestStartReq = FALSE;
	m_bEuvTestCancelReq = FALSE;
}

BOOL CEuvSeq::Sequence()
{
#ifndef _NO_EUV
	Sleep( 10 );
	CUshioEuvSeq::Sequence();
#endif

	return TRUE;
}

BOOL CEuvSeq::IsEuvUse()
{
	BOOL bUse = TRUE;

//	bUse &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupJOB_MODE];
	bUse &= m_pDicsData->m_JobCond.bJobProcessUse;
	bUse &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupUSE_EUV];

	BOOL bLampSelect = FALSE;
	for( int i=0; i<MAX_LAMP_CONTROL_NO; i++ )
	{
		bLampSelect |= m_pDicsData->m_JobCond.bEuvUse[i];
	}

	bUse &= bLampSelect;

	return bUse;
}