// PumpSeq.cpp: implementation of the CPumpSeq class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"	// halesu
#include "PumpSeq.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPumpSeq::CPumpSeq()
{

}

CPumpSeq::~CPumpSeq()
{

}

void CPumpSeq::InitParameter()
{
	CDicsPumpSeq::InitParameter();
	m_fDebugTankLevel = 0.;

	// hskwak ִ°͸ Ȯ
	m_nSeqGearSupplyNo = 0;
	m_nSeqMistShowerNo = 0;
	m_nSeqFrShowerNo = 0;
	m_nSeqSbjDiShowerNo = 0;	
	m_nSeqSWR1BathdrainNTankReturnNo = 0;
	m_nSeqAirKnifeNo = 0;
	m_nSeqInitNo = 0;	// 231220 halesu

	for(int i=0; i<MAX_DI_TANK_NO; i++ )
	{
		m_nSeqPumpOutValveNo[i] = 0;
		m_nSeqRbDirectValveNo[i] = 0;
	}
}

BOOL CPumpSeq::Initialize()
{
	InitParameter();

////////////////////////////////////////////////////////////////////
// Must be Init Address : for pump Interlock flow 
// 	m_nInterlockFlowMeterID[0] = noRB_UNIT_UP_SWR_FLOW;
////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////
// Must be Init Address : for Tank Level Simulation
#ifdef _MY_DEBUG
//	m_nTankLevelStartAddress[0] = DI_NODE2+35;
#endif
////////////////////////////////////////////////////////////////////
	return TRUE;
}

BOOL CPumpSeq::Sequence()
{
	Sleep( 100 );

	int i, j;

	SeqInit();
	SeqModeChange();
	SeqGlassExist();
	SeqAirKnife();		// Auto Mode ϶ ׻ Valve ش. Manual  AK CV  Ǹ Valve  .
	SeqFrShower();		// SWR4 FR  Sequence.
	SeqSbjDiShower();	// sWR1 Sbj  Sequence.
	SeqCleaningModeCtrl();	// Cleaning Mode ϰ .
	SeqSWR1BathDrainNTankReturn();

	for( i=0; i<MAX_DI_TANK_NO; i++ )
	{
		SeqPumpOutValve( i );		// Pump  - Pump    /̻.
#ifdef _BUFTANK_USE
		if( i < NO_BUFTANK ) SeqRbDirectValve( i );		//  . SWR2, SWR3 - Pump    /̻.
#else
		SeqRbDirectValve( i );		//  . SWR2, SWR3 - Pump    /̻.
#endif
	}
	for( i=0; i<MAX_DI_TANK_NO; i++ )
	{
		SeqDiPumpInterlock( i );
		SeqDiTank( i );
#ifdef _BUFTANK_USE
		SeqDiPumpWithBufTank( i );
#else 
		SeqDiPump( i );
#endif
		for( j=0; j<lvMAX; j++ )
		{
			SeqLevelSensor( i, j);
		}
	}
	for ( i=0; i<MAX_SBJ_NO; i++ )
	{	
		SeqSbj( i );
	}

	SeqDiwIdleRunning();



	for( i=0; i<MAX_IONIZER_NO; i++ )
	{
		SeqIonizer( i );
	}

	return TRUE;
}

/*
void CPumpSeq::SeqGearSupply()
{
	int nSeqNo = m_nSeqGearSupplyNo;
	
	BOOL bUse = ( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupGEAR_SUPPLY_USE] == 1 );

	switch( nSeqNo )
	{
	case 0 :
		if( m_pDicsData->m_GenInfo.bAuto )
		{
			if( bUse && !dosFR_UNIT_GEAR_SUPPLY_IN_VALVE )		doFR_UNIT_GEAR_SUPPLY_IN_VALVE( ON );
			else if( !bUse && dosFR_UNIT_GEAR_SUPPLY_IN_VALVE ) doFR_UNIT_GEAR_SUPPLY_IN_VALVE( OFF );
		}
	}
	m_nSeqGearSupplyNo = nSeqNo;
}
*/

void CPumpSeq::SeqAirKnife()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	static DWORD dwTickStart = 0;
	int nSeqNo = m_nSeqAirKnifeNo;
	BOOL bCVAK1FW =  m_pEqpAssy->m_CvMotorAll.GetMotorFwState( CV_MOTOR_NO_AK1 );
	BOOL bCVAK2FW =  m_pEqpAssy->m_CvMotorAll.GetMotorFwState( CV_MOTOR_NO_AK2 );
	BOOL bSensorAKIn = m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_AK, 0 );
	BOOL bSensorAKOut = m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_AK, 1 );

	static int nOldAKStatus = 0;
	static DWORD dwTickStop = 0;

	switch( nSeqNo )
	{
	case 0 :
		{
			dwTickStart = GetTickCount();
			nSeqNo = 10;
		}
		break;
	case 10 :
		if( GetTickCount() - dwTickStart > 1000 )
		{
			nSeqNo = 20;
		}
		break;
	case 20 :
		if( m_pDicsData->m_GenInfo.bAuto )
		{
			if( m_pDicsData->m_GenInfo.bEmo )
			{
				m_pEqpAssy->m_AutoValveAkUp.Set( 0, OFF );
				m_pEqpAssy->m_AutoValveAkLo.Set( 0, OFF );
				nOldAKStatus = 0;
			}
/*			else if( ( bSensorAKIn || bSensorAKOut ) && ( !bCVAK1FW && !bCVAK2FW ) )	// 191002 hskwak
			{
				if( nOldAKStatus == 0 )
				{
					dwTickStop = GetTickCount();
					nOldAKStatus = 1;
				}

				if( nOldAKStatus == 1 && (GetTickCount() - dwTickStop) > 2000)
				{
					if( m_pEqpAssy->m_AutoValveAkUp.GetState() ) 
					{
						m_pEqpAssy->m_AutoValveAkUp.Set( 0, OFF );					
					}
					if( m_pEqpAssy->m_AutoValveAkLo.GetState() ) 
					{
						m_pEqpAssy->m_AutoValveAkLo.Set( 0, OFF );					
					}
				}
			}
*/			else if( !m_pDicsData->m_GenInfo.bIdleRunning || m_pDicsData->m_IfPump.bDiStart )	// 150914 halesu
			{
				if( !m_pEqpAssy->m_AutoValveAkUp.GetState() )
				{
					m_pEqpAssy->m_AutoValveAkUp.Set( 0, ON );
				}
				if( !m_pEqpAssy->m_AutoValveAkLo.GetState() )
				{
					m_pEqpAssy->m_AutoValveAkLo.Set( 0, ON );
				}

				nOldAKStatus = 0;
			}
			else
			{
				m_pEqpAssy->m_AutoValveAkUp.Set( 0, OFF );
				m_pEqpAssy->m_AutoValveAkLo.Set( 0, OFF );
				nOldAKStatus = 0;
			}	
		}
		else
		{
			if ( m_pDicsData->m_GenInfo.bEmo )
			{
				m_pEqpAssy->m_AutoValveAkUp.Set( 0, OFF );
				m_pEqpAssy->m_AutoValveAkLo.Set( 0, OFF );
			}
			else if( ( m_pEqpAssy->m_CvMotorAll.GetMotorFwState( CV_MOTOR_NO_AK1 ) || m_pEqpAssy->m_CvMotorAll.GetMotorFwState( CV_MOTOR_NO_AK2 ) ) && 
				( !m_pEqpAssy->m_AutoValveAkUp.GetState() || !m_pEqpAssy->m_AutoValveAkLo.GetState() ) )
			{
				if( !m_pEqpAssy->m_AutoValveAkUp.GetState() ) 
				{
			    	m_pEqpAssy->m_AutoValveAkUp.Set( 0, ON );					
				}
				if( !m_pEqpAssy->m_AutoValveAkLo.GetState() ) 
				{
					m_pEqpAssy->m_AutoValveAkLo.Set( 0, ON );					
				}
			}	
			nOldAKStatus = 0;
		}
		break;
	}
	m_nSeqAirKnifeNo = nSeqNo;
}

void CPumpSeq::SeqDiPump( int nPumpNo )
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	m_sSeqName.Format( "SeqDiPump%d", nPumpNo+1 );

	static BOOL bInit[MAX_DI_TANK_NO] = {FALSE, };
	static DWORD dwStartTick[MAX_DI_TANK_NO] = {GetTickCount(), GetTickCount()};

	if( !bInit[nPumpNo] )
	{
		if( GetTickCount() - dwStartTick[nPumpNo] > 1000 )	bInit[nPumpNo] = TRUE;
		if( !bInit[nPumpNo] ) return;
	}

	int nSeqNo = m_nSeqDiPumpNo[nPumpNo];
	static int nReturnSeqNo[MAX_DI_TANK_NO];
	static int nAlarmId[MAX_DI_TANK_NO] = { 0, };

#ifdef _MY_DEBUG
	static float fCount[MAX_DI_TANK_NO] = {0.0, };
#endif

////////////////////////////////////////////////////////////////////////////////
// manual ¿ Pump, Valve Control ϱ ؼ Ʒ Flag ʿϴ.
	static BOOL bDiStop[MAX_DI_TANK_NO] = { TRUE, };
	static BOOL bAqkStop = TRUE;
////////////////////////////////////////////////////////////////////////////////

	if( !m_pEqpAssy->m_AutoValvePumpOut.GetState( nPumpNo ) )
	{
		if( m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState() )
		{
			m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn(0, OFF);
			if(nPumpNo == 0)
			{
				m_pEqpAssy->m_AutoValueSWR2TankReturn.Set(0, OFF);
			}
			
		}
	}

	BOOL bPumpUse = ( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE + nPumpNo] == 1 );

	BOOL bRunCond = TRUE;
	bRunCond &= !m_pDicsData->m_GenInfo.bEmo;
	bRunCond &= !m_pDicsData->m_GenInfo.bLeakSensor;
	bRunCond &= !m_pDicsData->m_GenInfo.bCoverOpen;
	bRunCond &= !m_pDicsData->m_GenInfo.bDoorOpen;
	bRunCond &= !( m_pDicsData->m_GenInfo.bSbjStop && m_pDicsData->m_GenInfo.bAuto );//2008.08.28 KIMGUN alarm ߻  pump Բ..
	bRunCond &= !( m_pDicsData->m_GenInfo.bPause && m_pDicsData->m_GenInfo.bAuto );
	bRunCond &= ( m_pDicsData->m_JobCond.bJobProcessUse == 1 );
	bRunCond &= !m_SeqFlag.bDiTankLevel[nPumpNo][lvHH];
//	bRunCond &= !m_pDicsData->m_GenInfo.bUlTimeOut;			// Thomas 201208, comment
	bRunCond &= !m_pDicsData->m_GenInfo.bUlNotReady;

#ifdef _BUFTANK_USE
	if( nPumpNo < NO_BUFTANK)
		bRunCond &= m_pEqpAssy->m_AutoValvePumpOut.GetState(nPumpNo);
	else
		bRunCond &= m_pEqpAssy->m_AutoValvePumpOut.GetState(nPumpNo) || m_pEqpAssy->m_AutoValvePumpOut.GetState(nPumpNo+1);
#else
	bRunCond &= m_pEqpAssy->m_AutoValvePumpOut.GetState(nPumpNo);
#endif

	BOOL bPumpRun = bRunCond; 
	bPumpRun &=	m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE+nPumpNo];
	bPumpRun &=	!m_pEqpAssy->m_DiTank[nPumpNo].GetPumpAlarm(); 
	bPumpRun &=	m_SeqFlag.bDiTankReady[nPumpNo];
	bPumpRun &=	(m_pDicsData->m_IfPump.bDiStart || m_pDicsData->m_IfPump.bCleaningStart);
	bPumpRun &= !m_SeqFlag.bInsufficientDiFlowrate[nPumpNo];
	bPumpRun &= m_SeqFlag.bDiTankLevel[nPumpNo][lvM];
	bPumpRun &= m_SeqFlag.bDiTankLevel[nPumpNo][lvL];

	// Thomas 201208, Check pump stop condition for unloading timeout
	DWORD		dwPumpOffDelayTime = atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupUL_TIMEOUT_PUMP_OFF_DELAY] );;
	static BOOL	bPumpOffDelay = FALSE;

	if( !bPumpOffDelay && m_pDicsData->m_GenInfo.bUlTimeOut )
	{
		dwStartTick[0] = GetTickCount();
		bPumpOffDelay = TRUE;
	}
	else if( !m_pDicsData->m_GenInfo.bUlTimeOut )
	{
		bPumpOffDelay = FALSE;
	}

	if( ( GetTickCount() - dwStartTick[0] > dwPumpOffDelayTime * 1000 ) && bPumpOffDelay )
	{
		bPumpRun = FALSE;
	}

	BOOL bSkipCond = !m_pDicsData->m_GenInfo.bAuto;
	switch( nSeqNo )
	{
	case 0:
		if( bPumpRun && m_pDicsData->m_GenInfo.bMjCdaReady[0] && m_pDicsData->m_GenInfo.bMjCdaReady[1] )
		{
			bDiStop[nPumpNo] = FALSE;
			if( !m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState() )
			{
				m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn(0, ON);
				SetLog( m_sSeqName, -1, -1, "DI PUMP MOTOR : RUN" );
			}
			nSeqNo = 10;
		}
		else if( m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState() )
		{
			BOOL bPumpManualRunCond = TRUE;
			bPumpManualRunCond &= !m_pEqpAssy->m_DiTank[nPumpNo].GetPumpAlarm(); 
			bPumpManualRunCond &= bPumpUse;
			bPumpManualRunCond &= !m_SeqFlag.bInsufficientDiFlowrate[nPumpNo];
			bPumpManualRunCond &= m_SeqFlag.bDiTankLevel[nPumpNo][lvM];
			bPumpManualRunCond &= m_SeqFlag.bDiTankLevel[nPumpNo][lvL];
			if( !bPumpManualRunCond )
			{
				m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn(0, OFF);
				SetLog( m_sSeqName, -1, -1, "DI PUMP MOTOR NOT CONDITION : STOP" );
			}
		}
		else if ( m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState() && !m_SeqFlag.bDiTankLevel[nPumpNo][lvL] )	// SanghoCho 2015.05.20
		{
			m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn( 0, OFF );
			nAlarmId[nPumpNo] = ALM_DI_TANK1_LV_SENSOR_ALARM5 + nPumpNo;
			m_pEqpStateSeq->SetAlarm( nAlarmId[nPumpNo] );
			
			SetLog( m_sSeqName, -1, -1, "DI PUMP NOT CONDITION : NOT TANK LL LEVEL" );
			nReturnSeqNo[nPumpNo] = nSeqNo;
			nSeqNo = 2000;			
		}
		else if ( /*bPumpUse &&*/ m_SeqFlag.bDiTankLevel[nPumpNo][lvHH] )	// SanghoCho 2015.05.20
		{
			if ( m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState() )
			{
				m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn( 0, OFF );
			}
			
			nAlarmId[nPumpNo] = ALM_DI_TANK1_LV_SENSOR_ALARM6 + nPumpNo;
			m_pEqpStateSeq->SetAlarm( nAlarmId[nPumpNo] );
			
			SetLog( m_sSeqName, -1, -1, "DI PUMP NOT CONDITION : TANK HH LEVEL" );
			nReturnSeqNo[nPumpNo] = nSeqNo;
			nSeqNo = 2000;
		}
		break;
	case 10:
		if( !bPumpRun )
		{
			if( !bRunCond || m_pDicsData->m_GenInfo.bAuto || !bDiStop[nPumpNo] )
			{
				bDiStop[nPumpNo] = TRUE;
			
				if( m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState() )
				{
					m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn(0, OFF);
					SetLog( m_sSeqName, -1, -1, "DI PUMP MOTOR : STOP" );
				}
			}
			nSeqNo = 0;
		}
		if( bPumpUse && m_pEqpAssy->m_DiTank[nPumpNo].GetPumpAlarm() )
		{
			if( m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState() ) 
			{
				m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn(0, OFF);
				SetLog( m_sSeqName, -1, -1, "DI PUMP MOTOR : STOP" );
			}
			
			nAlarmId[nPumpNo] = ALM_DI_PUMP_ALARM1 + nPumpNo;
			m_pEqpStateSeq->SetAlarm( nAlarmId[nPumpNo] );
			SetLog( m_sSeqName, -1, -1, "DI PUMP MOTOR : ALARM" );
			
			nReturnSeqNo[nPumpNo] = nSeqNo;
			nSeqNo = 1000;
			break;
		}
		break;
	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() && !m_pEqpAssy->m_DiTank[nPumpNo].GetPumpAlarm() )
		{
			m_pEqpStateSeq->ResetAlarm( nAlarmId[nPumpNo] );
			nAlarmId[nPumpNo] = 0;
			
			SetLog( m_sSeqName, -1, -1, "ALARM RESET" );
			nSeqNo = nReturnSeqNo[nPumpNo];
		}
		break;
	case 2000:	// TANK LEVEL ALARM
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			m_pEqpStateSeq->ResetAlarm( nAlarmId[nPumpNo] );
			nAlarmId[nPumpNo] = 0;
			
			SetLog( m_sSeqName, -1, -1, "ALARM RESET" );
			nSeqNo = nReturnSeqNo[nPumpNo];
		}
		break;
	}
	m_nSeqDiPumpNo[nPumpNo] = nSeqNo;
}

void CPumpSeq::SeqDiPumpWithBufTank( int nPumpNo )
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	m_sSeqName.Format( "SeqDiPumpwithBufTank%d", nPumpNo+1 );

	static BOOL bInit[MAX_DI_TANK_NO] = {FALSE, };
	static DWORD dwStartTick[MAX_DI_TANK_NO] = {GetTickCount(), GetTickCount()};

	if( !bInit[nPumpNo] )
	{
		if( GetTickCount() - dwStartTick[nPumpNo] > 1000 )	bInit[nPumpNo] = TRUE;
		if( !bInit[nPumpNo] ) return;
	}

	int nSeqNo = m_nSeqDiPumpNo[nPumpNo];
	static int nReturnSeqNo[MAX_DI_TANK_NO];
	static int nAlarmId[MAX_DI_PUMP_NO] = { 0, };

#ifdef _MY_DEBUG
	static float fCount[MAX_DI_TANK_NO] = {0.0, };
#endif

////////////////////////////////////////////////////////////////////////////////
// manual ¿ Pump, Valve Control ϱ ؼ Ʒ Flag ʿϴ.
	static BOOL bDiStop[MAX_DI_TANK_NO] = { TRUE, };
	static BOOL bAqkStop = TRUE;
////////////////////////////////////////////////////////////////////////////////

	if(nPumpNo < NO_BUFTANK)
	{
		if( !m_pEqpAssy->m_AutoValvePumpOut.GetState( nPumpNo ) )
		{
			if( m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState() )
			{
				m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn(0, OFF);
				if(nPumpNo == 0)
				{
					m_pEqpAssy->m_AutoValueSWR2TankReturn.Set(0, OFF);
				}
			}
		}
	}
	else 
	{
		if( !m_pEqpAssy->m_AutoValvePumpOut.GetState( nPumpNo ) &&  !m_pEqpAssy->m_AutoValvePumpOut.GetState( nPumpNo+1 )  )
		{
			if( m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState(0) )
			{
				m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn(0, OFF);
			}
		}
		if( !m_pEqpAssy->m_AutoValvePumpOut.GetState( nPumpNo+2 ) &&  !m_pEqpAssy->m_AutoValvePumpOut.GetState( nPumpNo+3 )  )
		{
			if( m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState(1) )
			{
				m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn(1, OFF);
			}
		}
	}


	BOOL bPumpUse = ( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE + nPumpNo] == 1 );

	BOOL bRunCond = TRUE;
	bRunCond &= !m_pDicsData->m_GenInfo.bEmo;
	bRunCond &= !m_pDicsData->m_GenInfo.bLeakSensor;
	bRunCond &= !m_pDicsData->m_GenInfo.bCoverOpen;
	bRunCond &= !m_pDicsData->m_GenInfo.bDoorOpen;
	bRunCond &= !( m_pDicsData->m_GenInfo.bSbjStop && m_pDicsData->m_GenInfo.bAuto );//2008.08.28 KIMGUN alarm ߻  pump Բ..
	bRunCond &= !( m_pDicsData->m_GenInfo.bPause && m_pDicsData->m_GenInfo.bAuto );
	bRunCond &= ( m_pDicsData->m_JobCond.bJobProcessUse == 1 );
	bRunCond &= !m_SeqFlag.bDiTankLevel[nPumpNo][lvHH];
	bRunCond &= !m_pDicsData->m_GenInfo.bUlTimeOut;
	bRunCond &= !m_pDicsData->m_GenInfo.bUlNotReady;

#ifdef _BUFTANK_USE
	BOOL bBufRunCond1 = bRunCond;
	BOOL bBufRunCond2 = bRunCond;
	if( nPumpNo < NO_BUFTANK)
		bRunCond &= m_pEqpAssy->m_AutoValvePumpOut.GetState(nPumpNo);
	else
	{
		
		bBufRunCond1 = m_pEqpAssy->m_AutoValvePumpOut.GetState(nPumpNo) || m_pEqpAssy->m_AutoValvePumpOut.GetState(nPumpNo+1);		
		bBufRunCond2 = m_pEqpAssy->m_AutoValvePumpOut.GetState(nPumpNo+2) || m_pEqpAssy->m_AutoValvePumpOut.GetState(nPumpNo+3);
	}
#else
	bRunCond &= m_pEqpAssy->m_AutoValvePumpOut.GetState(nPumpNo);
#endif

	BOOL bPumpRun = bRunCond; 
	bPumpRun &=	m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE+nPumpNo];
	bPumpRun &=	!m_pEqpAssy->m_DiTank[nPumpNo].GetPumpAlarm(); 
	bPumpRun &=	m_SeqFlag.bDiTankReady[nPumpNo];
	bPumpRun &=	(m_pDicsData->m_IfPump.bDiStart || m_pDicsData->m_IfPump.bCleaningStart);
	bPumpRun &= !m_SeqFlag.bInsufficientDiFlowrate[nPumpNo];
	bPumpRun &= m_SeqFlag.bDiTankLevel[nPumpNo][lvM];
	bPumpRun &= m_SeqFlag.bDiTankLevel[nPumpNo][lvL];

#ifdef _BUFTANK_USE
	BOOL bBufPumpRun1 = bBufRunCond1;
	BOOL bBufPumpRun2 = bBufRunCond2;
	bBufPumpRun1 &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE+nPumpNo];
	bBufPumpRun1 &=	!m_pEqpAssy->m_DiTank[nPumpNo].GetPumpAlarm(0); 
	bBufPumpRun1 &=	m_SeqFlag.bDiTankReady[nPumpNo];
	bBufPumpRun1 &=	(m_pDicsData->m_IfPump.bDiStart || m_pDicsData->m_IfPump.bCleaningStart);
	bBufPumpRun1 &= !m_SeqFlag.bInsufficientDiFlowrate[nPumpNo];
	bBufPumpRun1 &= m_SeqFlag.bDiTankLevel[nPumpNo][lvM];
	bBufPumpRun1 &= m_SeqFlag.bDiTankLevel[nPumpNo][lvL];

	bBufPumpRun2 &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE+nPumpNo];
	bBufPumpRun2 &=	!m_pEqpAssy->m_DiTank[nPumpNo].GetPumpAlarm(1); 
	bBufPumpRun2 &=	m_SeqFlag.bDiTankReady[nPumpNo];
	bBufPumpRun2 &=	(m_pDicsData->m_IfPump.bDiStart || m_pDicsData->m_IfPump.bCleaningStart);
	bBufPumpRun2 &= !m_SeqFlag.bInsufficientDiFlowrate[nPumpNo];
	bBufPumpRun2 &= m_SeqFlag.bDiTankLevel[nPumpNo][lvM];
	bBufPumpRun2 &= m_SeqFlag.bDiTankLevel[nPumpNo][lvL];

	BOOL bStatus, bStatus2;
#endif

	BOOL bSkipCond = !m_pDicsData->m_GenInfo.bAuto;
	switch( nSeqNo )
	{
	case 0:
#ifdef _BUFTANK_USE
		if(nPumpNo < NO_BUFTANK)
		{
			bStatus = bPumpRun;
			bStatus2 = FALSE;
		}
		else
		{
			bStatus = bBufPumpRun1;
			bStatus2 = bBufPumpRun2;
		}

		if( ( bStatus || bStatus2 ) && m_pDicsData->m_GenInfo.bMjCdaReady[0] && m_pDicsData->m_GenInfo.bMjCdaReady[1] )
		{			
			if( bStatus )
			{
				if( !m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState(0) )
				{
					m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn(0, ON);
					SetLog( m_sSeqName, -1, -1, "DI PUMP MOTOR : RUN" );
				}
			}
			if( bStatus2 )
			{
				if( !m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState(1) )
				{
					m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn(1, ON);
					SetLog( m_sSeqName, -1, -1, "DI PUMP MOTOR : RUN" );
				}
			}
		}
		else if(nPumpNo < NO_BUFTANK && m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState() )
		{
			BOOL bPumpManualRunCond = TRUE;
			bPumpManualRunCond &= !m_pEqpAssy->m_DiTank[nPumpNo].GetPumpAlarm(); 
			bPumpManualRunCond &= bPumpUse;
			bPumpManualRunCond &= !m_SeqFlag.bInsufficientDiFlowrate[nPumpNo];
			bPumpManualRunCond &= m_SeqFlag.bDiTankLevel[nPumpNo][lvM];
			bPumpManualRunCond &= m_SeqFlag.bDiTankLevel[nPumpNo][lvL];
			if( !bPumpManualRunCond )
			{
				m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn(0, OFF);
				SetLog( m_sSeqName, -1, -1, "DI PUMP MOTOR NOT CONDITION : STOP" );
			}
		}
		else if(nPumpNo == NO_BUFTANK && m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState(0) )
		{
			BOOL bPumpManualRunCond = TRUE;
			bPumpManualRunCond &= !m_pEqpAssy->m_DiTank[nPumpNo].GetPumpAlarm(0); 
			bPumpManualRunCond &= bPumpUse;
			bPumpManualRunCond &= !m_SeqFlag.bInsufficientDiFlowrate[nPumpNo];
			bPumpManualRunCond &= m_SeqFlag.bDiTankLevel[nPumpNo][lvM];
			bPumpManualRunCond &= m_SeqFlag.bDiTankLevel[nPumpNo][lvL];
			if( !bPumpManualRunCond )
			{
				m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn(0, OFF);
				SetLog( m_sSeqName, -1, -1, "DI PUMP MOTOR NOT CONDITION : STOP" );
			}
		}
		else if(nPumpNo == NO_BUFTANK && m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState(1) )
		{
			BOOL bPumpManualRunCond = TRUE;
			bPumpManualRunCond &= !m_pEqpAssy->m_DiTank[nPumpNo].GetPumpAlarm(1); 
			bPumpManualRunCond &= bPumpUse;
			bPumpManualRunCond &= !m_SeqFlag.bInsufficientDiFlowrate[nPumpNo];
			bPumpManualRunCond &= m_SeqFlag.bDiTankLevel[nPumpNo][lvM];
			bPumpManualRunCond &= m_SeqFlag.bDiTankLevel[nPumpNo][lvL];
			if( !bPumpManualRunCond )
			{
				m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn(1, OFF);
				SetLog( m_sSeqName, -1, -1, "DI PUMP MOTOR NOT CONDITION : STOP" );
			}
		}
		else if ( nPumpNo < NO_BUFTANK && m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState() && !m_SeqFlag.bDiTankLevel[nPumpNo][lvL] )	// SanghoCho 2015.05.20
		{
			m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn( 0, OFF );
			nAlarmId[nPumpNo] = ALM_DI_TANK1_LV_SENSOR_ALARM5 + nPumpNo;
			m_pEqpStateSeq->SetAlarm( nAlarmId[nPumpNo] );
			
			SetLog( m_sSeqName, -1, -1, "DI PUMP NOT CONDITION : NOT TANK LL LEVEL" );
			nReturnSeqNo[nPumpNo] = nSeqNo;
			nSeqNo = 2000;			
		}
		else if ( nPumpNo == NO_BUFTANK && ( m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState(0) || m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState(1) ) && !m_SeqFlag.bDiTankLevel[nPumpNo][lvL] )	// SanghoCho 2015.05.20
		{
			m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn( 0, OFF );
			m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn( 1, OFF );
			nAlarmId[nPumpNo] = ALM_DI_TANK1_LV_SENSOR_ALARM5 + nPumpNo;
			m_pEqpStateSeq->SetAlarm( nAlarmId[nPumpNo] );
			
			SetLog( m_sSeqName, -1, -1, "DI PUMP NOT CONDITION : NOT TANK LL LEVEL" );
			nReturnSeqNo[nPumpNo] = nSeqNo;
			nSeqNo = 2000;			
		}
		else if ( /*bPumpUse &&*/ m_SeqFlag.bDiTankLevel[nPumpNo][lvHH] )	// SanghoCho 2015.05.20
		{
			if( nPumpNo < NO_BUFTANK )
			{
				if ( m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState() )
				{
					m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn( 0, OFF );
				}
			}
			else
			{
				if ( m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState(0) )
				{
					m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn( 0, OFF );
				}
				if ( m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState(1) )
				{
					m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn( 1, OFF );
				}
			}

			nAlarmId[nPumpNo] = ALM_DI_TANK1_LV_SENSOR_ALARM6 + nPumpNo;
			m_pEqpStateSeq->SetAlarm( nAlarmId[nPumpNo] );
			
			SetLog( m_sSeqName, -1, -1, "DI PUMP NOT CONDITION : TANK HH LEVEL" );
			nReturnSeqNo[nPumpNo] = nSeqNo;
			nSeqNo = 2000;
		}
#else
		if( bPumpRun && m_pDicsData->m_GenInfo.bMjCdaReady[0] && m_pDicsData->m_GenInfo.bMjCdaReady[1] )
		{
			bDiStop[nPumpNo] = FALSE;
			if( !m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState() )
			{
				m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn(0, ON);
				SetLog( m_sSeqName, -1, -1, "DI PUMP MOTOR : RUN" );
			}
			nSeqNo = 10;
		}
		else if( m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState() )
		{
			BOOL bPumpManualRunCond = TRUE;
			bPumpManualRunCond &= !m_pEqpAssy->m_DiTank[nPumpNo].GetPumpAlarm(); 
			bPumpManualRunCond &= bPumpUse;
			bPumpManualRunCond &= !m_SeqFlag.bInsufficientDiFlowrate[nPumpNo];
			bPumpManualRunCond &= m_SeqFlag.bDiTankLevel[nPumpNo][lvM];
			bPumpManualRunCond &= m_SeqFlag.bDiTankLevel[nPumpNo][lvL];
			if( !bPumpManualRunCond )
			{
				m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn(0, OFF);
				SetLog( m_sSeqName, -1, -1, "DI PUMP MOTOR NOT CONDITION : STOP" );
			}
		}
		else if ( m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState() && !m_SeqFlag.bDiTankLevel[nPumpNo][lvL] )	// SanghoCho 2015.05.20
		{
			m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn( 0, OFF );
			nAlarmId[nPumpNo] = ALM_DI_TANK1_LV_SENSOR_ALARM5 + nPumpNo;
			m_pEqpStateSeq->SetAlarm( nAlarmId[nPumpNo] );
			
			SetLog( m_sSeqName, -1, -1, "DI PUMP NOT CONDITION : NOT TANK LL LEVEL" );
			nReturnSeqNo[nPumpNo] = nSeqNo;
			nSeqNo = 2000;			
		}
		else if ( /*bPumpUse &&*/ m_SeqFlag.bDiTankLevel[nPumpNo][lvHH] )	// SanghoCho 2015.05.20
		{
			if ( m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState() )
			{
				m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn( 0, OFF );
			}
			
			nAlarmId[nPumpNo] = ALM_DI_TANK1_LV_SENSOR_ALARM6 + nPumpNo;
			m_pEqpStateSeq->SetAlarm( nAlarmId[nPumpNo] );
			
			SetLog( m_sSeqName, -1, -1, "DI PUMP NOT CONDITION : TANK HH LEVEL" );
			nReturnSeqNo[nPumpNo] = nSeqNo;
			nSeqNo = 2000;
		}
#endif
		break;
	case 10:
#ifdef _BUFTANK_USE
		if(nPumpNo < NO_BUFTANK && !bPumpRun )
		{
			if( !bRunCond || m_pDicsData->m_GenInfo.bAuto || !bDiStop[nPumpNo] )
			{
				bDiStop[nPumpNo] = TRUE;
			
				if( m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState() )
				{
					m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn(0, OFF);
					SetLog( m_sSeqName, -1, -1, "DI PUMP MOTOR : STOP" );
				}
			}
			nSeqNo = 0;
		}

		if(nPumpNo == NO_BUFTANK && !bPumpRun )
		{
			if( !bRunCond || m_pDicsData->m_GenInfo.bAuto || !bDiStop[nPumpNo] )
			{
				bDiStop[nPumpNo] = TRUE;
			
				if( m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState() )
				{
					m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn(0, OFF);
					SetLog( m_sSeqName, -1, -1, "DI PUMP MOTOR : STOP" );
				}
			}
			nSeqNo = 0;
		}

		if( nPumpNo < NO_BUFTANK && bBufPumpRun1 && m_pEqpAssy->m_DiTank[nPumpNo].GetPumpAlarm(0) )
		{
			if( m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState(0) ) 
			{
				m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn(0, OFF);
				SetLog( m_sSeqName, -1, -1, "DI PUMP MOTOR : STOP" );
			}
			
			nAlarmId[nPumpNo] = ALM_DI_PUMP_ALARM1 + nPumpNo;
			m_pEqpStateSeq->SetAlarm( nAlarmId[nPumpNo] );
			SetLog( m_sSeqName, -1, -1, "DI PUMP MOTOR : ALARM" );
			
			nReturnSeqNo[nPumpNo] = nSeqNo;
			nSeqNo = 1000;
			break;
		}
		if( nPumpNo < NO_BUFTANK && bBufPumpRun2 && m_pEqpAssy->m_DiTank[nPumpNo].GetPumpAlarm(1) )
		{
			if( m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState(1) ) 
			{
				m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn(1, OFF);
				SetLog( m_sSeqName, -1, -1, "DI PUMP MOTOR : STOP" );
			}
			
			nAlarmId[nPumpNo] = ALM_DI_PUMP_ALARM1 + nPumpNo;
			m_pEqpStateSeq->SetAlarm( nAlarmId[nPumpNo] );
			SetLog( m_sSeqName, -1, -1, "DI PUMP MOTOR : ALARM" );
			
			nReturnSeqNo[nPumpNo] = nSeqNo;
			nSeqNo = 1000;
			break;
		}
#else
		if( !bPumpRun )
		{
			if( !bRunCond || m_pDicsData->m_GenInfo.bAuto || !bDiStop[nPumpNo] )
			{
				bDiStop[nPumpNo] = TRUE;
			
				if( m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState() )
				{
					m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn(0, OFF);
					SetLog( m_sSeqName, -1, -1, "DI PUMP MOTOR : STOP" );
				}
			}
			nSeqNo = 0;
		}

		if( bPumpUse && m_pEqpAssy->m_DiTank[nPumpNo].GetPumpAlarm() )
		{
			if( m_pEqpAssy->m_DiTank[nPumpNo].GetPumpOnState() ) 
			{
				m_pEqpAssy->m_DiTank[nPumpNo].SetPumpOn(0, OFF);
				SetLog( m_sSeqName, -1, -1, "DI PUMP MOTOR : STOP" );
			}
			
			nAlarmId[nPumpNo] = ALM_DI_PUMP_ALARM1 + nPumpNo;
			m_pEqpStateSeq->SetAlarm( nAlarmId[nPumpNo] );
			SetLog( m_sSeqName, -1, -1, "DI PUMP MOTOR : ALARM" );
			
			nReturnSeqNo[nPumpNo] = nSeqNo;
			nSeqNo = 1000;
			break;
		}
#endif
		break;
	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() && !m_pEqpAssy->m_DiTank[nPumpNo].GetPumpAlarm() )
		{
			m_pEqpStateSeq->ResetAlarm( nAlarmId[nPumpNo] );
			nAlarmId[nPumpNo] = 0;
			
			SetLog( m_sSeqName, -1, -1, "ALARM RESET" );
			nSeqNo = nReturnSeqNo[nPumpNo];
		}
		break;
	case 2000:	// TANK LEVEL ALARM
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			m_pEqpStateSeq->ResetAlarm( nAlarmId[nPumpNo] );
			nAlarmId[nPumpNo] = 0;
			
			SetLog( m_sSeqName, -1, -1, "ALARM RESET" );
			nSeqNo = nReturnSeqNo[nPumpNo];
		}
		break;
	}
	m_nSeqDiPumpNo[nPumpNo] = nSeqNo;
}

void CPumpSeq::SeqInit()	// hskwak Ready ׸ ° Ȯ  .
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	int nSeqNo = m_nSeqInitNo;

	m_sSeqName.Format( "SeqInit    " );

	static BOOL bAlarm = FALSE;
	static DWORD dwStartTick = 0;
	static int nAlarmId[MAX_DI_PUMP_NO] = { 0, };

	switch( nSeqNo )
	{
	case 0:
		if( m_SeqFlag.bInitReq )
		{
			m_SeqFlag.bInitReq	= FALSE;
			m_SeqFlag.bInitComp	= FALSE;
			m_SeqFlag.bInitFail = FALSE;
#ifdef _BUFTANK_USE
			int nPumpNo = MAX_DI_TANK_NO;
			for( int i=0; i<nPumpNo; i++ )
			{
				if(m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE+i] == TRUE)
				{
					for( int j=0; j<m_pEqpAssy->m_DiTank[i].GetDoPumpOnCount(); j++ )
					{
						m_sMessage.Format( "%2d%d", CDicsData::initPUMP1_CHECK + i+j, MSG_STATUS_START );
						Msg( WM_INIT_STATUS, MSG_STATUS_SET_PUMP1+i+j , (LPARAM)(LPCTSTR)m_sMessage, TRUE );
					}
				}
				else
				{
					for( int j=0; j<m_pEqpAssy->m_DiTank[i].GetDoPumpOnCount(); j++ )
					{
						m_sMessage.Format( "%2d%d", CDicsData::initPUMP1_CHECK + i+j, MSG_STATUS_NO_USE );
						Msg( WM_INIT_STATUS, MSG_STATUS_SET_PUMP1+i+j , (LPARAM)(LPCTSTR)m_sMessage, TRUE );
					}
				}
			}
#else
			int nPumpNo = MAX_DI_PUMP_NO;
			for( int i=0; i<nPumpNo; i++ )
			{
				m_sMessage.Format( "%2d%d", CDicsData::initPUMP1_CHECK + i, MSG_STATUS_START );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_PUMP1+i , (LPARAM)(LPCTSTR)m_sMessage, TRUE );
			}
#endif
			SetLog( m_sSeqName, -1, -1, "INITIALIZE : START" );
			dwStartTick = GetTickCount();
			nSeqNo = 10;
		}
		break;
	case 10:
		if( GetTickCount() - dwStartTick >= 1000 )
		{
#ifdef _BUFTANK_USE
			if( m_pDicsData->m_JobCond.bJobProcessUse == 1  &&
				(m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] == 1 || m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP2_USE] == 1
				|| m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_BUFTANK_USE] == 1))
			{
				for( int i=0; i<MAX_DI_TANK_NO; i++ )
				{					
					if(m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE+i] == TRUE)
					{
						for( int j=0; j<m_pEqpAssy->m_DiTank[i].GetDoPumpOnCount(); j++ )
						{
							bAlarm |= m_pEqpAssy->m_DiTank[i].GetPumpAlarm(j);
						}
					}
				}
			}
#else
			if( m_pDicsData->m_JobCond.bJobProcessUse == 1  &&
				(m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] == 1 || m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP2_USE] == 1))
			{
				for( int i=0; i<MAX_DI_PUMP_NO; i++ )
				{
					if(m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE+i] == TRUE)
						bAlarm |= m_pEqpAssy->m_DiTank[i].GetPumpAlarm();
				}
			}
#endif
			nSeqNo = 20;
		}
		break;
	case 20:
		if( !bAlarm )
		{
			for( int i=0; i<MAX_DI_PUMP_NO; i++ )
			{
				m_sMessage.Format( "DI PUMP%d ALARM CHECK : OK", i+1 );
				SetLog( m_sSeqName, -1, -1, m_sMessage );
			}
			dwStartTick = GetTickCount();
			nSeqNo = 30;
		}
		else
		{
			m_SeqFlag.bInitFail = TRUE;
#ifdef _BUFTANK_USE
			for( int i=0; i<MAX_DI_TANK_NO; i++ )
			{
				for( int j=0; j<m_pEqpAssy->m_DiTank[i].GetDoPumpOnCount(); j++)
				{
					if( m_pEqpAssy->m_DiTank[i].GetPumpAlarm(j) )
					{
						m_sMessage.Format( "%2d%d", CDicsData::initPUMP1_CHECK + i+j, MSG_STATUS_NG );
						Msg( WM_INIT_STATUS, MSG_STATUS_SET_PUMP1+i+j, (LPARAM)(LPCTSTR)m_sMessage, TRUE );
				
						m_sMessage.Format( "DI PUMP%d ALARM", i+j+1 );
						SetLog( m_sSeqName, -1, -1, m_sMessage );

						nAlarmId[i] = ALM_DI_PUMP_ALARM1 + i+j;
						m_pEqpStateSeq->SetAlarm( nAlarmId[i] );
					}
				}
			}
#else
			for( int i=0; i<MAX_DI_PUMP_NO; i++ )
			{
				if( m_pEqpAssy->m_DiTank[i].GetPumpAlarm() )
				{
					m_sMessage.Format( "%2d%d", CDicsData::initPUMP1_CHECK + i, MSG_STATUS_NG );
					Msg( WM_INIT_STATUS, MSG_STATUS_SET_PUMP1+i, (LPARAM)(LPCTSTR)m_sMessage, TRUE );
				
					m_sMessage.Format( "DI PUMP%d ALARM", i+1 );
					SetLog( m_sSeqName, -1, -1, m_sMessage );

					nAlarmId[i] = ALM_DI_PUMP_ALARM1 + i;
					m_pEqpStateSeq->SetAlarm( nAlarmId[i] );
				}
			}
#endif
			nSeqNo = 1000;
		}
		break;
	case 30:
		if( m_pDicsData->m_JobCond.bJobProcessUse == 1  &&
#ifdef _BUFTANK_USE
			(m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] == 1 || m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP2_USE] == 1 
			|| m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_BUFTANK_USE] == 1))
#else
			(m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] == 1 || m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP2_USE] == 1 ))
#endif
		{
			BOOL bTankSupplyReq = FALSE;
			for( int i=0; i<MAX_DI_TANK_NO; i++ )
			{
				if(m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE+i] == 1)
				{
					if( !m_SeqFlag.bDiTankLevel[i][lvL] && !m_SeqFlag.bDiTankLevel[i][lvH] ) bAlarm = TRUE;
					else bAlarm = FALSE;
					if( bAlarm)
					{
						bTankSupplyReq = TRUE;
#ifdef _BUFTANK_USE
						for( int j=0; j<m_pEqpAssy->m_DiTank[i].GetDoTankSupplyInValveCount(); j++ )
							m_pEqpAssy->m_DiTank[i].SetTankSupplyInValve( j, ON );
#else
						m_pEqpAssy->m_DiTank[i].SetTankSupplyInValve( 0, ON );
#endif
						m_sMessage.Format( "TANK%d DI SUPPLY : REQUEST", i+1 );
						SetLog( m_sSeqName, -1, -1, m_sMessage );
						SetLog( m_sSeqName, -1, -1, "TANK DI SPL VALVE : OPEN" );
					}
				}
			}
			if( bTankSupplyReq ) nSeqNo = 35;
			else  nSeqNo = 40;			
		}
		else
		{
			for( int i=0; i<MAX_DI_PUMP_NO; i++ )
			{
				m_sMessage.Format( "%2d%d", CDicsData::initPUMP1_CHECK + i, MSG_STATUS_OK );
				Msg( WM_INIT_STATUS, MSG_STATUS_SET_PUMP1+i, (LPARAM)(LPCTSTR)m_sMessage, TRUE );
			}
			nSeqNo = 100;	
		}
		break;
	case 35:
		if( m_pDicsData->m_JobCond.bJobProcessUse == 1  &&
#ifdef _BUFTANK_USE
			( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] == 1 || m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP2_USE] == 1 
			|| m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_BUFTANK_USE] == 1 ) )
#else
			( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] == 1 || m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP2_USE] == 1 ) )
#endif
		{
			BOOL bTankSupplyStop = TRUE;
			for( int i=0; i<MAX_DI_TANK_NO; i++)
			{
				if(m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE+i] == 1)
				{
					if( m_SeqFlag.bDiTankLevel[i][lvL] || m_SeqFlag.bDiTankLevel[i][lvH] )
					{
#ifdef _BUFTANK_USE
						for( int j=0; j<m_pEqpAssy->m_DiTank[i].GetDoTankSupplyInValveCount(); j++ )
						{
							if( m_pEqpAssy->m_DiTank[i].GetTankSupplyInValveState(j) )
							{
								m_pEqpAssy->m_DiTank[i].SetTankSupplyInValve( j, OFF );
						
	
								m_sMessage.Format( "TANK%d DI SUPPLY : STOP", i+j+1 );
								SetLog( m_sSeqName, -1, -1, m_sMessage );						
								SetLog( m_sSeqName, -1, -1, "TANK DI SPL VALVE : CLOSE" );
							}
							bTankSupplyStop &= TRUE;		
						}
						
#else
						if( m_pEqpAssy->m_DiTank[i].GetTankSupplyInValveState() )
						{
							m_pEqpAssy->m_DiTank[i].SetTankSupplyInValve( 0, OFF );
						

							m_sMessage.Format( "TANK%d DI SUPPLY : STOP", i+1 );
							SetLog( m_sSeqName, -1, -1, m_sMessage );						
							SetLog( m_sSeqName, -1, -1, "TANK DI SPL VALVE : CLOSE" );
						}
						bTankSupplyStop &= TRUE;
#endif	
					}
					else  bTankSupplyStop &= FALSE;
				}
			}
			if( bTankSupplyStop ) nSeqNo = 40;
		}
		else nSeqNo = 100;
		break;		
	case 40:
		if( m_pDicsData->m_JobCond.bJobProcessUse == 1  &&
#ifdef _BUFTANK_USE
			( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] == 1 || m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP2_USE] == 1
			|| m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_BUFTANK_USE] == 1 ) )
#else
			( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE] == 1 || m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP2_USE] == 1 ) )
#endif
		{
			bAlarm = FALSE;
			for( int i=0; i<MAX_DI_TANK_NO; i++)
			{
				if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE+i] == 1)
				{
					if( GetLevelSensorFault( i ) ) 
					{

						m_SeqFlag.bInitFail = TRUE;

						for( int j=0; j<m_pEqpAssy->m_DiTank[i].GetDoPumpOnCount(); j++)
						{
							m_sMessage.Format( "%2d%d", CDicsData::initPUMP1_CHECK + i+j, MSG_STATUS_NG );
							Msg( WM_INIT_STATUS, MSG_STATUS_SET_PUMP1+i+j, (LPARAM)(LPCTSTR)m_sMessage, TRUE );
						}

						m_sMessage.Format( "DI TANK%d LEVEL SENSOR FAULT ALARM", i+1 );
						SetLog( m_sSeqName, -1, -1, m_sMessage );	

						bAlarm |= TRUE;
					}
					else
					{
						for( int j=0; j<m_pEqpAssy->m_DiTank[i].GetDoPumpOnCount(); j++)
						{
							m_sMessage.Format( "%2d%d", CDicsData::initPUMP1_CHECK + i+j, MSG_STATUS_OK );
							Msg( WM_INIT_STATUS, MSG_STATUS_SET_PUMP1+i+j, (LPARAM)(LPCTSTR)m_sMessage, TRUE );
						}
					}
				}
			}
			if( bAlarm )
			{			
				nSeqNo = 1000;
			}
			else 
			{
				nSeqNo = 100;
			}
		}
		else nSeqNo = 100;	
		break;
	case 100:
		{
			m_SeqFlag.bInitComp = TRUE;
			m_SeqFlag.bInitReq	= FALSE;

			SetLog( m_sSeqName, -1, -1, "INITIALIZE : COMPLETE" );

			Msg( WM_EQP_MESSAGE, MSG_EQP_MESSAGE, (LPARAM)(LPCTSTR) "INITIALIZE : COMPLETE" );
			nSeqNo = 0;
		}
		break;
	case 1000:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			for( int i=0; i<MAX_DI_PUMP_NO; i++ )
			{
				m_pEqpStateSeq->ResetAlarm( nAlarmId[i] );
			}
			SetLog( m_sSeqName, 0, 0, "ALARM RESET" );
			nSeqNo = 0;
		}
		break;	
	}
	m_nSeqInitNo = nSeqNo;
}

void CPumpSeq::SeqSbj( int nSbjNo )
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	m_sSeqName.Format( "MJ%d   ", nSbjNo + 1 );

	int nSeqNo = m_nSeqSbjNo[nSbjNo];
	static int nReturnSeqNo = 0;

////////////////////////////////////////////////////////////////////////////////
// manual ¿ Pump, Valve Control ϱ ؼ Ʒ Flag ʿϴ.
	static BOOL bStop[MAX_SBJ_NO] = { TRUE, };
////////////////////////////////////////////////////////////////////////////////
	BOOL bRunCond = TRUE;
	bRunCond &= !m_pDicsData->m_GenInfo.bEmo;
	bRunCond &= !m_pDicsData->m_GenInfo.bLeakSensor;
	bRunCond &= !m_pDicsData->m_GenInfo.bCoverOpen;
	bRunCond &= !m_pDicsData->m_GenInfo.bDoorOpen;
	bRunCond &= ( !m_pDicsData->m_GenInfo.bPause && m_pDicsData->m_GenInfo.bAuto ) || ( !m_pDicsData->m_GenInfo.bAuto );
	bRunCond &= ( m_pDicsData->m_JobCond.bJobProcessUse == 1 );
	bRunCond &= ( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupSWR1_SBJ_USE+nSbjNo] == 1 );
	
	BOOL bSbjRun = bRunCond; 
	bSbjRun &= m_pDicsData->m_IfPump.bDiStart;
	if( m_pDicsData->m_GenInfo.bAuto )
	bSbjRun &= !m_pDicsData->m_GenInfo.bSbjStop;	

	switch( nSeqNo )
	{ 
	case 0:
		if( bSbjRun )
		{
			bStop[nSbjNo] = FALSE;			
			if( !m_pEqpAssy->m_AutoValveSbjCda.GetState( nSbjNo ) )
			{
				m_pEqpAssy->m_AutoValveSbjCda.Set( nSbjNo, ON );
				SetLog( m_sSeqName, -1, -1, "MJ CDA SPL VALVE : OPEN" );
			}			
		}
		nSeqNo = 10;
		break;		
	case 10:
		if( !bSbjRun )
		{
			if( !bRunCond || m_pDicsData->m_GenInfo.bAuto || !bStop[nSbjNo] )
			{
				bStop[nSbjNo] = TRUE;
				if( m_pEqpAssy->m_AutoValveSbjCda.GetState( nSbjNo ) )
				{
					m_pEqpAssy->m_AutoValveSbjCda.Set( nSbjNo, OFF );
					SetLog( m_sSeqName, -1, -1, "MJ CDA SPL VALVE : CLOSE" );
				}				
			}			
		}
		nSeqNo = 0;
		break;
	}
	m_nSeqSbjNo[nSbjNo] = nSeqNo;
}

void CPumpSeq::SeqLevelSensor( int nTankNo, int nSensorNo )
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	static BOOL bInit = FALSE;
	static DWORD dwInitTick = GetTickCount();

	if( !bInit )
	{
		if( GetTickCount() - dwInitTick > 1000 )	bInit = TRUE;
		if( !bInit ) return;
	}

	m_sSeqName.Format( "LEVEL%d-%d", nTankNo + 1 , nSensorNo + 1);

	int nSeqNo	= m_nSeqLevelSensorNo[nTankNo][nSensorNo];
	DWORD nConfirmTime = atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupLEVEL_SENSOR_CONFIRM_TIME] );
	static int nAlarmId[MAX_DI_TANK_NO][lvMAX]		= { 0, };
	static DWORD dwStartTick[MAX_DI_TANK_NO][lvMAX] = { 0, };

/*
#ifdef _MY_DEBUG
m_pEqpAssy->m_DiTank[0].SetLoadCelState( 0, m_fDebugTankLevel );
#endif
*/
	BOOL bTankLevel[lvMAX] = { FALSE, };
/*
#ifndef _MY_DEBUG
	float fTankLevel = m_pEqpAssy->m_DiTank[0].GetLoadCell( 0 );
#else
	float fTankLevel = m_pEqpAssy->m_DiTank[0].GetLoadCell( 0 );// 150;
#endif

	bTankLevel[lvMH] = ( fTankLevel >= DI_TANK_LEVEL_H ) ? TRUE : FALSE;
	bTankLevel[lvML] = ( fTankLevel >= DI_TANK_LEVEL_M ) ? TRUE : FALSE;
	bTankLevel[lvL] = ( fTankLevel >= DI_TANK_LEVEL_L ) ? TRUE : FALSE;
	bTankLevel[lvLL] = ( fTankLevel >= DI_TANK_LEVEL_LL ) ? TRUE : FALSE;
#ifndef _MY_DEBUG
	bTankLevel[lvLL] &= m_pEqpAssy->m_DiTank[0].GetTankLevel( 0 );
#endif
*/

#ifdef _MY_DEBUG
	if( nSensorNo == lvL || nSensorNo == lvM || nSensorNo == lvH )
	{
		m_pEqpAssy->m_DiTank[nTankNo].SetTankLevelState( nSensorNo, TRUE );
	}
#endif
	bTankLevel[nSensorNo] = m_pEqpAssy->m_DiTank[nTankNo].GetTankLevel( nSensorNo );
	
	switch( nSeqNo )
	{
	case 0 :
		{
			if( bTankLevel[nSensorNo] && !m_SeqFlag.bDiTankLevel[nTankNo][nSensorNo] )
			{
				dwStartTick[nTankNo][nSensorNo] = GetTickCount();
			}	
			nSeqNo = 10;
		}
		break;
	case 10 :
		if( ( GetTickCount()-dwStartTick[nTankNo][nSensorNo] > nConfirmTime*1000 ) &&
			bTankLevel[nSensorNo] )
		{
			if( ( nSensorNo == lvL ) || m_SeqFlag.bDiTankLevel[nTankNo][nSensorNo-1] )
			{
				if( !m_SeqFlag.bDiTankLevel[nTankNo][nSensorNo] )	
				{
					m_SeqFlag.bDiTankLevel[nTankNo][nSensorNo] = TRUE;
					SetLog( m_sSeqName, -1, -1, "LEVEL SENSOR ON : CONFIRM" );
				}
				nSeqNo = 0;
			}
			else if( !bTankLevel[nSensorNo-1] && !m_SeqFlag.bDiTankLevelSensorFault[nTankNo][nSensorNo-1] )
			{
				m_SeqFlag.bDiTankLevel[nTankNo][nSensorNo] = FALSE;
				m_SeqFlag.bDiTankLevelSensorFault[nTankNo][nSensorNo] = TRUE;

				nAlarmId[nTankNo][nSensorNo] = ALM_DI_TANK1_LV_SENSOR_ALARM1 + ( nTankNo*lvMAX + nSensorNo );
				m_pEqpStateSeq->SetAlarm( nAlarmId[nTankNo][nSensorNo] );

				SetLog( m_sSeqName, -1, -1, "LEVEL SENSOR FAULT" );
				nSeqNo = 1000;			
			}
		}
		else if( !bTankLevel[nSensorNo] )
		{
			if( m_SeqFlag.bDiTankLevel[nTankNo][nSensorNo] )
			{
				dwStartTick[nTankNo][nSensorNo] = GetTickCount();	// 160317 halesu
				m_SeqFlag.bDiTankLevel[nTankNo][nSensorNo] = FALSE;
				SetLog( m_sSeqName, -1, -1, "LEVEL SENSOR OFF : CONFIRM" );
			}

			if( ( nSensorNo == lvMAX-1 ) || !m_SeqFlag.bDiTankLevel[nTankNo][nSensorNo+1] )
			{
				nSeqNo = 0;
			}
			else 
			{
				m_SeqFlag.bDiTankLevelSensorFault[nTankNo][nSensorNo] = TRUE;
				
				nAlarmId[nTankNo][nSensorNo] = ALM_DI_TANK1_LV_SENSOR_ALARM1 + ( nTankNo*lvMAX + nSensorNo );
				m_pEqpStateSeq->SetAlarm( nAlarmId[nTankNo][nSensorNo] );

				SetLog( m_sSeqName, -1, -1, "LEVEL SENSOR FAULT" );
				nSeqNo = 1000;			
			}
		}
		break;		
	case 1000 :
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			m_SeqFlag.bDiTankLevelSensorFault[nTankNo][nSensorNo] = FALSE;

			m_pEqpStateSeq->ResetAlarm( nAlarmId[nTankNo][nSensorNo] );
			nAlarmId[nTankNo][nSensorNo] = 0;

			SetLog( m_sSeqName, -1, -1, "ALARM RESET" );
			dwStartTick[nTankNo][nSensorNo] = 0;
			nSeqNo = 1100;
		}
		break;		
	case 1100 :
		if( GetTickCount()-dwStartTick[nTankNo][nSensorNo] > 2000 )
		{
			nSeqNo = 0;
		}
		break;
	}
	m_nSeqLevelSensorNo[nTankNo][nSensorNo] = nSeqNo;
}

BOOL CPumpSeq::GetLevelSensorFault( int nTankNo )
{
	BOOL bFault = FALSE;
	
	for( int i = 0 ; i < lvMAX ; i++ )
	{
		bFault |= m_SeqFlag.bDiTankLevelSensorFault[nTankNo][i];
	}
	
	return bFault;
}

void CPumpSeq::SeqGlassExist()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	if( !m_SeqFlag.bInitComp ) return;
	if( !m_pDicsData->m_GenInfo.bAuto ) return;

	static DWORD dwStartTick = 0;
	DWORD nIdleWaitTime = 60 * 1000 * atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupIDLE_WAIT_TIME] );

	int nSeqNo = m_nSeqGlassExistNo;

	switch( nSeqNo )
	{
	case 0:
		// case 0  m_pDicsData->m_GenInfo.nGlassNo = 0  
	  	// case 10  m_pDicsData->m_GenInfo.nGlassNo > 0  Ǵ 
		if( !m_pDicsData->m_GenInfo.nGlassNo ) 
		{
			nSeqNo = 20;
		}
		else nSeqNo = 20;
		break;
	case 10:
		if( !m_pDicsData->m_GenInfo.nGlassNo )
		{
			m_pDicsData->m_IfPump.bDiStart = FALSE;

			dwStartTick = GetTickCount();			
			nSeqNo = 20;
		}
		else if( m_pDicsData->m_GenInfo.nGlassNo &&
				 m_pDicsData->m_JobCond.bJobProcessUse == 1 )
		{
			BOOL bProcessRequired = FALSE;
			for( int i=IF_UNIT_LD*2; i<=IF_UNIT_UL*2; i++ )
			{
				bProcessRequired |= m_pDicsData->m_GlsInfo[i].bIsValid;
			}
			
			if( !bProcessRequired && m_pDicsData->m_IfPump.bDiStart )
			{
				m_pDicsData->m_IfPump.bDiStart = FALSE;
			}
			else if( bProcessRequired && !m_pDicsData->m_IfPump.bDiStart )
			{
				m_pDicsData->m_IfPump.bDiStart = TRUE;
			}
		}
		break;
	case 20:
		if( m_pDicsData->m_GenInfo.nGlassNo ) 
		{
			m_pDicsData->m_GenInfo.bIdleRunning = FALSE;

			nSeqNo = 10;
		}
		else if( !m_pDicsData->m_GenInfo.bEqpInitComp )
		{
			dwStartTick = GetTickCount();
		}
		else if( !m_pDicsData->m_GenInfo.bIdleRunning &&
				 ( GetTickCount()-dwStartTick ) > nIdleWaitTime )
		{
			m_pDicsData->m_GenInfo.bIdleRunning = TRUE;
//			m_nSeqDiwIdleRunningNo = 0;
		}
		break;
	}
	m_nSeqGlassExistNo = nSeqNo;
}

void CPumpSeq::SeqDiTank(int nTankNo)
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	m_sSeqName.Format( "DI TANK%d", nTankNo + 1 );

	BOOL bRunCond = TRUE;
	bRunCond &= !m_pDicsData->m_GenInfo.bLeakSensor;
	bRunCond &= !m_pDicsData->m_GenInfo.bEmo;
	bRunCond &= !m_pDicsData->m_GenInfo.bCoverOpen;
	bRunCond &= !m_pDicsData->m_GenInfo.bDoorOpen;
	bRunCond &= ( m_pDicsData->m_JobCond.bJobProcessUse == 1 );
	bRunCond &= ( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE+nTankNo] == 1 );	
	bRunCond &= !m_SeqFlag.bDiTankLevel[nTankNo][lvHH];
	bRunCond &= !GetLevelSensorFault( nTankNo );

	if( !bRunCond || m_SeqFlag.bDiTankLevel[nTankNo][lvH] )
	{
#ifdef _BUFTANK_USE
		for( int j=0; j< m_pEqpAssy->m_DiTank[nTankNo].GetDoTankSupplyInValveCount(); j++ )
		{
			if( m_pEqpAssy->m_DiTank[nTankNo].GetTankSupplyInValveState(j) )
			{
				m_pEqpAssy->m_DiTank[nTankNo].SetTankSupplyInValve( j, OFF );

				if( !bRunCond )
				{
					SetLog( m_sSeqName, 0, 0, "TANK RUN CONDITION : NG" );
				}
				if( m_SeqFlag.bDiTankLevel[nTankNo][lvH] )
				{
					SetLog( m_sSeqName, 0, 0, "TANK H LEVEL SENSOR DETECT" );
				}
			
				SetLog( m_sSeqName, 0, 0, "TANK DI SPL VALVE : CLOSE" );
			}
		}
#else
		if( m_pEqpAssy->m_DiTank[nTankNo].GetTankSupplyInValveState() )
		{
			m_pEqpAssy->m_DiTank[nTankNo].SetTankSupplyInValve( 0, OFF );

			if( !bRunCond )
			{
				SetLog( m_sSeqName, 0, 0, "TANK RUN CONDITION : NG" );
			}
			if( m_SeqFlag.bDiTankLevel[nTankNo][lvH] )
			{
				SetLog( m_sSeqName, 0, 0, "TANK H LEVEL SENSOR DETECT" );
			}
			
			SetLog( m_sSeqName, 0, 0, "TANK DI SPL VALVE : CLOSE" );
		}
#endif
		
	}

	if( m_pDicsData->m_GenInfo.bEmo )// && !m_SeqFlag.bDiTankLevel[nTankNo][lvHH])
	{
		if( m_pEqpAssy->m_DiTank[nTankNo].GetTankDrainOutValveState() ) 
		{
			m_pEqpAssy->m_DiTank[nTankNo].SetTankDrainOutValve( 0, OFF );
		}
	}
//	else if ( m_SeqFlag.bDiTankLevel[nTankNo][lvHH] )
//	{
//		if( !m_pEqpAssy->m_DiTank[nTankNo].GetTankDrainOutValveState() ) 
//		{
//			m_pEqpAssy->m_DiTank[nTankNo].SetTankDrainOutValve( 0, ON );
//		}
//	}


	BOOL bNotReady = FALSE;
	bNotReady |= !m_SeqFlag.bDiTankLevel[nTankNo][lvL];
	bNotReady |= !m_SeqFlag.bDiTankLevel[nTankNo][lvL];
	bNotReady |= GetLevelSensorFault( nTankNo );

	if( bNotReady && m_SeqFlag.bDiTankReady[nTankNo] )
	{
		m_SeqFlag.bDiTankReady[nTankNo] = FALSE;
		SetLog( m_sSeqName, 0, 0, "TANK RUN CONDITION : NOT READY" );
	}

	//--------------------------------------------------------------------
	if( !bRunCond ||
	  ( m_pDicsData->m_GenInfo.bAuto && !m_SeqFlag.bInitComp ) ||
	  ( !m_pDicsData->m_GenInfo.bAuto && ( (!m_pDicsData->m_IfPump.bDiStart &&  !m_pDicsData->m_IfPump.bCleaningStart) && !m_pEqpAssy->m_DiTank[nTankNo].GetPumpOnState() ) ) ) return;
//	if( !m_pDicsData->m_GenInfo.bAuto && !bRunCond && !m_pDicsData->m_IfPump.bDiStart ) return; 

	int nSeqNo = m_nSeqDiTankNo[nTankNo];
	static int nReturnSeqNo[MAX_DI_TANK_NO];
	static DWORD dwStartTick[MAX_DI_TANK_NO] = { 0, };

	switch( nSeqNo )
	{
	case 0 :
		if( bRunCond && 
			!m_SeqFlag.bDiTankLevel[nTankNo][lvHH] &&
		  ( !m_SeqFlag.bDiTankLevel[nTankNo][lvH] ||
		    !m_SeqFlag.bDiTankLevel[nTankNo][lvM] ||
			!m_SeqFlag.bDiTankLevel[nTankNo][lvL] ) )
		{
#ifdef _BUFTANK_USE
			for( int j=0; j< m_pEqpAssy->m_DiTank[nTankNo].GetDoTankSupplyInValveCount(); j++ )
			{
				if( !m_pEqpAssy->m_DiTank[nTankNo].GetTankSupplyInValveState(j) )
				{
					m_pEqpAssy->m_DiTank[nTankNo].SetTankSupplyInValve( j, ON );
					SetLog( m_sSeqName, 0, 0, "TANK DI SPL VALVE : OPEN" );
				}
			}
#else
			if( !m_pEqpAssy->m_DiTank[nTankNo].GetTankSupplyInValveState() )
			{
				m_pEqpAssy->m_DiTank[nTankNo].SetTankSupplyInValve( 0, ON );
				SetLog( m_sSeqName, 0, 0, "TANK DI SPL VALVE : OPEN" );
			}
#endif
		}
		else if( !bRunCond || m_SeqFlag.bDiTankLevel[nTankNo][lvH] )
		{
#ifdef _BUFTANK_USE
			for( int j=0; j< m_pEqpAssy->m_DiTank[nTankNo].GetDoTankSupplyInValveCount(); j++ )
			{
				if( m_pEqpAssy->m_DiTank[nTankNo].GetTankSupplyInValveState(j) )
				{
					m_pEqpAssy->m_DiTank[nTankNo].SetTankSupplyInValve( j, OFF );
					SetLog( m_sSeqName, 0, 0, "TANK DI SPL VALVE : CLOSE" );
				}
			}
#else
			if( m_pEqpAssy->m_DiTank[nTankNo].GetTankSupplyInValveState() )
			{
				m_pEqpAssy->m_DiTank[nTankNo].SetTankSupplyInValve( 0, OFF );
				SetLog( m_sSeqName, 0, 0, "TANK DI SPL VALVE : CLOSE" );
			}
#endif
		}		
		nSeqNo = 10;
		break;
	case 10 :
		if( ( !m_SeqFlag.bDiTankLevel[nTankNo][lvM] ||
			  !m_SeqFlag.bDiTankLevel[nTankNo][lvL] ) &&
			  m_SeqFlag.bDiTankReady[nTankNo] )
		{
			m_SeqFlag.bDiTankReady[nTankNo] = FALSE;
		}
		nSeqNo = 20;
		break;		
	case 20:
		if( m_SeqFlag.bDiTankLevel[nTankNo][lvH] &&
			m_SeqFlag.bDiTankLevel[nTankNo][lvM] &&
			m_SeqFlag.bDiTankLevel[nTankNo][lvL] &&
			!m_SeqFlag.bDiTankReady[nTankNo] )
		{
			m_SeqFlag.bDiTankReady[nTankNo] = TRUE;
		}
		nSeqNo = 0;
		break;
	}
	m_nSeqDiTankNo[nTankNo] = nSeqNo;
}

void CPumpSeq::SeqDiwIdleRunning()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	if( !m_SeqFlag.bInitComp ) return;

	int nRunTime  = m_pSetupItems->m_nValueIdleRun[CSetupItems::idleDIW_IDLE_RUN_TIME];
	int nStopTime = m_pSetupItems->m_nValueIdleRun[CSetupItems::idleDIW_IDLE_STOP_TIME] * 60;

	BOOL bIdleCond = TRUE;
	bIdleCond &= m_SeqFlag.bInitComp;
//	bIdleCond &= !m_pDicsData->m_GenInfo.bPause;
	bIdleCond &= m_pDicsData->m_GenInfo.bAuto;
	bIdleCond &= !m_pDicsData->m_GenInfo.bEmo;
	bIdleCond &= !m_pDicsData->m_GenInfo.bLeakSensor;
	bIdleCond &= !m_pDicsData->m_GenInfo.bCoverOpen;
	bIdleCond &= !m_pDicsData->m_GenInfo.bDoorOpen;
 	bIdleCond &= !m_pDicsData->m_EqpInfo.nEqpState[CDicsData::stateDOWN];
 	
//	bIdleCond &= m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupJOB_MODE];
	bIdleCond &= m_pDicsData->m_JobCond.bJobProcessUse;
	bIdleCond &= m_pSetupItems->m_nValueIdleRun[CSetupItems::idleDIW_ZONE_USE];
	bIdleCond &= m_pDicsData->m_GenInfo.bIdleRunning;
	bIdleCond &= ( nRunTime > 0 );

#ifndef _MY_DEBUG
	bIdleCond &= !m_pDicsData->m_GenInfo.bCycleStop;
#endif

	static int nReturnSeqNo = 0;
	static int nOldTime = 0;

	int nTime = 0;
	int tm = TM_SEQ_DIW_IDLE;

	int nSeqNo = m_nSeqDiwIdleRunningNo;
					
	switch( nSeqNo )
	{
	case 0 :
		if( bIdleCond )
		{
			m_pDicsData->m_IfPump.bDiStart = !nStopTime;
			nSeqNo = 10;
		}
		break;
	case 10 :
		if( !bIdleCond )
		{			
			m_pDicsData->m_IfPump.bDiStart = FALSE;
			nSeqNo = 0;
		}
		else
		{
			nOldTime = 0;
			TIMER_ON( tm, nStopTime*10 );
			Msg( WM_DIW_IDLE_RUNNING_PROGRESS, PROGRESS_START, nStopTime, FALSE );
			nSeqNo = 20;
		}
		break;
	case 20 : // STOP TIME
		nTime = (int)( m_pTimer->m_pTimer[tm].dwNow / 100 );
		if( nTime - nOldTime > 2 )
		{
			nOldTime = nTime;
			
			Msg( WM_DIW_IDLE_RUNNING_PROGRESS, PROGRESS_SET, nTime, FALSE );
		}
		if( !bIdleCond )
		{
			m_pDicsData->m_IfPump.bDiStart = FALSE;
			Msg( WM_DIW_IDLE_RUNNING_PROGRESS, PROGRESS_END, 0, FALSE );
			nSeqNo = 0;
		}
		else if( TIMER( tm ) ) 
		{
			m_pDicsData->m_IfPump.bDiStart = TRUE;
			m_pDicsData->m_GenInfo.bSbjStop = FALSE;//2008.09.16 kimgun
			
			TIMER_ON( tm, nRunTime*10 );
			Msg( WM_DIW_IDLE_RUNNING_PROGRESS, PROGRESS_START, nRunTime, FALSE );
			nOldTime = 0;

			nSeqNo = 30;
		}
		break;
	case 30 : // RUN TIME
		nTime = (int)( m_pTimer->m_pTimer[tm].dwNow / 100 );
		if( nTime - nOldTime > 2 ) 
		{
			nOldTime = nTime;
			Msg( WM_DIW_IDLE_RUNNING_PROGRESS, PROGRESS_SET, nTime, FALSE );
		}
		if( !bIdleCond )
		{
			m_pDicsData->m_IfPump.bDiStart = FALSE;
			Msg( WM_DIW_IDLE_RUNNING_PROGRESS, PROGRESS_END, 0, FALSE );
			nSeqNo = 0;
		}
		else if( TIMER( tm ) )
		{
			m_pDicsData->m_IfPump.bDiStart = !nStopTime;
			Msg( WM_DIW_IDLE_RUNNING_PROGRESS, PROGRESS_END, 0, FALSE );
			nSeqNo = 10;
		}
		break;
	}
	m_nSeqDiwIdleRunningNo = nSeqNo;
}

void CPumpSeq::SeqFrShower()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	
	int nSeqNo = m_nSeqFrShowerNo;
	BOOL	bRunCond = TRUE;
	
	m_sSeqName.Format( "SWR4    " );
	
	static BOOL bDiStop = TRUE;
	
	// hskwak  κ    ؾ  SWR4 FR Shower.
	bRunCond &= m_pDicsData->m_JobCond.bJobProcessUse;
	bRunCond &= !m_pDicsData->m_GenInfo.bEmo;
	bRunCond &= !m_pDicsData->m_GenInfo.bLeakSensor;
	bRunCond &= !m_pDicsData->m_GenInfo.bCoverOpen;
	bRunCond &= !m_pDicsData->m_GenInfo.bDoorOpen;
	bRunCond &= !(m_pDicsData->m_GenInfo.bSbjStop && m_pDicsData->m_GenInfo.bAuto);
	bRunCond &= !(m_pDicsData->m_GenInfo.bPause && m_pDicsData->m_GenInfo.bAuto);
	
	BOOL bDiStart = bRunCond;
	bDiStart &= m_pDicsData->m_IfPump.bDiStart;
	
	switch( nSeqNo )
	{
	case 0:
		if( bDiStart )
		{
			bDiStop = FALSE;
			
			for(int i=0; i<m_pEqpAssy->m_AutoValveFrShower.GetDoSize(); i++)
			{
				if( !m_pEqpAssy->m_AutoValveFrShower.GetState( i ) )
				{
					m_pEqpAssy->m_AutoValveFrShower.Set( i, ON );
					m_sMessage.Format( "SWR4 UNIT AQK DI SPL VALVE : OPEN" );
					SetLog( m_sSeqName, -1, -1, m_sMessage);
				}				
			}			
		}
		nSeqNo = 10;
		break;
	case 10:
		if( !bDiStart )
		{
			if( !bRunCond || m_pDicsData->m_GenInfo.bAuto || !bDiStop )
			{
				bDiStop = TRUE;
				for(int i=0; i<m_pEqpAssy->m_AutoValveFrShower.GetDoSize(); i++)
				{
					if( m_pEqpAssy->m_AutoValveFrShower.GetState( i ) )
					{
						m_pEqpAssy->m_AutoValveFrShower.Set(i, OFF);
						m_sMessage.Format( "SWR4 UNIT AQK DI SPL VALVE : CLOSE" );
						SetLog( m_sSeqName, -1, -1, m_sMessage);
					}
				}
			}
		}
		nSeqNo = 0;
		break;
	}
	m_nSeqFrShowerNo = nSeqNo;
}


void CPumpSeq::SeqSbjDiShower()
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	
	int nSeqNo = m_nSeqSbjDiShowerNo;
	BOOL	bRunCond = TRUE;
	
	m_sSeqName.Format( "SWR1    " );
	
	static BOOL bDiStop = TRUE;

	bRunCond &= m_pDicsData->m_JobCond.bJobProcessUse;
	bRunCond &= !m_pDicsData->m_GenInfo.bEmo;
	bRunCond &= !m_pDicsData->m_GenInfo.bLeakSensor;
	bRunCond &= !m_pDicsData->m_GenInfo.bCoverOpen;
	bRunCond &= !m_pDicsData->m_GenInfo.bDoorOpen;
	bRunCond &= !(m_pDicsData->m_GenInfo.bSbjStop && m_pDicsData->m_GenInfo.bAuto);
	bRunCond &= !(m_pDicsData->m_GenInfo.bPause && m_pDicsData->m_GenInfo.bAuto);

	BOOL bDiStart = bRunCond;
	bDiStart &= m_pDicsData->m_IfPump.bDiStart;
	
	switch( nSeqNo )
	{
	case 0:
		if( bDiStart )
		{
			bDiStop = FALSE;
			
			for(int i=0; i<m_pEqpAssy->m_AutoValveSbjDi.GetDoSize(); i++)
			{
				if( !m_pEqpAssy->m_AutoValveSbjDi.GetState( i ) )
				{
					m_pEqpAssy->m_AutoValveSbjDi.Set( i, ON );
					m_sMessage.Format( "SWR1 UNIT SBJ DI SPL VALVE : OPEN" );
					SetLog( m_sSeqName, -1, -1, m_sMessage);
				}				
			}			
		}
		nSeqNo = 10;
		break;
	case 10:
		if( !bDiStart )
		{
			if( !bRunCond || m_pDicsData->m_GenInfo.bAuto || !bDiStop )
			{
				bDiStop = TRUE;
				for(int i=0; i<m_pEqpAssy->m_AutoValveSbjDi.GetDoSize(); i++)
				{
					if( m_pEqpAssy->m_AutoValveSbjDi.GetState( i ) )
					{
						m_pEqpAssy->m_AutoValveSbjDi.Set(i, OFF);
						m_sMessage.Format( "SWR1 UNIT SBJ DI SPL VALVE : CLOSE" );
						SetLog( m_sSeqName, -1, -1, m_sMessage);
					}
				}
			}
		}
		nSeqNo = 0;
		break;
	}
	m_nSeqSbjDiShowerNo = nSeqNo;
}

void CPumpSeq::SeqPumpOutValve( int nTank )
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	
	int nSeqNo = m_nSeqPumpOutValveNo[nTank];
	BOOL	bRunCond = TRUE;
	
	m_sSeqName.Format( "PUMP OUT   " );
	
	static BOOL bDiStop[MAX_DI_TANK_NO] = {TRUE,};

	//	bRunCond &=	m_pDicsData->m_GenInfo.bAuto;
	bRunCond &= m_pDicsData->m_JobCond.bJobProcessUse;
	bRunCond &= !m_pDicsData->m_GenInfo.bEmo;
	bRunCond &= !m_pDicsData->m_GenInfo.bLeakSensor;
	bRunCond &= !m_pDicsData->m_GenInfo.bCoverOpen;
	bRunCond &= !m_pDicsData->m_GenInfo.bDoorOpen;
	bRunCond &= !(m_pDicsData->m_GenInfo.bSbjStop && m_pDicsData->m_GenInfo.bAuto);
	bRunCond &= !(m_pDicsData->m_GenInfo.bPause && m_pDicsData->m_GenInfo.bAuto);
	bRunCond &=	m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE+nTank];
	BOOL bPumpRun = bRunCond; 
	bPumpRun &=	( m_pDicsData->m_IfPump.bDiStart ||  m_pDicsData->m_IfPump.bCleaningStart );
#ifdef _BUFTANK_USE
	BOOL bBufTAnkPumpRun = bRunCond; 
	bBufTAnkPumpRun &= m_pDicsData->m_IfPump.bDiStart;
#endif
	switch( nSeqNo )
	{
	case 0:
		if( bPumpRun )
		{
			bDiStop[nTank] = FALSE;
#ifdef _BUFTANK_USE
			if( nTank < NO_BUFTANK )
			{
				if( !m_pEqpAssy->m_AutoValvePumpOut.GetState( nTank ) )
				{
					m_pEqpAssy->m_AutoValvePumpOut.Set( nTank, ON );
					m_sMessage.Format( "PUMP%d OUT VALVE : OPEN", nTank+1 );
					SetLog( m_sSeqName, -1, -1, m_sMessage);
				}
			}
			else if( nTank == NO_BUFTANK && bBufTAnkPumpRun )
			{
				for( int j=0; j<4; j++ )
				{
					BOOL bAutoValve = TRUE;
					if ( j<2 )
					{
						bAutoValve = !m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE+j];
					}
					if( !m_pEqpAssy->m_AutoValvePumpOut.GetState( nTank+j ) && bAutoValve)
					{
						m_pEqpAssy->m_AutoValvePumpOut.Set( nTank+j, ON );
						m_sMessage.Format( "PUMP%d OUT VALVE : OPEN", nTank+j+1 );
						SetLog( m_sSeqName, -1, -1, m_sMessage);
					}
				}
			}
#else
			if( !m_pEqpAssy->m_AutoValvePumpOut.GetState( nTank ) )
			{
				m_pEqpAssy->m_AutoValvePumpOut.Set( nTank, ON );
				m_sMessage.Format( "PUMP%d OUT VALVE : OPEN", nTank+1 );
				SetLog( m_sSeqName, -1, -1, m_sMessage);
			}
#endif
		}
		nSeqNo = 10;
		break;
	case 10:
		if( !bPumpRun )
		{
#ifdef _BUFTANK_USE
			if( !bRunCond || m_pDicsData->m_GenInfo.bAuto || !bDiStop[nTank] )
			{
				bDiStop[nTank] = TRUE;
				if( nTank < NO_BUFTANK )
				{
					if( m_pEqpAssy->m_AutoValvePumpOut.GetState( nTank ) )
					{
						m_pEqpAssy->m_AutoValvePumpOut.Set(nTank, OFF);
						m_sMessage.Format( "PUMP%d OUT VALVE : CLOSE", nTank+1 );
						SetLog( m_sSeqName, -1, -1, m_sMessage);
					}
				}
				else
				{
					for( int j=0; j<4; j++ )
					{
						if( m_pEqpAssy->m_AutoValvePumpOut.GetState( nTank+j ) )
						{
							m_pEqpAssy->m_AutoValvePumpOut.Set(nTank+j, OFF);
							m_sMessage.Format( "PUMP%d OUT VALVE : CLOSE", nTank+j+1 );
							SetLog( m_sSeqName, -1, -1, m_sMessage);
						}
					}
				}
			}
#else
			if( !bRunCond || m_pDicsData->m_GenInfo.bAuto || !bDiStop[nTank] )
			{
				bDiStop[nTank] = TRUE;
				if( m_pEqpAssy->m_AutoValvePumpOut.GetState( nTank ) )
				{
					m_pEqpAssy->m_AutoValvePumpOut.Set(nTank, OFF);
					m_sMessage.Format( "PUMP%d OUT VALVE : CLOSE", nTank+1 );
					SetLog( m_sSeqName, -1, -1, m_sMessage);
				}
			}
#endif
		}
		nSeqNo = 0;
		break;
	}
	m_nSeqPumpOutValveNo[nTank] = nSeqNo;
}

void CPumpSeq::SeqRbDirectValve( int nTank )
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif
	
	int nSeqNo = m_nSeqRbDirectValveNo[nTank];
	BOOL	bRunCond = TRUE;
	
	m_sSeqName.Format( "PUMP OUT   " );
	
	static BOOL bDiStop[MAX_DI_TANK_NO] = {TRUE, TRUE};
	static BOOL bDrainStart[MAX_DI_TANK_NO] = {FALSE, FALSE}; // 191207 ssm

	//	bRunCond &=	m_pDicsData->m_GenInfo.bAuto;
	bRunCond &= m_pDicsData->m_JobCond.bJobProcessUse;
	bRunCond &= !m_pDicsData->m_GenInfo.bEmo;
	bRunCond &= !m_pDicsData->m_GenInfo.bLeakSensor;
	bRunCond &= !m_pDicsData->m_GenInfo.bCoverOpen;
	bRunCond &= !m_pDicsData->m_GenInfo.bDoorOpen;
	bRunCond &= !(m_pDicsData->m_GenInfo.bSbjStop && m_pDicsData->m_GenInfo.bAuto);
	bRunCond &= !(m_pDicsData->m_GenInfo.bPause && m_pDicsData->m_GenInfo.bAuto);
	bRunCond &=	!m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE + nTank];
	BOOL bDirectRun = bRunCond; 
	bDirectRun &=	(m_pDicsData->m_IfPump.bDiStart ||  m_pDicsData->m_IfPump.bCleaningStart );

	// 191207 ssm Pump No Use = Drain Valve always Open 
	if( m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE + nTank] )
	{
		if( m_pDicsData->m_IfPump.bDiStart || ( !m_pDicsData->m_GenInfo.bAuto && m_pDicsData->m_IfPump.bCleaningStart ) )
		{
			if( m_SeqFlag.bDiTankLevel[nTank][lvHH] && !bDrainStart[nTank]) // HH Open
			{		
				if( !m_pEqpAssy->m_DiTank[nTank].GetTankDrainOutValveState(0))
				{ 
					bDrainStart[nTank] = TRUE;
					m_pEqpAssy->m_DiTank[nTank].SetTankDrainOutValve(0,ON);
					m_sMessage.Format("TANK(%d) DRAIN AUTO VALVE OPEN", nTank+1 );
					SetLog( m_sSeqName, -1, -1, m_sMessage );
				}
			}
			else if( m_SeqFlag.bDiTankLevel[nTank][lvH] && bDrainStart[nTank]) // Wait H Level Off
			{
			}
			else if( !m_SeqFlag.bDiTankLevel[nTank][lvH] && bDrainStart[nTank]) // Drain OK
			{
				bDrainStart[nTank] = FALSE;
			}
			else
			{
				if( m_pEqpAssy->m_DiTank[nTank].GetTankDrainOutValveState(0) )
				{
					m_pEqpAssy->m_DiTank[nTank].SetTankDrainOutValve(0,OFF);	
					m_sMessage.Format("TANK(%d) DRAIN AUTO VALVE CLOSE", nTank+1 );
					SetLog( m_sSeqName, -1, -1, m_sMessage );
				}
			}
		}
	}
	else
	{
		if(!m_pEqpAssy->m_DiTank[nTank].GetTankDrainOutValveState(0))
		{
		    m_pEqpAssy->m_DiTank[nTank].SetTankDrainOutValve(0,ON);
			SetLog( m_sSeqName, -1, -1, "TANK1 DRAIN AUTO VALVE OPEN" );
		}
	}
	
	switch( nSeqNo )
	{
	case 0:
		if( bDirectRun )
		{
			bDiStop[nTank] = FALSE;
			
			if( !m_pEqpAssy->m_AutoValveDirect.GetState( nTank ) )
			{
				m_pEqpAssy->m_AutoValveDirect.Set( nTank, ON );
				//m_pEqpAssy->m_DiTank[nTank].SetTankDrainOutValve( 0, ON );	// hskwak DI   TANK Dranin Out Valve ON.
				m_sMessage.Format( "RB DIRECT(%d) VALVE : OPEN, TANK(%d) DRAIN VALVE : OPEN", nTank+1, nTank+1 );
				SetLog( m_sSeqName, -1, -1, m_sMessage);
			}			
		}
		nSeqNo = 10;
		break;
	case 10:
		if( !bDirectRun )
		{
			if( !bRunCond || m_pDicsData->m_GenInfo.bAuto || !bDiStop[nTank] )
			{
				bDiStop[nTank] = TRUE;
				if( m_pEqpAssy->m_AutoValveDirect.GetState( nTank ) )
				{
					m_pEqpAssy->m_AutoValveDirect.Set(nTank, OFF);
					//m_pEqpAssy->m_DiTank[nTank].SetTankDrainOutValve( 0, OFF );	// hskwak DI    TANK Dranin Out Valve OFF.
					m_sMessage.Format( "RB DIRECT(%d) VALVE : CLOSE, TANK(%d) DRAIN VALVE : CLOSE", nTank+1, nTank+1 );
					SetLog( m_sSeqName, -1, -1, m_sMessage);
				}		
			}
		}
		nSeqNo = 0;
		break;
	}
	m_nSeqRbDirectValveNo[nTank] = nSeqNo;
}

void CPumpSeq::SeqCleaningModeCtrl()
{
	int nSeqNo = m_nSeqCleaningModeCtrlNo;
	static BOOL bDiStop = TRUE;

	static DWORD dwTickStart; 

	BOOL bUse[4]    = { FALSE,};

	static BOOL bAlarm[4][2]    = { { FALSE, FALSE,}, };
	static BOOL bWarning[4][2]  = { { FALSE, FALSE,}, };	
	static int nCheckAiNo[4] = {0,0,0,0};
//	BOOL bCheckCond = TRUE; 
		
	double dCurVal[4] = { 0,};	

	int nLowLimit[4]   = { 0,};
	int	nLoWarning[4] = { 0,};	
	int	nUpWarning[4] = { 0,};
	int nUpLimit[4]	  = { 0,};

	BOOL bRunCond = TRUE;
	bRunCond &= m_pDicsData->m_JobCond.bJobProcessUse;
	bRunCond &= !m_pDicsData->m_GenInfo.bEmo;
	bRunCond &= !m_pDicsData->m_GenInfo.bLeakSensor;
	bRunCond &= !m_pDicsData->m_GenInfo.bCoverOpen;
	bRunCond &= !m_pDicsData->m_GenInfo.bDoorOpen;
	bRunCond &= !(m_pDicsData->m_GenInfo.bSbjStop && m_pDicsData->m_GenInfo.bAuto);
	bRunCond &= !(m_pDicsData->m_GenInfo.bPause && m_pDicsData->m_GenInfo.bAuto);
	bRunCond &=	!m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE];
	bRunCond &=	!m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP2_USE];

	BOOL bCheckCond = bRunCond; 
	bCheckCond &= m_pDicsData->m_IfPump.bCleaningStart ;

	switch( nSeqNo )
	{
	case 0:
		if( bCheckCond )
		{
			dwTickStart = GetTickCount();
			nSeqNo = 10;
		}
		break;

	case 10:
		if( !bCheckCond )
		{
			nSeqNo = 0;
		}
		else if( GetTickCount() - dwTickStart > 3000 )
		{
			for( int nAiNo = 0; nAiNo < m_pEqpAssy->m_AnalogInput.GetAiSize(); nAiNo++ )
			{
				for(int i=0; i<m_pEqpAssy->m_AnalogInputTank.GetAiSize(); i++)
				{
					if( m_pEqpAssy->m_AnalogInput.GetAddress( nAiNo ) == m_pEqpAssy->m_AnalogInputTank.GetAddress( i ) )
					{
						nCheckAiNo[i] = nAiNo;
						int nIntrNo = m_pEqpAssy->m_AnalogInput.m_aiSet[nAiNo].nAiIntrNo;
						if( nIntrNo < 0 ) continue;
						dCurVal[i] = (double) m_pEqpAssy->m_AnalogInputTank.GetRealVal( i );

						bUse[i]	   = m_pSetupItems->m_nValueGaugeLimit_Option[nIntrNo];
						nLowLimit[i]	= m_pSetupItems->m_nValueGaugeLimit[0][nIntrNo];
						nLoWarning[i]	= m_pSetupItems->m_nValueGaugeLimit[1][nIntrNo];
						nUpWarning[i]	= m_pSetupItems->m_nValueGaugeLimit[2][nIntrNo];
						nUpLimit[i]		= m_pSetupItems->m_nValueGaugeLimit[3][nIntrNo];
					}
				}
			}
			
			for(int i=0; i<4; i++)
			{
				if( bCheckCond && bUse[i] )
				{
					if(	nLowLimit[i] >= dCurVal[i]  ) bAlarm[i][0] = TRUE;
					else if( nLowLimit[i] < dCurVal[i] && nLoWarning[i] >= dCurVal[i] ) bWarning[i][0] = TRUE;
					else if( nUpLimit[i] <= dCurVal[i] ) bAlarm[i][1] = TRUE;
					else if( nUpLimit[i] > dCurVal[i] && nUpWarning[i] <= dCurVal[i] ) bWarning[i][1] = TRUE;
				}
			}
			
			if ( bAlarm[0][0] || bAlarm[0][1] || bWarning[0][0] || bWarning[0][1] ||
				 bAlarm[1][0] || bAlarm[1][1] || bWarning[1][0] || bWarning[1][1] || 
				 bAlarm[2][0] || bAlarm[2][1] || bWarning[2][0] || bWarning[2][1] ||
				 bAlarm[3][0] || bAlarm[3][1] || bWarning[3][0] || bWarning[3][1] )
			{
				for( int i=0; i<4; i++ )
				{
					bAlarm[i][0] = FALSE;
					bAlarm[i][1] = FALSE;
					bWarning[i][0] = FALSE;
					bWarning[i][1] = FALSE;
				}
				dwTickStart = GetTickCount();
				nSeqNo = 15;
			}
			else nSeqNo = 0;
		}
		break;
	case 15:
		if( !bCheckCond )
		{
			nSeqNo = 0;
		}
		else if( GetTickCount() - dwTickStart > 1000 )
		{
			for( int nAiNo = 0; nAiNo < m_pEqpAssy->m_AnalogInput.GetAiSize(); nAiNo++ )
			{
				for(int i=0; i<m_pEqpAssy->m_AnalogInputTank.GetAiSize(); i++)
				{
					if( m_pEqpAssy->m_AnalogInput.GetAddress( nAiNo ) == m_pEqpAssy->m_AnalogInputTank.GetAddress( i ) )
					{
						int nIntrNo = m_pEqpAssy->m_AnalogInput.m_aiSet[nAiNo].nAiIntrNo;
						if( nIntrNo < 0 ) continue;
						dCurVal[i] = (double) m_pEqpAssy->m_AnalogInputTank.GetRealVal( i );

						bUse[i]	   = m_pSetupItems->m_nValueGaugeLimit_Option[nIntrNo];
						nLowLimit[i]	= m_pSetupItems->m_nValueGaugeLimit[0][nIntrNo];
						nLoWarning[i]	= m_pSetupItems->m_nValueGaugeLimit[1][nIntrNo];
						nUpWarning[i]	= m_pSetupItems->m_nValueGaugeLimit[2][nIntrNo];
						nUpLimit[i]		= m_pSetupItems->m_nValueGaugeLimit[3][nIntrNo];
					}
				}
			}
			
			for(int i=0; i<4; i++)
			{
				if( bCheckCond && bUse[i] )
				{
					if(	nLowLimit[i] >= dCurVal[i]  ) bAlarm[i][0] = TRUE;
					else if( nLowLimit[i] < dCurVal[i] && nLoWarning[i] >= dCurVal[i] ) bWarning[i][0] = TRUE;
					else if( nUpLimit[i] <= dCurVal[i] ) bAlarm[i][1] = TRUE;
					else if( nUpLimit[i] > dCurVal[i] && nUpWarning[i] <= dCurVal[i] ) bWarning[i][1] = TRUE;
				}
			}
			
			if ( bAlarm[0][0] || bAlarm[0][1] || bWarning[0][0] || bWarning[0][1] ||
				 bAlarm[1][0] || bAlarm[1][1] || bWarning[1][0] || bWarning[1][1] || 
				 bAlarm[2][0] || bAlarm[2][1] || bWarning[2][0] || bWarning[2][1] ||
				 bAlarm[3][0] || bAlarm[3][1] || bWarning[3][0] || bWarning[3][1] )
			{
				m_pDicsData->m_IfPump.bCleaningStart = FALSE;

				nSeqNo = 20;
			}
			else nSeqNo = 0;
		}
		break;
	case 20:
		{
			for( int i=0; i<4; i++)
			{
				if ( bAlarm[i][0] ) m_pEqpStateSeq->SetAlarm( ALM_GAUGE_LOWER_ALARM1 + nCheckAiNo[i] );
			    if ( bAlarm[i][1] ) m_pEqpStateSeq->SetAlarm( ALM_GAUGE_UPPER_ALARM1 + nCheckAiNo[i] );
				if ( bWarning[i][0] ) m_pEqpStateSeq->SetAlarm( ALM_GAUGE_LOWER_WARNING1 + nCheckAiNo[i] );
				if ( bWarning[i][1] ) m_pEqpStateSeq->SetAlarm( ALM_GAUGE_UPPER_WARNING1 + nCheckAiNo[i] );
			}
			nSeqNo = 30;
		}
		break;

	case 30:
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{
			for ( int i=0; i<4; i++ )
			{ 
				if ( bAlarm[i][0] ) 
				{
					m_pEqpStateSeq->ResetAlarm( ALM_GAUGE_LOWER_ALARM1 + nCheckAiNo[i] );
					 bAlarm[i][0] = FALSE;
				}
				if ( bAlarm[i][1] ) 
				{
					m_pEqpStateSeq->ResetAlarm( ALM_GAUGE_UPPER_ALARM1 + nCheckAiNo[i] );
					bAlarm[i][1] = FALSE;
				}
				if ( bWarning[i][0] ) 
				{
					m_pEqpStateSeq->ResetAlarm( ALM_GAUGE_LOWER_WARNING1 + nCheckAiNo[i] );
					bWarning[i][0] =FALSE;
				}
				if ( bWarning[i][1] ) 
				{
					m_pEqpStateSeq->ResetAlarm( ALM_GAUGE_UPPER_WARNING1 + nCheckAiNo[i] );
					bWarning[i][1] = FALSE;
				}
			}

			nSeqNo = 0;
		}
		break;
	}
	m_nSeqCleaningModeCtrlNo = nSeqNo;

}

void CPumpSeq::SeqDiPumpInterlock(int nDiNo)
{
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return;
#endif

	static int nReturnSeqNo[MAX_DI_TANK_NO];
	static int nAlarmId[MAX_DI_TANK_NO];
	static DWORD dwStartTickCount[MAX_DI_TANK_NO];
	static DWORD dwMarginTime;
	BOOL bFlowInterlock[MAX_DI_FLOW_INTERLOCK] = { TRUE, TRUE };//, TRUE, TRUE, TRUE, TRUE };
	
	float fFlowRate[MAX_DI_TANK_NO][MAX_DI_FLOW_INTERLOCK] = { { 0, 0,}, };		// 20101001 ssm DI interlock count
	BOOL bSbjCheckCond = m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupSWR1_SBJ_USE + nDiNo];  // SanghoCho 2015.04.15		// hskwak interlock Ȯ
	
	int nSeqNo = m_nSeqDiPumpInterlockNo[nDiNo];
	
	m_sSeqName.Format( "DI INTR%d", nDiNo + 1 );

	
	switch( nSeqNo )
	{
	case 0 :
#ifdef _BUFTANK_USE
		if( nDiNo < NO_BUFTANK )
		{
			if(	m_pEqpAssy->m_DiTank[nDiNo].GetPumpOn() || m_pEqpAssy->m_DiTank[nDiNo].GetPumpOnState() )
			{
				dwStartTickCount[nDiNo] = GetTickCount();
				dwMarginTime = (DWORD)( PUMP_FLOW_LIMIT_CHECK_TIME * 1000 );
				nSeqNo = 10;
			}
		}
		else
		{
			if(	m_pEqpAssy->m_DiTank[nDiNo].GetPumpOn(0) || m_pEqpAssy->m_DiTank[nDiNo].GetPumpOnState(0) 
				|| m_pEqpAssy->m_DiTank[nDiNo].GetPumpOn(1) || m_pEqpAssy->m_DiTank[nDiNo].GetPumpOnState(1))
			{
				dwStartTickCount[nDiNo] = GetTickCount();
				dwMarginTime = (DWORD)( PUMP_FLOW_LIMIT_CHECK_TIME * 1000 );
				nSeqNo = 10;
			}
		}
#else
		if(	m_pEqpAssy->m_DiTank[nDiNo].GetPumpOn() || m_pEqpAssy->m_DiTank[nDiNo].GetPumpOnState() )
		{
			dwStartTickCount[nDiNo] = GetTickCount();
			dwMarginTime = (DWORD)( PUMP_FLOW_LIMIT_CHECK_TIME * 1000 );
			nSeqNo = 10;
		}
#endif
		break;		
	case 10 :
		{
			BOOL bInterlockOk = TRUE;
			BOOL bInterlockCheckCond = TRUE;
			for( int j = 0; j < MAX_DI_FLOW_INTERLOCK; j++ )
			{
				//if( j == 4 || j == 5 ) bInterlockCheckCond = bSbjCheckCond;
				//else 
				bInterlockCheckCond = TRUE;
				//  Check ̳  ļ üũ ϴ   ʿ.
				fFlowRate[nDiNo][j] = m_pEqpAssy->m_DiTank[nDiNo].GetShowerFlowInterlock(j);
				if( fFlowRate[nDiNo][j] < (float)DI_PUMP_INTERLOCK_MIN_FLOWRATE && bInterlockCheckCond )
				{
					bFlowInterlock[j] = FALSE;
				}				
				bInterlockOk &= bFlowInterlock[j];
#ifdef _MY_DEBUG
				bInterlockOk = TRUE;
#endif
			}

#ifdef _BUFTANK_USE
			if( !m_pEqpAssy->m_DiTank[nDiNo].GetPumpOn() || !m_pEqpAssy->m_DiTank[nDiNo].GetPumpOnState() || bInterlockOk )
			{
				m_SeqFlag.bInsufficientDiFlowrate[nDiNo] = FALSE;
				nSeqNo = 0;
			}
			else if( GetTickCount() - dwStartTickCount[nDiNo] > dwMarginTime )
			{
				m_pEqpAssy->m_DiTank[nDiNo].SetPumpOn(0, OFF);
				
				m_SeqFlag.bInsufficientDiFlowrate[nDiNo] = TRUE;
				
				SetLog( m_sSeqName, 0, 0, "INSUFFICIENT FLOW-RATE" );
				
				nAlarmId[nDiNo] = ALM_DI_PUMP1_INTERLOCK_ALARM + nDiNo;
				m_pEqpStateSeq->SetAlarm( nAlarmId[nDiNo] );
				nReturnSeqNo[nDiNo] = 0;
				nSeqNo = 1000;
			}
		}
#else
		if( nDiNo < NO_BUFTANK )
			if( !m_pEqpAssy->m_DiTank[nDiNo].GetPumpOn() || !m_pEqpAssy->m_DiTank[nDiNo].GetPumpOnState() || bInterlockOk )
			{
				m_SeqFlag.bInsufficientDiFlowrate[nDiNo] = FALSE;
				nSeqNo = 0;
			}
			else if( GetTickCount() - dwStartTickCount[nDiNo] > dwMarginTime )
			{
				m_pEqpAssy->m_DiTank[nDiNo].SetPumpOn(0, OFF);
				
				m_SeqFlag.bInsufficientDiFlowrate[nDiNo] = TRUE;
				
				SetLog( m_sSeqName, 0, 0, "INSUFFICIENT FLOW-RATE" );
				
				nAlarmId[nDiNo] = ALM_DI_PUMP1_INTERLOCK_ALARM + nDiNo;
				m_pEqpStateSeq->SetAlarm( nAlarmId[nDiNo] );
				nReturnSeqNo[nDiNo] = 0;
				nSeqNo = 1000;
			}
		}
#endif

		break;		
	case 1000 :
		if( m_pEqpAssy->m_DiTank[nDiNo].GetPumpOn() || m_pEqpAssy->m_DiTank[nDiNo].GetPumpOnState() )
		{
			m_pEqpAssy->m_DiTank[nDiNo].SetPumpOn( 0, OFF );
		}
		if( m_pEqpStateSeq->IsPushedAlarmReset() )
		{			
			m_SeqFlag.bInsufficientDiFlowrate[nDiNo] = FALSE;

			m_pEqpStateSeq->ResetAlarm( nAlarmId[nDiNo] );			

			SetLog( m_sSeqName, -1, -1, "ALARM RESET" );
			nSeqNo = nReturnSeqNo[nDiNo];
		}
		break;
	}
	m_nSeqDiPumpInterlockNo[nDiNo] = nSeqNo;
}

void CPumpSeq::SeqIonizer(int nIonNo)
{	
	BOOL bRunCond = TRUE;
	bRunCond &= m_pEqpAssy->m_OutputIonizer.GetState( nIonNo );
	if( !bRunCond )
	{
		m_pEqpAssy->m_OutputIonizer.Set( nIonNo, ON );
	}
}

void CPumpSeq::SeqSWR1BathDrainNTankReturn()
{
	int nStep = m_nSeqSWR1BathdrainNTankReturnNo;
	static DWORD	dTickTime = 0;
	BOOL	bRunCond = TRUE;
	
	//	bRunCond &=	m_pDicsData->m_GenInfo.bAuto;
	bRunCond &= m_pDicsData->m_JobCond.bJobProcessUse;
	bRunCond &= !m_pDicsData->m_GenInfo.bEmo;
	bRunCond &= !m_pDicsData->m_GenInfo.bLeakSensor;
//	bRunCond &= !m_pDicsData->m_GenInfo.bCoverOpen;
//	bRunCond &= !m_pDicsData->m_GenInfo.bDoorOpen;
//	bRunCond &= !(m_pDicsData->m_GenInfo.bSbjStop && m_pDicsData->m_GenInfo.bAuto);
//	bRunCond &= !(m_pDicsData->m_GenInfo.bPause && m_pDicsData->m_GenInfo.bAuto);
//	bRunCond &=	!m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP1_USE];
//	bRunCond &=	!m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupDI_PUMP2_USE];

	switch(nStep)
	{
	case 0:
		m_pEqpAssy->m_AutoValueSWR2BathDrain.Set(0, ON);
		nStep = 10;
		break;

	case 10:
		if( !bRunCond )
		{
			if( m_pEqpAssy->m_AutoValueSWR2BathDrain.GetState() )	m_pEqpAssy->m_AutoValueSWR2BathDrain.Set(0, OFF);
			if( m_pEqpAssy->m_AutoValueSWR2TankReturn.GetState() )	m_pEqpAssy->m_AutoValueSWR2TankReturn.Set(0, OFF);
		}
		nStep = 20;
		break;

	case 20:
		if( bRunCond && m_pDicsData->m_IfPump.bCleaningStart )
		{
			if( m_pEqpAssy->m_AutoValueSWR2BathDrain.GetState() )	m_pEqpAssy->m_AutoValueSWR2BathDrain.Set(0, OFF);
			if( !m_pEqpAssy->m_AutoValueSWR2TankReturn.GetState() )	m_pEqpAssy->m_AutoValueSWR2TankReturn.Set(0, ON);
		}
		else if( bRunCond && !m_pDicsData->m_IfPump.bCleaningStart && (m_pEqpAssy->m_AutoValveDirect.GetState( 0 ) ||  m_pEqpAssy->m_AutoValvePumpOut.GetState( 0 )))
		{
			if( !m_pEqpAssy->m_AutoValueSWR2BathDrain.GetState() )	m_pEqpAssy->m_AutoValueSWR2BathDrain.Set(0, ON);
			if( m_pEqpAssy->m_AutoValueSWR2TankReturn.GetState() )	m_pEqpAssy->m_AutoValueSWR2TankReturn.Set(0, OFF);
		}
		else if( bRunCond && !m_pDicsData->m_IfPump.bCleaningStart && !m_pEqpAssy->m_AutoValueSWR2BathDrain.GetState() )
		{
			if( dTickTime == 0 )	dTickTime = GetTickCount();
			else if( GetTickCount() - dTickTime > 60000 )
			{
				m_pEqpAssy->m_AutoValueSWR2BathDrain.Set(0, ON);
				dTickTime = 0;
			}
		}
		nStep = 10;
		break;
	}

	m_nSeqSWR1BathdrainNTankReturnNo = nStep;
}