// RbSeq.h: interface for the CRbSeq class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RBSEQ_H__98F957EA_7074_43AC_B998_517A0FBED456__INCLUDED_)
#define AFX_RBSEQ_H__98F957EA_7074_43AC_B998_517A0FBED456__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\MOTHER\DicsRbSeq.h"
#include "..\X\MuxCom.h"
#include "..\X\MuxCom2.h"

class CRbSeq : public CDicsRbSeq  
{
public:
	BOOL GetRbCond();
	void SeqRbGapControl( int nRbNo );
	CRbSeq();
	virtual ~CRbSeq();
	
	BOOL Sequence();
	void SeqRbMotorControl(int nRbNo);	
	void SeqRbMotorCond( int nRbNo );
	int  SetRbSpeed( int nRbNo );
	BOOL IsRbUse( int nRbNo );
	int  SetRbGap( int nRbNo );
	void SeqInit( int nRbNo);

	void SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage );//2008.12.17 kimgun

	CMuxCom*	m_pMuxCom;
	CMuxCom2*	m_pMuxCom2;
	void SetCommMux(CMuxCom * pComm) { m_pMuxCom = pComm; };
	void SetCommMux2(CMuxCom2 * pComm) { m_pMuxCom2 = pComm; };
	void SeqCommMux(int nMuxNo);
	int m_nSeqCommMux[MAX_MUX10];
	int ReceiveMux(char cSend, CString strReceiveData, CString sSeqName, int nMuxNo, int &nErrCode, int &nErrPart);
};

#endif // !defined(AFX_RBSEQ_H__98F957EA_7074_43AC_B998_517A0FBED456__INCLUDED_)
