// TitlePanel.cpp: implementation of the CTitlePanel class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Dics.h"
#include "TitlePanel.h"
#include "Dlg\DlgPassword.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
 
/////////////////////////////////////////////////////////////////////////////
// CTitlePanel

CTitlePanel::CTitlePanel()
{
}

CTitlePanel::~CTitlePanel()
{
}


BEGIN_MESSAGE_MAP(CTitlePanel,  CDialogBarEx)
	//{{AFX_MSG_MAP(CTitlePanel)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	ON_WM_CTLCOLOR()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_USER_ID, OnButtonUserID )
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_MSG_BOX_CLICKED, OnMsgBoxClicked )
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CTitlePanel message handlers

void CTitlePanel::DoDataExchange(CDataExchange* pDX) 
{
	CDialogBarEx::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTitlePanel)
	DDX_Control( pDX, IDC_BUTTON_USER_ID, m_bmpbtnUserID );
	DDX_Control( pDX, IDC_COMBO_MESSAGE, m_cbMessage );
	//}}AFX_DATA_MAP
}

// -----------------------------------------------------------
// OnInitDialogBar() : virtual function
// -----------------------------------------------------------
void CTitlePanel::OnInitDialogBar()
{
	if( !SetTimer( TIMER_CUR_TIME, 1000, NULL ) ) return;

	// CMsgBox : Date (100)
	CRect r;
	GetDlgItem( IDC_DATE )->GetWindowRect( &r );
	ScreenToClient( &r );
	m_msgDate.Create( 100, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_DATE,
			WHITE_COLOR, BLUE_COLOR, 18, TRUE );
	m_msgDate.SetOpMsg( "" );

	// CMsgBox : Time (101)
	GetDlgItem( IDC_TIME )->GetWindowRect( &r );
	ScreenToClient( &r );
	m_msgTime.Create( 101, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_TIME,
			WHITE_COLOR, BLUE_COLOR, 18, TRUE );
	m_msgTime.SetOpMsg( "" );

	// CMsgBox : Host Status (102)
	GetDlgItem( IDC_HOST_COMM_STATUS )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgHostCommStatus.Create( 102, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_HOST_COMM_STATUS,
			WHITE_COLOR, RED_COLOR, 20, TRUE );
	m_msgHostCommStatus.SetOpMsg( "Offline" );

	// CMsgBox : View Name (103)
	GetDlgItem( IDC_VIEW_NAME )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgViewName.Create( 103, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_VIEW_NAME,
			WHITE_COLOR, BLUE_COLOR, 28, TRUE );
	m_msgViewName.SetOpMsg( "AUTO" );

//	// CMsgBox : Message (104)
//	GetDlgItem( IDC_MESSAGE )->GetWindowRect( &r );
//	ScreenToClient( &r );
//	r -= CRect( 1, 1, 1, 1 );
//	m_msgMessage.Create( 104, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_MESSAGE,
//			YELLOW_COLOR, BLACK_COLOR, 20, TRUE );
//	m_msgMessage.SetOpMsg( "Message Area" );

	// CMsgBox : DeviceNet Status (105)
	GetDlgItem( IDC_STATUS1 )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgStatus1.Create( 200, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_STATUS1,
			BLUE_COLOR, RED_COLOR, 16, TRUE );
	m_msgStatus1.SetOpMsg( "Not Connected" );

	// CMsgBox : HSMS (106) TCP/IP
	GetDlgItem( IDC_STATUS2 )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgStatus2.Create( 106, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_STATUS2,
			WHITE_COLOR, RED_COLOR, 16, TRUE );
	m_msgStatus2.SetOpMsg( "Unknown" );

	// CMsgBox : UP Stream Status (107) MELSEC NET 1stBoard - LOAD
	GetDlgItem( IDC_STATUS3 )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgStatus3.Create( 107, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_STATUS3,
			WHITE_COLOR, RED_COLOR, 16, TRUE );
	m_msgStatus3.SetOpMsg( "Unknown" );	

	// CMsgBox : HSMS1 (106) TCP/IP
	GetDlgItem( IDC_STATUS4 )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgStatus4.Create( 106, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_STATUS4,
			WHITE_COLOR, RED_COLOR, 16, TRUE );
	m_msgStatus4.SetOpMsg( "Unknown" );

	// CMsgBox : UP Stream Status (107) MELSEC NET 1stBoard - UNLOAD
	GetDlgItem( IDC_STATUS5 )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgStatus5.Create( 107, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_STATUS5,
			WHITE_COLOR, RED_COLOR, 16, TRUE );
	m_msgStatus5.SetOpMsg( "Unknown" );

	// CMsgBox : User ID (108)
	GetDlgItem( IDC_USER_ID )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 1, 1, 1, 1 );
	m_msgUserID.Create( 108, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_USER_ID,
			YELLOW_COLOR, BLUE_COLOR, 16, FALSE );
#ifndef _MY_DEBUG	
	m_msgUserID.SetOpMsg( "OPERATOR" );
#else
	m_msgUserID.SetOpMsg( "ENGINEER" );
#endif
	m_bmpbtnUserID.LoadBitmaps( IDB_BITMAP_LOGIN );

	// Set the background color of ctlColor
	m_hbrBgColor = CreateSolidBrush( LIGHT_BLUE_COLOR );
	m_hbrCbColor = CreateSolidBrush( YELLOW_COLOR );

	VERIFY( m_AviLogo.SubclassDlgItem( IDC_STATIC_LOGO, this ) );
	CString sAviName;
	sAviName.Format( "res\\logo.avi" );
	VERIFY( m_AviLogo.Load( sAviName, /*AVC_AUTOPLAY|*/AVC_CENTERAVI ) == NOERROR );

	m_AviLogo.Play();

	// Redraw the dialog bar
	Invalidate();
}

// -----------------------------------------------------------
// OnDestroy()
// -----------------------------------------------------------
void CTitlePanel::OnDestroy() 
{
	CDialogBarEx::OnDestroy();
	
	DeleteObject( m_hbrBgColor );
	DeleteObject( m_hbrCbColor );
}

// -----------------------------------------------------------
// OnCtlColor()
// Set the control color
// -----------------------------------------------------------
HBRUSH CTitlePanel::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialogBarEx::OnCtlColor(pDC, pWnd, nCtlColor);
	
	UINT id = pWnd->GetDlgCtrlID();
	switch( nCtlColor )
	{
		case CTLCOLOR_EDIT:
			if( id == IDC_COMBO_MESSAGE )
			{
				hbr = m_hbrCbColor;
				pDC->SetBkColor( YELLOW_COLOR );
				pDC->SetBkMode( TRANSPARENT );
				pDC->SetTextColor( BLACK_COLOR );
			}
			break;
		case CTLCOLOR_STATIC:
			if( id == IDC_TITLE_HOST_STATUS ||
				id == IDC_TITLE_MESSAGE ||
				id == IDC_TITLE_VIEW_NAME ||
				id == IDC_TITLE_STATUS1 ||
				id == IDC_TITLE_STATUS2 ||
				id == IDC_TITLE_STATUS3 )
			{
				hbr = m_hbrBgColor;
				pDC->SetBkMode( TRANSPARENT );
				pDC->SetTextColor( BLACK_COLOR );
			}
			break;
	}
	return hbr;
}

//--------------------------------------------------------------------
// Show the date & time
//--------------------------------------------------------------------
void CTitlePanel::OnTimer(UINT nIDEvent) 
{
	if( nIDEvent == TIMER_CUR_TIME ) 
	{
		char timebuf[80];
		struct tm *newtime;
        char am_pm[] = "AM";
//		static char *week[] = 
//		{
//			"SUN", "MON", "TUE",
//			"WED", "THU", "FRI", "SAT"
//		};
        time_t long_time;

        time( &long_time );                // Get time as long integer. 
        newtime = localtime( &long_time ); // Convert to local time. 

        if( newtime->tm_hour >= 12 )        // Set up extension. 
                strcpy( am_pm, "PM" );
        if( newtime->tm_hour > 12 )        // Convert from 24-hour 
                newtime->tm_hour -= 12;    //   to 12-hour clock.  
        if( newtime->tm_hour == 0 )        // Set hour to 12 if midnight. 
                newtime->tm_hour = 12;

//		wsprintf( timebuf, 
//				"%d/%02d/%02d %s %s %02d:%02d:%02d\n", 
//					newtime->tm_year + 1900,
//					newtime->tm_mon+1,
//					newtime->tm_mday,
//					week[newtime->tm_wday],
//					am_pm,
//					newtime->tm_hour,
//					newtime->tm_min,
//					newtime->tm_sec );

//		wsprintf( timebuf, "%.19s %s %d", asctime( newtime ), am_pm, newtime->tm_year + 1900 );
		wsprintf( timebuf, "%.10s %d", asctime( newtime ), newtime->tm_year + 1900 );
		m_msgDate.SetOpMsg( timebuf );
		wsprintf( timebuf, "%02d:%02d:%02d %s", newtime->tm_hour, newtime->tm_min, newtime->tm_sec, am_pm );
		m_msgTime.SetOpMsg( timebuf );
	}
	
	CDialogBarEx::OnTimer(nIDEvent);
}

void CTitlePanel::OnButtonUserID()
{
}

LRESULT CTitlePanel::OnMsgBoxClicked( WPARAM wParam, LPARAM lParam )
{
	if( wParam == 108 )
	{
		CDlgPassword dlg;
		dlg.SetDicsData( m_pDicsData );
		if( dlg.DoModal() != IDOK )return 0;
		m_msgUserID.SetOpMsg( (LPCTSTR)m_pDicsData->m_LoginInfo.sCurUserID );
	}
	return 0;
}