#if !defined(AFX_ALARMSTAB2VIEW_H__0C5BCED6_2553_4E1F_B10E_D3C0F9939EC7__INCLUDED_)
#define AFX_ALARMSTAB2VIEW_H__0C5BCED6_2553_4E1F_B10E_D3C0F9939EC7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// AlarmsTab2View.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CAlarmsTab2View form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "..\X\ChartWnd.h"
#include "..\X\MsgBox.h"

class CAlarmInfo
{
public:
	CAlarmInfo( int nCode, int nCount )
	{
		m_nCode		= nCode;
		m_nCount	= nCount;
	}
public:
	int	m_nCode;
	int	m_nCount;
};

class CAlarmsTab2View : public CFormView
{
public:
	CAlarmsTab2View();           // protected constructor used by dynamic creation
	CAlarmsTab2View( CView* pView, int nTabNo );
	DECLARE_DYNCREATE(CAlarmsTab2View)

// Form Data
public:
	//{{AFX_DATA(CAlarmsTab2View)
	enum { IDD = IDD_ALARMS_TAB2_VIEW };
	CChartWnd 	m_ChartWnd;
	//}}AFX_DATA

// Attributes
public:
	int	m_nTabNo;
	CView* m_pView;
	int m_nMargin;
	CMutex m_mutex;
	int m_nMaxCount;

	CMsgBox		m_msgTitleDescription;
	CMsgBox		m_msgDescription;

	CTypedPtrArray< CPtrArray, CAlarmInfo* > m_arrayAlarmInfo;

// Operations
public:
	void AlarmGraphDraw();
	void GetAlarmCodeInfo();
	void QuickSort( int* nData, int lb, int ub );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAlarmsTab2View)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnDraw(CDC* pDC);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CAlarmsTab2View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CAlarmsTab2View)
	afx_msg void OnClose();
	//}}AFX_MSG
	afx_msg LRESULT OnMouseMoveOnUser( WPARAM wParam, LPARAM lParam );
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ALARMSTAB2VIEW_H__0C5BCED6_2553_4E1F_B10E_D3C0F9939EC7__INCLUDED_)
