#if !defined(AFX_ALARMSVIEW_H__33790B54_41D2_4FBE_AABD_7979510194A6__INCLUDED_)
#define AFX_ALARMSVIEW_H__33790B54_41D2_4FBE_AABD_7979510194A6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// AlarmsView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CAlarmsView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

// Include
#include "..\X\XTabCtrl.h"

#include "AlarmsTab1View.h"
#include "AlarmsTab2View.h"
#include "AlarmsTab3View.h"

class CAlarmsView : public CFormView
{
protected:
	CAlarmsView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CAlarmsView)

// Form Data
public:
	//{{AFX_DATA(CAlarmsView)
	enum { IDD = IDD_ALARMS_FORM };
	CXTabCtrl	m_tabCtrl;
	//}}AFX_DATA

// Attributes
public:
	CDicsDoc* GetDocument();

	CAlarmsTab1View*	m_pTabAlarmsTab1View;
	CAlarmsTab2View*	m_pTabAlarmsTab2View;
	CAlarmsTab3View*	m_pTabAlarmsTab3View;

	int m_nSelectedTab;

	enum { viewAlarmHistory, viewAlarmGraph, viewAlarmList };

	// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAlarmsView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CAlarmsView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CAlarmsView)
	afx_msg void OnDestroy();
	//}}AFX_MSG
	afx_msg LRESULT OnSelChangeTab( WPARAM wParam, LPARAM lParam );
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in DicsView.cpp
inline CDicsDoc* CAlarmsView::GetDocument()
   { return (CDicsDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ALARMSVIEW_H__33790B54_41D2_4FBE_AABD_7979510194A6__INCLUDED_)
