// DatalogTab2View.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "DatalogTab2View.h"
#include "DatalogView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDatalogTab2View

IMPLEMENT_DYNCREATE(CDatalogTab2View, CHiliteEditView)

CDatalogTab2View::CDatalogTab2View()
{
}

CDatalogTab2View::CDatalogTab2View(CView* pView)
{
	m_pView = pView;
	m_sPathName = "No file name";
}

CDatalogTab2View::~CDatalogTab2View()
{
}


BEGIN_MESSAGE_MAP(CDatalogTab2View, CHiliteEditView)
	//{{AFX_MSG_MAP(CDatalogTab2View)
	ON_WM_DESTROY()
	ON_WM_CHAR()
	ON_WM_CONTEXTMENU()
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDatalogTab2View drawing

void CDatalogTab2View::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CDatalogTab2View diagnostics

#ifdef _DEBUG
void CDatalogTab2View::AssertValid() const
{
	CHiliteEditView::AssertValid();
}

void CDatalogTab2View::Dump(CDumpContext& dc) const
{
	CHiliteEditView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDatalogTab2View message handlers

BOOL CDatalogTab2View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

//--------------------------------------------------------------------
// OnInitialUpdate()
//--------------------------------------------------------------------
void CDatalogTab2View::OnInitialUpdate() 
{
	CHiliteEditView::OnInitialUpdate();
	
	// TODO: Add your specialized code here and/or call the base class
	
}

//--------------------------------------------------------------------
// OnDestroy() : There is no OnClose() functoin
//--------------------------------------------------------------------
void CDatalogTab2View::OnDestroy() 
{
	// TODO: Add your message handler code here
}


//--------------------------------------------------------------------
// OnOpenFile
//--------------------------------------------------------------------
void CDatalogTab2View::OnOpenFile()
{
	// Backup the current directory
	char szPathName[100];
	GetCurrentDirectory( 100, szPathName );

	CFileDialog fileOpenDlg( TRUE, _T("log"), NULL, OFN_FILEMUSTEXIST|OFN_HIDEREADONLY,
		_T( "Eqp Log Files (EqpLog*.log)|EqpLog*.log|"
			"SF Log Files (SFLog*.log)|SFLog*.log|"
			"All Files (*.*)|*.*||") );
		
	if( fileOpenDlg.DoModal() != IDOK ) return;

	// Get the path name
	m_sPathName = fileOpenDlg.GetPathName();

	CFile f;
	if( f.Open( m_sPathName, CFile::modeRead | CFile::shareDenyNone ) )
	{
		// Set the path name
		( ( CDatalogView* ) m_pView )->m_msgFileName.SetOpMsg( m_sPathName );

		CArchive ar( &f, CArchive::load );

		BeginWaitCursor(); 
		Serialize( ar );
		EndWaitCursor(); 
		f.Close();
	}
	else AfxMessageBox( "File could not be opened" );

	// Set to the original path
	SetCurrentDirectory( szPathName );
}

//---------------------------------------------------------------------------
// Search data
//---------------------------------------------------------------------------
void CDatalogTab2View::OnSearch() 
{
	( ( CDatalogView* ) m_pView )->UpdateData( TRUE );

	if( ( ( CDatalogView* ) m_pView )->m_sTextSearch == "" ) return;

	BOOL bResult = FindText( ( ( CDatalogView* ) m_pView )->m_sTextSearch );
	if( !bResult ) AfxMessageBox( "Can't find the selected text" );
}

void CDatalogTab2View::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	return;

	CHiliteEditView::OnChar(nChar, nRepCnt, nFlags);
}

void CDatalogTab2View::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	// TODO: Add your message handler code here
	return;	
}

BOOL CDatalogTab2View::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
{
	// TODO: Add your specialized code here and/or call the base class
	// return TRUE;
	if( nID == 57637 || nID == 57635) //CTRL + V ? return false
	{
		return FALSE;
	}

	return CHiliteEditView::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

void CDatalogTab2View::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	return;
	CHiliteEditView::OnKeyDown(nChar, nRepCnt, nFlags);
}
