#if !defined(AFX_DATALOGVIEW_H__F161E882_7BF3_45C1_AC1F_9DAEF51EC872__INCLUDED_)
#define AFX_DATALOGVIEW_H__F161E882_7BF3_45C1_AC1F_9DAEF51EC872__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DatalogView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDatalogView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

// Include
#include "..\X\MacButtons.h"
#include "..\X\XTabCtrl.h"
#include "..\X\HiliteEditView.h"
#include "..\X\MsgBox.h"

#include "DatalogTab1View.h"
#include "DatalogTab2View.h"

class CDatalogView : public CFormView
{
protected:
	CDatalogView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CDatalogView)

// Form Data
public:
	//{{AFX_DATA(CDatalogView)
	enum { IDD = IDD_DATALOG_FORM };
	CXTabCtrl	m_tabCtrl;
	CString	m_sTextSearch;
	CMacButton m_macSearch;
	//}}AFX_DATA

// Attributes
public:
	CDicsDoc* GetDocument();
	CDatalogTab1View*	m_pTabDatalogTab1View;
	CDatalogTab2View*	m_pTabDatalogTab2View;

	CMsgBox		m_msgTitle;
	CMsgBox		m_msgFileName;

// Operations
public:
	void OnOpenFile();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDatalogView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CDatalogView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CDatalogView)
	afx_msg void OnDestroy();
	afx_msg void OnSearch();
	//}}AFX_MSG
	afx_msg LRESULT OnSelChangeTab( WPARAM wParam, LPARAM lParam );
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in DicsView.cpp
inline CDicsDoc* CDatalogView::GetDocument()
   { return (CDicsDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DATALOGVIEW_H__F161E882_7BF3_45C1_AC1F_9DAEF51EC872__INCLUDED_)
