// HelpTab1ContentsView.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "HelpTab1ContentsView.h"
#include "HelpTab1View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHelpTab1ContentsView

IMPLEMENT_DYNCREATE(CHelpTab1ContentsView, CFormView)

TREE_LEVEL CHelpTab1ContentsView::m_tlLevel1[] =
{ 
	{ "HDS", IMAGE_CLOSEFOLDER }
};

TREE_LEVEL CHelpTab1ContentsView::m_tlLevel2[] = 
{  
	{ "1. Jobs",			IMAGE_JOBS },
	{ "2. Maint",			IMAGE_MAINT },
	{ "3. System",			IMAGE_SYSTEM },
	{ "4. Servo",			IMAGE_SERVO },
	{ "5. Recipe",			IMAGE_RECIPE },
	{ "6. Datalog",			IMAGE_DATALOG },
	{ "7. Setup",			IMAGE_SETUP },
	{ "8. Alarm",			IMAGE_ALARM },
	{ "9. Item",			IMAGE_ITEM },
	{ "10.Trouble Shooting", IMAGE_ALARMHELP }
};

TREE_LEVEL CHelpTab1ContentsView::m_tlLevel31[] = 
{
	{ "1_1. MAIN VIEW",		IMAGE_CLOSEBOOK },
	{ "1_2. CIM VIEW",		IMAGE_CLOSEBOOK },
	{ "1_3. PIPING VIEW",	IMAGE_CLOSEBOOK },
	{ "1_4. INTERFACE VIEW",IMAGE_CLOSEBOOK },
	{ "1_5. Initialize",	IMAGE_INIT },
	{ "1_6. Cycle Stop",	IMAGE_CYCLESTOP },
	{ "1_7. Cycle Run",		IMAGE_CYCLERUN }
};

TREE_LEVEL CHelpTab1ContentsView::m_tlLevel32[] = 
{
	{ "2_1. MAIN VIEW",		IMAGE_CLOSEBOOK },
	{ "2_2. CIM VIEW",		IMAGE_CLOSEBOOK },
	{ "2_3. PIPING VIEW",	IMAGE_CLOSEBOOK },
	{ "2_4. INTERFACE VIEW",IMAGE_CLOSEBOOK },
	{ "2_5. DI Run",		IMAGE_DIRUN },
	{ "2_6. DI Stop",		IMAGE_DISTOP }
};

TREE_LEVEL CHelpTab1ContentsView::m_tlLevel33[] = 
{
	{ "3_1. INPUT",			IMAGE_CLOSEBOOK },
	{ "3_2. OUTPUT",		IMAGE_CLOSEBOOK }
};

TREE_LEVEL CHelpTab1ContentsView::m_tlLevel34[] = 
{
	{ "4_1. TR VIEW",				IMAGE_CLOSEBOOK },
	{ "4_2. LD LOWER HAND VIEW",	IMAGE_CLOSEBOOK },
	{ "4_3. LD UPPER HAND VIEW",	IMAGE_CLOSEBOOK },
	{ "4_4. UL LOWER HAND VIEW",	IMAGE_CLOSEBOOK },
	{ "4_5. UL UPPER HAND VIEW",	IMAGE_CLOSEBOOK },
	{ "4_6. SEMI AUTO VIEW",		IMAGE_CLOSEBOOK }
};

TREE_LEVEL CHelpTab1ContentsView::m_tlLevel35[] = 
{
	{ "5_1. RECIPE VIEW",	IMAGE_CLOSEBOOK },
	{ "5_2. Select", 		IMAGE_SELECT },
	{ "5_3. Copy",			IMAGE_COPY },
	{ "5_4. Save",			IMAGE_SAVE }
};

TREE_LEVEL CHelpTab1ContentsView::m_tlLevel36[] = 
{
	{ "6_1. Open",	IMAGE_OPEN }
};

TREE_LEVEL CHelpTab1ContentsView::m_tlLevel37[] = 
{
	{ "7_1. JOB CONDITION",		IMAGE_CLOSEBOOK },
	{ "7_2. INTR SET VIEW",		IMAGE_CLOSEBOOK },
	{ "7_3. HSMS PARA VIEW",	IMAGE_CLOSEBOOK },
	{ "7_4. Save",				IMAGE_SAVE }
};

TREE_LEVEL CHelpTab1ContentsView::m_tlLevel38[] = 
{
	{ "8_1. ALARM HISTORY VIEW",IMAGE_CLOSEBOOK },
	{ "8_2. Save",				IMAGE_SAVE },
	{ "8_3. Delete",			IMAGE_DELETE }
};

TREE_LEVEL CHelpTab1ContentsView::m_tlLevel39[] = 
{
	{ "9_1. Auto Valve",		IMAGE_CLOSEBOOK },
	{ "9_2. Conveyor Motor",	IMAGE_CLOSEBOOK },
	{ "9_3. EUV",				IMAGE_CLOSEBOOK },
	{ "9_4. IdleRunning",		IMAGE_CLOSEBOOK },
	{ "9_5. Pump ",				IMAGE_CLOSEBOOK },
	{ "9_6. Recovery",			IMAGE_CLOSEBOOK },
	{ "9_7. Roll Brush",		IMAGE_CLOSEBOOK },
	{ "9_8. Servo",				IMAGE_CLOSEBOOK }
};

TREE_LEVEL CHelpTab1ContentsView::m_tlLevel40[] = 
{
	{ "10_1. Initialize Error",					IMAGE_CLOSEBOOK },
	{ "10_2. Servo Error",						IMAGE_CLOSEBOOK },
	{ "10_3. CV Motor Error",					IMAGE_CLOSEBOOK },
	{ "10_4. R/B Motor Error",					IMAGE_CLOSEBOOK },
	{ "10_5. R/B Cylinder Error",				IMAGE_CLOSEBOOK },
	{ "10_6. Align Cylinder Error",				IMAGE_CLOSEBOOK },
	{ "10_7. Glass Sensing Error",				IMAGE_CLOSEBOOK },
	{ "10_8. Glass Not Sensing Error",			IMAGE_CLOSEBOOK },
	{ "10_9. Glass Data Error",					IMAGE_CLOSEBOOK },
	{ "10_10. Broken Sensing Error",			IMAGE_CLOSEBOOK },
	{ "10_11. Tank Level Sensor Error",			IMAGE_CLOSEBOOK },
	{ "10_12. On Timeout Error",				IMAGE_CLOSEBOOK },
	{ "10_13. Off Timeout Error",				IMAGE_CLOSEBOOK },
	{ "10_14. Bath Cover Open Error",			IMAGE_CLOSEBOOK },
	{ "10_15. Door Safty Sensor Error",			IMAGE_CLOSEBOOK },
	{ "10_16. Leak Sensor Sensing Error",		IMAGE_CLOSEBOOK },
	{ "10_17. Gauge Max Limit Error",			IMAGE_CLOSEBOOK },
	{ "10_18. Gauge Warning Max Limit Error",	IMAGE_CLOSEBOOK },
	{ "10_19. Gauge Min Limit Error",			IMAGE_CLOSEBOOK },
	{ "10_20. Gauge Warning Min Limit Error",	IMAGE_CLOSEBOOK }
};

CHelpTab1ContentsView::CHelpTab1ContentsView()
	: CFormView(CHelpTab1ContentsView::IDD)
{
	//{{AFX_DATA_INIT(CHelpTab1ContentsView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CHelpTab1ContentsView::CHelpTab1ContentsView(CView* pView)
	: CFormView(CHelpTab1ContentsView::IDD)
{
	m_pView = pView;
}

CHelpTab1ContentsView::~CHelpTab1ContentsView()
{
}

void CHelpTab1ContentsView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHelpTab1ContentsView)
	DDX_Control(pDX, IDC_TREE_CONTENTS, m_treeContents);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CHelpTab1ContentsView, CFormView)
	//{{AFX_MSG_MAP(CHelpTab1ContentsView)
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE_CONTENTS, OnSelchangedTreeContents)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHelpTab1ContentsView diagnostics

#ifdef _DEBUG
void CHelpTab1ContentsView::AssertValid() const
{
	CFormView::AssertValid();
}

void CHelpTab1ContentsView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CHelpTab1ContentsView message handlers

BOOL CHelpTab1ContentsView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

//--------------------------------------------------------------------
// OnInitialUpdate
//--------------------------------------------------------------------
void CHelpTab1ContentsView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	// Set the selected item name
	( (CHelpTab1View *) m_pView )->m_msgSelectedItem.SetOpMsg( m_tlLevel1[0].sLevel );

	// Set the imagelist of tree control
	m_ImageTree.Create( 16, 16, ILC_COLORDDB, 2, 1 );

	// You have to follow the order of imgae definition. 
	// Otherwise, it will show the wrong image that you think so.
	m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_JOBS));
	m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_MAINT));
	m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_SYSTEM));
	m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_SERVO));
	m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_RECIPE));
	m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_DATALOG));
	m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_SETUP));
	m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_ALARM));
	m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_ITEM));
	m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_ALARMHELP));

	m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_SELECT));
	m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_COPY));
	m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_SAVE));
    m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_OPEN));
	m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_DELETE));

	m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_INIT));
	m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_CYCLERUN));
	m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_CYCLESTOP));
   	m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_DIRUN));
	m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_DISTOP));

	m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_CLOSEFOLDER));
    m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_OPENFOLDER));
	m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_CLOSEBOOK));
	m_ImageTree.Add(AfxGetApp()->LoadIcon(IDI_OPENBOOK));

	m_treeContents.SetImageList( &m_ImageTree, TVSIL_NORMAL );

	//--- Set the tree control ----------------------------------------------
	TV_INSERTSTRUCT tvinsert;
    
	// Set option
	tvinsert.hParent = NULL;
	tvinsert.hInsertAfter = TVI_LAST;
	tvinsert.item.mask = TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_TEXT;
	tvinsert.item.state = 0;
	tvinsert.item.stateMask = 0;
	tvinsert.item.cchTextMax = 60;
	tvinsert.item.iSelectedImage = 1;
	tvinsert.item.cChildren = 0;

	//-------- 0. Set level1 node --------//
	tvinsert.item.pszText = m_tlLevel1[0].sLevel;
	tvinsert.item.iImage = 0;
	HTREEITEM hRoot = m_treeContents.InsertItem( tvinsert.item.pszText, IMAGE_CLOSEFOLDER, IMAGE_OPENFOLDER ); 

	//-------- 1. Jobs : Set level2 node --------//
   	tvinsert.hParent = hRoot;	// Add the parent
	tvinsert.item.pszText = m_tlLevel2[0].sLevel;
    HTREEITEM hItem = m_treeContents.InsertItem( tvinsert.item.pszText, IMAGE_JOBS, IMAGE_JOBS, hRoot );
	SetSubItem( hItem, sizeof( m_tlLevel31 ) / sizeof( TREE_LEVEL ), m_tlLevel31 );

	//-------- 2. Maint : Set level2 node --------//
   	tvinsert.hParent = hRoot;	// Add the parent
	tvinsert.item.pszText = m_tlLevel2[1].sLevel;
    hItem = m_treeContents.InsertItem( tvinsert.item.pszText, IMAGE_MAINT, IMAGE_MAINT, hRoot );
	SetSubItem( hItem, sizeof( m_tlLevel32 ) / sizeof( TREE_LEVEL ), m_tlLevel32 );

	//-------- 3. System : Set level2 node --------//
   	tvinsert.hParent = hRoot;	// Add the parent
	tvinsert.item.pszText = m_tlLevel2[2].sLevel;
    hItem = m_treeContents.InsertItem( tvinsert.item.pszText, IMAGE_SYSTEM, IMAGE_SYSTEM, hRoot );
	SetSubItem( hItem, sizeof( m_tlLevel33 ) / sizeof( TREE_LEVEL ), m_tlLevel33 );

	//-------- 4. Servo : Set level2 node --------//
   	tvinsert.hParent = hRoot;	// Add the parent
	tvinsert.item.pszText = m_tlLevel2[3].sLevel;
    hItem = m_treeContents.InsertItem( tvinsert.item.pszText, IMAGE_SERVO, IMAGE_SERVO, hRoot );
	SetSubItem( hItem, sizeof( m_tlLevel34 ) / sizeof( TREE_LEVEL ), m_tlLevel34 );

	//-------- 5. Recipe : Set level2 node --------//
   	tvinsert.hParent = hRoot;	// Add the parent
	tvinsert.item.pszText = m_tlLevel2[4].sLevel;
    hItem = m_treeContents.InsertItem( tvinsert.item.pszText, IMAGE_RECIPE, IMAGE_RECIPE, hRoot );
	SetSubItem( hItem, sizeof( m_tlLevel35 ) / sizeof( TREE_LEVEL ), m_tlLevel35 );

	//-------- 6. Datalog : Set level2 node --------//
   	tvinsert.hParent = hRoot;	// Add the parent
	tvinsert.item.pszText = m_tlLevel2[5].sLevel;
    hItem = m_treeContents.InsertItem( tvinsert.item.pszText, IMAGE_DATALOG, IMAGE_DATALOG, hRoot );
	SetSubItem( hItem, sizeof( m_tlLevel36 ) / sizeof( TREE_LEVEL ), m_tlLevel36 );

	//-------- 7. Setup : Set level2 node --------//
   	tvinsert.hParent = hRoot;	// Add the parent
	tvinsert.item.pszText = m_tlLevel2[6].sLevel;
    hItem = m_treeContents.InsertItem( tvinsert.item.pszText, IMAGE_SETUP, IMAGE_SETUP, hRoot );
	SetSubItem( hItem, sizeof( m_tlLevel37 ) / sizeof( TREE_LEVEL ), m_tlLevel37 );

	//-------- 8. Alarm : Set level2 node --------//
   	tvinsert.hParent = hRoot;	// Add the parent
	tvinsert.item.pszText = m_tlLevel2[7].sLevel;
    hItem = m_treeContents.InsertItem( tvinsert.item.pszText, IMAGE_ALARM, IMAGE_ALARM, hRoot );
	SetSubItem( hItem, sizeof( m_tlLevel38 ) / sizeof( TREE_LEVEL ), m_tlLevel38 );

	//-------- 9. Item : Set level2 node --------//
   	tvinsert.hParent = hRoot;	// Add the parent
	tvinsert.item.pszText = m_tlLevel2[8].sLevel;
    hItem = m_treeContents.InsertItem( tvinsert.item.pszText, IMAGE_ITEM, IMAGE_ITEM, hRoot );
	SetSubItem( hItem, sizeof( m_tlLevel39 ) / sizeof( TREE_LEVEL ), m_tlLevel39 );

	//-------- 10. Trouble Shooting : Set level2 node --------//
   	tvinsert.hParent = hRoot;	// Add the parent
	tvinsert.item.pszText = m_tlLevel2[9].sLevel;
    hItem = m_treeContents.InsertItem( tvinsert.item.pszText, IMAGE_ALARMHELP, IMAGE_ALARMHELP, hRoot );
	SetSubItem( hItem, sizeof( m_tlLevel40 ) / sizeof( TREE_LEVEL ), m_tlLevel40 );
}

//--------------------------------------------------------------------
// OnSelchangedTreeContents
//--------------------------------------------------------------------
void CHelpTab1ContentsView::OnSelchangedTreeContents(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
    HTREEITEM hItem = pNMTreeView->itemNew.hItem;

	CString sText = m_treeContents.GetItemText( hItem );
	int nFind = sText.Find( '.' );
	if( nFind == -1 ) return;

	// Get the online help file name
	char szPathName[100];
	GetCurrentDirectory( 100, szPathName );

	CString sFileName;
	sFileName.Format( "%s\\OnLineHelp\\On_Help%s.htm", szPathName, sText.Left( nFind ) );
	( (CHelpTab1View*) m_pView )->m_webHelp.Navigate( sFileName, NULL, NULL, NULL,NULL );

	// Set the selected item name
	( (CHelpTab1View *) m_pView )->m_msgSelectedItem.SetOpMsg( sText );
	
	*pResult = 0;
}

//--------------------------------------------------------------------
// user defined member function
//--------------------------------------------------------------------
void CHelpTab1ContentsView::SetSubItem( HTREEITEM& hItem, int nSize, TREE_LEVEL* m_tlLevel )
{
	for( int i=0 ; i<nSize ; i++ )	// No Image
	{	
		int nSelectedImage;
		if( m_tlLevel[i].nImage == IMAGE_CLOSEFOLDER || m_tlLevel[i].nImage == IMAGE_CLOSEBOOK )
			nSelectedImage = m_tlLevel[i].nImage + 1;
		else nSelectedImage = m_tlLevel[i].nImage;

		m_treeContents.InsertItem( m_tlLevel[i].sLevel, m_tlLevel[i].nImage, nSelectedImage, hItem );
	}
}
