#if !defined(AFX_HELPTAB1CONTENTSVIEW_H__6D7318B1_7C88_49B2_AD8B_C00330F00351__INCLUDED_)
#define AFX_HELPTAB1CONTENTSVIEW_H__6D7318B1_7C88_49B2_AD8B_C00330F00351__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// HelpTab1ContentsView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CHelpTab1ContentsView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#define MAX_IMAGE_NO		24
#define IMAGE_JOBS			0
#define IMAGE_MAINT			1
#define IMAGE_SYSTEM		2
#define IMAGE_SERVO			3
#define IMAGE_RECIPE		4
#define IMAGE_DATALOG		5
#define IMAGE_SETUP			6
#define IMAGE_ALARM			7
#define IMAGE_ITEM			8
#define IMAGE_ALARMHELP		9

#define IMAGE_SELECT		10
#define IMAGE_COPY			11
#define IMAGE_SAVE			12
#define IMAGE_OPEN			13
#define IMAGE_DELETE		14

#define IMAGE_INIT			15
#define IMAGE_CYCLERUN		16
#define IMAGE_CYCLESTOP		17

#define IMAGE_DIRUN			18
#define IMAGE_DISTOP		19

#define IMAGE_CLOSEFOLDER	20
#define IMAGE_OPENFOLDER	21
#define IMAGE_CLOSEBOOK		22
#define IMAGE_OPENBOOK		23

typedef struct tagTreeLevel 
{
	LPSTR sLevel;
	UINT nImage;
} TREE_LEVEL;

class CHelpTab1ContentsView : public CFormView
{
public:
	CHelpTab1ContentsView();           // protected constructor used by dynamic creation
	CHelpTab1ContentsView( CView* pView );
	DECLARE_DYNCREATE(CHelpTab1ContentsView)

// Form Data
public:
	//{{AFX_DATA(CHelpTab1ContentsView)
	enum { IDD = IDD_HELP_TAB1_CONTENTS_VIEW };
	CTreeCtrl	m_treeContents;
	//}}AFX_DATA

// Attributes
public:
	CView* m_pView;
	CImageList m_ImageTree;

	static TREE_LEVEL m_tlLevel1[];
	static TREE_LEVEL m_tlLevel2[];
	static TREE_LEVEL m_tlLevel31[];
	static TREE_LEVEL m_tlLevel32[];
	static TREE_LEVEL m_tlLevel33[];
	static TREE_LEVEL m_tlLevel34[];
	static TREE_LEVEL m_tlLevel35[];
	static TREE_LEVEL m_tlLevel36[];
	static TREE_LEVEL m_tlLevel37[];
	static TREE_LEVEL m_tlLevel38[];
	static TREE_LEVEL m_tlLevel39[];
	static TREE_LEVEL m_tlLevel40[];

// Operations
public:
	void SetSubItem( HTREEITEM& hItem, int nSize, TREE_LEVEL* m_tlLevel );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHelpTab1ContentsView)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CHelpTab1ContentsView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CHelpTab1ContentsView)
	afx_msg void OnSelchangedTreeContents(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HELPTAB1CONTENTSVIEW_H__6D7318B1_7C88_49B2_AD8B_C00330F00351__INCLUDED_)
