#if !defined(AFX_HELPTAB1SEARCHVIEW_H__EE02F97C_D423_422B_9E49_F680326D28A7__INCLUDED_)
#define AFX_HELPTAB1SEARCHVIEW_H__EE02F97C_D423_422B_9E49_F680326D28A7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// HelpTab1SearchView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CHelpTab1SearchView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "..\X\MacButtons.h"

class CHelpTab1SearchView : public CFormView
{
public:
	CHelpTab1SearchView();           // protected constructor used by dynamic creation
	CHelpTab1SearchView( CView* pView );
	DECLARE_DYNCREATE(CHelpTab1SearchView)

// Form Data
public:
	//{{AFX_DATA(CHelpTab1SearchView)
	enum { IDD = IDD_HELP_TAB1_SEARCH_VIEW };
	CListCtrl	m_lcContents;
	CString	m_sSearch;
	CMacButton m_macSearch;
	//}}AFX_DATA

// Attributes
public:
	CView*	m_pView;

// Operations
public:
	void InsertColumn();
	void AddItem();
	void FillData( CString sData );
	void GetItem( HTREEITEM hItemParent );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHelpTab1SearchView)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CHelpTab1SearchView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CHelpTab1SearchView)
	afx_msg void OnItemchangedListContents(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSearchButton();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HELPTAB1SEARCHVIEW_H__EE02F97C_D423_422B_9E49_F680326D28A7__INCLUDED_)
