//{{AFX_INCLUDES()
#include "..\webbrowser2.h"
//}}AFX_INCLUDES
#if !defined(AFX_HELPTAB1VIEW_H__4A7329F1_4426_4A95_96EB_5C1CFD8ECFBF__INCLUDED_)
#define AFX_HELPTAB1VIEW_H__4A7329F1_4426_4A95_96EB_5C1CFD8ECFBF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// HelpTab1View.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CHelpTab1View form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "..\X\XTabCtrl.h"
#include "..\X\MsgBox.h"
#include "HelpTab1ContentsView.h"
#include "HelpTab1SearchView.h"

class CHelpTab1View : public CFormView
{
public:
	CHelpTab1View();           // protected constructor used by dynamic creation
	CHelpTab1View( CView* pView );
	DECLARE_DYNCREATE(CHelpTab1View)

// Form Data
public:
	//{{AFX_DATA(CHelpTab1View)
	enum { IDD = IDD_HELP_TAB1_VIEW };
	CXTabCtrl		m_tabCtrl;
	CWebBrowser2	m_webHelp;
	//}}AFX_DATA

// Attributes
public:
	CView* m_pView;

	CHelpTab1ContentsView*	m_pHelpTab1ContentsView;
	CHelpTab1SearchView*	m_pHelpTab1SearchView;
	CMsgBox		m_msgTitle;
	CMsgBox		m_msgSelectedItem;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHelpTab1View)
	public:
	virtual void OnInitialUpdate();
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CHelpTab1View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CHelpTab1View)
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HELPTAB1VIEW_H__4A7329F1_4426_4A95_96EB_5C1CFD8ECFBF__INCLUDED_)
