// HelpView.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "HelpView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHelpView

IMPLEMENT_DYNCREATE(CHelpView, CFormView)

CHelpView::CHelpView()
	: CFormView(CHelpView::IDD)
{
	//{{AFX_DATA_INIT(CHelpView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_pTabHelpTab1View	= NULL;
}

CHelpView::~CHelpView()
{
	GetDocument()->m_pHelpWnd = NULL;
}

void CHelpView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHelpView)
		DDX_Control(pDX, IDC_TAB_HELP, m_tabCtrl);
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CHelpView, CFormView)
	//{{AFX_MSG_MAP(CHelpView)
		ON_WM_DESTROY()
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHelpView diagnostics

#ifdef _DEBUG
void CHelpView::AssertValid() const
{
	CFormView::AssertValid();
}

void CHelpView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CDicsDoc* CHelpView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDicsDoc)));
	return (CDicsDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CHelpView message handlers
void CHelpView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	// Create the TAB view 
	CRect r;
	GetDlgItem( IDC_TAB_HELP )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 0, 0, 6, 30 );

	m_pTabHelpTab1View = new CHelpTab1View( this );
	CCreateContext context;
	m_pTabHelpTab1View->Create(NULL, NULL, WS_CHILD|WS_VISIBLE, r, &m_tabCtrl, CHelpTab1View::IDD, &context);
	m_tabCtrl.AddTab( (CWnd*) m_pTabHelpTab1View, "    HELP VIEW    ", 0 );

	m_tabCtrl.SetSelectedColor( RED_COLOR );
	m_tabCtrl.SetMouseOverColor( GREEN_COLOR );
	m_tabCtrl.SetNormalColor( DARK_GRAY_COLOR );
}

void CHelpView::OnDestroy() 
{
	CFormView::OnDestroy();
	
	if( m_pTabHelpTab1View ) 
	{
		m_pTabHelpTab1View->SendMessage( WM_CLOSE );
		delete m_pTabHelpTab1View;
	}

}
