#if !defined(AFX_JOBSTABDOORVIEW_H__79C503E8_ADF7_4845_B7BC_86EE27014093__INCLUDED_)
#define AFX_JOBSTABDOORVIEW_H__79C503E8_ADF7_4845_B7BC_86EE27014093__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// JobsTabDoorView.h : header file
//
#include "..\FactoryLib\EqpAssy.h"

/////////////////////////////////////////////////////////////////////////////
// CJobsTabDoorView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

class CJobsTabDoorView : public CFormView
{
public:
	CJobsTabDoorView();           // protected constructor used by dynamic creation
	CJobsTabDoorView( CView* pView, int nTabNo );
	DECLARE_DYNCREATE(CJobsTabDoorView)

// Form Data
public:
	//{{AFX_DATA(CJobsTabDoorView)
	enum { IDD = IDD_JOBS_TAB_DOOR_VIEW };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

// Attributes
public:
	CView*				m_pView;
	int					m_nTabNo;
	XCtlDevice*			m_pDevice;
//	CSetupItems*		m_pSetupItems;
	CEqpAssy*			m_pEqpAssy;
	void SetEqpAssy( CEqpAssy* pEqpAssy ) { m_pEqpAssy = pEqpAssy; }


	CColorStatic	m_stcDoorOpen[MAX_DOOR_OPEN_NO];
	CColorStatic	m_stcEMO[MAX_EMO_NO];
	CColorStatic	m_strDIAlarm[MAX_DIALARM_NO];

// Operations
public:
	void UpdateDoorOpen();
	void UpdateObjects();
	void SetDevice( XCtlDevice* pDevice ) { m_pDevice = pDevice; }
	void SetColorStatic( CColorStatic& stcObject, BOOL bState, COLORREF OnColor = GREEN_COLOR, COLORREF OffColor = WHITE_COLOR );
//	void SetSetupItems( CSetupItems* pSetupItems ) { m_pSetupItems = pSetupItems; }
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CJobsTabProcessDataView)
public:
	virtual void OnInitialUpdate();
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
// Implementation
public:
	virtual ~CJobsTabDoorView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CJobsTabDoorView)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_JOBSTABDOORVIEW_H__79C503E8_ADF7_4845_B7BC_86EE27014093__INCLUDED_)
