// JobsTabEuvStatusView.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "JobsTabEuvStatusView.h"
#include "..\Dlg\DlgEditVal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CJobsTabEuvStatusView

IMPLEMENT_DYNCREATE(CJobsTabEuvStatusView, CFormView)

CJobsTabEuvStatusView::CJobsTabEuvStatusView()
	: CFormView(CJobsTabEuvStatusView::IDD)
{
	//{{AFX_DATA_INIT(CJobsTabEuvStatusView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CJobsTabEuvStatusView::CJobsTabEuvStatusView(CView* pView, int nTabNo)
	: CFormView(CJobsTabEuvStatusView::IDD)
{
	m_pView		= pView;
	m_nTabNo	= nTabNo; 
	m_pEuv = ( (CDicsView*) m_pView )->m_pEuvSeq;
	SetEqpAssy( ((CDicsView*)m_pView)->m_pEqpAssy );
}

CJobsTabEuvStatusView::~CJobsTabEuvStatusView()
{
}

void CJobsTabEuvStatusView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJobsTabEuvStatusView)
	DDX_Control(pDX, IDC_GRID_LAMP_USE_TIME, m_gridLampUseTime);
	DDX_Control(pDX, IDC_GRID_LAMP_INTENSITY, m_gridLampIntensity);
//	DDX_Control(pDX, IDC_EUV_INTENSITY_CHECK, m_macIntensityCheckOn);
	DDX_Control(pDX, IDC_EUV_REMOTE, m_macRemoteMode);
	DDX_Control(pDX, IDC_EUV_REMOTE_POS, m_macRemotePos);
	DDX_Control(pDX, IDC_EUV_BUSY, m_macBusy);
	DDX_Control(pDX, IDC_EUV_READY, m_macReady);
	DDX_Control(pDX, IDC_EUV_USE_TIME_EXCESS, m_macLampUsedTimeOver);
	DDX_Control(pDX, IDC_EUV_LAMP_ON_FAIL, m_macLampOnFail);
	DDX_Control(pDX, IDC_EUV_PROTECTIVE_FUN, m_macProtectiveFunc);
	DDX_Control(pDX, IDC_EUV_ELECTRIC_CIRCUIT_ERR, m_macElectricCircuitError);
	DDX_Control(pDX, IDC_EUV_N2_PRESS_SURPLUS, m_macN2PressOver);
	DDX_Control(pDX, IDC_EUV_LAMP_HOUSE_TEMP_ERR, m_macLampHouseOverheat);
	DDX_Control(pDX, IDC_EUV_LAMP_HOUSE_OPEN, m_macLampHouseOpen);
	DDX_Control(pDX, IDC_EUV_TRANSFORMER_TEMP_ERR, m_macTransformerOverheat);
	DDX_Control(pDX, IDC_EUV_N2_PRESS_DROP, m_macN2PressDrop);
	DDX_Control(pDX, IDC_EUV_COMP_COVER_OPEN, m_macElectricCircuitCoverOpen);
	DDX_Control(pDX, IDC_EUV_CONTROL_SYSTEM_ERR, m_macControlError);
	DDX_Control(pDX, IDC_EUV_EMO, m_macEuvEmo);
	DDX_Control(pDX, IDC_EUV_HUM_READY, m_macHumReady);
	DDX_Control(pDX, IDC_EUV_HUM_ERR, m_macHumError);
	DDX_Control(pDX, IDC_LAMP_ON, m_macLampOn);
	DDX_Control(pDX, IDC_PCW_VALVE, m_macPcwOn);
	DDX_Control(pDX, IDC_N2_VALVE, m_macN2On);
	DDX_Control(pDX, IDC_HUMIDIFIER_N2_VALVE, m_macHumidifierN2On);
	DDX_Control(pDX, IDC_HOUSE_UP, m_macHouseUp);
	DDX_Control(pDX, IDC_HOUSE_DN, m_macHouseDown);
	DDX_Control(pDX, IDC_EUV_UDLC, m_macEuvLocalModeLock);
	DDX_Control(pDX, IDC_EUV_UTRE, m_macEuvRemoteMode);
	DDX_Control(pDX, IDC_EUV_UEMG, m_macEmergency);
	DDX_Control(pDX, IDC_EUV_UERT, m_macEuvReset);
	DDX_Control(pDX, IDC_EUV_UICR, m_macCounterReset);
	DDX_Control(pDX, IDC_EUV_ULST, m_macUsedTimeReset);
	DDX_Control(pDX, IDC_HUM_UHER, m_macHumReset);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_HOUSE_POS1, m_macHousePos[0]);
	DDX_Control(pDX, IDC_HOUSE_POS2, m_macHousePos[1]);
	DDX_Control(pDX, IDC_LAMP1, m_macLampOnSelect[0]);
	DDX_Control(pDX, IDC_LAMP2, m_macLampOnSelect[1]);
	DDX_Control(pDX, IDC_LAMP3, m_macLampOnSelect[2]);
	DDX_Control(pDX, IDC_LAMP4, m_macLampOnSelect[3]);
// 	DDX_Control(pDX, IDC_LAMP5, m_macLampOnSelect[4]);
// 	DDX_Control(pDX, IDC_LAMP6, m_macLampOnSelect[5]);
// 	DDX_Control(pDX, IDC_LAMP7, m_macLampOnSelect[6]);
// 	DDX_Control(pDX, IDC_LAMP8, m_macLampOnSelect[7]);
}

BEGIN_MESSAGE_MAP(CJobsTabEuvStatusView, CFormView)
	//{{AFX_MSG_MAP(CJobsTabEuvStatusView)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_LAMP1, OnEuvLampOnSelect1)
	ON_BN_CLICKED(IDC_LAMP2, OnEuvLampOnSelect2)
	ON_BN_CLICKED(IDC_LAMP3, OnEuvLampOnSelect3)
	ON_BN_CLICKED(IDC_LAMP4, OnEuvLampOnSelect4)
// 	ON_BN_CLICKED(IDC_LAMP5, OnEuvLampOnSelect5)
// 	ON_BN_CLICKED(IDC_LAMP6, OnEuvLampOnSelect6)
// 	ON_BN_CLICKED(IDC_LAMP7, OnEuvLampOnSelect7)
// 	ON_BN_CLICKED(IDC_LAMP8, OnEuvLampOnSelect8)
	ON_BN_CLICKED(IDC_N2_VALVE, OnN2Valve)
	ON_BN_CLICKED(IDC_PCW_VALVE, OnPcwValve)
	ON_BN_CLICKED(IDC_CDA_VALVE, OnCdaValve)
	ON_BN_CLICKED(IDC_LAMP_ON, OnEuvLampOn)
//	ON_BN_CLICKED(IDC_EUV_INTENSITY_CHECK, OnEuvIntensityCheck)
	ON_BN_CLICKED(IDC_EUV_UDLC, OnEuvLocalModeLock)
	ON_BN_CLICKED(IDC_EUV_UTRE, OnEuvRemoteMode)
	ON_BN_CLICKED(IDC_EUV_UEMG, OnEuvEmergency)
	ON_BN_CLICKED(IDC_EUV_UERT, OnEuvReset)
	ON_BN_CLICKED(IDC_EUV_UICR, OnEuvCounterReset)
	ON_BN_CLICKED(IDC_EUV_ULST, OnEuvLampUseTimeAllReset)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_HUM_UHER, OnHumidifierReset)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_BTN_PUSHED, OnBtnPushed)
	ON_MESSAGE(WM_BTN_RELEASED, OnBtnReleased)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJobsTabEuvStatusView diagnostics

#ifdef _DEBUG
void CJobsTabEuvStatusView::AssertValid() const
{
	CFormView::AssertValid();
}

void CJobsTabEuvStatusView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CJobsTabEuvStatusView message handlers

BOOL CJobsTabEuvStatusView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CJobsTabEuvStatusView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();

	// Intensity Check Select

	for( int i = 0 ; i < MAX_LAMP_CONTROL_NO ; i++ )
	{
		m_macLampOnSelect[i].SetCheckColor( BLUE_COLOR );
		m_macLampOnSelect[i].SetBold();
		
		if( m_pEuv->GetLampOnSelected( i ) )
		{
			m_bLampOnSelect[i] = TRUE;
			m_macLampOnSelect[i].SetCheck( 1 );
		}
		else
		{
			m_bLampOnSelect[i] = FALSE;
			m_macLampOnSelect[i].SetCheck( 0 );
		}
	}
	
	m_bUERT = FALSE;
	m_bUHER	= FALSE;
	
	m_macRemoteMode.SetCheckColor( BLUE_COLOR );
	m_macRemotePos.SetCheckColor( BLUE_COLOR );
	m_macBusy.SetCheckColor( BLUE_COLOR );
	m_macReady.SetCheckColor( BLUE_COLOR );

	m_macHumReady.SetCheckColor( BLUE_COLOR );

	m_macLampUsedTimeOver.SetCheckColor( RED_COLOR );
	m_macLampOnFail.SetCheckColor( RED_COLOR );
	m_macProtectiveFunc.SetCheckColor( RED_COLOR );
	m_macElectricCircuitError.SetCheckColor( RED_COLOR );
	m_macN2PressOver.SetCheckColor( RED_COLOR );
	m_macLampHouseOverheat.SetCheckColor( RED_COLOR );
	m_macLampHouseOpen.SetCheckColor( RED_COLOR );
	m_macTransformerOverheat.SetCheckColor( RED_COLOR );
	m_macN2PressDrop.SetCheckColor( RED_COLOR );
	m_macElectricCircuitCoverOpen.SetCheckColor( RED_COLOR );
	m_macControlError.SetCheckColor( RED_COLOR );
	m_macEuvEmo.SetCheckColor( RED_COLOR );

	m_macHumError.SetCheckColor( RED_COLOR );

	m_macLampUsedTimeOver.SetBold();
	m_macLampOnFail.SetBold();
	m_macProtectiveFunc.SetBold();
	m_macElectricCircuitError.SetBold();
	m_macN2PressOver.SetBold();
	m_macLampHouseOverheat.SetBold();
	m_macLampHouseOpen.SetBold();
	m_macTransformerOverheat.SetBold();
	m_macN2PressDrop.SetBold();
	m_macElectricCircuitCoverOpen.SetBold();
	m_macControlError.SetBold();
	m_macEuvEmo.SetBold();

	MAC_COLOR_SET color_set;

	m_macHouseUp.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macHouseUp.SetColorSetting( color_set );
	m_macHouseUp.SetBold();

	m_macHouseDown.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_RED_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macHouseDown.SetColorSetting( color_set );
	m_macHouseDown.SetBold();

	m_macLampOn.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macLampOn.SetColorSetting( color_set );
	m_macLampOn.SetBold();
	GetDlgItem( IDC_LAMP_ON )->SetWindowText( "LAMP ON" );

//	m_macIntensityCheckOn.GetColorSetting( &color_set );
//	color_set.crFace = LIGHT_GREEN_COLOR;
//	color_set.crLiteShadow = MAGENTA_COLOR;
//	m_macIntensityCheckOn.SetColorSetting( color_set );
//	m_macIntensityCheckOn.SetBold();

	m_macN2On.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macN2On.SetColorSetting( color_set );
	m_macN2On.SetBold();

	m_macPcwOn.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macPcwOn.SetColorSetting( color_set );
	m_macPcwOn.SetBold();

	m_macHumidifierN2On.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macHumidifierN2On.SetColorSetting( color_set );
	m_macHumidifierN2On.SetBold();

	// EUV Operation
	m_macEuvLocalModeLock.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macEuvLocalModeLock.SetColorSetting( color_set );
	m_macEuvLocalModeLock.SetBold();

	m_macEuvRemoteMode.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macEuvRemoteMode.SetColorSetting( color_set );
	m_macEuvRemoteMode.SetBold();

	m_macEmergency.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macEmergency.SetColorSetting( color_set );
	m_macEmergency.SetBold();

	m_macEuvReset.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macEuvReset.SetColorSetting( color_set );
	m_macEuvReset.SetBold();

	m_macCounterReset.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macCounterReset.SetColorSetting( color_set );
	m_macCounterReset.SetBold();

	m_macUsedTimeReset.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macUsedTimeReset.SetColorSetting( color_set );
	m_macUsedTimeReset.SetBold();

	m_macHumReset.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macHumReset.SetColorSetting( color_set );
	m_macHumReset.SetBold();

	CRect r;
	GetDlgItem( IDC_EUV_MESSAGE )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 2, 2, 2, 2 );
	m_msgEuv.Create( 800, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_EUV_MESSAGE,
			BLACK_COLOR, WHITE_COLOR, 18, TRUE );
	m_msgEuv.SetOpMsg( "EUV Manual Operation View." );

	for( int i = 0 ; i < 2 ; i ++ )
	{
		GetDlgItem( IDC_MSG_VALVE1 + i )->GetWindowRect( &r );
		ScreenToClient( &r );
		r -= CRect( 2, 2, 2, 2 );
		m_msgValve[i].Create( 801 + i, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_MSG_VALVE1 + i,
				WHITE_COLOR, BLUE_COLOR, 18, TRUE );
		m_msgValve[i].SetOpMsg( "" );
	}

	GetDlgItem( IDC_MSG_VALVE3 )->GetWindowRect( &r );
	ScreenToClient( &r );
	r -= CRect( 2, 2, 2, 2 );
	m_msgValve[2].Create( 803, "0", WS_CHILD|WS_VISIBLE, r, this, IDC_MSG_VALVE3,
			WHITE_COLOR, BLUE_COLOR, 18, TRUE );
	m_msgValve[2].SetOpMsg( "" );

	for( int i = 0 ; i < MAX_LAMP_NO ; i++ )
	{
		m_nEuvHour[i] = 0;
	}

	GridInit_LampUseTime();
	GridInit_LampIntensity();

	// House Up/Down Operation Time Check Flag Initialize
	m_bHouseUp		= FALSE;
	m_bHouseDown	= FALSE;
	m_nHouseMoveOk	= 0;

//	SetTimer( TM_EUV_MONITOR, 500, NULL );

}

void CJobsTabEuvStatusView::OnClose() 
{
//	KillTimer( TM_EUV_MONITOR );

	CFormView::OnClose();
}


BEGIN_EVENTSINK_MAP(CJobsTabEuvStatusView, CFormView)
    //{{AFX_EVENTSINK_MAP(CJobsTabEuvStatusView)
	ON_EVENT(CJobsTabEuvStatusView, IDC_GRID_LAMP_INTENSITY, -600 /* Click */, OnClickGridLampIntensity, VTS_NONE)
	ON_EVENT(CJobsTabEuvStatusView, IDC_GRID_LAMP_USE_TIME, -601 /* DblClick */, OnDblClickGridUsedTime, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
//	ON_EVENT_RANGE(CJobsTabEuvStatusView, IDC_EUV_ULS1, IDC_EUV_ULS8, -600 /* Click */, OnEuvLampOnSelect, VTS_I2)
END_EVENTSINK_MAP()

//--------------------------------------------------------------------
// Display the terminal message
//--------------------------------------------------------------------

void CJobsTabEuvStatusView::UpdateObjects() 
{

	if( ( ( (CDicsView*) m_pView )->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idENGINEER ) 
		|| ( (CDicsView*) m_pView )->m_pDicsData->m_GenInfo.bAuto 
		|| ((CDicsView*)m_pView)->GetDocument()->m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupUSE_EUV] == 0 )//2008.11.19 kimgun)
	{
		for( int i = 0 ; i < MAX_LAMP_CONTROL_NO ; i++ )
		{
			GetDlgItem( IDC_LAMP1 + i )->EnableWindow( FALSE );
		}

		EnableButton( FALSE );
	}
	else
	{
		for( int i = 0 ; i < MAX_LAMP_CONTROL_NO ; i++ )
		{
			GetDlgItem( IDC_LAMP1 + i )->EnableWindow( TRUE );
		}
		EnableButton( TRUE );
	}

	int iRes;
	iRes = m_pEuv->GetStatus();
	if( iRes & CEuvSeq::euvREMOTE_MODE )			m_macRemoteMode.SetCheck( 1 );		else m_macRemoteMode.SetCheck( 0 );
	if( iRes & CEuvSeq::euvREMOTE_MODE_POSSIBLE )	m_macRemotePos.SetCheck( 1 );		else m_macRemotePos.SetCheck( 0 );
	if( iRes & CEuvSeq::euvBUSY )					m_macBusy.SetCheck( 1 );			else m_macBusy.SetCheck( 0 );
	if( iRes & CEuvSeq::euvREADY )					m_macReady.SetCheck( 1 );			else m_macReady.SetCheck( 0 );

	iRes = m_pEuv->GetEuvAlarm();
	if( iRes & CEuvSeq::euvAlmLampUseTimeExcess )		m_macLampUsedTimeOver.SetCheck( 1 );		else m_macLampUsedTimeOver.SetCheck( 0 );
	if( iRes & CEuvSeq::euvAlmLampOnFail )				m_macLampOnFail.SetCheck( 1 );				else m_macLampOnFail.SetCheck( 0 );
	if( iRes & CEuvSeq::euvAlmProtectiveFunction )		m_macProtectiveFunc.SetCheck( 1 );			else m_macProtectiveFunc.SetCheck( 0 );
	if( iRes & CEuvSeq::euvAlmElectricCircuit )			m_macElectricCircuitError.SetCheck( 1 );	else m_macElectricCircuitError.SetCheck( 0 );
	if( iRes & CEuvSeq::euvAlmN2PressSurplus )			m_macN2PressOver.SetCheck( 1 );				else m_macN2PressOver.SetCheck( 0 );
	if( iRes & CEuvSeq::euvAlmLampHouseTemp )			m_macLampHouseOverheat.SetCheck( 1 );		else m_macLampHouseOverheat.SetCheck( 0 );
	if( iRes & CEuvSeq::euvAlmLampHouseOpen )			m_macLampHouseOpen.SetCheck( 1 );			else m_macLampHouseOpen.SetCheck( 0 );
	if( iRes & CEuvSeq::euvAlmTransformerTemp )			m_macTransformerOverheat.SetCheck( 1 );		else m_macTransformerOverheat.SetCheck( 0 );
	if( iRes & CEuvSeq::euvAlmN2PressDrop )				m_macN2PressDrop.SetCheck( 1 );				else m_macN2PressDrop.SetCheck( 0 );
	if( iRes & CEuvSeq::euvAlmElectricCompCover	)		m_macElectricCircuitCoverOpen.SetCheck( 1 );	else m_macElectricCircuitCoverOpen.SetCheck( 0 );
	if( iRes & CEuvSeq::euvAlmControlSystem	)			m_macControlError.SetCheck( 1 );				else m_macControlError.SetCheck( 0 );
	if( iRes & CEuvSeq::euvAlmEMO )						m_macEuvEmo.SetCheck( 1 );						else m_macEuvEmo.SetCheck( 0 );
	
	iRes = m_pEuv->GetHumStatus();
	if( iRes & CEuvSeq::humREADY )					m_macHumReady.SetCheck( 1 );		else m_macHumReady.SetCheck( 0 );

	if( iRes & CEuvSeq::humABNORMAL )				m_macHumError.SetCheck( 1 );		else m_macHumError.SetCheck( 0 );

	for( int i = 0 ; i < MAX_LAMP_NO ; i++ )
	{
		int nVal = (int)m_pEuv->GetLampUsedTime( i );

//		if( m_nEuvHour[i] != nVal / 3600 ||
//			m_nEuvMin[i] !=( nVal % 3600 ) / 60 ||
//			m_nEuvSec[i] !=( nVal % 3600 ) % 60 )
		if( m_nEuvHour[i] != nVal )
		{
			SetDataToGridCtrl_LampUseTime();
		}
	}

	static double fOldIntensity[MAX_LAMP_INTENSITY_NO] = { -99.9, -99.9, -99.9, -99.9, };
	for( int i = 0; i < MAX_LAMP_INTENSITY_NO ; i ++ )
	{
		float fCurIntensity = m_pEuv->GetLampIntensity( i );
		if(  fOldIntensity[i] != fCurIntensity )
		{
			fOldIntensity[i] = fCurIntensity;
			SetDataToGridCtrl_LampIntensity( i );
		}
	}

	static int nValveStatus[3] = { -1, -1, -1 };
	for( int i = 0 ; i < 3 ; i++ )
	{
		if( m_pEqpAssy->m_AutoValveEuv.GetState(i) && nValveStatus[i] != 1 )
		{
			nValveStatus[i] = 1;
			m_msgValve[i].SetTextColor( RED_COLOR );
			m_msgValve[i].SetOpMsg( "ON" );
		}
		else if( !m_pEqpAssy->m_AutoValveEuv.GetState( i ) && nValveStatus[i] != 0 )
		{
			nValveStatus[i] = 0;
			m_msgValve[i].SetTextColor( BLUE_COLOR );
			m_msgValve[i].SetOpMsg( "OFF" );
		}
	}

	static BOOL bOldLampSelect[MAX_LAMP_CONTROL_NO] = { FALSE, FALSE, FALSE, };
	for( int i = 0 ; i < MAX_LAMP_CONTROL_NO ; i++ )
	{
		if( !bOldLampSelect[i] && m_pEuv->GetLampOnSelected( i ) )
		{
			bOldLampSelect[i] = TRUE;
			m_macLampOnSelect[i].SetCheck( TRUE );
		}
		else if( bOldLampSelect[i] && !m_pEuv->GetLampOnSelected( i ) )
		{
			bOldLampSelect[i] = FALSE;
			m_macLampOnSelect[i].SetCheck( FALSE );
		}
	}
	//2008.09.09 kimgun
	if( m_pEqpAssy->m_CylinderEuvUpDn.GetFw( 0 ) )
	{
		m_macHousePos[0].SetCheck( 1 );
		m_macHousePos[1].SetCheck( 0 );
	}
	else if( m_pEqpAssy->m_CylinderEuvUpDn.GetBw( 0 ) && m_pEqpAssy->m_SensorEuvHouseClose.Get() )
	{
		m_macHousePos[1].SetCheck( 1 );
		m_macHousePos[0].SetCheck( 0 );
	}
	else
	{
		m_macHousePos[1].SetCheck( 0 );
		m_macHousePos[0].SetCheck( 0 );
	}
	
	if( m_pEqpAssy->m_UshioEuv.GetIfUdlcState() ) m_macEuvLocalModeLock.SetCheck( 1 );
	else m_macEuvLocalModeLock.SetCheck( 0 );

	if( m_pEqpAssy->m_UshioEuv.GetIfUtreState() ) m_macEuvRemoteMode.SetCheck( 1 );
	else m_macEuvRemoteMode.SetCheck( 0 );

	if( m_pEqpAssy->m_UshioEuv.GetIfUemgState() ) m_macEmergency.SetCheck( 1 );
	else m_macEmergency.SetCheck( 0 );

	if( m_pEqpAssy->m_UshioEuv.GetIfUertState() ) m_macEuvReset.SetCheck( 1 );
	else m_macEuvReset.SetCheck( 0 );

	if( m_pEqpAssy->m_UshioEuv.GetIfUicrState() ) m_macCounterReset.SetCheck( 1 );
	else m_macCounterReset.SetCheck( 0 );

	if( m_pEqpAssy->m_UshioEuv.GetIfUlstState() ) m_macUsedTimeReset.SetCheck( 1 );
	else m_macUsedTimeReset.SetCheck( 0 );

	CheckPushBtnTime();
	CheckEMOStatus();
	SetMelody();
}

void CJobsTabEuvStatusView::EnableButton(BOOL bStatus)
{
	GetDlgItem( IDC_LAMP_ON )->EnableWindow( bStatus );				
	GetDlgItem( IDC_HOUSE_UP )->EnableWindow( bStatus );
	GetDlgItem( IDC_HOUSE_DN )->EnableWindow( bStatus );
//	GetDlgItem( IDC_EUV_INTENSITY_CHECK )->EnableWindow( bStatus );
	GetDlgItem( IDC_PCW_VALVE )->EnableWindow( bStatus );
	GetDlgItem( IDC_N2_VALVE )->EnableWindow( bStatus );
	GetDlgItem( IDC_HUMIDIFIER_N2_VALVE )->EnableWindow( bStatus );

	GetDlgItem( IDC_EUV_UDLC )->EnableWindow( bStatus );
	GetDlgItem( IDC_EUV_UTRE )->EnableWindow( bStatus );
	GetDlgItem( IDC_EUV_UEMG )->EnableWindow( bStatus );
	GetDlgItem( IDC_EUV_UERT )->EnableWindow( bStatus );
	GetDlgItem( IDC_EUV_UICR )->EnableWindow( bStatus );
	GetDlgItem( IDC_EUV_ULST )->EnableWindow( bStatus );
	GetDlgItem( IDC_HUM_UHER )->EnableWindow( FALSE );//2008.12.17 kimgun
}

void CJobsTabEuvStatusView::CheckPushBtnTime()
{
	static DWORD dwTickStart;
	static int nSeqCheckPushBtnTimeNo = 0;

#ifndef _MY_DEBUG
	DWORD nDelay = 3000;
#else
	DWORD nDelay = 1000;
#endif

	switch( nSeqCheckPushBtnTimeNo )
	{
	case 0:
		if( ( m_bHouseUp || m_bHouseDown ) && ( m_nHouseMoveOk == 0 ) )
		{
			if( m_bHouseUp ) nSeqCheckPushBtnTimeNo = 10;
			else nSeqCheckPushBtnTimeNo = 20;

			dwTickStart = GetTickCount();
		}
		break;
	case 10:
		if( m_bHouseUp && ( ( GetTickCount() - dwTickStart ) > nDelay ) )
		{
			m_nHouseMoveOk = 1;
			nSeqCheckPushBtnTimeNo = 0;

			OnBtnPushed( (WPARAM)IDC_HOUSE_UP, (LPARAM)0 );
		}
		else if( !m_bHouseUp ) nSeqCheckPushBtnTimeNo = 0;
		break;
	case 20:
		if( m_bHouseDown && ( ( GetTickCount() - dwTickStart ) > nDelay ) )
		{
			m_nHouseMoveOk = -1;
			nSeqCheckPushBtnTimeNo = 0;

			OnBtnPushed( (WPARAM)IDC_HOUSE_DN, (LPARAM)0 );
		}
		else if( !m_bHouseDown ) nSeqCheckPushBtnTimeNo = 0;
		break;
	}
}

void CJobsTabEuvStatusView::CheckEMOStatus()
{
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	if( pDoc->m_pDicsView->m_pDicsData->m_GenInfo.bEmo )
		{
			if( m_pEqpAssy->m_CylinderEuvUpDn.GetFwState( 0 ) || m_pEqpAssy->m_CylinderEuvUpDn.GetBwState( 0 ) )
			{
				m_pEqpAssy->m_CylinderEuvUpDn.SetFw( 0, OFF );
				m_pEqpAssy->m_CylinderEuvUpDn.SetBw( 0, OFF );
				SetDlgItemText( IDC_EUV_MESSAGE, "EMO State : EUV House Up/Down Stop" );
			}
		}
}

void CJobsTabEuvStatusView::SetMelody()
{
/*	if( dosEUV_UNIT_CYL_UP || dosEUV_UNIT_CYL_DN )
	{
		if( !dosLD_UNIT_MELODY_3 ) doLD_UNIT_MELODY_3( ON );
	}
	else 
	{
		if( dosLD_UNIT_MELODY_3 ) doLD_UNIT_MELODY_3 ( OFF );
	}	*/
}

void CJobsTabEuvStatusView::GridInit_LampUseTime()
{
	LPTSTR sLvcText[] = { " Lamp No. ", " Use Time ", " Warning setting " };
	int nColWidth[] = { 900, 1400, 1350 };

	m_gridLampUseTime.SetRows( MAX_LAMP_NO + 1 ); 
	m_gridLampUseTime.SetCols( 3 );
	
	if( MAX_LAMP_NO<=2 ) nColWidth[0] += 270;

	//-------------------------------------------
	m_gridLampUseTime.SetRow( 0 );  
	m_gridLampUseTime.SetColWidth( 0, nColWidth[0] );
	m_gridLampUseTime.SetCol( 0 ); 
	m_gridLampUseTime.SetCellAlignment( 4 );
	m_gridLampUseTime.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridLampUseTime.SetText( sLvcText[0] ); 
	//---------------------------------------------
	m_gridLampUseTime.SetColWidth( 1, nColWidth[1] );
	m_gridLampUseTime.SetCol( 1 ); 
	m_gridLampUseTime.SetCellAlignment( 4 );
	m_gridLampUseTime.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridLampUseTime.SetText( sLvcText[1] ); 
	//---------------------------------------------
	m_gridLampUseTime.SetColWidth( 2, nColWidth[2] );
	m_gridLampUseTime.SetCol( 2 ); 
	m_gridLampUseTime.SetCellAlignment( 4 );
	m_gridLampUseTime.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridLampUseTime.SetText( sLvcText[2] ); 

	SetDataToGridCtrl_LampUseTime();
}

void CJobsTabEuvStatusView::SetDataToGridCtrl_LampUseTime()
{
	CString sBuf;
	
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	CDicsView* pView = (CDicsView*) m_pView;

	for( int i = 0 ; i < MAX_LAMP_NO ; i++ )
	{
		sBuf.Format( "Lamp %d", i + 1 );

		m_gridLampUseTime.SetCol( 0 );
		m_gridLampUseTime.SetRow( i + 1 );
		m_gridLampUseTime.SetCellAlignment( 4 );
		m_gridLampUseTime.SetCellBackColor( LIGHT_CYAN_COLOR );
		m_gridLampUseTime.SetText( (LPCTSTR) sBuf );

		UINT nVal = m_pEuv->GetLampUsedTime( i );
		m_nEuvHour[i] = nVal;
		sBuf.Format( "%d (Hour)", m_nEuvHour[i] );
//		m_nEuvHour[i] = nVal / 3600;
//		m_nEuvMin[i] = ( nVal % 3600 ) / 60;
//		m_nEuvSec[i] = ( nVal % 3600 ) % 60;
//		sBuf.Format( "%d : %02d : %02d", m_nEuvHour[i], m_nEuvMin[i], m_nEuvSec[i] );

		m_gridLampUseTime.SetCol( 1 );
		m_gridLampUseTime.SetCellAlignment( 4 );


//		if( m_nEuvHour[i] >= atoi( pDoc->m_pSetupItems->m_sValueSetup[CSetupItems::setupEUV1_LIFE_TIME + i] ) )
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_UshioEuv.GetIfUla( i ) )
#else
		if( 0 )
#endif
		{
			m_gridLampUseTime.SetCellBackColor( RED_COLOR );
		}
//		else if( m_nEuvHour[i] < atoi( pDoc->m_pSetupItems->m_sValueSetup[CSetupItems::setupEUV1_LIFE_TIME + i] ) )
		else if( !m_pEqpAssy->m_UshioEuv.GetIfUla( i ) )
		{
			m_gridLampUseTime.SetCellBackColor( WHITE_COLOR );
		}

		m_gridLampUseTime.SetText( (LPCTSTR) sBuf );

		m_gridLampUseTime.SetCol( 2 );
		m_gridLampUseTime.SetCellAlignment( 4 );

		sBuf.Format( "%d Hours", atoi( pDoc->m_pSetupItems->m_sValueSetup[CSetupItems::setupEUV1_LIFE_TIME + i] ) );
		m_gridLampUseTime.SetText( sBuf );
	}
}

void CJobsTabEuvStatusView::GridInit_LampIntensity()
{
	LPTSTR sLvcText[] = { " Pos No. ", " Intensity " };
//  int nColWidth[] = { 900, 2750 };
	int nColWidth[] = { 900, 1400 };

	m_gridLampIntensity.SetRows( MAX_LAMP_INTENSITY_NO +1 ); 
	m_gridLampIntensity.SetCols( 2 );

	if( MAX_LAMP_INTENSITY_NO<=2 ) nColWidth[0] += 270;

	//-------------------------------------------
	m_gridLampIntensity.SetRow( 0 );  
	m_gridLampIntensity.SetColWidth( 0, nColWidth[0] );
	m_gridLampIntensity.SetCol( 0 ); 
	m_gridLampIntensity.SetCellAlignment( 4 );
	m_gridLampIntensity.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridLampIntensity.SetText( sLvcText[0] ); 
	//---------------------------------------------
	m_gridLampIntensity.SetColWidth( 1, nColWidth[1] );
	m_gridLampIntensity.SetCol( 1 ); 
	m_gridLampIntensity.SetCellAlignment( 4 );
	m_gridLampIntensity.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridLampIntensity.SetText( sLvcText[1] ); 
	//---------------------------------------------

	SetDataToGridCtrl_LampIntensity();
}

void CJobsTabEuvStatusView::SetDataToGridCtrl_LampIntensity()
{
	CString sBuf;
	
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	CDicsView* pView = (CDicsView*) m_pView;
	
	for( int i = 0 ; i < MAX_LAMP_INTENSITY_NO ; i++ )
	{
		sBuf.Format( "Pos %d ", i + 1 );

		m_gridLampIntensity.SetCol( 0 );
		m_gridLampIntensity.SetRow( i + 1 );
		m_gridLampIntensity.SetCellAlignment( 4 );
		m_gridLampIntensity.SetCellBackColor( LIGHT_CYAN_COLOR );
		m_gridLampIntensity.SetText( (LPCTSTR) sBuf );

//		sBuf.Format( "%3.1f", m_pEuv->GetLampIntensity( i ) );
		sBuf.Format( "%s", m_pEuv->GetLampIntensity( i ) );
		m_gridLampIntensity.SetCol( 1 );
		m_gridLampIntensity.SetCellAlignment( 4 );
		m_gridLampIntensity.SetCellBackColor( WHITE_COLOR );

		m_gridLampIntensity.SetText( (LPCTSTR) sBuf );
	}
}

void CJobsTabEuvStatusView::SetDataToGridCtrl_LampIntensity( int nPos )
{
	CString sBuf;
	
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	CDicsView* pView = (CDicsView*) m_pView;
	
	m_gridLampIntensity.SetRow( nPos + 1 );
	m_gridLampIntensity.SetCol( 1 );
	m_gridLampIntensity.SetCellAlignment( 4 );
	m_gridLampIntensity.SetCellBackColor( WHITE_COLOR );

	sBuf.Format( "%3.1f", m_pEuv->GetLampIntensity( nPos ) );
//	sBuf.Format( "%s", m_pEuv->GetLampIntensity( nPos ) );

	m_gridLampIntensity.SetText( (LPCTSTR) sBuf );
}

void CJobsTabEuvStatusView::SetLampSelect( int nLampNo )
{
	//CString	sMsg;
	if( m_macLampOnSelect[nLampNo].GetCheck() )
	{
		m_bLampOnSelect[nLampNo] = FALSE;
		m_macLampOnSelect[nLampNo].SetCheck( 0 );
//		m_sMessage.Format( "Lamp %d, %d is Unselected", nLampNo*2 + 1, nLampNo*2 + 2 );
		m_sMessage.Format( "Lamp %d is Unselected", nLampNo + 1 );
		m_msgEuv.SetOpMsg( m_sMessage );
	}
	else
	{
		m_bLampOnSelect[nLampNo] = TRUE;
		m_macLampOnSelect[nLampNo].SetCheck( 1 );
//		m_sMessage.Format( "Lamp %d, %d is Selected", nLampNo*2 + 1, nLampNo*2 + 2 );
		m_sMessage.Format( "Lamp %d is Selected", nLampNo + 1 );
		m_msgEuv.SetOpMsg( m_sMessage );
	}

	m_pEuv->LampOnSelect( nLampNo, m_bLampOnSelect[nLampNo] );
}

void CJobsTabEuvStatusView::OnEuvLampOnSelect( UINT nID )
{
	int nLampNo = IDC_LAMP1 - nID;
	SetLampSelect( nLampNo );
}

void CJobsTabEuvStatusView::OnEuvLampOnSelect1() 
{
	SetLampSelect( 0 );
}

void CJobsTabEuvStatusView::OnEuvLampOnSelect2() 
{
	SetLampSelect( 1 );
}

void CJobsTabEuvStatusView::OnEuvLampOnSelect3() 
{
	SetLampSelect( 2 );
}

void CJobsTabEuvStatusView::OnEuvLampOnSelect4() 
{
	SetLampSelect( 3 );
}

void CJobsTabEuvStatusView::OnEuvLampOnSelect5() 
{
	SetLampSelect( 4 );
}
void CJobsTabEuvStatusView::OnEuvLampOnSelect6() 
{
	SetLampSelect( 5 );
}

void CJobsTabEuvStatusView::OnEuvLampOnSelect7() 
{
	SetLampSelect( 6 );
}

void CJobsTabEuvStatusView::OnEuvLampOnSelect8() 
{
	SetLampSelect( 7 );
}

void CJobsTabEuvStatusView::OnPcwValve()
{
	if( m_pEqpAssy->m_AutoValveEuvPcw.GetState() )
		m_pEqpAssy->m_AutoValveEuvPcw.Set( 0, OFF );
	else
		m_pEqpAssy->m_AutoValveEuvPcw.Set( 0, ON );
}

void CJobsTabEuvStatusView::OnN2Valve()
{
	if( m_pEqpAssy->m_AutoValveEuvN2.GetState() )
		m_pEqpAssy->m_AutoValveEuvN2.Set( 0, OFF );
	else
		m_pEqpAssy->m_AutoValveEuvN2.Set( 0, ON );
}

void CJobsTabEuvStatusView::OnCdaValve()
{
	if( m_pEqpAssy->m_AutoValveEuvCda.GetState() )
		m_pEqpAssy->m_AutoValveEuvCda.Set( 0, OFF );
	else
		m_pEqpAssy->m_AutoValveEuvCda.Set( 0, ON );
}

void CJobsTabEuvStatusView::OnEuvLampOn() 
{
	// TODO: Add your control notification handler code here
	MAC_COLOR_SET color_set;

	CDicsView* pView = ( CDicsView* ) m_pView;
	
	if( !m_pEuv->GetLampOnState() )
	{
		if( m_pEuv->GetEuvAlarm() )
		{
			m_msgEuv.SetOpMsg( "EUV is Alarm Condition" );
		}
#ifndef _MY_DEBUG
		else if( !m_pEqpAssy->m_UshioEuv.GetIfUnre() ) m_msgEuv.SetOpMsg( "EUV is not Remote mode" );
#endif
		else if( !m_pEqpAssy->m_AutoValveEuvN2.GetState() ) m_msgEuv.SetOpMsg( "EUV Unit N2 Valve is not Open" );
		else if( !m_pEqpAssy->m_AutoValveEuvPcw.GetState() ) m_msgEuv.SetOpMsg( "EUV Unit PCW Valve is not Open" );
		else if( !m_pEqpAssy->m_AutoValveEuvCda.GetState() ) m_msgEuv.SetOpMsg( "CDA Valve is not Open" );
		else
		{			
			m_macLampOn.GetColorSetting( &color_set );
			color_set.crFace = LIGHT_ORANGE_COLOR;
			color_set.crLiteShadow = MAGENTA_COLOR;
			m_macLampOn.SetColorSetting( color_set );
			m_macLampOn.SetBold();
			m_macLampOn.SetCheck( 1 );
			GetDlgItem( IDC_LAMP_ON )->SetWindowText( "LAMP OFF" );
			m_msgEuv.SetOpMsg( "EUV Lamp ON" );
#ifndef _NO_EUV
			pView->m_pCvSeq->m_CvMotor.nCvManual[IF_UNIT_EUV] = CCvSeq::cvFW;	//eun 070320 Ushio Request
#endif
			m_pEuv->LampControl( ON );

			SetLog("EUV VIEW", 0, 0, "Lamp On");
		}
	}
	else
	{
		m_macLampOn.GetColorSetting( &color_set );
		color_set.crFace = LIGHT_GREEN_COLOR;
		color_set.crLiteShadow = MAGENTA_COLOR;
		m_macLampOn.SetColorSetting( color_set );
		m_macLampOn.SetBold();
		m_macLampOn.SetCheck( 0 );
		GetDlgItem( IDC_LAMP_ON )->SetWindowText( "LAMP ON" );
		m_msgEuv.SetOpMsg( "EUV Lamp OFF" );
#ifndef _NO_EUV		
		pView->m_pCvSeq->m_CvMotor.nCvManual[IF_UNIT_EUV] = CCvSeq::cvSTOP;		//eun 070320 Ushio Request
#endif
		m_pEuv->LampControl( OFF );

		SetLog("EUV VIEW", 0, 0, "Lamp Off");
	}
	
//	Invalidate();
}

//void CJobsTabEuvStatusView::OnEuvIntensityCheck() 
//{
////	int nLamp = m_gridLampIntensity.GetRow() - 1;
////	m_pEuv->m_IfEuv.bLampIntensityCheckReq[nLamp] = TRUE;
//	m_pEuv->m_IfEuv.bLampIntensityCheckReq[0] = TRUE;
//}

void CJobsTabEuvStatusView::SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage )
{
	// Log
	CString sLog;
	CString sPortNo;
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() ); // 2009.01.14 minhan
	if( nPortNo <= 0 ) sPortNo = "";
	else sPortNo.Format( "%d", nPortNo );

	CString sSlotNo;
	if( nSlotNo <= 0 ) sSlotNo = "";
	else sSlotNo.Format( "%d", nSlotNo );

	m_sMessage.Format( "MAIN\t%s\t%s\t%s\t%s", sSeqName, sPortNo, sSlotNo, sMessage );
	Log.TextOut( m_sMessage );
    if( pDoc->m_pDicsView->m_pDicsData->m_GenInfo.bEnableEqpLog ) // 2009.01.14 minhan
	{
		sLog.Format( "%s : %s", sSeqName, sMessage );
		( (CDicsView*) m_pView )->SendMessage( WM_EQP_LOG, 0, (LPARAM)(LPCTSTR) sLog );
	}
}


LRESULT CJobsTabEuvStatusView::OnBtnPushed(WPARAM wParam, LPARAM lParam )
{
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	
	if( pDoc->m_pDicsView->m_pDicsData->m_GenInfo.bEmo )
	{
		SetDlgItemText( IDC_EUV_MESSAGE, "EMO state : Lamp House can't move" );
		return 0;
	}

	switch( (UINT)wParam ) 
	{
	case IDC_HOUSE_UP:
		if( m_bHouseUp && !m_bHouseDown && ( m_nHouseMoveOk == 1 ) )
		{
			if( !m_pEqpAssy->m_CylinderEuvUpDn.GetFwState( 0 ) )
			{
				m_pEqpAssy->m_CylinderEuvUpDn.SetFw( 0, ON );
				m_pEqpAssy->m_CylinderEuvUpDn.SetBw( 0, OFF );
			}
 			SetDlgItemText( IDC_EUV_MESSAGE, "Lamp House is moving upward" );
		}
		else
		{
			m_bHouseUp		= TRUE;
			m_bHouseDown	= FALSE;
		}
		break;

	case IDC_HOUSE_DN:
		if( !m_bHouseUp && m_bHouseDown && ( m_nHouseMoveOk == -1 ) )
		{
			if( !m_pEqpAssy->m_CylinderEuvUpDn.GetBwState( 0 ) )
			{
				m_pEqpAssy->m_CylinderEuvUpDn.SetFw( 0, OFF );
				m_pEqpAssy->m_CylinderEuvUpDn.SetBw( 0, ON );
			}
			SetDlgItemText( IDC_EUV_MESSAGE, "Lamp House is moving downward" );
		}
		else
		{
			m_bHouseUp		= FALSE;
			m_bHouseDown	= TRUE;
		}
		break;
	}
	return 0;
}

LRESULT CJobsTabEuvStatusView::OnBtnReleased(WPARAM wParam, LPARAM lParam)
{
	// Reset Delay interlock
	m_bHouseUp		= FALSE;
	m_bHouseDown	= FALSE;
	m_nHouseMoveOk	= 0;

	switch( (UINT)wParam ) 
	{
	case IDC_HOUSE_UP:
		m_pEqpAssy->m_CylinderEuvUpDn.SetFw( 0, OFF );
		m_pEqpAssy->m_CylinderEuvUpDn.SetBw( 0, OFF );
		m_macHouseUp.SetCheck( 0 );
		SetDlgItemText( IDC_MESSAGE, "Lamp House is stopped" );
		break;
	case IDC_HOUSE_DN:
		m_pEqpAssy->m_CylinderEuvUpDn.SetFw( 0, OFF );
		m_pEqpAssy->m_CylinderEuvUpDn.SetBw( 0, OFF );
		m_macHouseDown.SetCheck( 0 );
		SetDlgItemText( IDC_MESSAGE, "Lamp House is stopped" );
		break;
	}
	return 0;
}


void CJobsTabEuvStatusView::OnClickGridLampIntensity() 
{
	// TODO: Add your control notification handler code here
//	int nLamp = m_gridLampIntensity.GetRow() - 1;
//	CString sBuf;
//	sBuf.Format( "Pos %d Intensity Check", nLamp + 1 );
////	GetDlgItem( IDC_EUV_INTENSITY_CHECK )->SetWindowText( (LPCTSTR)sBuf );
//	
//	m_sMessage.Format( "Position %d is Selected", nLamp + 1 );
//	m_msgEuv.SetOpMsg( m_sMessage );
	
}

void CJobsTabEuvStatusView::OnDblClickGridUsedTime() 
{
	return;

	if( ( (CDicsView*) m_pView )->m_pDicsData->m_GenInfo.bAuto )
	{
		AfxMessageBox("Now Auto Mode : Cannot Reset Value" );
		return;
	}

	int nRow = m_gridLampUseTime.GetRow();
	int nCol = m_gridLampUseTime.GetCol();

	if ( nRow == 0 || nCol == 0) return;

	if( AfxMessageBox("Do you want to clear Current Value ? ", MB_YESNO ) != IDYES )
	{
		return;
	}
	else
	{
		((CDicsView*)m_pView)->m_pEuvSeq->SetLampUsedTime( nRow-1, -1 );
		SetDataToGridCtrl_LampUseTime();		
	}
}

void CJobsTabEuvStatusView::OnEuvLocalModeLock() 
{
	MAC_COLOR_SET color_set;
	
	if( m_macEuvLocalModeLock.GetCheck() )
	{
		m_pEuv->LampLocalLock( OFF );
		m_macEuvLocalModeLock.SetCheck( 0 );
		color_set.crFace = LIGHT_GREEN_COLOR;
		color_set.crLiteShadow = MAGENTA_COLOR;
		m_macEuvLocalModeLock.SetColorSetting( color_set );
		m_sMessage.Format( "EUV Lamp Local Lock Off" );
		m_msgEuv.SetOpMsg( m_sMessage );
	}
	else
	{
		m_pEuv->LampLocalLock( ON );
		m_macEuvLocalModeLock.SetCheck( 1 );
		color_set.crFace = LIGHT_ORANGE_COLOR;
		color_set.crLiteShadow = MAGENTA_COLOR;
		m_macEuvLocalModeLock.SetColorSetting( color_set );
		m_sMessage.Format( "EUV Lamp Local Lock On" );
		m_msgEuv.SetOpMsg( m_sMessage );
	}
	
}

void CJobsTabEuvStatusView::OnEuvRemoteMode() 
{
	MAC_COLOR_SET color_set;
	
	if( m_macEuvRemoteMode.GetCheck() )
	{
		m_pEuv->LampRemote( OFF );
		color_set.crFace = LIGHT_GREEN_COLOR;
		color_set.crLiteShadow = MAGENTA_COLOR;
		m_macEuvRemoteMode.SetColorSetting( color_set );
		m_macEuvRemoteMode.SetCheck( 0 );
		m_sMessage.Format( "EUV Lamp Remote Off" );
		m_msgEuv.SetOpMsg( m_sMessage );
	}
	else
	{
		if( m_pEuv->LampRemote( ON ) ) 
		{
			color_set.crFace = LIGHT_ORANGE_COLOR;
			color_set.crLiteShadow = MAGENTA_COLOR;
			m_macEuvRemoteMode.SetColorSetting( color_set );
			m_macEuvRemoteMode.SetCheck( 1 );
			m_sMessage.Format( "EUV Lamp Remote On" );
			m_msgEuv.SetOpMsg( m_sMessage );
		}
		else
			m_msgEuv.SetOpMsg( "Remote Mode Change Fail" );
	}
}

void CJobsTabEuvStatusView::OnEuvEmergency() 
{
	MAC_COLOR_SET color_set;
	
	if( m_macEmergency.GetCheck() )
	{
		m_pEuv->LampEmergency( OFF );
		color_set.crFace = LIGHT_GREEN_COLOR;
		color_set.crLiteShadow = MAGENTA_COLOR;
		m_macEmergency.SetColorSetting( color_set );
		m_macEmergency.SetCheck( 0 );
		m_sMessage.Format( "EUV Lamp EMG Off" );
		m_msgEuv.SetOpMsg( m_sMessage );
	}
	else
	{
		m_pEuv->LampEmergency( ON );
		color_set.crFace = LIGHT_ORANGE_COLOR;
		color_set.crLiteShadow = MAGENTA_COLOR;
		m_macEmergency.SetColorSetting( color_set );
		m_macEmergency.SetCheck( 1 );
		m_sMessage.Format( "EUV Lamp EMG On" );
		m_msgEuv.SetOpMsg( m_sMessage );
	}
}

void CJobsTabEuvStatusView::OnEuvReset() 
{
	MAC_COLOR_SET color_set;

	if( m_bUERT )
	{
		m_bUERT = FALSE;
		m_pEqpAssy->m_UshioEuv.SetIfUert( OFF );
		color_set.crFace = LIGHT_GREEN_COLOR;
		color_set.crLiteShadow = MAGENTA_COLOR;
		m_macEuvReset.SetColorSetting( color_set );
		m_macEuvReset.SetCheck( 0 );
		m_sMessage.Format( "EUV Lamp Reset Off" );
		m_msgEuv.SetOpMsg( m_sMessage );
	}
	else if( !m_bUERT )
	{
		m_bUERT = TRUE;
		m_pEqpAssy->m_UshioEuv.SetIfUert( ON );
		color_set.crFace = LIGHT_ORANGE_COLOR;
		color_set.crLiteShadow = MAGENTA_COLOR;
		m_macEuvReset.SetColorSetting( color_set );
		m_macEuvReset.SetCheck( 1 );
		m_sMessage.Format( "EUV Lamp Reset On" );
		m_msgEuv.SetOpMsg( m_sMessage );
	}
	Sleep( 1000 );
	
	m_bUERT = FALSE;
	m_pEqpAssy->m_UshioEuv.SetIfUert( OFF );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macEuvReset.SetColorSetting( color_set );
	m_macEuvReset.SetCheck( 0 );
	m_sMessage.Format( "EUV Lamp Reset Off" );
	m_msgEuv.SetOpMsg( m_sMessage );
}

void CJobsTabEuvStatusView::OnEuvCounterReset() 
{
	MAC_COLOR_SET color_set;
	
	if( m_macCounterReset.GetCheck() )
	{
		m_pEqpAssy->m_UshioEuv.SetIfUicr( OFF );
		color_set.crFace = LIGHT_GREEN_COLOR;
		color_set.crLiteShadow = MAGENTA_COLOR;
		m_macCounterReset.SetColorSetting( color_set );
		m_macCounterReset.SetCheck( 0 );
		m_sMessage.Format( "EUV Initial Counter Reset Off" );
		m_msgEuv.SetOpMsg( m_sMessage );
	}
	else
	{
		m_pEqpAssy->m_UshioEuv.SetIfUicr( ON );
		color_set.crFace = LIGHT_ORANGE_COLOR;
		color_set.crLiteShadow = MAGENTA_COLOR;
		m_macCounterReset.SetColorSetting( color_set );
		m_macCounterReset.SetCheck( 1 );
		m_sMessage.Format( "EUV Initial Counter Reset On" );
		m_msgEuv.SetOpMsg( m_sMessage );
	}
}

void CJobsTabEuvStatusView::OnEuvLampUseTimeAllReset() 
{
	MAC_COLOR_SET color_set;
	
	if( m_macUsedTimeReset.GetCheck() )
	{
		m_pEqpAssy->m_UshioEuv.SetIfUlst( OFF );
		color_set.crFace = LIGHT_GREEN_COLOR;
		color_set.crLiteShadow = MAGENTA_COLOR;
		m_macUsedTimeReset.SetColorSetting( color_set );
		m_macUsedTimeReset.SetCheck( 0 );
		m_sMessage.Format( "EUV Lamp Used Time Reset Off" );
		m_msgEuv.SetOpMsg( m_sMessage );
	}
	else
	{
		m_pEqpAssy->m_UshioEuv.SetIfUlst( ON );
		color_set.crFace = LIGHT_ORANGE_COLOR;
		color_set.crLiteShadow = MAGENTA_COLOR;
		m_macUsedTimeReset.SetColorSetting( color_set );
		m_macUsedTimeReset.SetCheck( 1 );
		m_sMessage.Format( "EUV Lamp Used Time Reset On" );
		m_msgEuv.SetOpMsg( m_sMessage );
	}
}

void CJobsTabEuvStatusView::OnHumidifierReset() 
{
	MAC_COLOR_SET color_set;
	
	if( m_bUHER )
	{
		m_bUHER = FALSE;
		m_pEuv->HumidifierReset( OFF );
		color_set.crFace = LIGHT_GREEN_COLOR;
		color_set.crLiteShadow = MAGENTA_COLOR;
		m_macHumReset.SetColorSetting( color_set );
		m_macHumReset.SetCheck( 0 );
		m_sMessage.Format( "Humidifier Reset Off" );
		m_msgEuv.SetOpMsg( m_sMessage );
	}
	else if( !m_bUHER )
	{
		m_bUHER = TRUE;
		m_pEuv->HumidifierReset( ON );
		color_set.crFace = LIGHT_ORANGE_COLOR;
		color_set.crLiteShadow = MAGENTA_COLOR;
		m_macHumReset.SetColorSetting( color_set );
		m_macHumReset.SetCheck( 1 );
		m_sMessage.Format( "Humidifier Reset On" );
		m_msgEuv.SetOpMsg( m_sMessage );
	}

	Sleep( 1000 );

	m_bUHER = FALSE;
	m_pEuv->HumidifierReset( OFF );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macHumReset.SetColorSetting( color_set );
	m_macHumReset.SetCheck( 0 );
	m_sMessage.Format( "Humidifier Reset Off" );
	m_msgEuv.SetOpMsg( m_sMessage );
}
