//{{AFX_INCLUDES()
#include "..\pump.h"
#include "..\AnalogCtrl.h"
//}}AFX_INCLUDES
#if !defined(AFX_JOBSTABMOTORLOADFACTORVIEW_H__72001315_F9D6_4837_9235_DA36D2329E03__INCLUDED_)
#define AFX_JOBSTABMOTORLOADFACTORVIEW_H__72001315_F9D6_4837_9235_DA36D2329E03__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// JobsTabMotorLoadFactorView.h : header file
//
#include "..\X\AVICtrl.h"	// Added by ClassView
#include "..\X\colorstatic.h"	// Added by ClassView
#include "..\X\TextProgressCtrl.h"	// Added by ClassView
#include "..\X\ColorBtn.h"
#include "..\X\MsgBox.h"
#include "..\FactoryLib\EqpAssy.h"
/////////////////////////////////////////////////////////////////////////////
// JobsTabMotorLoadFactorView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#define MAX_MOTOR_LOAD_FACTOR_AI_NO	36

class CJobsTabMotorLoadFactorView : public CFormView
{
public:
	CJobsTabMotorLoadFactorView();           // protected constructor used by dynamic creation
	CJobsTabMotorLoadFactorView( CView* pView, int nTabNo );
	DECLARE_DYNCREATE(CJobsTabMotorLoadFactorView)

// Form Data
public:
	//{{AFX_DATA(CJobsTabMotorLoadFactorView)
	enum { IDD = IDD_JOBS_TAB_MOTOR_LOAD_FACTOR_VIEW };

	//}}AFX_DATA

	CAnalogCtrl		*m_ocxAnalogInput;
// Attributes
public:
	int				m_nTabNo;
	CView*			m_pView;
	CSetupItems*	m_pSetupItems;
	XCtlDevice*		m_pDevice;
	CDicsData*		m_pDicsData;
	CEqpAssy*		m_pEqpAssy;
	BOOL			m_bInitialUpdateComp;

	// hskwak 20.01.17
	CColorStatic	m_aiView[MAX_LF_VIEW_AI_NO];
	BOOL			m_bAiControlHide;

// Operations
public:
	void SetBitmaps();
	void SetAnalogOcxInitParameter();
	void SetAiInitParameter();
	void SetDevice( XCtlDevice* pDevice ) { m_pDevice = pDevice; }
	void SetEqpAssy( CEqpAssy* pEqpAssy ) { m_pEqpAssy = pEqpAssy; }
	void SetDicsData( CDicsData* pDicsData ){ m_pDicsData = pDicsData; }
	void SetColorStatic(CColorStatic &stcObject, BOOL bState, COLORREF color);
		
	void SetHideAiControl(BOOL bHide);			// hskwak 20.01.17 ai hide
	void UpdateAiView(int nId, float fAiVaue);	// hskwak 20.01.17 ai status

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CJobsTabMotorLoadFactorView)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CJobsTabMotorLoadFactorView();
	void UpdateObjects();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CJobsTabMotorLoadFactorView)
	afx_msg void OnClickAnalogInput( UINT nID );
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
public:

protected:
	void UpdateAI();
public:
	afx_msg void OnStnClickedUnitAnalogview1();
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_JOBSTABMOTORLOADFACTORVIEW_H__72001315_F9D6_4837_9235_DA36D2329E03__INCLUDED_)
