//{{AFX_INCLUDES()
#include "..\pump.h"
#include "..\AnalogCtrl.h"
//}}AFX_INCLUDES
#if !defined(AFX_JOBSTABPIPINGBUFTANKVIEW_H__72001315_F9D6_4837_9235_DA36D2329E03__INCLUDED_)
#define AFX_JOBSTABPIPINGBUFTANKVIEW_H__72001315_F9D6_4837_9235_DA36D2329E03__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "..\X\AVICtrl.h"	// Added by ClassView
#include "..\X\colorstatic.h"	// Added by ClassView
#include "..\X\TextProgressCtrl.h"	// Added by ClassView
#include "..\sbjunit.h"
#include "..\aqkunit.h"
#include "..\shwunit.h"
#include "..\AirKnife.h"
#include "..\AutoValve.h"
#include "..\X\ColorBtn.h"
#include "..\X\MsgBox.h"
#include "..\FactoryLib\EqpAssy.h"

// CJobsTabPipingBufTankView  Դϴ.

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

class CJobsTabPipingBufTankView : public CFormView
{
public:
	CJobsTabPipingBufTankView();           //  ⿡ Ǵ protected Դϴ.
	CJobsTabPipingBufTankView( CView* pView, int nTabNo );
	DECLARE_DYNCREATE(CJobsTabPipingBufTankView)

public:
	enum { IDD = IDD_JOBS_TAB_PIPING_VIEW_BUFTANK };

	CAutoValve		m_ocxAutoValve[MAX_DI_BUFTANK_AUTOVALVE];
	CTextProgressCtrl m_progBufTank[MAX_DI_BUFTANK_NO];
	CPump			m_ocxBufTankPump[MAX_DI_BUFTANK_PUMP_NO];
	CAnalogCtrl		*m_ocxAnalogInput;
// Attributes
public:
	int				m_nTabNo;
	CView*			m_pView;
	CSetupItems*	m_pSetupItems;
	XCtlDevice*		m_pDevice;
	CDicsData*		m_pDicsData;
	CEqpAssy*		m_pEqpAssy;
	BOOL			m_bInitialUpdateComp;

	CColorStatic	m_stcBufTankHH[MAX_DI_BUFTANK_NO];
	CColorStatic	m_stcBufTankH[MAX_DI_BUFTANK_NO];
	CColorStatic	m_stcBufTankL[MAX_DI_BUFTANK_NO];
	CColorStatic	m_stcBufTankLL[MAX_DI_BUFTANK_NO];
	CColorStatic	m_stcLeak[MAX_BUFTANK_LEAK_SENSOR_NO];

// Operations
public:
	void SetAnalogOcxInitParameter();
	void SetAiInitParameter();
	void SetDevice( XCtlDevice* pDevice ) { m_pDevice = pDevice; }
	void SetEqpAssy( CEqpAssy* pEqpAssy ) { m_pEqpAssy = pEqpAssy; }
	void SetDicsData( CDicsData* pDicsData ){ m_pDicsData = pDicsData; }
	void SetColorStatic(CColorStatic &stcObject, BOOL bState, COLORREF color);

#ifdef _DEBUG
	virtual void AssertValid() const;
#ifndef _WIN32_WCE
	virtual void Dump(CDumpContext& dc) const;
#endif
#endif

// Implementation
public:
	virtual ~CJobsTabPipingBufTankView();
	void UpdateObjects();

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.

	DECLARE_MESSAGE_MAP()

	afx_msg LRESULT OnValveStatusChanged( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnPumpStatusChanged( WPARAM wParam, LPARAM lParam );
	afx_msg LRESULT OnBufTankStatusChanged( WPARAM wParam, LPARAM lParam );
public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
protected:
	void UpdateAI();
	void UpdateValve();
	void UpdateDiwPump();
	void UpdateDiwPump2();
	void UpdateDiwBufTank();
	void UpdateLeakSensor();
	void UpdateSensor();

public:
	DECLARE_EVENTSINK_MAP()
	void ClickAnalogInput( UINT nID );
	void ClickAutovalve( UINT nID );
	void ClickBuftankPump( UINT nID );
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_JOBSTABPIPINGBUFTANKVIEW_H__72001315_F9D6_4837_9235_DA36D2329E03__INCLUDED_)

