// ServoTabSemiAutoView.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "ServoTabSemiAutoView.h"
#include "ServoView.h"

#include "..\X\XLog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/*	//hskwak skip/ 
CString CServoTabSemiAutoView::m_sRbtName[MAX_TR_RBT_NO+1] = {
	"CV Unit",	
	"LD UPDN Unit(Upper position)",
	"LD UPDN Unit(Lower position)",	
};

CString m_sRbtNameOrg[MAX_TR_RBT_NO] = {
	"TR Unit",
	"LD Fish Unit",
};
*/
/////////////////////////////////////////////////////////////////////////////
// CServoTabSemiAutoView

IMPLEMENT_DYNCREATE(CServoTabSemiAutoView, CFormView)

CServoTabSemiAutoView::CServoTabSemiAutoView()
	: CFormView(CServoTabSemiAutoView::IDD)
{
	//{{AFX_DATA_INIT(CServoTabSemiAutoView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CServoTabSemiAutoView::CServoTabSemiAutoView(CView* pView)
	: CFormView(CServoTabSemiAutoView::IDD)
{
	m_pView = pView;

	m_nJointPos = 0;

	m_nSeqGlassMoveNo = 0;
	m_nBeforeSendPosNo = 0;
	m_nBeforeRcvPosNo = 0;
	m_nRevBeforeSendPosNo = 0;
	m_nRevBeforeRecvPosNo = 0;

	m_nSeqTrMoveRbtPosNo = 0;
	m_nSeqTrJointNo = 0;
	m_nSeqRobotReadyNo = 0;
	m_nRobotReadyComp = 0;

	// SeqNo 
	m_nSeqUpCvSemiAutoNo		= 0;
	m_nSeqLdUpdnSemiAutoNo  = 0;
	
	m_nSeqTrAlignNo		    = 0;
	m_nSeqTrTurnNo		    = 0;

	m_nSeqFishRibNo			= 0;
		
	m_nAction = -1;
	m_bAutoMove = FALSE;
	m_bAlarm = FALSE;
	m_nOnFocus	= -1;
	m_bAlarmReset = FALSE;
	m_bAlarmResetLdUpdn = FALSE;

	m_bBufCvStart = FALSE;
	m_bAllCvStart = FALSE;

	m_nArray[fcsFROM] = -1;
	m_nArray[fcsTO] = -1;

	for( int i = 0 ; i < MAX_RBT_NO; i ++ )
	{
		m_RBT_IF[i].nROLE			= roleNONE;

		m_RBT_IF[i].bRECV_RDY		= FALSE;
		m_RBT_IF[i].bRECV_COMP		= FALSE;
		m_RBT_IF[i].bSEND_RDY		= FALSE;
		m_RBT_IF[i].bSEND_COMP		= FALSE;
		
		m_RBT_IF[i].bREV_RECV_RDY   = FALSE;
		m_RBT_IF[i].bREV_RECV_COMP	= FALSE;
		m_RBT_IF[i].bREV_SEND_RDY	= FALSE;
		m_RBT_IF[i].bREV_SEND_COMP	= FALSE;
		
		m_RBT_IF[i].bINIT_POS		= FALSE;
		m_RBT_IF[i].bSAFE_POS		= FALSE;
		m_RBT_IF[i].bFAIL			= FALSE;
		m_RBT_IF[i].bERROR			= FALSE;
	}
}

CServoTabSemiAutoView::~CServoTabSemiAutoView()
{
}

void CServoTabSemiAutoView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CServoTabSemiAutoView)
	DDX_Control(pDX, IDC_LIST_SEQ_LOG, m_lbSeqLog);
	DDX_Control(pDX, IDC_GRID_RBT, m_gridCtrl);
	DDX_Control(pDX, IDC_SEMI_AUTO_MOVE, m_macMove);
	DDX_Control(pDX, IDC_SEMI_AUTO_CANCEL, m_macCancel);
	DDX_Control(pDX, IDC_SEMI_AUTO_ALARM_RESET, m_macAlarmReset);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_SERVO8_BUTTON1, m_macServoButton[0]);	
	DDX_Control(pDX, IDC_SERVO8_BUTTON2, m_macServoButton[1]);	
	DDX_Control(pDX, IDC_SERVO8_BUTTON3, m_macServoButton[2]);	
	DDX_Control(pDX, IDC_SERVO8_BUTTON5, m_macServoButton[3]);	
	DDX_Control(pDX, IDC_SERVO8_BUTTON6, m_macServoButton[4]);	
	DDX_Control(pDX, IDC_SERVO8_BUTTON7, m_macServoButton[5]);

	DDX_Control(pDX, IDC_SERVO8_CHECK1, m_macJointStatus[0]);
	DDX_Control(pDX, IDC_SERVO8_CHECK2, m_macJointStatus[1]);
	DDX_Control(pDX, IDC_SERVO8_CHECK3, m_macJointStatus[2]);
	DDX_Control(pDX, IDC_SERVO8_CHECK5, m_macJointStatus[3]);
	DDX_Control(pDX, IDC_SERVO8_CHECK6, m_macJointStatus[4]);
	DDX_Control(pDX, IDC_SERVO8_CHECK7, m_macJointStatus[5]);
}

BEGIN_MESSAGE_MAP(CServoTabSemiAutoView, CFormView)
	//{{AFX_MSG_MAP(CServoTabSemiAutoView)
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_SEMI_AUTO_MOVE, OnRbtMove)
	ON_BN_CLICKED(IDC_SEMI_AUTO_CANCEL, OnRbtCancel)
	ON_BN_CLICKED(IDC_SEMI_AUTO_ALARM_RESET, OnAlarmReset)
	ON_BN_CLICKED(IDC_SET_SOURCE, OnSetSource)
	ON_BN_CLICKED(IDC_SET_TARGET, OnSetTarget)
	ON_BN_CLICKED(IDC_RADIO_JOINT1, OnRadioJoint1)
	ON_BN_CLICKED(IDC_RADIO_JOINT2, OnRadioJoint2)
	ON_BN_CLICKED(IDC_RADIO_JOINT3, OnRadioJoint3)
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE( IDC_SERVO8_BUTTON1, IDC_SERVO8_BUTTON8, OnBtnClicked )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CServoTabSemiAutoView diagnostics

#ifdef _DEBUG
void CServoTabSemiAutoView::AssertValid() const
{
	CFormView::AssertValid();
}

void CServoTabSemiAutoView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CServoTabSemiAutoView message handlers

BOOL CServoTabSemiAutoView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CServoTabSemiAutoView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	CDicsApp* pApp = ( CDicsApp* ) AfxGetApp();
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	
	// TODO: Add your specialized code here and/or call the base class

	m_pDevice = ((CServoView*) m_pView )->m_pDevice;
	m_pMmc = ((CServoView*)m_pView)->m_pMmc;
	m_pDicsData = ( (CServoView*)m_pView )->m_pDicsData;
	m_pSetupItems = pDoc->m_pSetupItems;
	m_pEqpAssy = ((CServoView*)m_pView)->m_pEqpAssy;
//	int nCurPosTrUnit = m_pMmc->GetCurPoint( RBT_TR_UNIT );
	
/*	if( nCurPosTrUnit == TR_UNIT_SEND_POS )
	{
		OnRadioJoint1();
	}
	else if( nCurPosTrUnit == TR_UNIT_WAIT_POS )
	{
		OnRadioJoint2();
	}
*/
	m_MoveMsg[0].SubclassDlgItem( IDC_SEMI_AUTO_FROM_STATIC, this );
	m_MoveMsg[0].SetTextColor( CYAN_COLOR );
	m_MoveMsg[0].SetBkColor( BLACK_COLOR );

	m_MoveMsg[1].SubclassDlgItem( IDC_SEMI_AUTO_TO_STATIC, this );
	m_MoveMsg[1].SetTextColor( MAGENTA_COLOR );
	m_MoveMsg[1].SetBkColor( BLACK_COLOR );

	m_AlarmMsg.SubclassDlgItem( IDC_SEMI_AUTO_ALARM_STATIC, this );
	m_AlarmMsg.SetTextColor( RED_COLOR );
	m_AlarmMsg.SetBkColor( BLACK_COLOR );
	
	GetDlgItem( IDC_SEMI_AUTO_MOVE )->EnableWindow( FALSE );
	GetDlgItem( IDC_SEMI_AUTO_CANCEL )->EnableWindow( FALSE ); 

	m_btnFrom.Attach( IDC_SET_SOURCE, this, YELLOW_COLOR, BLUE_COLOR, DARK_GRAY_COLOR );
	m_btnTo.Attach( IDC_SET_TARGET, this );

	GridInit();

	// Set the MAC button
	MAC_COLOR_SET color_set;
	m_macMove.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_BLUE_COLOR;
	color_set.crLiteShadow = BLUE_COLOR;
	m_macMove.SetColorSetting( color_set );
	m_macMove.SetBold();

	m_macCancel.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_BLUE_COLOR;
	color_set.crLiteShadow = BLUE_COLOR;
	m_macCancel.SetColorSetting( color_set );
	m_macCancel.SetBold();

	m_macAlarmReset.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_RED_COLOR;
	color_set.crLiteShadow = RED_COLOR;
	m_macAlarmReset.SetColorSetting( color_set );
	m_macAlarmReset.SetBold();

	for( int i=0; i<6; i++ )
	{
		m_macServoButton[i].GetColorSetting( &color_set );
		color_set.crFace = LIGHT_BLUE_COLOR;
		color_set.crLiteShadow = BLUE_COLOR;
		m_macServoButton[i].SetColorSetting( color_set );
		m_macServoButton[i].SetBold();		
	}

#ifdef _MY_DEBUG
	for( int i =0; i<=IF_SEMI_LD; i++ )
	m_pMmc->m_bHomeComp[i] = TRUE;
#endif

//	int nIndex = 0;
//	int nPath[7];
//	GetRbtMovePath( 1, 0, 3, nPath, &nIndex );			

	SetTimer( TIMER_ROBOT( MAX_RBT_NO + 1 ), 100, NULL );
}

void CServoTabSemiAutoView::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	KillTimer( TIMER_ROBOT( MAX_RBT_NO + 1 ) );
	CFormView::OnClose();
}

//--------------------------------------------------------------------
// Button clicked
//--------------------------------------------------------------------
void CServoTabSemiAutoView::OnBtnClicked(UINT nID )
{
	int nCtlId = nID - IDC_SERVO8_BUTTON1;

//0. LD Tilt Dn
//1. UL Tilt Dn
//2. UL HAND BW
//4. LD Tilt Up
//5. UL Tilt Up
//6. UL HAND FW
	if( nCtlId == 0 )
	{
	   	if( m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_LD ) ) // minhan 080922
		{
			AfxMessageBox( "LD C/V Status Error" );
			return;
		}
		m_pEqpAssy->m_CylinderLdTilt.SetBw();
	}

	if( nCtlId == 1 )
	{
		if( m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_UL ) ) // minhanx 080922
		{
			AfxMessageBox( "UL C/V Status Error" );
			return;
		}
		m_pEqpAssy->m_CylinderUlTilt.SetBw();
	}

	if( nCtlId == 2 )
	{
		// minhan 080922
//		if( !m_pMmc->GetHomeSwitch(1) && m_pEqpAssy->m_GlassExistUnitIn.GetAnd( IF_UNIT_UL_HAND ) )
		{
			AfxMessageBox( "UL Hand Glass exist Error" );
			return;
		}
		m_pEqpAssy->m_CylinderUlHand.SetBw();
	}

	if( nCtlId == 4 )
	{
		m_pEqpAssy->m_CylinderLdTilt.SetFw();
	}

	if( nCtlId == 5 )
	{
		BOOL bUlHandSendSensorStatus = m_pEqpAssy->m_PosSensorUlHand.GetAnd( UL_HAND_UNIT_SEND_POS );	// 101119 halesu

		if( !m_pEqpAssy->m_CylinderUlHand.GetBw() && !bUlHandSendSensorStatus )	// 101119 halesu
		{
			AfxMessageBox( "UL Hand Cylinder Status Error" );
			return;
		}
		m_pEqpAssy->m_CylinderUlTilt.SetFw();
	}

	if( nCtlId == 6 )
	{
		if( !m_pEqpAssy->m_CylinderUlTilt.GetBw() )
		{
			AfxMessageBox("UL Unit Tilt Status Error!");
			return;
		}
		else if( (( m_pMmc->GetCurPoint(1) == UL_HAND_UNIT_AFTER_RECV_POS ) ||
			   ( m_pMmc->GetCurPoint(1) == -1 ) )&&
			   ( m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_UL ) || m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_UL )) )
		{ // minhan 080922 
			AfxMessageBox("UL Unit Glass exist!");
			return;
		}
		
		m_pEqpAssy->m_CylinderUlHand.SetFw();
	}
}

void CServoTabSemiAutoView::OnTimer(UINT nIDEvent) 
{
	SeqUpCvSemiAuto();
	SeqLdUpdnSemiAuto();

	if( m_nSeqUpCvSemiAutoNo != 0 || 
		m_nSeqLdUpdnSemiAutoNo !=0 )			
	{
		((CServoView*)m_pView)->m_pDicsData->m_SeqFlag.bSemiAutoMove = TRUE;
	}
	else 
	{
		((CServoView*)m_pView)->m_pDicsData->m_SeqFlag.bSemiAutoMove = FALSE;		
	}

//	CButton* pBtn;
	int nServoCheckNum = 6;
	for( int i=0; i<nServoCheckNum; i++ )
	{
		if( IsCylinderSS(i) ) 
			m_macJointStatus[i].SetCheck( 1 );
		else  
			m_macJointStatus[i].SetCheck( 0 );
	}

	if ( m_bAlarm ) GetDlgItem( IDC_SEMI_AUTO_ALARM_RESET )->EnableWindow( TRUE );
	else GetDlgItem( IDC_SEMI_AUTO_ALARM_RESET )->EnableWindow( FALSE );

	DisplayRbtFormInfo();
	CFormView::OnTimer(nIDEvent);
}

//--------------------------------------------------------------------
// Cylinder Sensor Status
//--------------------------------------------------------------------
BOOL CServoTabSemiAutoView::IsCylinderSS(int nNO)
{
//0. LD Tilt Dn
//1. UL Tilt Dn
//2. UL HAND BW
//4. LD Tilt Up
//5. UL Tilt Up
//6. UL HAND FW

	switch( nNO )
	{
	case 0:
#ifndef _MY_DEBUG
		return m_pEqpAssy->m_CylinderLdTilt.GetBw();
#else
		return m_pEqpAssy->m_CylinderLdTilt.GetBwState();
#endif
		break;
	case 1:
#ifndef _MY_DEBUG
		return m_pEqpAssy->m_CylinderUlTilt.GetBw();
#else
		return m_pEqpAssy->m_CylinderUlTilt.GetBwState();
#endif
		break;
	case 2:
#ifndef _MY_DEBUG
		return m_pEqpAssy->m_CylinderUlHand.GetBw();
#else
		return m_pEqpAssy->m_CylinderUlHand.GetBwState();
#endif
		break;
	case 3:
#ifndef _MY_DEBUG
		return m_pEqpAssy->m_CylinderLdTilt.GetFw();
#else
		return m_pEqpAssy->m_CylinderLdTilt.GetFwState();
#endif
		break;
	case 4:
#ifndef _MY_DEBUG
		return m_pEqpAssy->m_CylinderUlTilt.GetFw();
#else
		return m_pEqpAssy->m_CylinderUlTilt.GetFwState();
#endif
		break;
	case 5:
#ifndef _MY_DEBUG
		return m_pEqpAssy->m_CylinderUlHand.GetFw();
#else
		return m_pEqpAssy->m_CylinderUlHand.GetFwState();
#endif
		break;
	default:
		break;
	}  
	return FALSE;
}

void CServoTabSemiAutoView::DisplayRbtFormInfo()
{
	// 1. CurPoint Display
	// 2. Glass Exist SS Display
	// 3. Motor Alarm SS Display
	static int nRbtPos[MAX_RBT_NO] = {-1, };
	static BOOL bGlassSS[MAX_RBT_NO] = {FALSE, };

	for( int i = 0 ; i < MAX_RBT_NO - 7 ; i ++ )
	{
		//  Robot  ǥ////////////////////
		int nState=0; // nState == 0 ̸ 
		RBT_STATE rsState = m_pMmc->GetRbtStatus( i );
		for( int j=0; j< 4; j++ )
		{
		   if( m_pMmc->m_RbtInfo[i].nMask & ( 1 << j ) ) 
		   {
				nState += rsState.nAxis_state[j];
		   }
		}

//		if( nState == 0 )
//			((CServoView*)m_pView)->m_RbtState[i].SetBkColor( LIGHT_BLUE_COLOR );
//		else ((CServoView*)m_pView)->m_RbtState[i].SetBkColor( RED_COLOR );

		//  Sensor   point ǥ/////////////
//		if( bGlassSS[i] != digSERVO_GLASS_SENSOR(i) )
//		{
//			bGlassSS[i] = digSERVO_GLASS_SENSOR(i);
//			if( bGlassSS[i] )
//				((CServoView*)m_pView)->m_RbtSensor[i].SetBkColor( GREEN_COLOR );
//			else ((CServoView*)m_pView)->m_RbtSensor[i].SetBkColor( BG_COLOR );
//		}
//
//		//  Robot Current Point ȹ
//		if( nRbtPos[i] != m_pMmc->GetCurPoint(i) )
//		{
//			nRbtPos[i] = m_pMmc->GetCurPoint(i);
//			CString sPos;
//			sPos.Format("%d", nRbtPos[i] );
//			((CServoView*)m_pView)->m_RbtSensor[i].SetWindowText( sPos );
//		}
	}

	int nGlsCheckUnitNum = 4;
	for( int i=0; i<nGlsCheckUnitNum; i++ )
	{
#ifndef _MY_DEBUG
		int nRv = GetGlassExist(i);
#else
		int nRv = 0;
#endif
//		if( nRv == 1 ) m_PosInfo[i].SetBkColor( DARK_GREEN_COLOR );
//		else m_PosInfo[i].SetBkColor( BG_COLOR );
	}
}

// 0(SEND), 1(RECV), 2(ALL Not Connection)
int CServoTabSemiAutoView::IsTrJointConfirm()
{
/*	int nRv=2;
	for( int i=0; i<2; i++ )
	{
		if( digTR_UNIT_JOINT_CONFIRM( i ) )	
		{
			nRv = i;
			break;
		}
	}
#ifndef _MY_DEBUG
	return nRv;
#else
	return nRv = 1;
#endif */
	return 1;
}

int CServoTabSemiAutoView::IsTrGlassExist()
{
//	int nJoint = IsTrJointConfirm();
//	if( nJoint == 2 ) return -1;
//	return m_pEqpAssy->m_GlassExistUnit.GetAnd(RBT_TR_UNIT);
	return 1;
}
 
int CServoTabSemiAutoView::GetGlassExist(int nUnit)
{
	switch( nUnit )
	{
	case IF_SEMI_CV: 
		{
			return TRUE;
		}
		break;

	case IF_SEMI_LD_UPDN:
		return ( m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_LD ) || m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_LD ) );
		break;

	case IF_SEMI_LD:	
		return (m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_LD ) || m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_LD ) );
		break;

	default:
		break;
	} 

	return TRUE;
}

void CServoTabSemiAutoView::OnRbtMove()
{
	// Set Log
	SetLog( "MOVE BTN", 0, 0, "BUTTON PUSH" );

	if( ((CServoView*)m_pView)->m_bHomeBtn ) return;

	if( m_bAlarm )
	{
		AfxMessageBox("Please! Continue after alarm reset");
		return;
	}

	if( m_nArray[fcsFROM] == -1 || 
		m_nArray[fcsTO] == -1 )
	{
		return;
	}
	
//	if( m_nArray[fcsFROM] > m_nArray[fcsTO] ) 
//	{
//		AfxMessageBox( "Glass must be transferred ", MB_OK );
//		return;
//	}

	if( MessageBox( "Do you really move the selected glass?", "Move", MB_ICONQUESTION | MB_YESNO | MB_DEFBUTTON2) != IDYES ) return;

	m_bAutoMove = TRUE;
	GetDlgItem( IDC_SEMI_AUTO_MOVE )->EnableWindow( FALSE );
	GetDlgItem( IDC_SEMI_AUTO_CANCEL )->EnableWindow( FALSE );

	m_RBT_IF[m_nArray[fcsFROM]].bERROR			= FALSE;
	m_RBT_IF[m_nArray[fcsFROM]].bINIT_POS		= FALSE;
	m_RBT_IF[m_nArray[fcsFROM]].bRECV_COMP		= FALSE;
	m_RBT_IF[m_nArray[fcsFROM]].bRECV_RDY		= FALSE;
	m_RBT_IF[m_nArray[fcsFROM]].bSEND_COMP		= FALSE;
	m_RBT_IF[m_nArray[fcsFROM]].bSEND_RDY		= FALSE;
	m_RBT_IF[m_nArray[fcsFROM]].bSAFE_POS		= FALSE;
	m_RBT_IF[m_nArray[fcsFROM]].bREV_RECV_COMP  = FALSE;
	m_RBT_IF[m_nArray[fcsFROM]].bREV_RECV_RDY   = FALSE;
	m_RBT_IF[m_nArray[fcsFROM]].bREV_SEND_COMP  = FALSE;
	m_RBT_IF[m_nArray[fcsFROM]].bREV_SEND_RDY   = FALSE;


	m_RBT_IF[m_nArray[fcsTO]].bERROR			= FALSE;
	m_RBT_IF[m_nArray[fcsTO]].bINIT_POS			= FALSE;
	m_RBT_IF[m_nArray[fcsTO]].bRECV_COMP		= FALSE;
	m_RBT_IF[m_nArray[fcsTO]].bRECV_RDY			= FALSE;
	m_RBT_IF[m_nArray[fcsTO]].bSEND_COMP		= FALSE;
	m_RBT_IF[m_nArray[fcsTO]].bSEND_RDY			= FALSE;
	m_RBT_IF[m_nArray[fcsTO]].bSAFE_POS			= FALSE;
	m_RBT_IF[m_nArray[fcsTO]].bREV_RECV_COMP    = FALSE;
	m_RBT_IF[m_nArray[fcsTO]].bREV_RECV_RDY     = FALSE;
	m_RBT_IF[m_nArray[fcsTO]].bREV_SEND_COMP    = FALSE;
	m_RBT_IF[m_nArray[fcsTO]].bREV_SEND_RDY     = FALSE;

	m_nSeqUpCvSemiAutoNo		= 0;
	m_nSeqLdUpdnSemiAutoNo	= 0;

	if ( m_nArray[fcsFROM] > m_nArray[fcsTO] )
	{
		m_RBT_IF[m_nArray[fcsFROM]].nROLE = roleREV_SEND;
		m_RBT_IF[m_nArray[fcsTO]].nROLE = roleREV_RECV;

//		m_sMessage.Format( "%s -> %s Start", m_sRbtName[m_nArray[fcsFROM]], m_sRbtName[m_nArray[fcsTO]] );
	}
	else
	{
		m_RBT_IF[m_nArray[fcsFROM]].nROLE = roleSEND;
		m_RBT_IF[m_nArray[fcsTO]].nROLE = roleRECV;

//		m_sMessage.Format( "%s -> %s Start", m_sRbtName[m_nArray[fcsFROM]], m_sRbtName[m_nArray[fcsTO]] );
	}
//	((CServoView*)m_pView)->m_pMainSeq->AskInitialize();

	m_AlarmMsg.SetWindowText( m_sMessage );
}

void CServoTabSemiAutoView::OnRbtCancel()
{
	m_MoveMsg[0].SetWindowText( "" );
	m_MoveMsg[1].SetWindowText( "" );

	m_RBT_IF[m_nArray[fcsFROM]].nROLE = roleNONE;
	m_RBT_IF[m_nArray[fcsTO]].nROLE = roleNONE;
}

void CServoTabSemiAutoView::OnAlarmReset()
{
	// Set Log
	SetLog( "RST BTN ", 0, 0, "BUTTON PUSH" );

	m_bAlarmReset = TRUE;
	m_bAlarmResetLdUpdn = TRUE;
	m_AlarmMsg.SetWindowText("");
	m_bAlarm = FALSE;
	m_nRobotReadyComp = 0;
}


// TR Rbt Position Move
//1) TR Joint Confirm Ȯ
//2) TR Coupling Unlock(All) -> 0.5 Delay
//3) TR Power Joint DN(All)
//4) TR Position Move
//5) TR Power Joint UP(nPos)
//6) TR Power Joint UP(nPos) Ȯ -> 1 Delay
//7) TR Coupling Lock
//8)  Wait Position̸ Position Sensor Ȯ

int CServoTabSemiAutoView::SeqTrMoveRbtPos(INT nRbtType, INT nPosNo)
{
/*	if( nRbtType != RBT_TR_UNIT ) return 200;

	int nRv;
	int iReturn = -1;
	static int nJointPos = 2;
	static DWORD dwCount;
	CString sErrMsg;
	int nSeqNo = m_nSeqTrMoveRbtPosNo;

	switch( nSeqNo )
	{
	case 0:
		{
			CDicsApp* pApp = (CDicsApp*) AfxGetApp();
			CDicsView* pDicsView = (CDicsView*) pApp->m_pMainView;
			BOOL bTrRobotInterrupt = pDicsView->m_pTrSeq->IsTrRobotInterrupt();

			if( !bTrRobotInterrupt )
			{
				nSeqNo = 5;
			}
			else
			{
				sErrMsg = "Loader Robot Interrupt";
				SetLog( "TR MOVE ", 0, 0, sErrMsg );
				m_AlarmMsg.SetWindowText( sErrMsg );
				nSeqNo = 2000;
			}
		}
		break;
	case 5:
#ifndef _SIM_JOINT
		nJointPos = IsTrJointConfirm(); // 0(SEND), 1(WAIT), 2(RECV), -1(ALL Not Connection)
//		if( nJointPos != -1 )
//		{
//			nSeqNo = 10;
//		}
//		else nSeqNo = 20;

		// JointConfirm  Ҿ  Join Up Ȯ ϴ 찡 Ƿ,
		// TR Move ϱ   Joint Downϴ° .
		nSeqNo = 10;	
#else
		nSeqNo = 20;
#endif
		break;
	case 10:
#ifndef _MY_DEBUG
		if( ( nRv = SeqTrJoint(nJointPos, OFF) ) == TRUE )
#else
		if( 1 )
#endif
		{
			SetLog( "TR MOVE ", 0, 0, "Coupling Release OK" );
			nSeqNo = 20;		
		}
		else if( nRv == 0 )
		{
			nSeqNo = 2000;
		}
		break;

	case 20:
		if( ( nRv = m_pMmc->MoveRbtPos( RBT_TR_UNIT, nPosNo ) ) == 0 )
		{
			m_sMessage.Format( "Position %d Move", nPosNo );
			SetLog( "TR MOVE ", 0, 0, m_sMessage );
			nSeqNo = 30;
		}
		else if( nRv > 0 )
		{
			if( nPosNo == TR_UNIT_SEND_POS ) sErrMsg = "Error Moving the SEND Position";
			else if( nPosNo == TR_UNIT_WAIT_POS ) sErrMsg = "Error Moving the WAIT Position";
			else if( nPosNo == TR_UNIT_RECV_POS ) sErrMsg = "Error Moving the RECV Position";
			else sErrMsg = "Error Moving the HOME Position";

			SetLog( "TR MOVE ", 0, 0, sErrMsg );
			m_AlarmMsg.SetWindowText( sErrMsg );
			nSeqNo = 2000;
		}
		break;
		
	case 30:
		{
			int nCurPos = m_pMmc->GetCurPoint(RBT_TR_UNIT);
			
			if( ( nCurPos == TR_UNIT_SEND_POS ) ||	( nCurPos == TR_UNIT_RECV_POS ) )
			{
				if( ( nCurPos == TR_UNIT_SEND_POS ) ) nJointPos = 0;
				else if( ( nCurPos == TR_UNIT_RECV_POS ) ) nJointPos = 1;

#ifndef _MY_DEBUG
				if( ( nRv = SeqTrJoint( nJointPos, ON ) ) == TRUE )
#else
				if( 1 )
#endif
				{
					SetLog( "TR MOVE ", 0, 0, "Coupling Joint OK" );
					nSeqNo = 40;		
				}
				else if( nRv == FALSE )
				{
					nSeqNo = 2000;
				}
			}
			else
			{
				nJointPos = 2;
				nSeqNo = 40;
			}
		}

		break;

	case 40:
		{
			SetLog( "TR MOVE ", 0, 0, "Position Confirm" );
			nSeqNo = 1000;
		}
		break;

	case 1000:	// Success ó
		SetLog( "TR MOVE ", 0, 0, "Position Move Success" );
		nSeqNo = 0;
		iReturn = TRUE;
		break;
		
	case 2000:	// Alarm ó
		SetLog( "TR MOVE ", 0, 0, "Position Move Fail" );
		nSeqNo = 0;
		iReturn = FALSE;
		break;
	}
	m_nSeqTrMoveRbtPosNo = nSeqNo;
	return iReturn;*/
return 1;
}

// TR Joint 
// nPos : Jointϴ ġ 0(SEND), 1(RECV)
// bAction : 0(Release), 1(Joint)
// Joint => 1. Power Joint Up, 2. Coupling Joint Up, 3. Check Valve ON
// Release => 1. Check Valve OFF, 2. Coupling Joint Down, 3. Power Joint Down
BOOL CServoTabSemiAutoView::SeqTrJoint(int nPos, BOOL bAction)
{/*
	int iReturn = -1;
	static DWORD dwCount;
	CString sErrMsg;
	int nSeqNo = m_nSeqTrJointNo;
	int nJointPos = MAX_JOINT_NO;
	
	switch( nSeqNo )
	{
	case 0:
		if( bAction ) nSeqNo = 10;
		else nSeqNo = 100;
		break;
		
	case 10:
		{
#ifndef _SIM_JOINT
			dogTR_UNIT_JOINT_LOCK(nPos, !bAction);
			dogTR_UNIT_JOINT_UNLOCK( nPos, bAction );
#endif
			dwCount = GetTickCount();
			nSeqNo = 20;
		}
		break;
	case 20:
		if( GetTickCount() - dwCount > 500 )
		{
#ifndef _SIM_JOINT
			dogTR_UNIT_JOINT_UP(nPos, bAction);
			dogTR_UNIT_JOINT_DN(nPos, !bAction);
#endif
			dwCount = GetTickCount();
			nSeqNo = 30;
		}
		break;

	case 30:
#ifndef _SIM_JOINT
		if( digTR_UNIT_JOINT_UP( nPos ) )
#else
		if( 1 )
#endif
		{
			dwCount = GetTickCount();
			nSeqNo = 40;
		}
		else if( GetTickCount() - dwCount > 5000  )
		{
			SetLog( "TR JOINT", 0, 0, "Power Joint UP Sensor Error" );
			sErrMsg = "Power Joint UP Sensor Error";
			m_AlarmMsg.SetWindowText( sErrMsg );
			nSeqNo = 2000;
		}
		break;

	case 40:
		if( GetTickCount() - dwCount > 1000  )
		{
#ifndef _SIM_JOINT
			dogTR_UNIT_JOINT_LOCK(nPos, bAction);
			dogTR_UNIT_JOINT_UNLOCK(nPos, !bAction);
#endif
			nSeqNo = 1000;
		}
		break;
		
	case 100:
		{
#ifndef _SIM_JOINT
			for( int i=0; i<nJointPos; i++ )
			{
				dogTR_UNIT_JOINT_LOCK(i, bAction);
				dogTR_UNIT_JOINT_UNLOCK(i, !bAction);
			}
#endif
			dwCount = GetTickCount();
			nSeqNo = 110;
		}
		break;

	case 110:
		if( GetTickCount() - dwCount > 1000  )
		{
			for( int i=0; i<nJointPos; i++ )
			{
				dogTR_UNIT_JOINT_UP(i, bAction);
				dogTR_UNIT_JOINT_DN(i, !bAction);
			}
			dwCount = GetTickCount();
			nSeqNo = 120;
		}
		break;

	case 120:
		{
			CDicsApp* pApp = (CDicsApp*) AfxGetApp();
			CDicsView* pDicsView = (CDicsView*) pApp->m_pMainView;

			if( pDicsView->m_pTrSeq->IsAllJointDown() )
			{
				nSeqNo = 1000;
			}
			else if( GetTickCount() - dwCount > 5000 )
			{
				SetLog( "TR JOINT", 0, 0, "Power Joint DN Sensor Error" );
				sErrMsg = "Power Joint DN Sensor Error";
				m_AlarmMsg.SetWindowText( sErrMsg );
				nSeqNo = 2000;
			}
		}
		break;
	case 1000:	// Success ó
		SetLog( "TR JOINT", 0, 0, "Joint Success!" );
		nSeqNo = 0;
		iReturn = TRUE;
		break;

	case 2000:	// Alarm ó
		SetLog( "TR JOINT", 0, 0, "Joint Fail" );
		nSeqNo = 0;
		iReturn = FALSE;
		break;

	}
	m_nSeqTrJointNo = nSeqNo;

	return iReturn; */
	return 1;
}

int CServoTabSemiAutoView::GetJointPos()
{
	/* enum jointPOS { jointSEND, jointWAIT, jointRECV, jointNONE } */
/*	int nRv = CTrSeq::jointNONE;
	if( diTR_UNIT_UL_POS_JOINT_CONFIRM ) nRv = CTrSeq::jointRECV;
	else if( diTR_UNIT_LD_POS_JOINT_CONFIRM ) nRv = CTrSeq::jointSEND;

	return nRv;*/
	return 1;
}

int CServoTabSemiAutoView::SeqTrAlign(int nType)
{/*
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return -1;
#endif

	int iReturn = -1;
	static int	nCurJoint;
	static int	nPortNo, nSlotNo;
	static DWORD dwCount;

	int nSeqNo = m_nSeqTrAlignNo;

	switch( nSeqNo )
	{
	case 0 :
		nPortNo = nSlotNo = 0;

		nCurJoint = GetJointPos();

		if( nType == CTrSeq::alignOFF )
		{
			// Log
			SetLog( "TR ALIGN", nPortNo, nSlotNo, "Align Off Start" );
			nSeqNo = 100;
		}
		else // alignON, alignONOFF
		{
			// Log
			SetLog( "TR ALIGN", nPortNo, nSlotNo, "Align On Start" );
			nSeqNo = 10;
		}
		break;
		// Align On
	case 10 :
		// Log
		SetLog( "TR ALIGN", nPortNo, nSlotNo, "Align On" );
		dogTR_UNIT_ALIGN_FW( nCurJoint, ON );
		dogTR_UNIT_ALIGN_BW( nCurJoint, OFF );
		
		dwCount = GetTickCount();

		nSeqNo = 20;
		break;

	case 20 :
#ifndef _MY_DEBUG
		if( digTR_UNIT_ALIGN_FW( nCurJoint ) &&
			!digTR_UNIT_ALIGN_BW( nCurJoint ) )
#else
		if( GetTickCount() - dwCount > 50 )
#endif
		{
			// Log
			SetLog( "TR ALIGN", nPortNo, nSlotNo, "Align On OK" );
			if( nType == CTrSeq::alignONOFF )
			{
				// Log
				SetLog( "TR ALIGN", nPortNo, nSlotNo, "Align Off Start" );
				dwCount = GetTickCount();
				nSeqNo = 30;
			}
			else nSeqNo = 1000;
		}
#ifndef _MY_DEBUG
		else if( GetTickCount() - dwCount > 5000 ) 
#else
		else if( FALSE )
#endif
		{
			// Log
			SetLog( "TR ALIGN", nPortNo, nSlotNo, "Align On Error" );
			nSeqNo = 2000;
		}
		break;

	case 30 :
		if( GetTickCount() - dwCount > 1000 )
		{
			nSeqNo = 100;
		}
		break;

		// Align Off
	case 100 :
		// Log
		SetLog( "TR ALIGN", nPortNo, nSlotNo, "Align Off" );
		dogTR_UNIT_ALIGN_FW( nCurJoint, OFF );
		dogTR_UNIT_ALIGN_BW( nCurJoint, ON );

		dwCount = GetTickCount(); 
		nSeqNo = 110;
		break;

	case 110 :
#ifndef _MY_DEBUG
		if( !digTR_UNIT_ALIGN_FW( nCurJoint ) &&
			digTR_UNIT_ALIGN_BW( nCurJoint ) )
#else
		if( GetTickCount() - dwCount > 50 )
#endif
		{
			// Log
			SetLog( "TR ALIGN", nPortNo, nSlotNo, "Align Off OK" );
			nSeqNo = 1000;
		}
#ifndef _MY_DEBUG
		else if( GetTickCount() - dwCount > 5000 )
#else
		else if( FALSE )
#endif
		{
			// Log
			SetLog( "TR ALIGN", nPortNo, nSlotNo, "Align Off Error" );
			nSeqNo = 2000;
		}
		break;

	case 1000:	// Success ó
		SetLog( "TR ALIGN", 0, 0, "Position Move Success" );
		nSeqNo = 0;
		iReturn = TRUE;
		break;
		
	case 2000:	// Alarm ó
		SetLog( "TR ALIGN", 0, 0, "Position Move Fail" );
		nSeqNo = 0;
		iReturn = FALSE;
		break;
	}
	m_nSeqTrAlignNo = nSeqNo;
	return iReturn; */
	return 1;
}

// bStatus => Pin Align Status FW : Forward(TRUE), BW : Backward(FALSE)
BOOL CServoTabSemiAutoView::IsTrPinAlign( int nPos,  BOOL bStatus )
{/*
	if( bStatus ) // Forward
	{
		return ( digTR_UNIT_ALIGN_FW(nPos) ); // && digTR_UNIT_ALIGN2_FW(nPos) );
	}
	else
	{
		return ( digTR_UNIT_ALIGN_BW(nPos) ); // && digTR_UNIT_ALIGN2_BW(nPos) );
	} */
	return 1;
}

//---------------------------------------------------------------------------
// Set the Log
//---------------------------------------------------------------------------
void CServoTabSemiAutoView::SetLog( CString sSeqName, int nPortNo, int nSlotNo, CString sMessage )
{
	// Log
	CString sLog;
	CString sPortNo;
	if( nPortNo <= 0 ) sPortNo = "";
	else sPortNo.Format( "%d", nPortNo );

	CString sSlotNo;
	if( nSlotNo <= 0 ) sSlotNo = "";
	else sSlotNo.Format( "%d", nSlotNo );

	sLog.Format( "SEMI\t%s\t%s\t%s\t%s", sSeqName, sPortNo, sSlotNo, sMessage );
	Log.TextOut( sLog );

	sLog.Format( "%s : %s", sSeqName, sMessage );
	( (CDicsView*) m_pView )->SendMessage( WM_EQP_LOG, 0, (LPARAM)(LPCTSTR) sLog );

	if( m_lbSeqLog.GetCount() >= 30 ) m_lbSeqLog.DeleteString( 0 );
	int i = m_lbSeqLog.AddString( sLog );
	m_lbSeqLog.SetCurSel( i );
}

void CServoTabSemiAutoView::SeqUpCvSemiAuto()
{
	int nSeqNo = m_nSeqUpCvSemiAutoNo;
	static DWORD dwTickStart = 0;

//	int nCurLdUpdnPosition;// = m_pMmc->GetCurPoint( RBT_LD_UPDN_UNIT );
	
	switch( nSeqNo ) 
	{
	case 0 :
		if( m_RBT_IF[IF_SEMI_CV].nROLE != roleNONE )
		{
			if( m_RBT_IF[IF_SEMI_CV].nROLE == roleRECV )
			{
				SetLog( "TR UNIT ", 0, 0, "Recv Start" );
				nSeqNo = 0;
			}
			else if( m_RBT_IF[IF_SEMI_CV].nROLE == roleSEND )
			{
				SetLog( "CV UNIT ", 0, 0, "Send Start" );
				nSeqNo = 200;
			}
			else if( m_RBT_IF[IF_SEMI_CV].nROLE == roleREV_RECV )
			{
				SetLog( "TR UNIT ", 0, 0, "Reverse Recv Start" );
				nSeqNo = 0;
			}
		}
		break;

	case 200:
		{
			int nUnitNo = -1;
#ifndef _MY_DEBUG
//			for( int i = 7; i>=0; i-- )
			for( int i = 9; i>=0; i-- )
			{
				if( m_pEqpAssy->m_GlassExistUnit.GetOr( i ) )
				{
					nUnitNo = i;
					break;
				}
			}
#else
//			for( int i = 3; i>=0; i-- )
			for( int i = 4; i>=0; i-- )
			{
				if( m_pDicsData->m_bDebugOutSensor[i] || m_pDicsData->m_bDebugInSensor[i] )
				{
					nUnitNo = i;
					break;
				}
			}
#endif
		/*
#ifndef _MY_DEBUG
			if( ( ( nUnitNo == 9 ) && !m_pEqpAssy->m_GlassExistUnitIn.GetAnd( IF_UNIT_BUF1 ) && !m_pEqpAssy->m_GlassExistUnitOut.GetAnd( IF_UNIT_BUF1 ) && !m_pEqpAssy->m_GlassExistUnitIn.GetAnd( IF_UNIT_BUF_MID ) && !m_pEqpAssy->m_GlassExistUnitOut.GetAnd( IF_UNIT_BUF_MID )) ||
				( ( nUnitNo == 8 || nUnitNo == 7 || nUnitNo == 6 ) && !m_pEqpAssy->m_GlassExistUnitIn.GetAnd( IF_UNIT_BUF1 ) && !m_pEqpAssy->m_GlassExistUnitIn.GetAnd( IF_UNIT_BUF_MID )) )
#else
			if( ( ( nUnitNo == 9 ) && !m_pDicsData->m_bDebugInSensor[IF_UNIT_BUF1] && !m_pDicsData->m_bDebugOutSensor[IF_UNIT_BUF1] && !m_pDicsData->m_bDebugInSensor[IF_UNIT_BUF_MID] && !m_pDicsData->m_bDebugOutSensor[IF_UNIT_BUF_MID]) ||
				( ( nUnitNo == 8 || nUnitNo == 7 || nUnitNo == 6 ) && !m_pDicsData->m_bDebugInSensor[IF_UNIT_BUF1] && !m_pDicsData->m_bDebugInSensor[IF_UNIT_BUF_MID] ) )
#endif
			{
				// Only Buf CV Start
				m_bBufCvStart = TRUE; 
				nSeqNo = 210;
			}
			else if( nUnitNo != -1 )
			{
				// All CV Start
				m_bAllCvStart = TRUE;
				nSeqNo = 210;
			}
			else 
			{
				SetLog( "CV UNIT ", 0, 0, "CV UNIT Glass Exist Check NG" );
				m_RBT_IF[IF_SEMI_CV].bERROR = TRUE;
				m_bAlarm = TRUE;
				nSeqNo = 1000;
			}
			*/
		}
		break;

	case 210:
#ifndef _MY_DEBUG
		if( m_RBT_IF[IF_SEMI_LD_UPDN].bRECV_RDY && m_pEqpAssy->m_PosSensorLdUnit.GetAnd( LD_UPDN_UNIT_RECV_POS ) &&
			m_pEqpAssy->m_CylinderLdTilt.GetBw() ) 
#else
		if( m_RBT_IF[IF_SEMI_LD_UPDN].bRECV_RDY )
#endif
		{
			m_RBT_IF[IF_SEMI_LD_UPDN].bRECV_RDY = FALSE;
			SetLog( "CV UNIT ", 0, 0, "LD UPDN UNIT Receive Check OK" );

			nSeqNo = 220;
		}
		break;	
///////////////////////////////////////////////////////////////////////
	case 220 :
		/*if( m_bBufCvStart )
		{
			m_bBufCvStart = FALSE;
			
			for( int i = IF_UNIT_BUF1; i <= IF_UNIT_LD; i++ )
			{
				int nCvSpeed = atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupUP_CV_NORMAL_SPEED] ); // 20000 mm/min
				m_pEqpAssy->m_CvMotor.SetMotorSpeed( i, nCvSpeed );
//				int nSpeed = (int) ( CV_SPEED_2_AO( i, nCvSpeed ) );
//				if( nSpeed > 0x4000 ) nSpeed = 0x4000;
//				aogCV_MOTOR_SPEED( i, nSpeed );
			}

			CDicsDoc* pDoc = (CDicsDoc*)( m_pView->GetDocument() );
			
			SetLog( "CV UNIT ", 0, 0, "BUF CV Start" );
			nSeqNo = 230;
		}
		else if( m_bAllCvStart )
		{
			m_bAllCvStart = FALSE;

			for( int i = IF_UNIT_UP_LD; i <= IF_UNIT_LD; i++ )
			{
				int nCvSpeed = atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupUP_CV_NORMAL_SPEED] ); // 20000 mm/min
				m_pEqpAssy->m_CvMotor.SetMotorSpeed( i, nCvSpeed );
//				int nSpeed = (int) ( CV_SPEED_2_AO( i, nCvSpeed ) );
//				if( nSpeed > 0x4000 ) nSpeed = 0x4000;
//				aogCV_MOTOR_SPEED( i, nSpeed );
			}

			CDicsDoc* pDoc = (CDicsDoc*)( m_pView->GetDocument() );

			SetLog( "CV UNIT ", 0, 0, "ALL CV Start" );
			nSeqNo = 230;
		}
		*/
		break;

	case 230:
	/*
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_LD ) )
#else
		if( 1 )
#endif
		{
			int nCvSpeed = atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupLD_CV_DECEL_SPEED] ); // 20000 mm/min
			m_pEqpAssy->m_CvMotor.SetMotorSpeed( IF_UNIT_LD, nCvSpeed );
//			int nSpeed = (int) ( CV_SPEED_2_AO( IF_UNIT_LD, nCvSpeed ) );
//			if( nSpeed > 0x4000 ) nSpeed = 0x4000;
//			aogCV_MOTOR_SPEED( IF_UNIT_LD, nSpeed );

			dwTickStart = GetTickCount();
			nSeqNo = 240;
		}
		break;
	*/
	case 240:
		if( ( ( GetTickCount() - dwTickStart ) > 3000 ) && !m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_LD ) )
		{
			CDicsDoc* pDoc = (CDicsDoc*)( m_pView->GetDocument() );

			dwTickStart = GetTickCount();
			nSeqNo = 250;
		}
		break;

	case 250:
/*
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_LD ) && 
			!m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_LD ) && 
			!m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_BUF3 ) && 
			!m_pEqpAssy->m_CvMotor.GetMotorFwState( CV_NO_LD ) && 
			!m_pEqpAssy->m_CvMotor.GetMotorBwState( CV_NO_LD ) ) 
#else
		if( !m_pEqpAssy->m_CvMotor.GetMotorFwState( CV_NO_LD ) && 
			!m_pEqpAssy->m_CvMotor.GetMotorBwState( CV_NO_LD ) )
#endif
		{
			SetLog( "CV UNIT ", 0, 0, "Glass Send Complete!" );
			m_RBT_IF[IF_SEMI_CV].bSEND_COMP = TRUE;
			m_RBT_IF[IF_SEMI_CV].nROLE = roleNONE;

			nSeqNo = 260;
		}
		else if( ( GetTickCount() - dwTickStart ) > 2000 ) 
		{
			SetLog( "CV UNIT ", 0, 0, "CV UNIT Glass Exist Check NG" );
			m_RBT_IF[IF_SEMI_CV].bERROR = TRUE;
			
			m_bAlarm = TRUE;
			nSeqNo = 1000;
		}
		*/
		break;

	case 260:
		/*
		if( m_RBT_IF[IF_SEMI_LD_UPDN].bRECV_COMP )
		{
			m_RBT_IF[IF_SEMI_LD_UPDN].bRECV_COMP = FALSE;
			m_RBT_IF[IF_SEMI_CV].nROLE = roleNONE;

			nSeqNo = 0;
		}
		*/
		break;
	case 1000 :
		if( m_bAlarmReset )
		{
			m_bAlarmReset = FALSE;

			m_AlarmMsg.SetWindowText( "" );

			m_RBT_IF[IF_SEMI_CV].nROLE = roleNONE;
			m_RBT_IF[IF_SEMI_CV].bERROR = FALSE;
			nSeqNo = 0;
		}
		break;
	}
	m_nSeqUpCvSemiAutoNo = nSeqNo; 
}

void CServoTabSemiAutoView::SeqLdUpdnSemiAuto()
{
	int nSeqNo = m_nSeqLdUpdnSemiAutoNo;
//	int nRv;
	int nCurLdUpdnPosition = 0;
	static DWORD dwTickStart;	
	CString sErrMsg;
	
	switch( nSeqNo ) 
	{
	case 0 :
		if( m_RBT_IF[IF_SEMI_LD_UPDN].nROLE != roleNONE )
		{
/*			if( !m_pMmc->m_bHomeComp[RBT_LD_UPDN_UNIT] && !m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_LD ) && !m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_LD ) )
			{
				SetLog( "LD UPDN   ", 0, 0, "Home return not finish" );
				m_RBT_IF[IF_SEMI_LD_UPDN].nROLE = roleNONE;
				break;
			}				
			if( m_RBT_IF[IF_SEMI_LD_UPDN].nROLE == roleRECV ) //Cv->Ld UPDN
			{
				SetLog( "LD UPDN   ", 0, 0, "Recv Start" );
				nSeqNo = 10;
			}
			else if( m_RBT_IF[IF_SEMI_LD_UPDN].nROLE == roleSEND ) //Ld UPDN(Up)->Ld UPDN(Dn)
			{
				SetLog( "LD UPDN   ", 0, 0, "Send Start" );
				nSeqNo = 200;
			}
			else if( m_RBT_IF[IF_SEMI_LD_UPDN].nROLE == roleREV_RECV ) //Ld UPDN(Dn)->Ld UPDN(Up)
			{
				SetLog( "LD UPDN   ", 0, 0, "Reverse Recv Start" );
				nSeqNo = 300;
			}
			else if( m_RBT_IF[IF_SEMI_LD_UPDN].nROLE == roleREV_SEND ) //Ld UPDN->Cv
			{
				SetLog( "LD UPDN   ", 0, 0, "Reverse Send Start" );
				nSeqNo = 400;
			}
*/		}
		break;
		
	// FROM CV UNIT RECV ----------------------------------------------------------
	case 10 :
/*		if( 1 ) //m_RBT_IF[IF_SEMI_TR].bINIT_POS )
		{
			nCurLdUpdnPosition = m_pMmc->GetCurPoint( RBT_LD_UPDN_UNIT );

			if( nCurLdUpdnPosition == LD_UPDN_UNIT_HOME_POS ||
				nCurLdUpdnPosition == LD_UPDN_UNIT_RECV_POS ||
				nCurLdUpdnPosition == LD_UPDN_UNIT_SEND_POS ) nSeqNo =  15; // LD Unit Glass Exist
			else 
			{
				sErrMsg = "Ld Updn Unit Position NG";
				SetLog( "LD UPDN   ", 0, 0, sErrMsg );
				m_AlarmMsg.SetWindowText( sErrMsg );

				m_RBT_IF[IF_SEMI_LD_UPDN].bERROR = TRUE;
				m_bAlarm	= TRUE;
				nSeqNo		= 1000;	
			}
		} 
//		else if( m_RBT_IF[IF_SEMI_TR].bERROR ) 
//		{
//			m_RBT_IF[IF_SEMI_LD_FISH].nROLE = roleNONE;
//			nSeqNo = 0;
//		}
*/		break;
	
	case 15 :
#ifndef _MY_DEBUG
		if( !GetGlassExist(IF_SEMI_LD_UPDN) )
#else
		if( !m_pDicsData->m_bDebugInSensor[IF_UNIT_LD] )
#endif
		{
			SetLog( "LD FISH   ", 0, 0, "LD UPDN No Glass Confirm" );
			SetLog( "LD FISH   ", 0, 0, "LD UPDN Tilt Down Start" );

			m_pEqpAssy->m_CylinderLdTilt.SetBw();

			dwTickStart = GetTickCount();

			nSeqNo = 17;
		}
		else 
		{
			sErrMsg = "LD UPDN Glass Confirm NG";
			SetLog( "LD UPDN   ", 0, 0, sErrMsg );
			m_AlarmMsg.SetWindowText( sErrMsg );
			
			m_RBT_IF[IF_SEMI_LD_UPDN].bERROR = TRUE;
			m_bAlarm	= TRUE;
			nSeqNo		= 1000;				
		}
		break;

	case 17 :
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_CylinderLdTilt.GetBw() )
#else
		if( m_pEqpAssy->m_CylinderLdTilt.GetBwState() )
#endif
		{
			SetLog( "LD UPDN   ", 0, 0, "LD UPDN Unit Tilt Down OK" );
			nSeqNo = 20;
		}
		else if( ( GetTickCount() - dwTickStart ) > 5000 )
		{
			sErrMsg = "LD UPDN Tilt Down Sensor NG";
			SetLog( "LD UPDN   ", 0, 0, sErrMsg );
			m_AlarmMsg.SetWindowText( sErrMsg );
			
			m_RBT_IF[IF_SEMI_LD_UPDN].bERROR = TRUE;
			m_bAlarm	= TRUE;
			nSeqNo		= 1000;
		}
		break;

	case 20 :
/*		if( ( nRv = m_pMmc->MoveRbtPos( RBT_LD_UPDN_UNIT, LD_UPDN_UNIT_RECV_POS ) ) == 0 ) 
		{
			SetLog( "LD UPDN   ", 0, 0, "LD UPDN Unit Recv Position" );
			nSeqNo = 30;
		}
		else if( nRv > 0 )
		{
			sErrMsg = "LD UPDN Unit Recv Position Error";
			SetLog( "LD FISH   ", 0, 0, sErrMsg );
			m_AlarmMsg.SetWindowText( sErrMsg );

			m_RBT_IF[IF_SEMI_LD_UPDN].bERROR = TRUE;
			m_bAlarm	= TRUE;
			nSeqNo		= 1000;
		}
*/		break;

	case 30 :
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_PosSensorLdUnit.GetAnd( LD_UPDN_UNIT_RECV_POS ) )
#else
		if( 1 )
#endif	
		{
			SetLog( "LD UPDN   ", 0, 0, "LD UPDN Unit Recv Position Sensor" );
			m_RBT_IF[IF_SEMI_LD_UPDN].bRECV_RDY = TRUE;
			nSeqNo = 50;
		}
		else 
		{
			sErrMsg = "LD UPDN Unit Recv Position Sensor Error";
			SetLog( "LD FISH   ", 0, 0, sErrMsg );
			m_AlarmMsg.SetWindowText( sErrMsg );

			m_RBT_IF[IF_SEMI_LD_UPDN].bERROR = TRUE;
			m_bAlarm	= TRUE;
			nSeqNo		= 1000;
		}
		break;

	case 50 :
		if( m_RBT_IF[IF_SEMI_CV].bSEND_COMP )
		{
			SetLog( "LD UPDN   ", 0, 0, "CV Send Confirm" );

			m_RBT_IF[IF_SEMI_CV].bSEND_COMP = FALSE;
			nSeqNo = 70;
		}
		if( m_RBT_IF[IF_SEMI_CV].bERROR )
		{
			m_RBT_IF[IF_SEMI_LD_UPDN].nROLE = roleNONE;
			nSeqNo = 0;
		}
		break;

	case 70:
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_LD ) && 
			!m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_LD ) && 
			!m_pEqpAssy->m_CvMotor.GetMotorFwState( CV_NO_LD ) && 
			!m_pEqpAssy->m_CvMotor.GetMotorBwState( CV_NO_LD ) )
#else 
		if( 1 )
#endif
		{
			SetLog( "LD UPDN   ", 0, 0, "LD UPDN Unit Recv Confirm" );
#ifdef _MY_DEBUG
			m_pDicsData->m_bDebugInSensor[IF_UNIT_LD] = TRUE;
			m_pDicsData->m_bDebugOutSensor[IF_UNIT_LD] = FALSE;
#endif
			m_RBT_IF[IF_SEMI_LD_UPDN].bRECV_COMP = TRUE;

			SetLog( "LD UDPN   ", 0, 0, "LD UPDN Unit - Recv End" );
			m_RBT_IF[IF_SEMI_LD_UPDN].nROLE = roleNONE;

			nSeqNo = 0;
		}
		else 
		{
			sErrMsg = "LD UPDN Unit Recv Error";
			SetLog( "LD UPDN   ", 0, 0, sErrMsg );
			m_AlarmMsg.SetWindowText( sErrMsg );

			m_RBT_IF[IF_SEMI_LD_UPDN].bERROR = TRUE;
			m_bAlarm	= TRUE;
			nSeqNo		= 1000;
		}
		break;

	// LD UPDN->LD Unit -------------------------------------------------------------------
	case 200:
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_LD ) && !m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_LD ) ) 
#else
		if( m_pDicsData->m_bDebugInSensor[IF_UNIT_LD] )
#endif	
		{
			SetLog( "LD UPDN   ", 0, 0, "LD UPDN Unit Glass Exist Check OK" );

//			nCurLdUpdnPosition = m_pMmc->GetCurPoint( RBT_LD_UPDN_UNIT );
			
			if( nCurLdUpdnPosition == LD_UPDN_UNIT_HOME_POS ||
				nCurLdUpdnPosition == LD_UPDN_UNIT_RECV_POS ||
				nCurLdUpdnPosition == LD_UPDN_UNIT_SEND_POS ) nSeqNo =  230;
			else 
			{
				sErrMsg = "Ld Updn Unit Position NG";
				SetLog( "LD UPDN   ", 0, 0, sErrMsg );
				m_AlarmMsg.SetWindowText( sErrMsg );
				
				m_RBT_IF[IF_SEMI_LD_UPDN].bERROR = TRUE;
				m_bAlarm = TRUE;
				nSeqNo = 1000;	
			}
		}
		else 
		{
			sErrMsg = "LD UPDN Unit Glass Exist Check NG";
			SetLog( "LD UPDN   ", 0, 0, sErrMsg );
			m_AlarmMsg.SetWindowText( sErrMsg );

			m_RBT_IF[IF_SEMI_LD_UPDN].bERROR = TRUE;
			m_bAlarm	= TRUE;
			nSeqNo		= 1000;
		}
		break;	
		
	case 230 :
/*		if( ( nRv = m_pMmc->MoveRbtPos( RBT_LD_UPDN_UNIT, LD_UPDN_UNIT_SEND_POS ) ) == 0 ) 
		{
			SetLog( "LD UPDN   ", 0, 0, "SEND Position" );
			nSeqNo = 240;
		}
		else if( nRv > 0 )
		{
			sErrMsg = "SEND Position Error";
			SetLog( "LD UPDN   ", 0, 0, sErrMsg );
			m_AlarmMsg.SetWindowText( sErrMsg );
			
			m_RBT_IF[IF_SEMI_LD_UPDN].bERROR = TRUE;
			m_bAlarm	= TRUE;
			nSeqNo		= 1000;
		}
*/		break;
		
	case 240:
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_PosSensorLdUnit.GetAnd( LD_UPDN_UNIT_SEND_POS ) )
#else
		if( 1 )
#endif
		{
			SetLog( "LD UPDN   ", 0, 0, "LD UPDN Unit Send Position Sensor" );

//			RBT_VEL rvVel;
//			( ( CServoView * )m_pView )->m_pMainSeq->GetRbtVel( RBT_LD_FISH_UNIT, rvVel );
//			rvVel.dVel[2] = GLASS_CHANGING_VEL;
//			m_pMmc->SetVel( RBT_LD_FISH_UNIT, rvVel );

			SetLog( "LD FISH   ", 0, 0, "LD UPDN Tilt Up Start" );

			m_pEqpAssy->m_CylinderLdTilt.SetFw();

			dwTickStart = GetTickCount();

			nSeqNo = 250;
		}
		else 
		{
			sErrMsg = "Ld UPDN Unit Send Position Sensor Error";
			SetLog( "LD UPDN   ", 0, 0, sErrMsg );
			m_AlarmMsg.SetWindowText( sErrMsg );
			
			m_RBT_IF[IF_SEMI_LD_UPDN].bERROR = TRUE;
			m_bAlarm	= TRUE;
			nSeqNo		= 1000;
		}
		break;

	case 250 :
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_CylinderLdTilt.GetFw() )
#else
		if( m_pEqpAssy->m_CylinderLdTilt.GetFwState() )
#endif
		{
			SetLog( "LD UPDN   ", 0, 0, "LD UPDN Unit Tilt Up OK" );
			SetLog( "LD UPDN   ", 0, 0, "LD Unit Glass Check OK" );
			m_RBT_IF[IF_SEMI_LD_UPDN].nROLE = roleNONE;
			nSeqNo = 0;
		}
		else if( ( GetTickCount() - dwTickStart ) > 5000 )
		{
			sErrMsg = "LD UPDN Tilt Up Sensor NG";
			SetLog( "LD UPDN   ", 0, 0, sErrMsg );
			m_AlarmMsg.SetWindowText( sErrMsg );
			
			m_RBT_IF[IF_SEMI_LD_UPDN].bERROR = TRUE;
			m_bAlarm	= TRUE;
			nSeqNo		= 1000;
		}
		break;

	//LD UPDN(Dn) -> LD UPDN(Up)
	case 300:
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_GlassExistUnitIn.GetOr( IF_UNIT_LD ) && !m_pEqpAssy->m_GlassExistUnitOut.GetOr( IF_UNIT_LD ) )
#else
		if( m_pDicsData->m_bDebugInSensor[IF_UNIT_LD] )
#endif
		{
			SetLog( "LD UPDN   ", 0, 0, "LD Unit Glass Check OK" );
			nSeqNo = 310;
		}
		else
		{
			sErrMsg = "LD Unit Glass Check(Position) NG";
			SetLog( "LD UPDN   ", 0, 0, sErrMsg );
			m_AlarmMsg.SetWindowText( sErrMsg );
			
			m_RBT_IF[IF_SEMI_LD_UPDN].bERROR = TRUE;
			m_bAlarm	= TRUE;
			nSeqNo		= 1000;
		}
		break;

	case 310:
/*
#ifndef _MY_DEBUG
		if( 1 )//!GetGlassExist( IF_SEMI_LD_FISH ) )
#else
		if( 1 )//!m_pDicsData->m_bDebugInSensor[IF_UNIT_LD_FISH] )
#endif
		{
			SetLog( "LD UPDN   ", 0, 0, "LD UPDN Unit Glass Check OK" );

			nCurLdUpdnPosition = m_pMmc->GetCurPoint( RBT_LD_UPDN_UNIT );
			
			if( nCurLdUpdnPosition == LD_UPDN_UNIT_HOME_POS ||
				nCurLdUpdnPosition == LD_UPDN_UNIT_RECV_POS ||
				nCurLdUpdnPosition == LD_UPDN_UNIT_SEND_POS ) nSeqNo =  320;
			else 
			{
				sErrMsg = "Ld Updn Unit Position NG";
				SetLog( "LD UPDN   ", 0, 0, sErrMsg );
				m_AlarmMsg.SetWindowText( sErrMsg );
				
				m_RBT_IF[IF_SEMI_LD_UPDN].bERROR = TRUE;
				m_bAlarm	= TRUE;
				nSeqNo		= 1000;	
			}
		}
		else
		{
			sErrMsg = "LD Updn Unit Glass Check NG";
			SetLog( "LD UPDN   ", 0, 0, sErrMsg );
			m_AlarmMsg.SetWindowText( sErrMsg );
			
			m_RBT_IF[IF_SEMI_LD_UPDN].bERROR = TRUE;
			m_bAlarm	= TRUE;
			nSeqNo		= 1000;
		}
*/		break;
	case 320:
		{
			SetLog( "LD FISH   ", 0, 0, "LD UPDN Tilt Up Start" );

			m_pEqpAssy->m_CylinderLdTilt.SetBw();

			dwTickStart = GetTickCount();

			nSeqNo = 330;
		}
		break;
	case 330 :
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_CylinderLdTilt.GetBw() )
#else
		if( m_pEqpAssy->m_CylinderLdTilt.GetBwState() )
#endif
		{
			SetLog( "LD UPDN   ", 0, 0, "LD UPDN Unit Tilt Down OK" );
			nSeqNo = 340;
		}
		else if( ( GetTickCount() - dwTickStart ) > 5000 )
		{
			sErrMsg = "LD UPDN Tilt Down Sensor NG";
			SetLog( "LD UPDN   ", 0, 0, sErrMsg );
			m_AlarmMsg.SetWindowText( sErrMsg );
			
			m_RBT_IF[IF_SEMI_LD_UPDN].bERROR = TRUE;
			m_bAlarm	= TRUE;
			nSeqNo		= 1000;
		}
		break;
	case 340:
/*		if( ( nRv = m_pMmc->MoveRbtPos( RBT_LD_UPDN_UNIT, LD_UPDN_UNIT_RECV_POS ) ) == 0 ) 
		{
			SetLog( "LD UPDN   ", 0, 0, "Recv Position" );
			nSeqNo = 350;
		}
		else if( nRv > 0 )
		{
			sErrMsg = "UPDN Position Error";
			SetLog( "LD UPDN   ", 0, 0, sErrMsg );
			m_AlarmMsg.SetWindowText( sErrMsg );
			
			m_RBT_IF[IF_SEMI_LD_UPDN].bERROR = TRUE;
			m_bAlarm	= TRUE;
			nSeqNo		= 1000;
		}
*/		break;
	case 350:
#ifndef _MY_DEBUG
		if( m_pEqpAssy->m_PosSensorLdUnit.GetAnd( LD_UPDN_UNIT_RECV_POS ) )
#else
		if( 1 )
#endif
		{
			SetLog( "LD UPDN   ", 0, 0, "Recv Position Sensor OK" );
			m_RBT_IF[IF_SEMI_LD_UPDN].nROLE = roleNONE;
			nSeqNo = 0;
		}
		else
		{
			sErrMsg = "Recv Position Sensor NG";
			SetLog( "LD UPDN   ", 0, 0, sErrMsg );
			m_AlarmMsg.SetWindowText( sErrMsg );
			
			m_RBT_IF[IF_SEMI_LD_UPDN].bERROR = TRUE;
			m_bAlarm	= TRUE;
			nSeqNo		= 1000;	
		}
		break;
		
	case 1000 :
		if( m_bAlarmResetLdUpdn )
		{
			SetLog( "LD FISH   ", 0, 0, "Error Recovery" );
			m_bAlarmResetLdUpdn = FALSE;

			sErrMsg = "";
			m_AlarmMsg.SetWindowText( sErrMsg );

			m_RBT_IF[IF_SEMI_LD_UPDN].nROLE = roleNONE;
			m_RBT_IF[IF_SEMI_LD_UPDN].bERROR = FALSE;
			nSeqNo = 0;
		}
		break;
	}
	m_nSeqLdUpdnSemiAutoNo = nSeqNo; 
}

BOOL CServoTabSemiAutoView::SeqFishRib(int nUnit, BOOL bAction)
{/*
#ifndef _MY_DEBUG
	if( !m_pDevice->IsActive() ) return -1;
#endif

	int iReturn = -1;
	static int	nPortNo, nSlotNo;
	static DWORD dwCount;

	int nSeqNo = m_nSeqFishRibNo;
	CString sErrMsg;

	switch( nSeqNo ) 
	{
	case 0:
		if( bAction ) nSeqNo = 10;
		else nSeqNo = 100;
		break;

	case 10:
		{
			dogFISH_UNIT_RIB_UP(nUnit,ON);
			dogFISH_UNIT_RIB_DN(nUnit,OFF);

			dwCount = GetTickCount();
			nSeqNo = 20;
		}
		break;

	case 20:
		if( diLD_FISH_UNIT_RIB_UP_L && diLD_FISH_UNIT_RIB_UP_R )
		{
			SetLog( "FISH MOVE", 0, 0, "LD fish Rib Up OK" );
			nSeqNo = 1000;
		}
		else if( GetTickCount() - dwCount > 5000  )
		{
			SetLog( "FISH MOVE", 0, 0, "LD fish Rib Up Sensor Error" );
			sErrMsg = "LD fish Rib Up Sensor Error";
			m_AlarmMsg.SetWindowText( sErrMsg );
			nSeqNo = 2000;
		}
		break;

	case 100:
			doLD_FISH_UNIT_RIB_DN(ON);
			doLD_FISH_UNIT_RIB_UP(OFF);

			dwCount = GetTickCount();
			nSeqNo = 110;
		break;

	case 110:
		if( diLD_FISH_UNIT_RIB_DN_L && diLD_FISH_UNIT_RIB_DN_R )
		{
			SetLog( "FISH MOVE", 0, 0, "LD fish Rib Down OK" );
			nSeqNo = 1000;
		}
		else if( GetTickCount() - dwCount > 5000  )
		{
			SetLog( "FISH MOVE", 0, 0, "LD fish Rib Down Sensor Error" );
			sErrMsg = "LD fish Rib Down Sensor Error";
			m_AlarmMsg.SetWindowText( sErrMsg );
			nSeqNo = 2000;
		}
		break;

	case 1000:	// Success ó
		SetLog( "FISH MOVE", 0, 0, "Move Success!" );
		nSeqNo = 0;
		iReturn = TRUE;
		break;

	case 2000:	// Alarm ó
		SetLog( "FISH MOVE", 0, 0, "Move Fail" );
		nSeqNo = 0;
		iReturn = FALSE;
		break;
	}
	m_nSeqFishRibNo = nSeqNo;

	return iReturn; */
	return 1;
}

void CServoTabSemiAutoView::OnSetSource() 
{
	// TODO: Add your control notification handler code here
	m_btnTo.SetBGColor( GRAY_COLOR );
	m_btnTo.SetFGColor( BLACK_COLOR );
	m_btnTo.Invalidate();

	m_btnFrom.SetBGColor( YELLOW_COLOR );
	m_btnFrom.SetFGColor( BLACK_COLOR );
	m_btnFrom.Invalidate();

	m_nOnFocus = fcsFROM;
}

void CServoTabSemiAutoView::OnSetTarget() 
{
	// TODO: Add your control notification handler code here
	m_btnFrom.SetBGColor( GRAY_COLOR );
	m_btnFrom.SetFGColor( BLACK_COLOR );
	m_btnFrom.Invalidate();

	m_btnTo.SetBGColor( YELLOW_COLOR );
	m_btnTo.SetFGColor( BLACK_COLOR );
	m_btnTo.Invalidate();

	m_nOnFocus = fcsTO;
}

void CServoTabSemiAutoView::SetDataToGridCtrl()
{
	CString sBuf;

	for( int nRow=0; nRow < MAX_TR_RBT_NO+2 ; nRow++ )
	{
		// 1st column
		m_gridCtrl.SetCol( 0 );
		m_gridCtrl.SetRow( nRow + 1 );
		m_gridCtrl.SetCellAlignment( 4 );
		m_gridCtrl.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d", nRow + 1 );
		m_gridCtrl.SetText( (LPCTSTR)sBuf );

		// 2nd column
		m_gridCtrl.SetCol( 1 );
		m_gridCtrl.SetRow( nRow + 1 );
		m_gridCtrl.SetCellAlignment( 4 );
		m_gridCtrl.SetCellBackColor( WHITE_COLOR );
	//	m_gridCtrl.SetText( (LPCTSTR) m_sRbtName[nRow] );
	}
}

void CServoTabSemiAutoView::GridInit()
{
	LPTSTR sLvcText[] = { " No. ", " Name " };
	int nColWidth[] = { 950, 4000 }; 

	// initialize GridCtrl
	m_gridCtrl.SetRows( MAX_TR_RBT_NO+2 + 1 ); 
	m_gridCtrl.SetCols( 2 );

	//-------------------------------------------
	m_gridCtrl.SetRow( 0 );  
	m_gridCtrl.SetColWidth( 0, nColWidth[0] );
	m_gridCtrl.SetCol( 0 ); 
	m_gridCtrl.SetCellAlignment( 4 );
	m_gridCtrl.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridCtrl.SetText( sLvcText[0] ); 
	//---------------------------------------------
	m_gridCtrl.SetColWidth( 1, nColWidth[1] );
	m_gridCtrl.SetCol( 1 ); 
	m_gridCtrl.SetCellAlignment( 4 );
	m_gridCtrl.SetCellBackColor( LIGHT_BLUE_COLOR );
	m_gridCtrl.SetText( sLvcText[1] ); 

	SetDataToGridCtrl();
}


BEGIN_EVENTSINK_MAP(CServoTabSemiAutoView, CFormView)
    //{{AFX_EVENTSINK_MAP(CServoTabSemiAutoView)
	ON_EVENT(CServoTabSemiAutoView, IDC_GRID_RBT, -600 /* Click */, OnClickGridRbt, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CServoTabSemiAutoView::OnClickGridRbt() 
{
	int nRow = m_gridCtrl.GetRow();
	int nCol = m_gridCtrl.GetCol();
	
	if( m_nOnFocus == fcsFROM )
	{
	//	m_MoveMsg[fcsFROM].SetWindowText( (LPCTSTR)m_sRbtName[nRow-1] );
		m_nArray[fcsFROM] = nRow - 1;
	}
	if( m_nOnFocus == fcsTO )
	{
	//	m_MoveMsg[fcsTO].SetWindowText( (LPCTSTR)m_sRbtName[nRow-1] );
		m_nArray[fcsTO] = nRow - 1;
	}
/*
	if( m_nArray[fcsFROM] == m_nArray[fcsTO] ||
		( m_nArray[fcsFROM] <= 3 && m_nArray[fcsFROM] > m_nArray[fcsTO] ) ||
		( m_nArray[fcsFROM] < m_nArray[fcsTO] && m_nArray[fcsFROM] + 1 != m_nArray[fcsTO] ) || 
		( m_nArray[fcsFROM] > m_nArray[fcsTO] && m_nArray[fcsFROM] - 1 != m_nArray[fcsTO] ))*/
	if( m_nArray[fcsFROM] == m_nArray[fcsTO] ||
		( m_nArray[fcsFROM] < m_nArray[fcsTO] && m_nArray[fcsFROM] + 1 != m_nArray[fcsTO] ) || 
		( m_nArray[fcsFROM] > m_nArray[fcsTO] && m_nArray[fcsFROM] - 1 != m_nArray[fcsTO] ))
	{
			GetDlgItem( IDC_SEMI_AUTO_MOVE )->EnableWindow( FALSE );
			return;
	}
	if( m_nArray[fcsFROM] > -1 && m_nArray[fcsTO] > -1 )
	{
		if( m_nArray[fcsFROM] + 1 == m_nArray[fcsTO] ||
			m_nArray[fcsFROM] - 1 == m_nArray[fcsTO] )
		{
			GetDlgItem( IDC_SEMI_AUTO_MOVE )->EnableWindow( TRUE );
			return;
		}
	}
	GetDlgItem( IDC_SEMI_AUTO_MOVE )->EnableWindow( FALSE );
}



void CServoTabSemiAutoView::OnRadioJoint1() 
{
//	m_macJointSel[0].SetBold();
//	m_macJointSel[1].SetBold( FALSE );
//	m_macJointSel[2].SetBold( FALSE );
//	m_nJointPos = CTrSeq::jointSEND;
}

void CServoTabSemiAutoView::OnRadioJoint2() 
{
//	m_macJointSel[0].SetBold( FALSE );
//	m_macJointSel[1].SetBold();
//	m_macJointSel[2].SetBold( FALSE );
//	m_nJointPos = CTrSeq::jointWAIT;
}

void CServoTabSemiAutoView::OnRadioJoint3() 
{
//	m_macJointSel[0].SetBold( FALSE );
//	m_macJointSel[1].SetBold( FALSE );
//	m_macJointSel[2].SetBold();
//	m_nJointPos = CTrSeq::jointRECV;
}
