//{{AFX_INCLUDES()
#include "..\msflexgrid.h"
//}}AFX_INCLUDES
#if !defined(AFX_SetupTabCVDistanceSetView_H__8BE98B8D_495D_49E6_9244_6D7BE77CD5A7__INCLUDED_)
#define AFX_SetupTabCVDistanceSetView_H__8BE98B8D_495D_49E6_9244_6D7BE77CD5A7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SetupTabCVDistanceSetView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSetupTabCVDistanceSetView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#define	CV_SPEED_INTERVAL		30

#include "..\X\MacButtons.h"
#include "..\X\MsgBox.h"

class CSetupTabCVDistanceSetView : public CFormView
{
public:
	CSetupTabCVDistanceSetView();           // protected constructor used by dynamic creation
	CSetupTabCVDistanceSetView( CView* pView );
	DECLARE_DYNCREATE(CSetupTabCVDistanceSetView)

// Form Data
public:
	//{{AFX_DATA(CSetupTabCVDistanceSetView)
	enum { IDD = IDD_SETUP_TAB_CVDISTANCE_VIEW };
	CComboBox	m_cbCvSpeed;
	CMSFlexGrid	m_gridCvLength;
	CMSFlexGrid	m_gridInSensorOffTimeOutInfo;
	CMSFlexGrid	m_gridOutSensorOffTimeOutInfo;
	CMacButton		m_macStart;
	CMacButton		m_macStop;
	int		m_nIndex;
	//}}AFX_DATA

// Attributes
public:
	CView* m_pView;

	CMsgBox		m_msgComment;
	CMsgBox		m_msgCommentStatic;

// Operations
public:
	void GridInit();
	void GridInit_InSensorOffTimeoutInfo();
	void GridInit_OutSensorOffTimeoutInfo();
	void SetDataToGridCtrl();
	void SetDataToGridCtrl_InSensorOffTimeOutInfo();
	void SetDataToGridCtrl_OutSensorOffTimeOutInfo();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSetupTabCVDistanceSetView)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CSetupTabCVDistanceSetView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CSetupTabCVDistanceSetView)
	afx_msg void OnDblClickGridSetupInfo();
	afx_msg void OnDblClickGridInSensorOffTimeOut();
	afx_msg void OnDblClickGridOutSensorOffTimeOut();
	afx_msg void OnSelchangeComboCvSpeed();
	afx_msg void OnStart();
	afx_msg void OnStop();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SetupTabCVDistanceSetView_H__8BE98B8D_495D_49E6_9244_6D7BE77CD5A7__INCLUDED_)
