// SetupTabInterfaceParaView1.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "SetupTabInterfaceParaView1.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetupTabInterfaceParaView1

IMPLEMENT_DYNCREATE(CSetupTabInterfaceParaView1, CFormView)

CSetupTabInterfaceParaView1::CSetupTabInterfaceParaView1()
	: CFormView(CSetupTabInterfaceParaView1::IDD)
{
	//{{AFX_DATA_INIT(CSetupTabInterfaceParaView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CSetupTabInterfaceParaView1::CSetupTabInterfaceParaView1(CView* pView)
	: CFormView(CSetupTabInterfaceParaView1::IDD)
{
	m_pView = pView;
}

CSetupTabInterfaceParaView1::~CSetupTabInterfaceParaView1()
{
}

void CSetupTabInterfaceParaView1::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetupTabInterfaceParaView1)
	DDX_Control(pDX, IDC_GRID_HSMS_PARA1, m_gridHsmsPara1);
//	DDX_Control(pDX, IDC_GRID_INTERFACE_PARA, m_gridInterfacePara);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetupTabInterfaceParaView1, CFormView)
	//{{AFX_MSG_MAP(CSetupTabInterfaceParaView1)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupTabInterfaceParaView1 diagnostics

#ifdef _DEBUG
void CSetupTabInterfaceParaView1::AssertValid() const
{
	CFormView::AssertValid();
}

void CSetupTabInterfaceParaView1::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSetupTabInterfaceParaView1 message handlers

BOOL CSetupTabInterfaceParaView1::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}


void CSetupTabInterfaceParaView1::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	// Initialize the temperary variable
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	pDoc->m_pSetupItems->InitTempVarTabInterfaceParaView1();

	// Set the items
	GridInit_Hsms1();
}

//--------------------------------------------------------------------
// Initialize the GridCtrl (SensorIntr)
//--------------------------------------------------------------------
void CSetupTabInterfaceParaView1::GridInit_Hsms1()
{
	LPTSTR sLvcText[] = { " ITEMS ", " VALUE " };
	int nColWidth[] = { 5100, 3000 }; 

	// initialize GridCtrl
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoHsmsPara1;
	if( nRows <= 27 ) nColWidth[0] += 270;
	m_gridHsmsPara1.SetRows( nRows + 1 ); 
	m_gridHsmsPara1.SetCols( 2 );

	m_gridHsmsPara1.SetRow( 0 );  
	for( int i=0; i<2; i++ )
	{
		m_gridHsmsPara1.SetColWidth( i, nColWidth[i] );
		m_gridHsmsPara1.SetCol( i ); 
		m_gridHsmsPara1.SetCellAlignment( 4 );
		m_gridHsmsPara1.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridHsmsPara1.SetText( sLvcText[i] ); 
	}

	SetDataToGridCtrl_Hsms1();
}

//--------------------------------------------------------------------
// Set data (SensorIntr)
//--------------------------------------------------------------------
void CSetupTabInterfaceParaView1::SetDataToGridCtrl_Hsms1()
{
	CString sBuf;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	int nRows = pDoc->m_pSetupItems->m_nItemNoHsmsPara1;

	for( int i=0; i<nRows; i++ )
	{
		// 1st column
		m_gridHsmsPara1.SetCol( 0 );
		m_gridHsmsPara1.SetRow( i + 1 );
		m_gridHsmsPara1.SetCellAlignment( 0 );	// Left adjusted
		m_gridHsmsPara1.SetCellBackColor( LIGHT_CYAN_COLOR );
		sBuf.Format( "%d. %s", i + 1, pDoc->m_pSetupItems->m_infoHsmsPara1[i].sName );
		m_gridHsmsPara1.SetText( (LPCTSTR) sBuf );

		// 2nd column
		m_gridHsmsPara1.SetCol( 1 );
		m_gridHsmsPara1.SetRow( i + 1 );

		// Set the background color
		if( pDoc->m_pSetupItems->m_infoHsmsPara1[i].nOption == CSetupItems::optionBOOL5 )
		{
			CString sBuf;
			if( pDoc->m_pSetupItems->m_sValueHsmsParaTemp1[i] == "ACTIVE" ) 
			{
				m_gridHsmsPara1.SetCellBackColor( BG_COLOR_BOOL_ON );
				m_gridHsmsPara1.SetCellForeColor( BLACK_COLOR );
			}
			else 
			{
				m_gridHsmsPara1.SetCellBackColor( BG_COLOR_BOOL_OFF );
				m_gridHsmsPara1.SetCellForeColor( DARK_GRAY_COLOR );
			}
		}
		else if( pDoc->m_pSetupItems->m_infoHsmsPara1[i].nOption == CSetupItems::optionBOOL6 )
		{
			CString sBuf;
			if( pDoc->m_pSetupItems->m_sValueHsmsParaTemp1[i] == "ENABLE" ) 
			{
				m_gridHsmsPara1.SetCellBackColor( BG_COLOR_BOOL_ON );
				m_gridHsmsPara1.SetCellForeColor( BLACK_COLOR );
			}
			else 
			{
				m_gridHsmsPara1.SetCellBackColor( BG_COLOR_BOOL_OFF );
				m_gridHsmsPara1.SetCellForeColor( DARK_GRAY_COLOR );
			}
		}
		else if( pDoc->m_pSetupItems->m_infoHsmsPara1[i].nOption == CSetupItems::optionTRI_STATE2 )
		{
			if( pDoc->m_pSetupItems->m_sValueHsmsParaTemp1[i] == "OFFLINE" )
			{
				m_gridHsmsPara1.SetCellBackColor( BG_COLOR_BOOL_OFF );
				m_gridHsmsPara1.SetCellForeColor( DARK_GRAY_COLOR );
			}
			else
			{
				m_gridHsmsPara1.SetCellBackColor( BG_COLOR_BOOL_ON );
				m_gridHsmsPara1.SetCellForeColor( BLACK_COLOR );
			}
		} 
		
		// Set Text
		sBuf.Format( "%s %s", 
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp1[i], 
			pDoc->m_pSetupItems->m_infoHsmsPara1[i].sUnit );
		m_gridHsmsPara1.SetCellAlignment( 4 );
		m_gridHsmsPara1.SetText( (LPCTSTR) sBuf );
	}
}


BEGIN_EVENTSINK_MAP(CSetupTabInterfaceParaView1, CFormView)
    //{{AFX_EVENTSINK_MAP(CSetupTabInterfaceParaView1)
	ON_EVENT(CSetupTabInterfaceParaView1, IDC_GRID_HSMS_PARA1, -601 /* DblClick */, OnDblClickGridHsmsPara1, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CSetupTabInterfaceParaView1::OnDblClickGridHsmsPara1() 
{
	int nRow = m_gridHsmsPara1.GetRowSel();
	int nCol = m_gridHsmsPara1.GetColSel();

	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	if( pView->m_pDicsData->m_GenInfo.bAuto || pView->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idENGINEER ) return;

	if ( nRow == 0 || nRow == 1 || nRow == 2) return;

	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	if( pDoc->m_pSetupItems->m_infoHsmsPara1[nRow - 1].nOption == CSetupItems::optionBOOL5 )
	{
		if( pDoc->m_pSetupItems->m_sValueHsmsParaTemp1[nRow - 1] == "ACTIVE" ) 
		{
			m_gridHsmsPara1.SetCellBackColor( BG_COLOR_BOOL_OFF );
			m_gridHsmsPara1.SetCellForeColor( DARK_GRAY_COLOR );
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp1[nRow - 1] = "PASSIVE";
		}
		else 
		{
			m_gridHsmsPara1.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridHsmsPara1.SetCellForeColor( BLACK_COLOR );
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp1[nRow - 1] = "ACTIVE";
		}

		CString sBuf;
		sBuf.Format( "%s %s", 
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp1[nRow - 1], 
			pDoc->m_pSetupItems->m_infoHsmsPara1[nRow - 1].sUnit );
		m_gridHsmsPara1.SetText( (LPCTSTR) sBuf );
	}
	else if( pDoc->m_pSetupItems->m_infoHsmsPara1[nRow - 1].nOption == CSetupItems::optionBOOL6 )
	{
		if( pDoc->m_pSetupItems->m_sValueHsmsParaTemp1[nRow - 1] == "ENABLE" ) 
		{
			m_gridHsmsPara1.SetCellBackColor( BG_COLOR_BOOL_OFF );
			m_gridHsmsPara1.SetCellForeColor( DARK_GRAY_COLOR );
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp1[nRow - 1] = "DISABLE";
		}
		else
		{
			m_gridHsmsPara1.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridHsmsPara1.SetCellForeColor( BLACK_COLOR );
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp1[nRow - 1] = "ENABLE";
		}

		CString sBuf;
		sBuf.Format( "%s %s", 
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp1[nRow - 1], 
			pDoc->m_pSetupItems->m_infoHsmsPara1[nRow - 1].sUnit );
		m_gridHsmsPara1.SetText( (LPCTSTR) sBuf );
	}
	else if( pDoc->m_pSetupItems->m_infoHsmsPara1[nRow - 1].nOption == CSetupItems::optionTRI_STATE2 )
	{
		if( pDoc->m_pSetupItems->m_sValueHsmsParaTemp1[nRow - 1] == "OFFLINE" ) 
		{
			m_gridHsmsPara1.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridHsmsPara1.SetCellForeColor( BLACK_COLOR );
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp1[nRow - 1] = "LOCAL";
		}
		else if( pDoc->m_pSetupItems->m_sValueHsmsParaTemp1[nRow - 1] == "LOCAL" ) 
		{
			m_gridHsmsPara1.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridHsmsPara1.SetCellForeColor( BLACK_COLOR );
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp1[nRow - 1] = "REMOTE";
		}
		else
		{
			m_gridHsmsPara1.SetCellBackColor( BG_COLOR_BOOL_OFF );
			m_gridHsmsPara1.SetCellForeColor( DARK_GRAY_COLOR );
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp1[nRow - 1] = "OFFLINE";
		}

		CString sBuf;
		sBuf.Format( "%s %s", 
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp1[nRow - 1], 
			pDoc->m_pSetupItems->m_infoHsmsPara1[nRow - 1].sUnit );
		m_gridHsmsPara1.SetText( (LPCTSTR) sBuf );
	}
	else
	{
		CDlgEditVal dlg;
		dlg.m_sCurVal = dlg.m_sOldVal = pDoc->m_pSetupItems->m_sValueHsmsParaTemp1[nRow - 1];
		dlg.m_nType = CDlgEditVal::typeINPUT;
		dlg.m_nFormat = pDoc->m_pSetupItems->m_infoHsmsPara1[nRow - 1].nFormat;
		if( dlg.DoModal() == IDOK )
		{
			// Set the changed value to temperary variable
			pDoc->m_pSetupItems->m_sValueHsmsParaTemp1[nRow - 1] = dlg.m_sCurVal;

			CString sBuf;
			sBuf.Format( "%s %s", dlg.m_sCurVal, pDoc->m_pSetupItems->m_infoHsmsPara1[nRow - 1].sUnit );
			m_gridHsmsPara1.SetText( (LPCTSTR) sBuf );
		}
	}
}


