//{{AFX_INCLUDES()
#include "..\msflexgrid.h"
//}}AFX_INCLUDES
#if !defined(AFX_SETUPTAB2VIEW_H__3596143B_9F4A_4DA1_B12D_A534D2230CF6__INCLUDED_)
#define AFX_SETUPTAB2VIEW_H__3596143B_9F4A_4DA1_B12D_A534D2230CF6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SetupTabInterlockSet2View.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSetupTabInterlockSet2View form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "..\X\XCtlDevice.h"	// Added by ClassView
class CSetupTabInterlockSet2View : public CFormView
{
public:
	CSetupTabInterlockSet2View();           // protected constructor used by dynamic creation
	CSetupTabInterlockSet2View( CView* pView );
	DECLARE_DYNCREATE(CSetupTabInterlockSet2View)

// Form Data
public:
	//{{AFX_DATA(CSetupTabInterlockSet2View)
	enum { IDD = IDD_SETUP_TAB_INTERLOCK2_VIEW };
	CMSFlexGrid m_gridBathCoverIntr;
	CMSFlexGrid m_gridDoorIntr;
	CMSFlexGrid m_gridLeakDetectIntr;
	CMSFlexGrid m_gridFFUAlarmIntr;
	CMSFlexGrid m_gridBrokenIntr;
	CMSFlexGrid m_gridETCIntr;
	//}}AFX_DATA

// Attributes
public:
	XCtlDevice * m_pDevice;
	CView* m_pView;

// Operations
public:
	void SetDevice(XCtlDevice * pDevice){ m_pDevice = pDevice; }
	void GridInit_BathCoverIntr();
	void SetDataToGridCtrl_BathCoverIntr();
	void GridInit_DoorIntr();
	void SetDataToGridCtrl_DoorIntr();
	void GridInit_LeakDetectIntr();
	void SetDataToGridCtrl_LeakDetectIntr();
	void GridInit_FFUAlarmIntr();
	void SetDataToGridCtrl_FFUAlarmIntr();
	void GridInit_BrokenIntr();
	void SetDataToGridCtrl_BrokenIntr();
	void GridInit_ETCIntr();
	void SetDataToGridCtrl_ETCIntr();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSetupTabInterlockSet2View)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CSetupTabInterlockSet2View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CSetupTabInterlockSet2View)
	afx_msg void OnDblClickGridBathCoverIntr();
	afx_msg void OnDblClickGridDoorIntr();
	afx_msg void OnDblClickGridLeakDetectIntr();
	afx_msg void OnDblClickGridFFUAlarmIntr();
	afx_msg void OnDblClickGridBrokenIntr();
	afx_msg void OnDblClickGridETCIntr();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SETUPTAB2VIEW_H__3596143B_9F4A_4DA1_B12D_A534D2230CF6__INCLUDED_)
