//{{AFX_INCLUDES()
#include "..\msflexgrid.h"
//}}AFX_INCLUDES
#if !defined(AFX_SetupTabJobConditionView_H__924150E6_443A_4B2D_A0DD_F054EDF9952C__INCLUDED_)
#define AFX_SetupTabJobConditionView_H__924150E6_443A_4B2D_A0DD_F054EDF9952C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SetupTabJobConditionView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSetupTabJobConditionView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

class CSetupTabJobConditionView : public CFormView
{
public:
	CSetupTabJobConditionView();           // protected constructor used by dynamic creation
	CSetupTabJobConditionView( CView* pView );
	DECLARE_DYNCREATE(CSetupTabJobConditionView)

// Form Data
public:
	//{{AFX_DATA(CSetupTabJobConditionView)
	enum { IDD = IDD_SETUP_TAB_JOBCOND_VIEW };
	CMSFlexGrid	m_gridIdleRunInfo;
	CMSFlexGrid	m_gridSetupInfo;
	CMSFlexGrid	m_gridTankLevelInfo;
	CMSFlexGrid	m_gridPartsLifeTimePara;
	//}}AFX_DATA

// Attributes
public:
	CView* m_pView;

// Operations
public:
	void SetBoolTypeValue(int nValue, int nOption, CMSFlexGrid& gridCtrl);
	void GridInit_SetupInfo();
	void GridInit_IdleRunInfo();
	void GridInit_TankLevelInfo();
	void GridInit_PartsLifeTimeInfo();

	void SetDataToGridCtrl_SetupInfo();
	void SetDataToGridCtrl_IdleRunInfo();
	void SetDataToGridCtrl_TankLevelInfo();
	void SetDataToGridCtrl_PartsLifeTimeInfo();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSetupTabJobConditionView)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CSetupTabJobConditionView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CSetupTabJobConditionView)
	afx_msg void OnClose();
	afx_msg void OnDblClickGridSetupInfo();
	afx_msg void OnDblClickGridIdleRunInfo();
	afx_msg void OnDblClickGridTankLevelInfo();
	afx_msg void OnDblClickGridPartsLifeTimeInfo();
	afx_msg void OnKeyPressGridSetupInfo(short FAR* KeyAscii);
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SetupTabJobConditionView_H__924150E6_443A_4B2D_A0DD_F054EDF9952C__INCLUDED_)
