#if !defined(AFX_SETUPVIEW_H__76B26458_87E2_451B_BBA5_3B3CD3703210__INCLUDED_)
#define AFX_SETUPVIEW_H__76B26458_87E2_451B_BBA5_3B3CD3703210__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SetupView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSetupView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

// Include
#include "..\X\XTabCtrl.h"

#include "SetupTabJobConditionView.h"
#include "SetupTabInterlockSetView.h"
#include "SetupTabInterlockSet2View.h"
#include "SetupTabInterfaceParaView.h"
#include "SetupTabInterfaceParaView1.h"
#include "SetupTabCVDistanceSetView.h"
#include "SetupTabCVMotorParaView.h"
#include "SetupTabDVParaView.h"

class CSetupView : public CFormView
{
protected:
	CSetupView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CSetupView)

// Form Data
public:
	//{{AFX_DATA(CSetupView)
	enum { IDD = IDD_SETUP_FORM };
	CXTabCtrl	m_tabCtrl;
	//}}AFX_DATA

// Attributes
public:
	CDicsDoc* GetDocument();

	CSetupTabJobConditionView*	m_pTabSetupTabJobConditionView;
	CSetupTabInterlockSetView*	m_pTabSetupTabInterlockSetView;
	CSetupTabInterlockSet2View*	m_pTabSetupTabInterlockSet2View;
	CSetupTabInterfaceParaView*	m_pTabSetupTabInterfaceParaView;
	CSetupTabInterfaceParaView1*	m_pTabSetupTabInterfaceParaView1;
	CSetupTabCVDistanceSetView*	m_pTabSetupTabCVDistanceSetView;
//	CSetupTabCVMotorParaView*	m_pTabSetupTabCVMotorParaView;
//	CSetupTabDVParaView*		m_pTabSetupTabDVParaView;
	int m_nViewNo;

	enum { viewJobCond, viewInterlockSet, viewInterlockSet2, viewInterfacePara, viewInterfacePara1, viewCVDistanceSet, viewCVMotorPara, viewDVPara };

// Operations
public:
	void SaveReport();
	void OnSetupSave( BOOL bAllSave = FALSE );
	void OnSetupView( WPARAM wParam, LPARAM lParam );
	void SetLog(CString sSeqName, CString sMessage);//2009.03,11 kimgun

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSetupView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CSetupView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CSetupView)
	afx_msg void OnDestroy();
	//}}AFX_MSG
	afx_msg LRESULT OnSelChangeTab( WPARAM wParam, LPARAM lParam );
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in DicsView.cpp
inline CDicsDoc* CSetupView::GetDocument()
   { return (CDicsDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SETUPVIEW_H__76B26458_87E2_451B_BBA5_3B3CD3703210__INCLUDED_)
