//{{AFX_INCLUDES()
#include "..\msflexgrid.h"
//}}AFX_INCLUDES
#if !defined(AFX_SYSTEMTAB1VIEW_H__13AEE71A_8A81_4260_9E31_9471BF1C2381__INCLUDED_)
#define AFX_SYSTEMTAB1VIEW_H__13AEE71A_8A81_4260_9E31_9471BF1C2381__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SystemTab1View.h : header file
//
#include "..\X\XCtlDevice.h"	// Added by ClassView
#include "..\X\MsgBox.h"

/////////////////////////////////////////////////////////////////////////////
// CSystemTab1View form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

class CSystemTab1View : public CFormView
{
public:
	CSystemTab1View();           // protected constructor used by dynamic creation
	CSystemTab1View( CView* pView );
	DECLARE_DYNCREATE(CSystemTab1View)

// Form Data
public:
	//{{AFX_DATA(CSystemTab1View)
	enum { IDD = IDD_SYSTEM_TAB1_VIEW };
	CMSFlexGrid	m_gridCtrl;
	//}}AFX_DATA
	CMsgBox		m_msgNote;
	CMsgBox		m_msgNoteStatic;

// Attributes
public:
	CView* m_pView;

	BOOL			m_bPermitAccess;
	int				m_nMaxInNo;
	XCtlDevice*	m_pDevice;

// Operations
public:
	void GridInit();
	void SetDataToGridCtrl();
	void MonitorInput();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSystemTab1View)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CSystemTab1View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CSystemTab1View)
	afx_msg void OnClose();
	afx_msg void OnClickIncheckList();
	afx_msg void OnDblClickIncheckList();
	afx_msg void OnTimer(UINT nIDEvent);
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SYSTEMTAB1VIEW_H__13AEE71A_8A81_4260_9E31_9471BF1C2381__INCLUDED_)
