//{{AFX_INCLUDES()
#include "..\msflexgrid.h"
//}}AFX_INCLUDES
#if !defined(AFX_SYSTEMTAB2VIEW_H__EDFF4C03_1C5B_4D53_A005_19FF443A6D4D__INCLUDED_)
#define AFX_SYSTEMTAB2VIEW_H__EDFF4C03_1C5B_4D53_A005_19FF443A6D4D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SystemTab2View.h : header file
//
#include "..\X\XCtlDevice.h"	// Added by ClassView
#include "..\X\MsgBox.h"

/////////////////////////////////////////////////////////////////////////////
// CSystemTab2View form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

class CSystemTab2View : public CFormView
{
public:
	CSystemTab2View();           // protected constructor used by dynamic creation
	CSystemTab2View( CView* pView );
	DECLARE_DYNCREATE(CSystemTab2View)

// Form Data
public:
	//{{AFX_DATA(CSystemTab2View)
	enum { IDD = IDD_SYSTEM_TAB2_VIEW };
	CMSFlexGrid	m_gridCtrl;
	//}}AFX_DATA
	CMsgBox		m_msgNote;
	CMsgBox		m_msgNoteStatic;

// Attributes
public:
	CView* m_pView;

	BOOL			m_bPermitAccess;
	int				m_nMaxOutNo;
	XCtlDevice*		m_pDevice;

	BOOL			m_bRepeat;
	int				m_nRepeatTime;

	void			MonitorOutput();
// Operations
public:
	void SetDataToGridCtrl();
	void GridInit();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSystemTab2View)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CSystemTab2View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CSystemTab2View)
	afx_msg void OnClose();
	afx_msg void OnClickOutcheckList();
	afx_msg void OnDblClickOutcheckList();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnTimer(UINT_PTR nIDEvent);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SYSTEMTAB2VIEW_H__EDFF4C03_1C5B_4D53_A005_19FF443A6D4D__INCLUDED_)
