//{{AFX_INCLUDES()
#include "..\msflexgrid.h"
//}}AFX_INCLUDES
#if !defined(AFX_SYSTEMTAB3VIEW_H__EDFF4C03_1C5B_4D53_A005_19FF443A6D4D__INCLUDED_)
#define AFX_SYSTEMTAB3VIEW_H__EDFF4C03_1C5B_4D53_A005_19FF443A6D4D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SystemTab2View.h : header file
//
#include "..\X\XCtlDevice.h"	// Added by ClassView
#include "..\X\MsgBox.h"
#include "..\X\MacButtons.h"
//#include "X\XCtlMelsec.h"

/////////////////////////////////////////////////////////////////////////////
// CSystemTab3View form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

class CSystemTab3View : public CFormView
{
public:
	CSystemTab3View();           // protected constructor used by dynamic creation
	CSystemTab3View( CView* pView );
	DECLARE_DYNCREATE(CSystemTab3View)

// Form Data
public:
	//{{AFX_DATA(CSystemTab3View)
	enum { IDD = IDD_SYSTEM_TAB3_VIEW };
	CComboBox	m_cbAddress;
	CMSFlexGrid	m_gridCtrl;
	CMacButton	m_macNextButton;
	CMacButton	m_macPrevButton;
	//}}AFX_DATA

// Attributes
public:
	CView*		m_pView;
	XCtlMelsec* m_pMelsec;

	int			m_nSetPage;
	BOOL		m_bValue[16][16];
	BOOL		m_bOldValue[16][16];
	int			m_nStartAddress;

// Operations
public:
	void GridInit();
	void SetCellIndex();
	void SetCellValue();


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSystemTab3View)
	public:
	virtual void OnInitialUpdate();
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CSystemTab3View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CSystemTab3View)
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnMelPrev();
	afx_msg void OnMelNext();
	afx_msg void OnDblClickGridCtrl();
	afx_msg void OnSelchangeComboAddress();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SYSTEMTAB3VIEW_H__EDFF4C03_1C5B_4D53_A005_19FF443A6D4D__INCLUDED_)
