// jobstabhpmjstatusview.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "jobstabhpmjstatusview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//////////////////////////////////////////////////////////////////////////
//  INT				nRows;
//	INT				nCols;
//	LPTSTR			sText[MAX_GRID_COLS];
//	INT				nColWidth[MAX_GRID_COLS];
//	unsigned int	uCellBackColor;
//	BOOL			bTitle;
//////////////////////////////////////////////////////////////////////////
GRID_INFO_VER2 CJobsTabHpmjStatusView::m_GridInfo[MAX_GRID_CTRLS] = 
{
	{ 
		10, 
		2, 
		{ "Total ð ġ", "Pump Packing ȯð ġ","Filter ȯð ġ","Pump Packing ȯð ġ", "Filter ȯð ġ", "Alarm Code", "Alarm Code1", "Alarm Code2", "Alarm Code3", },
		{ " Items ", " Value ", }, 
		{ 3150, 3000, }, 
		LIGHT_BLUE_COLOR,
		TRUE
	},
	{
		7,
		5,
		{ "Shower Flow", "Main DI Press","Filter In Press", "Filter Out Press", "Resistivity", "Filter Diff Press" },
		{ " Items ", " UP Error ", "LO Error", "UP Warning", "LO Warning"},
		{ 1750, 1100, 1100, 1100, 1100 }, 
		LIGHT_BLUE_COLOR,
		TRUE
	},
	{
		4,
		2,
		{ "Running Mode", "Frequency Set", "Pressure Set" },
		{ " Items ", " Value ",},
		{ 3150, 3000, }, 
		LIGHT_BLUE_COLOR,
		TRUE
	}
};

/////////////////////////////////////////////////////////////////////////////
// CJobsTabHpmjStatusView

IMPLEMENT_DYNCREATE(CJobsTabHpmjStatusView, CFormView)

CJobsTabHpmjStatusView::CJobsTabHpmjStatusView()
	: CFormView(CJobsTabHpmjStatusView::IDD)
{
	//{{AFX_DATA_INIT(CJobsTabHpmjStatusView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}
CJobsTabHpmjStatusView::CJobsTabHpmjStatusView(CView* pView, int nTabNo)
	: CFormView(CJobsTabHpmjStatusView::IDD)
{
	m_pView		= pView;
	m_nTabNo	= nTabNo; 
	SetDevice( ((CDicsView*)m_pView)->m_pDevice );
	SetEqpAssy( ((CDicsView*)m_pView)->m_pEqpAssy );

}

CJobsTabHpmjStatusView::~CJobsTabHpmjStatusView()
{
	if( m_ocxAnalogInput )
		delete []m_ocxAnalogInput;
}

void CJobsTabHpmjStatusView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJobsTabHpmjStatusView)
	DDX_Control(pDX, IDC_HPMJ_RUN, m_checkRun);
	DDX_Control(pDX, IDC_HPMJ_REMOTE, m_checkRemote);
	DDX_Control(pDX, IDC_HPMJ_READY, m_checkReady);
	DDX_Control(pDX, IDC_HPMJ_PING, m_checkPing);
	DDX_Control(pDX, IDC_HPMJ_ALARM2, m_checkWarning);
	DDX_Control(pDX, IDC_HPMJ_ALARM, m_checkAlarm);
	DDX_Control(pDX, IDC_BUTTON_HPMJ_STOP, m_macStop);
	DDX_Control(pDX, IDC_BUTTON_HPMJ_START, m_macStart);
	DDX_Control(pDX, IDC_BUTTON_HPMJ_REMOTE, m_macRemoteMode);
	DDX_Control(pDX, IDC_BUTTON_HPMJ_LOCAL, m_macLocalMode);
	DDX_Control(pDX, IDC_BUTTON_HPMJ_RUN_TIME_RESET, m_macRunTimeReset);
	DDX_Control(pDX, IDC_BUTTON_HPMJ_PUMP_COUNT_RESET, m_macPumpCountReset);
	DDX_Control(pDX, IDC_BUTTON_HPMJ_FILTER_COUNT_RESET, m_macFilterCountReset);
	DDX_Control(pDX, IDC_BUTTON_HPMJ_BUZZER_OFF, m_macBuzzerOff);
	DDX_Control(pDX, IDC_BUTTON_HPMJ_ALARM_RESET, m_macAlarmReset);
	DDX_Control(pDX, IDC_GRID_HPMJ_PARA_DATA, m_gridParaData);
	DDX_Control(pDX, IDC_GRID_HPMJ_PPID_DATA, m_gridPpidData);
	DDX_Control(pDX, IDC_GRID_HPMJ_STATE_DATA, m_gridStateData);
	DDX_Control(pDX, IDC_PUMP1, m_ocxPump);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CJobsTabHpmjStatusView, CFormView)
	//{{AFX_MSG_MAP(CJobsTabHpmjStatusView)
	ON_BN_CLICKED(IDC_BUTTON_HPMJ_REMOTE, OnRemote)
	ON_BN_CLICKED(IDC_BUTTON_HPMJ_LOCAL, OnLocal)
	ON_BN_CLICKED(IDC_BUTTON_HPMJ_START, OnStart)
	ON_BN_CLICKED(IDC_BUTTON_HPMJ_STOP, OnStop)
	ON_BN_CLICKED(IDC_BUTTON_HPMJ_RUN_TIME_RESET, OnRunTimeReset)
	ON_BN_CLICKED(IDC_BUTTON_HPMJ_PUMP_COUNT_RESET, OnPumpCountReset)
	ON_BN_CLICKED(IDC_BUTTON_HPMJ_FILTER_COUNT_RESET, OnFilterCountReset)
	ON_BN_CLICKED(IDC_BUTTON_HPMJ_BUZZER_OFF, OnBuzzerOff)
	ON_BN_CLICKED(IDC_BUTTON_HPMJ_ALARM_RESET, OnAlarmReset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJobsTabHpmjStatusView diagnostics

#ifdef _DEBUG
void CJobsTabHpmjStatusView::AssertValid() const
{
	CFormView::AssertValid();
}

void CJobsTabHpmjStatusView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CJobsTabHpmjStatusView message handlers

BOOL CJobsTabHpmjStatusView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CJobsTabHpmjStatusView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	// TODO: Add your specialized code here and/or call the base class
	m_pSetupItems = ( (CDicsView*)m_pView )->GetDocument()->m_pSetupItems;
	// Set the macButton
	MAC_COLOR_SET color_set;


	m_checkRun.GetColorSetting( &color_set );
//	color_set.crFace = LIGHT_CYAN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_checkRun.SetColorSetting( color_set );
	m_checkRun.SetBold();

	m_checkRemote.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_CYAN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_checkRemote.SetColorSetting( color_set );
	m_checkRemote.SetBold();

	m_checkReady.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_CYAN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_checkReady.SetColorSetting( color_set );
	m_checkReady.SetBold();

	m_checkPing.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_CYAN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_checkPing.SetColorSetting( color_set );
	m_checkPing.SetBold();
		
	m_checkWarning.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_CYAN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_checkWarning.SetColorSetting( color_set );
	m_checkWarning.SetBold();

	m_checkAlarm.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_CYAN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_checkAlarm.SetColorSetting( color_set );
	m_checkAlarm.SetBold();
	
	m_macStart.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macStart.SetColorSetting( color_set );
	m_macStart.SetBold();

	m_macStop.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macStop.SetColorSetting( color_set );
	m_macStop.SetBold();

	m_macRemoteMode.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macRemoteMode.SetColorSetting( color_set );
	m_macRemoteMode.SetBold();

	m_macLocalMode.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macLocalMode.SetColorSetting( color_set );
	m_macLocalMode.SetBold();
	
	m_macRunTimeReset.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macRunTimeReset.SetColorSetting( color_set );
	m_macRunTimeReset.SetBold();

	m_macPumpCountReset.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macPumpCountReset.SetColorSetting( color_set );
	m_macPumpCountReset.SetBold();

	m_macFilterCountReset.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macFilterCountReset.SetColorSetting( color_set );
	m_macFilterCountReset.SetBold();

	m_macBuzzerOff.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macBuzzerOff.SetColorSetting( color_set );
	m_macBuzzerOff.SetBold();

	m_macAlarmReset.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_GREEN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macAlarmReset.SetColorSetting( color_set );
	m_macAlarmReset.SetBold();

	SetAnalogOcxInitParameter();
	SetAiInitParameter();
	m_pSetupItems->GetRegistryTabInterlockSetView();

	for( int i = 0; i < 4; i++)
	{
//		m_ocxShwUnit[i].SubclassDlgItem(IDC_SHWUNITCTRL1+i, this);
	}
	
	m_ocxPump.SetStop();

	GridInit( m_gridStateData, m_GridInfo[gStateInfo] );
	GridInit( m_gridParaData, m_GridInfo[gParaInfo] );
	GridInit( m_gridPpidData, m_GridInfo[gSetupInfo] );

}

void CJobsTabHpmjStatusView::SetAnalogOcxInitParameter()
{
	m_ocxAnalogInput = new CAnalogCtrl[MAX_HPMJ_VIEW_AI_NO];
	
	for( int i = 0 ; i < MAX_HPMJ_VIEW_AI_NO; i++ )
	{
		m_ocxAnalogInput[i].SubclassDlgItem( IDC_ANALOGCTRLCTRL22+i, this);
		m_ocxAnalogInput[i].SetAlarmEnable();
		int nAddress = m_ocxAnalogInput[i].GetAiRealID();
		m_ocxAnalogInput[i].SetInitParameterSet( nAddress );
		UINT uResId = m_ocxAnalogInput[i].GetAnalogOcxCtlId();

		for( int j = 0; j < m_pEqpAssy->m_AnalogInput.GetAiSize(); j++ )
		{
			if( nAddress == m_pEqpAssy->m_AnalogInput.m_aiSet[j].nReal )
			{
				CString sAiName = m_ocxAnalogInput[i].GetAnalogUnitName();
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].nOwnerViewNo = CDicsView::viewJobHpmj;
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].sName = sAiName;
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].nOwnerUnitNo = m_ocxAnalogInput[i].GetApdReportUnitNo();
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].uRESID = uResId; //IDC_ANALOGCTRLCTRL1+i;
				m_pEqpAssy->m_AnalogInput.m_aiSet[j].sKind = m_ocxAnalogInput[i].GetUnitOfKind( nAddress );
				if( m_ocxAnalogInput[i].GetApdReportSelect() )
				{
					m_pEqpAssy->m_AnalogInput.m_aiSet[j].nApdReportNo = m_pEqpAssy->m_AnalogInput.m_nMaxApdAiNo;
					m_pEqpAssy->m_AnalogInput.m_nMaxApdAiNo ++;
				}
				else m_pEqpAssy->m_AnalogInput.m_aiSet[j].nApdReportNo = -1;
				if( m_ocxAnalogInput[i].GetInterlockUsingSelect() )
				{
					m_pEqpAssy->m_AnalogInput.m_aiSet[j].nAiIntrNo = m_pEqpAssy->m_AnalogInput.m_nMaxIntrAiNo;
					m_pEqpAssy->m_AnalogInput.m_nMaxIntrAiNo ++;
				}
				else m_pEqpAssy->m_AnalogInput.m_aiSet[j].nAiIntrNo = -1;
				if( m_ocxAnalogInput[i].GetEdcReportSelect() )
				{
					m_pEqpAssy->m_AnalogInput.m_aiSet[j].nEdcReportNo = m_pEqpAssy->m_AnalogInput.m_nMaxEdcAiNo;
					m_pEqpAssy->m_AnalogInput.m_nMaxEdcAiNo ++;
				}
				else m_pEqpAssy->m_AnalogInput.m_aiSet[j].nEdcReportNo = -1;
			}
		}
	}	
}

void CJobsTabHpmjStatusView::SetAiInitParameter()
{
	float fAnalogVal = 0.0f;
	for( int i=0; i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++ )
	{
		if( m_pEqpAssy->m_AnalogInput.m_aiSet[i].nOwnerViewNo != CDicsView::viewJobHpmj ) continue;
		int nAddress = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nReal;
		int nOcxId = m_pEqpAssy->m_AnalogInput.m_aiSet[i].uRESID;// - IDC_ANALOGCTRLCTRL1;
		if( nOcxId >= 0 )
		{
			fAnalogVal =  m_pEqpAssy->m_AnalogInput.GetRealVal( i );
			m_ocxAnalogInput[nOcxId].SetAnalogCalDisplay( fAnalogVal );
		}
	}
}

void CJobsTabHpmjStatusView::UpdateAI()
{
	float fAnalogVal = 0.0f;
	int nCurAdcVal = 0;
	for( int i=0; i<m_pEqpAssy->m_AnalogInput.GetAiSize(); i++ )
	{
		if( m_pEqpAssy->m_AnalogInput.m_aiSet[i].nOwnerViewNo != CDicsView::viewJobHpmj ) continue;
		int nAddress = m_pEqpAssy->m_AnalogInput.m_aiSet[i].nReal;
		int nOcxId = m_pEqpAssy->m_AnalogInput.m_aiSet[i].uRESID;// - IDC_ANALOGCTRLCTRL21;
		if( nOcxId >= 0 )
		{
			m_pDevice->m_pFilterGain[nAddress]  = m_ocxAnalogInput[nOcxId].GetFilterGain();
			m_pDevice->m_aiInfo[nAddress].nScale   = m_ocxAnalogInput[nOcxId].GetCalScale();
			m_pDevice->m_aiInfo[nAddress].nAdcMin  = m_ocxAnalogInput[nOcxId].GetAdcMinVal();
			m_pDevice->m_aiInfo[nAddress].nAdcMax  = m_ocxAnalogInput[nOcxId].GetAdcMaxVal();
			m_pDevice->m_aiInfo[nAddress].fRealMin = m_ocxAnalogInput[nOcxId].GetRealMinVal();
			m_pDevice->m_aiInfo[nAddress].fRealMax = m_ocxAnalogInput[nOcxId].GetRealMaxVal();

			fAnalogVal =  m_pEqpAssy->m_AnalogInput.GetRealVal( i );
			nCurAdcVal = m_pEqpAssy->m_AnalogInput.GetAdcVal( i );
			m_ocxAnalogInput[nOcxId].SetCurAdcVal( nCurAdcVal );
			m_ocxAnalogInput[nOcxId].SetAnalogCalDisplay( fAnalogVal );
		}
	}
}

void CJobsTabHpmjStatusView::UpdateShower()
{
	static BOOL bHpmjNozzerle = FALSE;
	BOOL bRun = m_pEqpAssy->m_Hpmj.GetHpmjInputState( hpmjPUMPRUN );
	BOOL bAlarm = m_pEqpAssy->m_Hpmj.GetHpmjInputState( hpmjINVTALARM );
	
	if( bRun && !bAlarm && !bHpmjNozzerle)
	{
		bHpmjNozzerle = TRUE;
		for( int i = 0; i<4; i++)
		m_ocxShwUnit[i].SetRun();
	}
	else if( ( !bRun || bAlarm ) && bHpmjNozzerle  )
	{
		bHpmjNozzerle = FALSE;
		for( int i = 0; i<4; i++)
		m_ocxShwUnit[i].SetStop();
	}
}

void CJobsTabHpmjStatusView::OnRemote() 
{
	// TODO: Add your control notification handler code here
	if( ((CDicsView*)m_pView)->m_pDicsData->m_GenInfo.bAuto ||
	    ( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) )
	{
		m_macRemoteMode.SetCheck( 0 );
		return;
	}
	if( m_pEqpAssy->m_Hpmj.GetHpmjActState( hpmjINVTRUN ) )
	{
		((CDicsView*)m_pView)->m_pDicsData->m_IfHpmj.bPumpRun = FALSE;
	}
	m_pEqpAssy->m_Hpmj.SetHpmjAct( hpmjMANUAL, OFF );
	((CDicsView*)m_pView)->m_pDicsData->m_IfHpmj.bLocalReq = FALSE;
}

void CJobsTabHpmjStatusView::OnLocal() 
{
	// TODO: Add your control notification handler code here
	if( ((CDicsView*)m_pView)->m_pDicsData->m_GenInfo.bAuto ||
	    ( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) )
	{
		m_macLocalMode.SetCheck( 0 );
		return;
	}
	m_pEqpAssy->m_Hpmj.SetHpmjAct( hpmjMANUAL, ON );
	((CDicsView*)m_pView)->m_pDicsData->m_IfHpmj.bRemote = FALSE;
}

void CJobsTabHpmjStatusView::OnStart() 
{
	// TODO: Add your control notification handler code here
	

	if( ((CDicsView*)m_pView)->m_pDicsData->m_GenInfo.bAuto ||
	    ( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) )
	{
		m_macStart.SetCheck( 0 );
		return;
	}
	((CDicsView*)m_pView)->m_pDicsData->m_IfHpmj.bPumpRun = TRUE;

}

void CJobsTabHpmjStatusView::OnStop() 
{
	// TODO: Add your control notification handler code here
	if( ((CDicsView*)m_pView)->m_pDicsData->m_GenInfo.bAuto ||
		( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel <= CDicsData::idMAINT ) )
	{
		m_macStop.SetCheck( 0 );
		return;
	}
	((CDicsView*)m_pView)->m_pDicsData->m_IfHpmj.bPumpRun = FALSE;	
}

void CJobsTabHpmjStatusView::UpdateButton()
{
	BOOL bEnable = TRUE, bFlg = FALSE;
	bEnable &= !((CDicsView*)m_pView)->m_pDicsData->m_GenInfo.bAuto;
	m_macRemoteMode.EnableWindow( bEnable );
	m_macRemoteMode.SetCheck( !m_pEqpAssy->m_Hpmj.GetHpmjActState( hpmjMANUAL ) );
	m_macLocalMode.EnableWindow( bEnable && !m_pEqpAssy->m_Hpmj.GetHpmjActState( hpmjINVTRUN )  );
	m_macLocalMode.SetCheck( m_pEqpAssy->m_Hpmj.GetHpmjActState( hpmjMANUAL ) );
	m_macStop.EnableWindow( bEnable && !m_pEqpAssy->m_Hpmj.GetHpmjActState( hpmjMANUAL ) );
	m_macStop.SetCheck( !((CDicsView*)m_pView)->m_pDicsData->m_IfHpmj.bPumpRun );
	m_macStart.EnableWindow( bEnable && !m_pEqpAssy->m_Hpmj.GetHpmjActState( hpmjMANUAL ) );
	m_macStart.SetCheck( ((CDicsView*)m_pView)->m_pDicsData->m_IfHpmj.bPumpRun );
	
	bFlg = !((CDicsView*)m_pView)->m_pDicsData->m_IfHpmj.bRunTimeCountReset;
	m_macRunTimeReset.EnableWindow( bEnable && bFlg );
	if( bFlg && m_macRunTimeReset.GetCheck() ) m_macRunTimeReset.SetCheck( FALSE );
	bFlg = !((CDicsView*)m_pView)->m_pDicsData->m_IfHpmj.bPumpChangeCountReset;
	m_macPumpCountReset.EnableWindow( bEnable && bFlg );
	if( bFlg && m_macPumpCountReset.GetCheck() ) m_macPumpCountReset.SetCheck( FALSE );
	bFlg = !((CDicsView*)m_pView)->m_pDicsData->m_IfHpmj.bFilterChangeCountReset;
	m_macFilterCountReset.EnableWindow(  bEnable && bFlg );
	if( bFlg && m_macFilterCountReset.GetCheck() ) m_macFilterCountReset.SetCheck( FALSE );
	bFlg = !((CDicsView*)m_pView)->m_pDicsData->m_IfHpmj.bBuzzerOff;

	m_macBuzzerOff.EnableWindow( FALSE );
	m_macAlarmReset.EnableWindow( FALSE );

}

void CJobsTabHpmjStatusView::OnRunTimeReset() 
{
	if( ((CDicsView*)m_pView)->m_pDicsData->m_GenInfo.bAuto ||
	    ( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) )
	{
		m_macRunTimeReset.SetCheck( 0 );
		return;
	}
	((CDicsView*)m_pView)->m_pDicsData->m_IfHpmj.bRunTimeCountReset = TRUE;
	
}

void CJobsTabHpmjStatusView::OnPumpCountReset() 
{
	if( ((CDicsView*)m_pView)->m_pDicsData->m_GenInfo.bAuto ||
	    ( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) )
	{
		m_macPumpCountReset.SetCheck( 0 );
		return;
	}

	((CDicsView*)m_pView)->m_pDicsData->m_IfHpmj.bPumpChangeCountReset = TRUE;	
}

void CJobsTabHpmjStatusView::OnFilterCountReset() 
{
	if( ((CDicsView*)m_pView)->m_pDicsData->m_GenInfo.bAuto ||
	    ( ((CDicsView*)m_pView)->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idMAINT ) )
	{
		m_macFilterCountReset.SetCheck( 0 );
		return;
	}

	((CDicsView*)m_pView)->m_pDicsData->m_IfHpmj.bFilterChangeCountReset = TRUE;
	
}

void CJobsTabHpmjStatusView::OnBuzzerOff() 
{
	// TODO: Add your control notification handler code here
	((CDicsView*)m_pView)->m_pDicsData->m_IfHpmj.bBuzzerOff = TRUE;	
}

void CJobsTabHpmjStatusView::OnAlarmReset() 
{
	// TODO: Add your control notification handler code here
	((CDicsView*)m_pView)->m_pDicsData->m_IfHpmj.bAlarmReset = TRUE;
	
}
void CJobsTabHpmjStatusView::GridInit(CMSFlexGrid &gridCtrl, GRID_INFO_VER2 gridInfo)

{
	CString sText;
	
	gridCtrl.SetRows( gridInfo.nRows );
	gridCtrl.SetCols( gridInfo.nCols );
	
	if( gridInfo.bTitle )
	{
		for( int i = 0; i < gridInfo.nCols; i++ )
		{
			gridCtrl.SetRow( 0 );
			gridCtrl.SetCol( i );
			gridCtrl.SetCellAlignment( 4 );
			gridCtrl.SetCellBackColor( gridInfo.uCellBackColor );
			gridCtrl.SetColWidth( i, gridInfo.nColWidth[i] );
			gridCtrl.SetText( gridInfo.sText[i] );
		}
		for( int i=0; i<gridInfo.nRows-1; i++ )
		{
			gridCtrl.SetCol( 0 );
			gridCtrl.SetRow( i + 1 );
			gridCtrl.SetCellAlignment( 4 );
			gridCtrl.SetCellBackColor( gridInfo.uCellBackColor );
			gridCtrl.SetText( gridInfo.sItem[i] );
		}
	}
}

void CJobsTabHpmjStatusView::SetDataToGridCtrl_StateData()
{
	static float fOldState[MAX_HPMJ_STATE_DATA] = {-1.0,-1.0,-1.0,-1.0,-1.0,-1.0,-1.0,-1.0,-1.0};
	CString sVal("");
	for( int i=1; i<m_GridInfo[gStateInfo].nRows; i++ )
	{
		if( fOldState[i-1] != m_fStateData[i-1] )
		{
			fOldState[i-1] = m_fStateData[i-1];
			m_gridStateData.SetRow( i );
			m_gridStateData.SetCol( 1 );
			m_gridStateData.SetCellAlignment( 0 );
#ifdef _HPMJ_SFU_CTRL
			sVal.Format("%.3f", m_fStateData[i-1]);
#else
			if( i < 6 )
				sVal.Format( "%.0f (minute)", m_fStateData[i-1] );
			else
				sVal.Format( "%.0f", m_fStateData[i-1] );
#endif
			m_gridStateData.SetText( (LPCTSTR) sVal );
		}
	}
}

void CJobsTabHpmjStatusView::SetDataToGridCtrl_ParaData()
{
	static float fOldPara[6][4] = {{-1.0,-1.0,-1.0,-1.0},{-1.0,-1.0,-1.0,-1.0},{-1.0,-1.0,-1.0,-1.0},{-1.0,-1.0,-1.0,-1.0},{-1.0,-1.0,-1.0,-1.0},{-1.0,-1.0,-1.0,-1.0},};
	CString sVal("");
	for( int i=1; i<m_GridInfo[gParaInfo].nRows; i++ )
	{
		for( int j=1; j<m_GridInfo[gParaInfo].nCols; j++ )
		{
			if( fOldPara[i-1][j-1] != m_fParaData[i-1][j-1] )
			{
				fOldPara[i-1][j-1] = m_fParaData[i-1][j-1];
				m_gridParaData.SetRow( i );
				m_gridParaData.SetCol( j );
				m_gridParaData.SetCellAlignment( 0 );
				sVal.Format("%.3f", m_fParaData[i-1][j-1]);

				if( i == m_GridInfo[gParaInfo].nRows-1 && ( j == 2 || j == 4 ) ) m_gridParaData.SetText( " ");
				else m_gridParaData.SetText( (LPCTSTR) sVal );
			}
		}
	}
}

void CJobsTabHpmjStatusView::SetDataToGridCtrl_PpidData()
{
	static float fOldPpid[3] = {0.0,0.0,0.0};
	CString sVal("");
	for( int i=1; i<m_GridInfo[gSetupInfo].nRows; i++ )
	{
		if( fOldPpid[i-1] != m_fPpidData[i-1] )
		{
			fOldPpid[i-1] = m_fPpidData[i-1];
			m_gridPpidData.SetRow( i );
			m_gridPpidData.SetCol( 1 );
			m_gridPpidData.SetCellAlignment( 0 );
			if( i == 1 )
			{
				if( m_fPpidData[i-1] > 0 )
					sVal.Format( "Pressure" );
				else
					sVal.Format( "Frequency" );
			}
			else
				sVal.Format("%.3f", m_fPpidData[i-1]);

			m_gridPpidData.SetText( (LPCTSTR) sVal );
		}
	}
}

void CJobsTabHpmjStatusView::UpdateStateData()
{
/*	static float fOldState[MAX_HPMJ_STATE_DATA] = {-1.0,-1.0,-1.0,-1.0,-1.0,-1.0,-1.0,-1.0,-1.0};
	BOOL bUpdate = FALSE;
	for( int i=0; i<m_GridInfo[gStateInfo].nRows-1; i++ )
	{
		m_fStateData[i] = (float)((CDicsView*) m_pView)->m_pHpmjSeq->m_nHpmjStateData[i];

		if( fOldState[i] != m_fStateData[i] )
		{
			bUpdate = TRUE;
			fOldState[i] = m_fStateData[i];
		}
	}
	if( bUpdate ) SetDataToGridCtrl_StateData();
*/
}

void CJobsTabHpmjStatusView::UpdateParaData()
{
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	static float fOldPara[6][4] = {{-1.0,-1.0,-1.0,-1.0},{-1.0,-1.0,-1.0,-1.0},{-1.0,-1.0,-1.0,-1.0},{-1.0,-1.0,-1.0,-1.0},{-1.0,-1.0,-1.0,-1.0},{-1.0,-1.0,-1.0,-1.0},};
	BOOL bUpdate = FALSE;
	for( int i=0; i<m_GridInfo[gParaInfo].nRows-1; i++ )
	{
		for( int j=0; j<m_GridInfo[gParaInfo].nCols-1; j++ )
		{
			
			//m_fParaData[0][j] = m_ocxAnalogInput[i].GetAnalogUnitName();
			m_fParaData[i][0] = m_ocxAnalogInput[i].GetLowLimitValue();
			m_fParaData[i][1] = m_ocxAnalogInput[i].GetLoWaringValue();
			m_fParaData[i][2] = m_ocxAnalogInput[i].GetUpWarningValue();
			m_fParaData[i][3] = m_ocxAnalogInput[i].GetUpLimitValue();

			if( fOldPara[i][j] != m_fParaData[i][j] )
			{
				bUpdate = TRUE;
				fOldPara[i][j] = m_fParaData[i][j];
			}
		}
	}
	if( bUpdate ) SetDataToGridCtrl_ParaData();
}

void CJobsTabHpmjStatusView::UpdatePpidData()
{
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	static float fOldPpid[3] = {0.0,0.0,0.0};
	BOOL bUpdate = FALSE;
	for( int i=0; i<m_GridInfo[gSetupInfo].nRows-1; i++ )
	{
//		if( i == 0 )
//			m_fPpidData[i] = (float)( pDoc->m_pSetupItems->m_nValueSetup_Option[CSetupItems::setupHPMJ_RUN_MODE] );
//		else
//			m_fPpidData[i] = (float)atof( pDoc->m_pSetupItems->m_sValueSetup[CSetupItems::setupHPMJ_FRQ_SET+i-1] );
		if( fOldPpid[i] != m_fPpidData[i] )
		{
			bUpdate = TRUE;
			fOldPpid[i] = m_fPpidData[i];
		}
	}
	if( bUpdate ) SetDataToGridCtrl_PpidData();
}
void CJobsTabHpmjStatusView::UpdatePump()
{
	static int nOldPumpRun = FALSE;
	
	int nPumpRun = m_pEqpAssy->m_Hpmj.GetHpmjActState( hpmjINVTRUN );
	if( nPumpRun != nOldPumpRun )
	{
		nOldPumpRun = nPumpRun;
		if( nPumpRun ) m_ocxPump.SetStart();
		else m_ocxPump.SetStop();
	}
}
void CJobsTabHpmjStatusView::UpdateInputStatus()
{
	static BOOL bOldIn[6] = {FALSE,};
	BOOL bIn[6] = {FALSE,};

	bIn[0] = FALSE; 
	bIn[1] = ((CDicsView*) m_pView)->m_pDicsData->m_IfHpmj.bAlarm;
	bIn[2] = ((CDicsView*) m_pView)->m_pDicsData->m_IfHpmj.bWarning;
	bIn[3] = ((CDicsView*) m_pView)->m_pDicsData->m_IfHpmj.bReady;
	bIn[4] = m_pEqpAssy->m_Hpmj.GetHpmjActState( hpmjINVTRUN );
	bIn[5] = !m_pEqpAssy->m_Hpmj.GetHpmjActState( hpmjMANUAL );

	if( bIn[0] != bOldIn[0] )
	{
		bOldIn[0] = bIn[0];
		if( bIn[0] ) m_checkPing.SetCheck( 1 );
		else m_checkPing.SetCheck( 0 );
	}
	if( bIn[1] != bOldIn[1] )
	{
		bOldIn[1] = bIn[1];
		if( bIn[1] ) m_checkAlarm.SetCheck( 1 );
		else m_checkAlarm.SetCheck( 0 );
	}
	if( bIn[2] != bOldIn[2] )
	{
		bOldIn[2] = bIn[2];
		if( bIn[2] ) m_checkWarning.SetCheck( 1 );
		else m_checkWarning.SetCheck( 0 );
	}
	if( bIn[3] != bOldIn[3] )
	{
		bOldIn[3] = bIn[3];
		if( bIn[3] ) m_checkReady.SetCheck( 1 );
		else m_checkReady.SetCheck( 0 );
	}
	if( bIn[4] != bOldIn[4] )
	{
		bOldIn[4] = bIn[4];
		if( bIn[4] ) m_checkRun.SetCheck( 1 );
		else m_checkRun.SetCheck( 0 );
	}
	if( bIn[5] != bOldIn[5] )
	{
		bOldIn[5] = bIn[5];
		if( bIn[5] ) m_checkRemote.SetCheck( 1 );
		else m_checkRemote.SetCheck( 0 );
	}

}

void CJobsTabHpmjStatusView::UpdateObjects()
{
	UpdateAI();
	UpdateShower();
	UpdatePump();
	UpdateInputStatus();
	UpdateButton();
	UpdateStateData();
	UpdateParaData();
	UpdatePpidData();
}


