#if !defined(AFX_MSGBOX_H__266A1F61_6DDF_11D3_BAEA_00104B15946E__INCLUDED_)
#define AFX_MSGBOX_H__266A1F61_6DDF_11D3_BAEA_00104B15946E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MsgBox.h : header file
//

#define BLACK	RGB(0,0,0)
#define BLUE	RGB(0,0,128)
#define GREEN	RGB(0,128,0)
#define CYAN	RGB(0,128,128)
#define RED		RGB(128,0,0)
#define MAGENTA	RGB(128,0,128)
#define BROWN	RGB(128,128,0)
#define DARKGRAY	RGB(128,128,128)
#define LIGHTGRAY	RGB(192,192,192)
#define LIGHTBLUE	RGB(0,0,225)
#define LIGHTGREEN	RGB(0,225,0)
#define LIGHTCYAN	RGB(0,255,255)
#define LIGHTRED	RGB(255,0,0)
#define LIGHTMAGENTA	RGB(255,0,255)
#define YELLOW		RGB(255,255,0)
#define WHITE		RGB(255,255,255)

/////////////////////////////////////////////////////////////////////////////
// CMsgBox window

class CMsgBox : public CWnd
{
// Construction
public:
	CMsgBox();

// Attributes
public:
	CWnd* m_pOwner;
	int m_nID;
	int m_nFontSize;
	int m_nAlign;

	enum{	alignLEFT,
			alignCENTER };

// Operations
public:
	void SetAlign(int nAlign ) { m_nAlign = nAlign; }

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMsgBox)
	//}}AFX_VIRTUAL

// Implementation
public:
	BOOL Create(int nID, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd *pParentWnd, 
		UINT nResID, COLORREF colorBack, COLORREF colorText, int nFontSize,
		BOOL bNonClick = FALSE);
	void SetOpMsg(LPCTSTR szMsg);
	CString GetOpMsg() { return m_szOpMsg; }
	void SetTextColor( COLORREF colorText );
	void SetBgColor( COLORREF colorBack );

	enum{	idBLACK,
			idBLUE,
			idGREEN,
			idCYAN,
			idRED,
			idMAGENTA,
			idBROWN,
			idDARKGRAY,
			idLIGHTGRAY,
			idLIGHTBLUE,
			idLIGHTGREEN,
			idLIGHTCYAN,
			idLIGHTRED,
			idLIGHTMAGENTA,
			idYELLOW,
			idWHITE};

	virtual ~CMsgBox();

protected:
	CPen m_Pen[16];
	CBrush m_Brush;
	CFont m_FontS;
	CFont m_FontL;
	COLORREF m_colorBack;
	COLORREF m_colorText;
	BOOL m_bNonClick;

	// Generated message map functions
protected:
	CString m_szOpMsg;
	CString m_szOldOpMsg;
	//{{AFX_MSG(CMsgBox)
	afx_msg void OnPaint();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MSGBOX_H__266A1F61_6DDF_11D3_BAEA_00104B15946E__INCLUDED_)
