// XAnalogInput.cpp: implementation of the XAnalogInput class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Dics.h"
#include "XAnalogInput.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

XAnalogInput::XAnalogInput()
{

}

XAnalogInput::~XAnalogInput()
{

}

WORD XAnalogInput::Get()
{
	if( IsActive() )
	{
		return m_pDevice->AioRead( m_nAddress );
	}
	else
	{
		return 0;
	}
}

float XAnalogInput::GetCalAi()
{
	if( IsActive() )
		return m_pDevice->GetCalAI( m_nAddress );
	else 
		return 0.0f;
}

float XAnalogInput::GetVoltage()
{
	float fVal;
	WORD wVal;
	wVal = Get();
	fVal =  (float)( (double)wVal / (double)0x8000 );
	return fVal;
}

void XAnalogInput::SetRawAi( float fVal )
{
	if( IsActive() )
		m_pDevice->SetRawAI( m_nAddress, fVal );
	else return;
}