#if !defined(AFX_XCTLCCLINK_H__C6084373_BCAC_4E50_85C9_4115C17DA882__INCLUDED_)
#define AFX_XCTLCCLINK_H__C6084373_BCAC_4E50_85C9_4115C17DA882__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// XCtlCCLink.h : header file
//
#include <afxtempl.h>
#include "XCCLink.h"
#include "..\DicsDoc.h"
/////////////////////////////////////////////////////////////////////////////
// XCtlCCLink thread

class XCtlCCLink : public CWinThread, public XCCLink
{
	DECLARE_DYNCREATE(XCtlCCLink)
public:
	XCtlCCLink();           // protected constructor used by dynamic creation
	XCtlCCLink* m_pCCLink;
	virtual ~XCtlCCLink();
// Attributes
public:
	struct tagNetworkInfo{
		short nNetworkNo; 
		short nUpNetworkNo;
		short nDnNetworkNo;
		short nStationNo;
		short nUpStationNo;
		short nDnStationNo;
	}m_NetworkInfo;

	CString m_sBuf;
	CString m_sMessage;

// Operations
public:
	BOOL Start( CWnd* pOwner, int nChannel, int nMode );
	BOOL End();

	void InitParameter();
	void Watch();
	void Msg( UINT uMsg, WPARAM wParam, LPARAM lParam=0 );
	void SetMelsecParameter(short nNetworkNo, short nStationNo, 
									short nUpNetworkNo, short nUpStationNo, 
									short nDnNetworkNo, short nDnStationNo );
	void UpdateState();
	
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(XCtlCCLink)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation
protected:
	CWnd*	m_pOwner;
	HANDLE	m_hDead;
	HANDLE	m_hKill;

	// Generated message map functions
	//{{AFX_MSG(XCtlCCLink)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_XCTLCCLINK_H__C6084373_BCAC_4E50_85C9_4115C17DA882__INCLUDED_)
