// XDigitalOutput.cpp: implementation of the XDigitalOutput class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Dics.h"
#include "XDigitalOutput.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

XDigitalOutput::XDigitalOutput()
{

}

XDigitalOutput::~XDigitalOutput()
{

}

BOOL XDigitalOutput::Get()
{
	if( IsActive() )
		return m_pDevice->GetDoState( m_nAddress );
	else
		return FALSE;
}

void XDigitalOutput::Set(BOOL bVal)
{
	if( IsActive() )
		m_pDevice->DioWrite( m_nAddress, bVal );
}
