// AnalogInputCln.h: interface for the CAnalogInput1 class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ANALOGINPUTCLN_H__664FE826_8120_4553_83A6_9B42D99B25C3__INCLUDED_)
#define AFX_ANALOGINPUTCLN_H__664FE826_8120_4553_83A6_9B42D99B25C3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "X\MsgBox.h"

class CAnalogInput1 : public CObject  
{
public:
	CAnalogInput1(CWnd* pOwner);
	virtual ~CAnalogInput1();

	void CreateMsgBox(CWnd* pOwner);
	void SetOpMsg(int nID, float fVal);

	static AI_SET m_aiSet[MAX_ANALOG_IN_NO];

	int m_nMaxApdAiNo;
	int m_nMaxEdcAiNo;
	int m_nMaxIntrAiNo;

public:
	CWnd* m_pOwner;
	CMsgBox m_msgAI[MAX_ANALOG_IN_NO];

	// PS : Pressure
	// FR : Flow rate
	// DM : Digital Manometer
	// AM : Anenometer
	// WR : Water resistance
	// IC : Ion Checker
	// TL : Tank Level
	// TM : Temperature
	// IL : Light Density
	enum aiKIND { aiPS, aiFR, aiDM, aiAM, aiWR, aiIC, aiTL, aiTM, aiIL };
};

#endif // !defined(AFX_ANALOGINPUTCLN_H__664FE826_8120_4553_83A6_9B42D99B25C3__INCLUDED_)
