// CommVCR.cpp: implementation of the CCommVCR class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "dics.h"
#include "CommVCR.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCommVCR::CCommVCR()
	: m_evCommRcvd( FALSE, TRUE ) // Initially Own = FALSE, Manual Reset = TRUE
{
	m_bErrorhappened = FALSE;
}

CCommVCR::~CCommVCR()
{

}

BOOL CCommVCR::TrigSendCommand( CString sCmd )
{
	BOOL bRv = FALSE;
/*	m_sSendData.Format( "%C%s%C%C%C", ccESC, sCmd, ccByte2, ccByte3, ccCR ); //1B,50,00,FF,0D (ESC,P,00,FF,CR)

	bRv = Write( m_sSendData.GetBuffer( m_sSendData.GetLength() ), m_sSendData.GetLength() );
	m_sSendData.ReleaseBuffer();
	return bRv; */
//	char buf[5];
//	buf[0] = 0x1B ;
//	buf[1] = 0x50 ;
//	buf[2] = 0x00 ;
//	buf[3] = 0xFF ;
//	buf[4] = 0x0D ;
//	bRv = Write( buf, 5 );

	return bRv;
}

void CCommVCR::DataReceived()
{
	char buf[256];
	Sleep( 1 );
	
	int nLen = XComm::Read( buf, 30 );
	
	m_sReceivedData = CString( buf );

	if( nLen > 0 )
	{
		if( buf[0] == 'V' )
		{
			CString sBuf;
//			int nDataCount = m_sReceivedData.Mid( 1, 2 );
//			sBuf = m_sReceivedData.Mid( 3, nDataCount );
			m_sGlassId = sBuf;
		}
		else if( buf[0] == 'D' )
		{
			CString sBuf;
			int nDataCount;
			nDataCount = atoi( m_sReceivedData.Mid( 1, 4 ) );
			sBuf = m_sReceivedData.Mid( 5, nDataCount );
			m_sGlassId = sBuf;

		}
		else if( buf[0] == 'R')
		{
//			int nErrorCode = atoi( m_sReceivedData.Mid( 1, 2 ) );
			m_bErrorhappened = TRUE;
		}
	} 
}

BOOL CCommVCR::IsCommRcvd()
{
	static int nSeqNo = 0;
	BOOL bRcvd = FALSE;
	CSingleLock commRcvd( &m_evCommRcvd );

	switch( nSeqNo )
	{
	case 0:
		// When the port received value initially, we force it reset.
		m_evCommRcvd.ResetEvent();
		nSeqNo = 10;
		break;
	case 10:
		commRcvd.Lock( 0 );
		bRcvd = commRcvd.IsLocked();
		if( bRcvd ) 
		{
			m_evCommRcvd.ResetEvent();
			nSeqNo = 0;
		}
		break;
	}
	return bRcvd;
}