// CommVCR.h: interface for the CCommVCR class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMMVCR_H__69818A7B_6231_4BF2_903A_F4346A2B5A41__INCLUDED_)
#define AFX_COMMVCR_H__69818A7B_6231_4BF2_903A_F4346A2B5A41__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "X\XCommThread.h"
#include "DicsData.h"

class CCommVCR : public XCommThread  
{
public:
	CCommVCR();
	virtual ~CCommVCR();
public:
	void DataReceived();
	void SetData(CDicsData* pData) { m_pDicsData = pData; }

	BOOL TrigSendCommand( CString sCmd );
	BOOL IsCommRcvd();

	CDicsData*			m_pDicsData;

	CString m_sGlassId;
	CString m_sSendData;

	BOOL	m_bErrorhappened;

	CEvent	m_evCommRcvd;

	enum ControlCharacters {
		ccMMODE = 0x56,
		ccDATAMATRIX = 0x44,
		ccERROR = 0x52,
	};

	enum _TERMINATE_CODE{
		ccOK = 0x11,
		ccESC = 0x1B,
		ccByte2 = 0x00,
		ccByte3 = 0xFF,
		ccNG = 0x0F,
		ccCR = 0x0D,
	};

};

#endif // !defined(AFX_COMMVCR_H__69818A7B_6231_4BF2_903A_F4346A2B5A41__INCLUDED_)
