#if !defined(AFX_DAOERRHISTSET_H__106DCE6A_1BB9_4D0B_BFF0_80335B03BFB1__INCLUDED_)
#define AFX_DAOERRHISTSET_H__106DCE6A_1BB9_4D0B_BFF0_80335B03BFB1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// daoerrhistset.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDaoErrHistSet DAO recordset

class CDaoErrHistSet : public CDaoRecordset
{
public:
	CDaoErrHistSet(CDaoDatabase* pDatabase = NULL);
	DECLARE_DYNAMIC(CDaoErrHistSet)

// Field/Param Data
	//{{AFX_FIELD(CDaoErrHistSet, CDaoRecordset)
	long	m_ID;
	COleDateTime	m_ErrorTime;
	long	m_ErrorID;
	CString	m_ErrorLevel;
	CString	m_ErrorContent;
	//}}AFX_FIELD

	BOOL AddErrData(int nCode, LPCTSTR szErr, LPCTSTR szLevel);
	BOOL DelErrData(int nIndex);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDaoErrHistSet)
	public:
	virtual CString GetDefaultDBName();		// Default database name
	virtual CString GetDefaultSQL();		// Default SQL for Recordset
	virtual void DoFieldExchange(CDaoFieldExchange* pFX);  // RFX support
	//}}AFX_VIRTUAL

// Implementation
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DAOERRHISTSET_H__106DCE6A_1BB9_4D0B_BFF0_80335B03BFB1__INCLUDED_)

