//BEGIN
#ifndef _DEFINEALARM_H
#define _DEFINEALARM_H
//END
///////////////////////////////////////////////////////////////////////////
//// AlarmID	// NOTE : AlarmCode	(tab) Level	(tab) AlarmText
///////////////////////////////////////////////////////////////////////////
#define ALM_EMO1		                		1		// NOTE : 2	S	EMO Alarm1 (LD OP EMO)
#define ALM_EMO2			              		2		// NOTE : 2	S	EMO Alarm2 (LD MID OP EMO)
#define ALM_EMO3								3		// NOTE : 2	S	EMO Alarm3 (LD MID MT EMO)
#define ALM_EMO4								4		// NOTE : 2	S	EMO Alarm4 (LD LO MT EMO)
#define ALM_EMO5								5		// NOTE : 2	S	EMO Alarm5 (SWR4 LO MT EMO)
#define ALM_EM06								6		// NOTE : 2	S	EMO Alarm6 (SWR4 MD MT EMO)
#define ALM_EM07								7		// NOTE : 2	S	EMO Alarm7 (AK MID OP EMO)
#define ALM_EM08								8		// NOTE : 2	S	EMO Alarm8 (AK LO OP EMO)
#define ALM_EM09								9		// NOTE : 2	S	EMO Alarm9 (UL LO MT EMO)
#define ALM_EM09								10		// NOTE : 2	S	EMO Alarm9 (UL MID MT EMO)
#define ALM_POWER_OFF							11		// NOTE : 2	S	Power ON Switch OFF

#define ALM_GLASS_SENSING1						20		// NOTE : 2	S	UP LD Unit Glass Sensing Error
#define ALM_GLASS_SENSING2						21		// NOTE : 2	S	BUF1 Unit Glass Sensing Error
#define ALM_GLASS_SENSING3						22		// NOTE : 2	S	BUF2 Glass Sensing Error
#define ALM_GLASS_SENSING4						23		// NOTE : 2	S	LD Unit Glass Sensing Error
#define ALM_GLASS_SENSING5						24		// NOTE : 2	S	BUF3 Unit Glass Sensing Error
#define ALM_GLASS_SENSING6						25		// NOTE : 2	S	SWR1 Unit Glass Sensing Error
#define ALM_GLASS_SENSING7						26		// NOTE : 2	S	SWR2 Unit Glass Sensing Error
#define ALM_GLASS_SENSING8						27		// NOTE : 2	S	AK Unit Glass Sensing Error
#define ALM_GLASS_SENSING9						28		// NOTE : 2	S	UL Unit Glass Sensing Error

#define ALM_GLASS_DATA_ERROR1					31		// NOTE : 2	S	UP LD Unit Glass Data Error
#define ALM_GLASS_DATA_ERROR2					32		// NOTE : 2	S	BUF1 Unit Glass Data Error
#define ALM_GLASS_DATA_ERROR3					33		// NOTE : 2	S	BUF2 Glass Data Error
#define ALM_GLASS_DATA_ERROR4					34		// NOTE : 2	S	BUF3 Glass Data Error
#define ALM_GLASS_DATA_ERROR5					35		// NOTE : 2	S	LD Unit Glass Data Error
#define ALM_GLASS_DATA_ERROR6					36		// NOTE : 2	S	EUV Unit Glass Data Error
#define ALM_GLASS_DATA_ERROR7					37		// NOTE : 2	S	RB Unit Glass Data Error
#define ALM_GLASS_DATA_ERROR8					38		// NOTE : 2	S	FR Unit Glass Data Error
#define ALM_GLASS_DATA_ERROR9					39		// NOTE : 2	S	AK Unit Glass Data Error
#define ALM_GLASS_DATA_ERROR10					40		// NOTE : 2	S	UL Unit Glass Data Error
#define ALM_GLASS_DATA_ERROR11					41		// NOTE : 2	S	UL HAND Unit Glass Data Error

#define ALM_SENSOR_IN_ON_TIMEOUT1	        	51		// NOTE : 2	S	UP LD Unit In Sensor On Error
#define ALM_SENSOR_IN_ON_TIMEOUT2	      		52		// NOTE : 2	S	BUF1 Unit In Sensor On Error
#define ALM_SENSOR_IN_ON_TIMEOUT3				53		// NOTE : 2	S	BUF2 Unit In Sensor On Error
#define ALM_SENSOR_IN_ON_TIMEOUT4				54		// NOTE : 2	S	BUF3 Unit In Sensor On Error
#define ALM_SENSOR_IN_ON_TIMEOUT5				55		// NOTE : 2	S	LD Unit In Sensor On Error
#define ALM_SENSOR_IN_ON_TIMEOUT6				56		// NOTE : 2	S	EUV Unit In Sensor On Error
#define ALM_SENSOR_IN_ON_TIMEOUT7	      		57		// NOTE : 2	S	RB Unit In Sensor On Error
#define ALM_SENSOR_IN_ON_TIMEOUT8				58		// NOTE : 2	S	FR Unit In Sensor On Error
#define ALM_SENSOR_IN_ON_TIMEOUT9				59		// NOTE : 2	S	AK Unit In Sensor On Error
#define ALM_SENSOR_IN_ON_TIMEOUT10				60		// NOTE : 2	S	UL Unit In Sensor On Error
#define ALM_SENSOR_IN_ON_TIMEOUT11				61		// NOTE : 2	S	UL HAND Unit In Sensor On Error

#define ALM_SENSOR_IN_OFF_TIMEOUT1	        	71		// NOTE : 2	S	UP LD Unit In Sensor Off Error
#define ALM_SENSOR_IN_OFF_TIMEOUT2	      		72		// NOTE : 2	S	BUF1 Unit In Sensor Off Error
#define ALM_SENSOR_IN_OFF_TIMEOUT3				73		// NOTE : 2	S	BUF2 Unit In Sensor Off Error
#define ALM_SENSOR_IN_OFF_TIMEOUT4				74		// NOTE : 2	S	BUF3 Unit In Sensor Off Error
#define ALM_SENSOR_IN_OFF_TIMEOUT5				75		// NOTE : 2	S	LD Unit In Sensor Off Error
#define ALM_SENSOR_IN_OFF_TIMEOUT6				76		// NOTE : 2	S	EUV Unit In Sensor Off Error
#define ALM_SENSOR_IN_OFF_TIMEOUT7	        	77		// NOTE : 2	S	RB Unit In Sensor Off Error
#define ALM_SENSOR_IN_OFF_TIMEOUT8	      		78		// NOTE : 2	S	FR Unit In Sensor Off Error
#define ALM_SENSOR_IN_OFF_TIMEOUT9				79		// NOTE : 2	S	AK Unit In Sensor Off Error
#define ALM_SENSOR_IN_OFF_TIMEOUT10				80		// NOTE : 2	S	UL Unit In Sensor Off Error
#define ALM_SENSOR_IN_OFF_TIMEOUT11				81		// NOTE : 2	S	UL HAND Unit In Sensor Off Error

#define ALM_SENSOR_OUT_ON_TIMEOUT1	        	91		// NOTE : 2	S	UP LD Unit Out Sensor On Error
#define ALM_SENSOR_OUT_ON_TIMEOUT2	      		92		// NOTE : 2	S	BUF1 Unit Out Sensor On Error
#define ALM_SENSOR_OUT_ON_TIMEOUT3				93		// NOTE : 2	S	BUF2 Unit Out Sensor On Error
#define ALM_SENSOR_OUT_ON_TIMEOUT4				94		// NOTE : 2	S	BUF3 Unit Out Sensor On Error
#define ALM_SENSOR_OUT_ON_TIMEOUT5				95		// NOTE : 2	S	LD Unit Out Sensor On Error
#define ALM_SENSOR_OUT_ON_TIMEOUT6				96		// NOTE : 2	S	EUV Unit Out Sensor On Error
#define ALM_SENSOR_OUT_ON_TIMEOUT7	        	97		// NOTE : 2	S	RB Unit Out Sensor On Error
#define ALM_SENSOR_OUT_ON_TIMEOUT8	      		98		// NOTE : 2	S	FR Unit Out Sensor On Error
#define ALM_SENSOR_OUT_ON_TIMEOUT9				99		// NOTE : 2	S	AK Unit Out Sensor On Error
#define ALM_SENSOR_OUT_ON_TIMEOUT10				100		// NOTE : 2	S	UL Unit Out Sensor On Error
#define ALM_SENSOR_OUT_ON_TIMEOUT11				101		// NOTE : 2	S	UL HAND Unit Out Sensor On Error

#define ALM_SENSOR_OUT_OFF_TIMEOUT1	        	111		// NOTE : 2	S	UP LD Unit Out Sensor Off Error
#define ALM_SENSOR_OUT_OFF_TIMEOUT2	      		112		// NOTE : 2	S	BUF1 Unit Out Sensor Off Error
#define ALM_SENSOR_OUT_OFF_TIMEOUT3				113		// NOTE : 2	S	BUF2 Unit Out Sensor Off Error
#define ALM_SENSOR_OUT_OFF_TIMEOUT4				114		// NOTE : 2	S	BUF3 Unit Out Sensor Off Error
#define ALM_SENSOR_OUT_OFF_TIMEOUT5				115		// NOTE : 2	S	LD Unit Out Sensor Off Error
#define ALM_SENSOR_OUT_OFF_TIMEOUT6				116		// NOTE : 2	S	EUV Unit Out Sensor Off Error
#define ALM_SENSOR_OUT_OFF_TIMEOUT7	        	117		// NOTE : 2	S	RB Unit Out Sensor Off Error
#define ALM_SENSOR_OUT_OFF_TIMEOUT8	      		118		// NOTE : 2	S	FR Unit Out Sensor Off Error
#define ALM_SENSOR_OUT_OFF_TIMEOUT9				119		// NOTE : 2	S	AK Unit Out Sensor Off Error
#define ALM_SENSOR_OUT_OFF_TIMEOUT10			120		// NOTE : 2	S	UL Unit Out Sensor Off Error
#define ALM_SENSOR_OUT_OFF_TIMEOUT11			121		// NOTE : 2	S	UL HAND Unit Out Sensor Off Error

#define ALM_IN_ON_SENSOR_WARNING1				131		// NOTE : 6	L	UP LD Unit In Sensor On Sensing Warning
#define ALM_IN_ON_SENSOR_WARNING2				132		// NOTE : 6	L	BUF1 Unit In Sensor On Sensing Warning
#define ALM_IN_ON_SENSOR_WARNING3				133		// NOTE : 6	L	BUF2 Unit In Sensor On Sensing Warning
#define ALM_IN_ON_SENSOR_WARNING4				134		// NOTE : 6	L	BUF3 Unit In Sensor On Sensing Warning
#define ALM_IN_ON_SENSOR_WARNING5				135		// NOTE : 6	L	LD Unit In Sensor On Sensing Warning
#define ALM_IN_ON_SENSOR_WARNING6				136		// NOTE : 6	L	EUV Unit In Sensor On Sensing Warning
#define ALM_IN_ON_SENSOR_WARNING7				137		// NOTE : 6	L	RB Unit In Sensor On Sensing Warning
#define ALM_IN_ON_SENSOR_WARNING8				138		// NOTE : 6	L	FR Unit In Sensor On Sensing Warning
#define ALM_IN_ON_SENSOR_WARNING9				139		// NOTE : 6	L	AK Unit In Sensor On Sensing Warning
#define ALM_IN_ON_SENSOR_WARNING10				140		// NOTE : 6	L	UL Unit In Sensor On Sensing Warning
#define ALM_IN_ON_SENSOR_WARNING11				141		// NOTE : 6	L	UL HAND Unit In Sensor On Sensing Warning

#define ALM_OUT_ON_SENSOR_WARNING1				151		// NOTE : 6	L	UP LD Unit Out Sensor On Sensing Warning
#define ALM_OUT_ON_SENSOR_WARNING2				152		// NOTE : 6	L	BUF1 Unit Out Sensor On Sensing Warning
#define ALM_OUT_ON_SENSOR_WARNING3				153		// NOTE : 6	L	BUF2 Unit Out Sensor On Sensing Warning
#define ALM_OUT_ON_SENSOR_WARNING4				154		// NOTE : 6	L	BUF3 Unit Out Sensor On Sensing Warning
#define ALM_OUT_ON_SENSOR_WARNING5				155		// NOTE : 6	L	LD Unit Out Sensor On Sensing Warning
#define ALM_OUT_ON_SENSOR_WARNING6				156		// NOTE : 6	L	EUV Unit Out Sensor On Sensing Warning
#define ALM_OUT_ON_SENSOR_WARNING7				157		// NOTE : 6	L	RB Unit Out Sensor On Sensing Warning
#define ALM_OUT_ON_SENSOR_WARNING8				158		// NOTE : 6	L	FR Unit Out Sensor On Sensing Warning
#define ALM_OUT_ON_SENSOR_WARNING9				159		// NOTE : 6	L	AK Unit Out Sensor On Sensing Warning
#define ALM_OUT_ON_SENSOR_WARNING10				160		// NOTE : 6	L	UL Unit Out Sensor On Sensing Warning
#define ALM_OUT_ON_SENSOR_WARNING11				161		// NOTE : 6	L	UL HAND Unit Out Sensor On Sensing Warning

#define ALM_IN_OFF_SENSOR_WARNING1				171		// NOTE : 6	L	UP LD Unit In Sensor Off Sensing Warning
#define ALM_IN_OFF_SENSOR_WARNING2				172		// NOTE : 6	L	BUF1 Unit In Sensor Off Sensing Warning
#define ALM_IN_OFF_SENSOR_WARNING3				173		// NOTE : 6	L	BUF2 Unit In Sensor Off Sensing Warning
#define ALM_IN_OFF_SENSOR_WARNING4				174		// NOTE : 6	L	BUF3 Unit In Sensor Off Sensing Warning
#define ALM_IN_OFF_SENSOR_WARNING5				175		// NOTE : 6	L	LD Unit In Sensor Off Sensing Warning
#define ALM_IN_OFF_SENSOR_WARNING6				176		// NOTE : 6	L	EUV Unit In Sensor Off Sensing Warning
#define ALM_IN_OFF_SENSOR_WARNING7				177		// NOTE : 6	L	RB Unit In Sensor Off Sensing Warning
#define ALM_IN_OFF_SENSOR_WARNING8				178		// NOTE : 6	L	FR Unit In Sensor Off Sensing Warning
#define ALM_IN_OFF_SENSOR_WARNING9				179		// NOTE : 6	L	AK Unit In Sensor Off Sensing Warning
#define ALM_IN_OFF_SENSOR_WARNING10				180		// NOTE : 6	L	UL Unit In Sensor Off Sensing Warning
#define ALM_IN_OFF_SENSOR_WARNING11				181		// NOTE : 6	L	UL HAND Unit In Sensor Off Sensing Warning

#define ALM_OUT_OFF_SENSOR_WARNING1				191		// NOTE : 6	L	UP LD Unit Out Sensor Off Sensing Warning
#define ALM_OUT_OFF_SENSOR_WARNING2				192		// NOTE : 6	L	BUF1 Unit Out Sensor Off Sensing Warning
#define ALM_OUT_OFF_SENSOR_WARNING3				193		// NOTE : 6	L	BUF2 Unit Out Sensor Off Sensing Warning
#define ALM_OUT_OFF_SENSOR_WARNING4				194		// NOTE : 6	L	BUF3 Unit Out Sensor Off Sensing Warning
#define ALM_OUT_OFF_SENSOR_WARNING5				195		// NOTE : 6	L	LD Unit Out Sensor Off Sensing Warning
#define ALM_OUT_OFF_SENSOR_WARNING6				196		// NOTE : 6	L	EUV Unit Out Sensor Off Sensing Warning
#define ALM_OUT_OFF_SENSOR_WARNING7				197		// NOTE : 6	L	RB Unit Out Sensor Off Sensing Warning
#define ALM_OUT_OFF_SENSOR_WARNING8				198		// NOTE : 6	L	FR Unit Out Sensor Off Sensing Warning
#define ALM_OUT_OFF_SENSOR_WARNING9				199		// NOTE : 6	L	AK Unit Out Sensor Off Sensing Warning
#define ALM_OUT_OFF_SENSOR_WARNING10			200		// NOTE : 6	L	UL Unit Out Sensor Off Sensing Warning
#define ALM_OUT_OFF_SENSOR_WARNING11			201		// NOTE : 6	L	UL HAND Unit Out Sensor Off Sensing Warning

#define ALM_BUF2_UNIT_INTR_ON_TIMEOUT			211		// NOTE : 2	S	BUF2 Unit Interlock Sensor On Timeout Error
#define ALM_BUF2_UNIT_INTR_OFF_TIMEOUT			212		// NOTE : 2 S	BUF2 Unit Interlock Sensor Off Timeout Error

#define ALM_GAUGE_LOWER_ALARM1					221		// NOTE : 2	S	EUV Unit ACID Exhaust Press Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM2					222		// NOTE : 2	S	RB Unit A/C CDA Flow Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM3					223		// NOTE : 2	S	RB Unit A/C CDA Press Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM4					224		// NOTE : 2	S	RB Unit Exhaust 1 Press Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM5					225		// NOTE : 2	S	RB Unit Exhaust 2 Press Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM6					226		// NOTE : 2	S	RB Unit Lower Shower Flow Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM7					227		// NOTE : 2	S	RB Unit Upper Shower Flow Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM8					228		// NOTE : 2	S	RB Unit MJ1 DI Flow Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM9					229		// NOTE : 2	S	FR Unit MJ3 DI Flow Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM10					230		// NOTE : 2	S	RB Unit MJ1 CDA Press Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM11					231		// NOTE : 2	S	RB Unit MJ1 CDA Flow Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM12					232		// NOTE : 2	S	FR Unit MJ2 CDA Flow Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM13					233		// NOTE : 2	S	FR Unit MJ3 CDA Flow Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM14					234		// NOTE : 2	S	FR Unit MJ4 CDA Flow Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM15					235		// NOTE : 2	S	FR Unit Exhaust1 Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM16					236		// NOTE : 2	S	FR Unit Exhaust2 Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM17					237		// NOTE : 2	S	FR Unit MJ2 CDA Press Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM18					238		// NOTE : 2	S	FR Unit MJ3 CDA Press Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM19					239		// NOTE : 2	S	FR Unit MJ4 CDA Press Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM20					240		// NOTE : 2	S	FR Unit MJ Lower Shower Flow Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM21					241		// NOTE : 2	S	FR Unit MJ4 DI Flow Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM22					242		// NOTE : 2	S	FR Unit AQA1 Shower Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM23					243		// NOTE : 2	S	FR Unit Lower Shower Flow Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM24					244		// NOTE : 2	S	FR Unit AQA2 Shower Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM25					245		// NOTE : 2	S	FR Unit Tank DI Resister Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM26					246		// NOTE : 2	S	FR Unit DI Resister Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM27					247		// NOTE : 2	S	AK Unit Upper Exhaust1 Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM28					248		// NOTE : 2	S	AK Unit Upper Exhaust2 Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM29					249		// NOTE : 2	S	AK Unit Lower Exhaust Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM30					250		// NOTE : 2	S	AK Unit Lower AK CDA Press Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM31					251		// NOTE : 2	S	AK Unit Upper AK CDA Press Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM32					252		// NOTE : 2	S	AK Unit Lower AK CDA Flow Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM33					253		// NOTE : 2	S	AK Unit Upper AK CDA Flow Lower Limit Alarm
#define ALM_GAUGE_LOWER_ALARM34					254		// NOTE : 2	S	Driving CDA Pressure Lower Limit Alarm

#define ALM_GAUGE_LOWER_WARNING1				261		// NOTE : 6	L	EUV Unit ACID Exhaust Press Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING2				262		// NOTE : 6	L	RB Unit A/C CDA Flow Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING3				263		// NOTE : 6	L	RB Unit A/C CDA Press Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING4				264		// NOTE : 6	L	RB Unit Exhaust 1 Press Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING5				265		// NOTE : 6	L	RB Unit Exhaust 2 Press Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING6				266		// NOTE : 6	L	RB Unit Lower Shower Flow Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING7				267		// NOTE : 6	L	RB Unit Upper Shower Flow Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING8				268		// NOTE : 6	L	RB Unit MJ1 DI Flow Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING9				269		// NOTE : 6	L	FR Unit MJ3 DI Flow Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING10				270		// NOTE : 6	L	RB Unit MJ1 CDA Press Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING11				271		// NOTE : 6	L	RB Unit MJ1 CDA Flow Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING12				272		// NOTE : 6	L	FR Unit MJ2 CDA Flow Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING13				273		// NOTE : 6	L	FR Unit MJ3 CDA Flow Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING14				274		// NOTE : 6	L	FR Unit MJ4 CDA Flow Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING15				275		// NOTE : 6	L	FR Unit Exhaust1 Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING16				276		// NOTE : 6	L	FR Unit Exhaust2 Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING17				277		// NOTE : 6	L	FR Unit MJ2 CDA Press Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING18				278		// NOTE : 6	L	FR Unit MJ3 CDA Press Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING19				279		// NOTE : 6	L	FR Unit MJ4 CDA Press Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING20				280		// NOTE : 6	L	FR Unit MJ Lower Shower Flow Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING21				281		// NOTE : 6	L	FR Unit MJ4 DI Flow Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING22				282		// NOTE : 6	L	FR Unit AQA1 Shower Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING23				283		// NOTE : 6	L	FR Unit Lower Shower Flow Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING24				284		// NOTE : 6	L	FR Unit AQA2 Shower Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING25				285		// NOTE : 6	L	FR Unit Tank DI Resister Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING26				286		// NOTE : 6	L	FR Unit DI Resister Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING27				287		// NOTE : 6	L	AK Unit Upper Exhaust1 Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING28				288		// NOTE : 6	L	AK Unit Upper Exhaust2 Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING29				289		// NOTE : 6	L	AK Unit Lower Exhaust Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING30				290		// NOTE : 6	L	AK Unit Lower AK CDA Press Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING31				291		// NOTE : 6	L	AK Unit Upper AK CDA Press Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING32				292		// NOTE : 6	L	AK Unit Lower AK CDA Flow Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING33				293		// NOTE : 6	L	AK Unit Upper AK CDA Flow Lower Limit Warning
#define ALM_GAUGE_LOWER_WARNING34				294		// NOTE : 6	L	Driving CDA Pressure Lower Limit Warning

#define ALM_GAUGE_UPPER_ALARM1					301		// NOTE : 2	S	EUV Unit ACID Exhaust Press Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM2					302		// NOTE : 2	S	RB Unit A/C CDA Flow Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM3					303		// NOTE : 2	S	RB Unit A/C CDA Press Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM4					304		// NOTE : 2	S	RB Unit Exhaust 1 Press Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM5					305		// NOTE : 2	S	RB Unit Exhaust 2 Press Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM6					306		// NOTE : 2	S	RB Unit Lower Shower Flow Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM7					307		// NOTE : 2	S	RB Unit Upper Shower Flow Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM8					308		// NOTE : 2	S	RB Unit MJ1 DI Flow Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM9					309		// NOTE : 2	S	FR Unit MJ3 DI Flow Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM10					310		// NOTE : 2	S	RB Unit MJ1 CDA Press Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM11					311		// NOTE : 2	S	RB Unit MJ1 CDA Flow Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM12					312		// NOTE : 2	S	FR Unit MJ2 CDA Flow Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM13					313		// NOTE : 2	S	FR Unit MJ3 CDA Flow Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM14					314		// NOTE : 2	S	FR Unit MJ4 CDA Flow Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM15					315		// NOTE : 2	S	FR Unit Exhaust1 Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM16					316		// NOTE : 2	S	FR Unit Exhaust2 Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM17					317		// NOTE : 2	S	FR Unit MJ2 CDA Press Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM18					318		// NOTE : 2	S	FR Unit MJ3 CDA Press Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM19					319		// NOTE : 2	S	FR Unit MJ4 CDA Press Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM20					320		// NOTE : 2	S	FR Unit MJ Lower Shower Flow Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM21					321		// NOTE : 2	S	FR Unit MJ4 DI Flow Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM22					322		// NOTE : 2	S	FR Unit AQA1 Shower Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM23					323		// NOTE : 2	S	FR Unit Lower Shower Flow Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM24					324		// NOTE : 2	S	FR Unit AQA2 Shower Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM25					325		// NOTE : 2	S	FR Unit Tank DI Resister Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM26					326		// NOTE : 2	S	FR Unit DI Resister Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM27					327		// NOTE : 2	S	AK Unit Upper Exhaust1 Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM28					328		// NOTE : 2	S	AK Unit Upper Exhaust2 Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM29					329		// NOTE : 2	S	AK Unit Lower Exhaust Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM30					330		// NOTE : 2	S	AK Unit Lower AK CDA Press Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM31					331		// NOTE : 2	S	A/K Unit Upper AK CDA Press Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM32					332		// NOTE : 2	S	AK Unit Lower AK CDA Flow Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM33					333		// NOTE : 2	S	AK Unit Upper AK CDA Flow Upper Limit Alarm
#define ALM_GAUGE_UPPER_ALARM34					334		// NOTE : 2	S	Driving CDA Pressure Upper Limit Alarm

#define ALM_GAUGE_UPPER_WARNING1				341		// NOTE : 6	L	EUV Unit ACID Exhaust Press Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING2				342		// NOTE : 6	L	RB Unit A/C CDA Flow Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING3				343		// NOTE : 6	L	RB Unit A/C CDA Press Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING4				344		// NOTE : 6	L	RB Unit Exhaust 1 Press Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING5				345		// NOTE : 6	L	RB Unit Exhaust 2 Press Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING6				346		// NOTE : 6	L	RB Unit Lower Shower Flow Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING7				347		// NOTE : 6	L	RB Unit Upper Shower Flow Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING8				348		// NOTE : 6	L	RB Unit MJ1 DI Flow Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING9				349		// NOTE : 6	L	FR Unit MJ3 DI Flow Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING10				350		// NOTE : 6	L	RB Unit MJ1 CDA Press Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING11				351		// NOTE : 6	L	RB Unit MJ1 CDA Flow Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING12				352		// NOTE : 6	L	FR Unit MJ2 CDA Flow Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING13				353		// NOTE : 6	L	FR Unit MJ3 CDA Flow Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING14				354		// NOTE : 6	L	FR Unit MJ4 CDA Flow Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING15				355		// NOTE : 6	L	FR Unit Exhaust1 Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING16				356		// NOTE : 6	L	FR Unit Exhaust2 Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING17				357		// NOTE : 6	L	FR Unit MJ2 CDA Press Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING18				358		// NOTE : 6	L	FR Unit MJ3 CDA Press Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING19				359		// NOTE : 6	L	FR Unit MJ4 CDA Press Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING20				360		// NOTE : 6	L	FR Unit MJ Lower Shower Flow Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING21				361		// NOTE : 6	L	FR Unit MJ4 DI Flow Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING22				362		// NOTE : 6	L	FR Unit AQA1 Shower Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING23				363		// NOTE : 6	L	FR Unit Lower Shower Flow Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING24				364		// NOTE : 6	L	FR Unit AQA2 Shower Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING25				365		// NOTE : 6	L	FR Unit Tank DI Resister Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING26				366		// NOTE : 6	L	FR Unit DI Resister Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING27				367		// NOTE : 6	L	Ak Unit Upper Exhaust1 Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING28				368		// NOTE : 6	L	AK Unit Upper Exhaust2 Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING29				369		// NOTE : 6	L	AK Unit Lower Exhaust Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING30				370		// NOTE : 6	L	AK Unit Lower AK CDA Press Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING31				371		// NOTE : 6	L	AK Unit Upper AK CDA Press Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING32				372		// NOTE : 6	L	AK Unit Lower AK CDA Flow Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING33				373		// NOTE : 6	L	AK Unit Upper AK CDA Flow Upper Limit Warning
#define ALM_GAUGE_UPPER_WARNING34				374		// NOTE : 6	L	Driving CDA Pressure Upper Limit Warning

#define ALM_AK_FLOW_DEVIATION					380		// NOTE : 2	S	AK Flow Deviation Alarm

#define ALM_COVER_OPEN1							381		// NOTE : 2	S	RB Bath Cover 1 Open Alarm
#define ALM_COVER_OPEN2							382		// NOTE : 2	S	RB Bath Cover 2 Open Alarm
#define ALM_COVER_OPEN3							383		// NOTE : 2	S	FR Bath Cover 1 Open Alarm
#define ALM_COVER_OPEN4							384		// NOTE : 2	S	FR Bath Cover 2 Open Alarm
#define ALM_COVER_OPEN5							385		// NOTE : 2	S	AK Bath Cover 1 Open Alarm
#define ALM_COVER_OPEN6							386		// NOTE : 2	S	AK Bath Cover 2 Open Alarm

#define ALM_DOOR_OPEN1							391		// NOTE : 2	S	LD Unit Middle Front Door Open Alarm	
#define ALM_DOOR_OPEN2							392		// NOTE : 2	S	LD Unit Lower Front Door Open Alarm	
#define ALM_DOOR_OPEN3							393		// NOTE : 2	S	LD Unit Middle Rear Door Open Alarm	
#define ALM_DOOR_OPEN4							394		// NOTE : 2	S	LD Unit Lower Rear Door Open Alarm	
#define ALM_DOOR_OPEN6							395		// NOTE : 2	S	EUV Unit Middle Front Door Open Alarm	
#define ALM_DOOR_OPEN7							396		// NOTE : 2	S	EUV Unit Middle Rear Door Open Alarm	
#define ALM_DOOR_OPEN8							397		// NOTE : 2	S	UL Unit Middle Front Door Open Alarm	
#define ALM_DOOR_OPEN9							398		// NOTE : 2	S	UL Unit Lower Front Door Open Alarm		
#define ALM_DOOR_OPEN10							399		// NOTE : 2	S	UL Unit Middle Rear Door Open Alarm
#define ALM_DOOR_OPEN11							400		// NOTE : 2	S	UL Unit Lower Rear Door Open Alarm
#define ALM_DOOR_OPEN12							401		// NOTE : 2	S	LD Upper Unit Front Door Open Alarm	
#define ALM_DOOR_OPEN13							402		// NOTE : 2	S	LD Upper Unit Rear Door Open Alarm	
#define ALM_DOOR_OPEN14							403		// NOTE : 2	S	EUV Upper Unit Front Door Open Alar	
#define ALM_DOOR_OPEN15							404		// NOTE : 2	S	EUV Upper Unit Rear Door Open Alarm	
#define ALM_DOOR_OPEN16							405		// NOTE : 2	S	RB Upper Unit Front Door Open Alar	
#define ALM_DOOR_OPEN17							406		// NOTE : 2	S	RB Upper Unit Rear Door Open Alarm
#define ALM_DOOR_OPEN18							407		// NOTE : 2	S	FR Upper Unit Front Door Open Alarm
#define ALM_DOOR_OPEN19							408		// NOTE : 2	S	FR Upper Unit Rear Door Open Alarm	
#define ALM_DOOR_OPEN20							409		// NOTE : 2	S	AK Upper Unit Front Door Open Alarm
#define ALM_DOOR_OPEN21							410		// NOTE : 2	S	AK Upper Unit Rear Door Open Alarm
#define ALM_DOOR_OPEN22							411		// NOTE : 2	S	UL Upper Unit Front Door Open Alarm
#define ALM_DOOR_OPEN23							412		// NOTE : 2	S	UL Upper Unit Rear Door Open Alarm

#define ALM_LEAK1								421		// NOTE : 2	S	EUV Unit Leak OP alarm
#define ALM_LEAK2								422		// NOTE : 2	S	EUV Unit Leak MT alarm
#define ALM_LEAK3							    423		// NOTE : 2	S	RB Bath Leak OP alarm
#define ALM_LEAK4							    424		// NOTE : 2	S	RB Bath Leak MT alarm
#define ALM_LEAK5								425		// NOTE : 2	S	FR Bath Leak OP alarm
#define ALM_LEAK6								426		// NOTE : 2	S	FR Bath Leak MT alarm
#define ALM_LEAK7								427		// NOTE : 2	S	AK Bath Leak OP alarm
#define ALM_LEAK8								428		// NOTE : 2	S	AK Bath Leak MT alarm

#define ALM_CV_MOTOR_DRIVER_ALARM1				431		// NOTE : 2	S	LD UP Unit C/V FBL Motor Alarm
#define ALM_CV_MOTOR_DRIVER_ALARM2				432		// NOTE : 2	S	BUF1 Unit C/V FBL Motor Alarm
#define ALM_CV_MOTOR_DRIVER_ALARM3				433		// NOTE : 2	S	BUF2 Unit C/V FBL Motor Alarm
#define ALM_CV_MOTOR_DRIVER_ALARM4				434		// NOTE : 2	S	BUF3 Unit C/V FBL Motor Alarm
#define ALM_CV_MOTOR_DRIVER_ALARM5				435		// NOTE : 2	S	LD Unit C/V FBL Motor Alarm
#define ALM_CV_MOTOR_DRIVER_ALARM6				436		// NOTE : 2	S	EUV Unit C/V FBL Motor Alarm
#define ALM_CV_MOTOR_DRIVER_ALARM7				437		// NOTE : 2	S	RB Unit C/V FBL Motor Alarm
#define ALM_CV_MOTOR_DRIVER_ALARM8				438		// NOTE : 2	S	FR Unit C/V FBL Motor Alarm
#define ALM_CV_MOTOR_DRIVER_ALARM9				439		// NOTE : 2	S	AK Unit C/V FBL Motor Alarm
#define ALM_CV_MOTOR_DRIVER_ALARM10				440		// NOTE : 2	S	UL Unit C/V FBL Motor Alarm

#define ALM_CV_MOTOR_CP_OFF1					441		// NOTE : 2	S	LD UP Unit C/V FBL C/P Down
#define ALM_CV_MOTOR_CP_OFF2					442		// NOTE : 2	S	BUF1 Unit C/V FBL C/P Down
#define ALM_CV_MOTOR_CP_OFF3					443		// NOTE : 2	S	BUF2 Unit C/V FBL C/P Down
#define ALM_CV_MOTOR_CP_OFF4					444		// NOTE : 2	S	BUF3 Unit C/V FBL C/P Down
#define ALM_CV_MOTOR_CP_OFF5					445		// NOTE : 2	S	LD Unit C/V FBL C/P Down
#define ALM_CV_MOTOR_CP_OFF6					446		// NOTE : 2	S	EUV Unit C/V FBL C/P Down
#define ALM_CV_MOTOR_CP_OFF7					447		// NOTE : 2	S	RB Unit C/V FBL C/P Down
#define ALM_CV_MOTOR_CP_OFF8					448		// NOTE : 2	S	FR Unit C/V FBL C/P Down
#define ALM_CV_MOTOR_CP_OFF9					449		// NOTE : 2	S	AK Unit C/V FBL C/P Down
#define ALM_CV_MOTOR_CP_OFF10					450		// NOTE : 2	S	UL Unit C/V FBL C/P Down

#define ALM_RB_FBL_MOTOR_DRIVER_ALARM1			451		// NOTE : 2	S	RB Unit RB1 Upper FBL Motor Alarm
#define ALM_RB_FBL_MOTOR_DRIVER_ALARM2			452		// NOTE : 2	S	RB Unit RB1 Lower FBL Motor Alarm
#define ALM_RB_FBL_MOTOR_DRIVER_ALARM3			453		// NOTE : 2	S	RB Unit RB2 Upper FBL Motor Alarm
#define ALM_RB_FBL_MOTOR_DRIVER_ALARM4			454		// NOTE : 2	S	RB Unit RB2 Lower FBL Motor Alarm

#define ALM_RB_FBL_MOTOR_CP_OFF1				455		// NOTE : 2	S	RB Unit R/B1 Upper FBL Motor C/P Off
#define ALM_RB_FBL_MOTOR_CP_OFF2				456		// NOTE : 2	S	RB Unit R/B1 Lower FBL Motor C/P Off
#define ALM_RB_FBL_MOTOR_CP_OFF3				457		// NOTE : 2	S	RB Unit R/B2 Upper FBL Motor C/P Off
#define ALM_RB_FBL_MOTOR_CP_OFF4				458		// NOTE : 2	S	RB Unit R/B2 Lower FBL Motor C/P Off

#define ALM_LD_UNIT_BROKEN_SENSOR1				461		// NOTE : 2	S	LD UP Unit Glass Broken 1 Alarm
#define ALM_LD_UNIT_BROKEN_SENSOR2				462		// NOTE : 2	S	LD UP Unit Glass Broken 2 Alarm
#define ALM_LD_UNIT_BROKEN_SENSOR3				463		// NOTE : 2	S	LD UP Unit Glass Broken 3 Alarm
#define ALM_LD_UNIT_BROKEN_SENSOR4				464		// NOTE : 2	S	LD UP Unit Glass Broken 4 Alarm

#define ALM_LD_UNIT_SCAN_SENSOR					465		// NOTE : 2	S	LD Unit Glass Scan Broken Alarm 
#define ALM_UL_UNIT_SCAN_SENSOR					466		// NOTE : 2	S	UL Unit Glass Scan Broken Alarm
//#define ALM_BUF3_UNIT_SCAN_SENSOR				467		// NOTE : 2	S	BUF3 Unit Glass Scan Broken Alarm 
#define ALM_UL_UNIT_CCD_SENSOR					468		// NOTE : 2	S	UL Unit CCD Sensor Alarm 

#define ALM_DI_PUMP_ALARM1						470		// NOTE : 2	S	FR Unit DI Pump Alarm

#define ALM_DI_PUMP1_INTERLOCK_ALARM			475		// NOTE : 2	S	DI Pump Interlock Alarm

#define ALM_DI_TANK1_LV_SENSOR_ALARM1			480		// NOTE : 2	S	DI Tank1 LL Level Fault Alarm
#define ALM_DI_TANK1_LV_SENSOR_ALARM2			481		// NOTE : 2	S	DI Tank1 L Level Fault Alarm
#define ALM_DI_TANK1_LV_SENSOR_ALARM3			482		// NOTE : 2	S	DI Tank1 M Level Fault Alarm
#define ALM_DI_TANK1_LV_SENSOR_ALARM4			483		// NOTE : 2	S	DI Tank1 H Level Fault Alarm

#define ALM_RB_UNIT_UP_RB1_SERVO_ALARM			485		// NOTE : 2	S	RB Unit Upper R/B1 Servo Motor Alarm
#define ALM_RB_UNIT_LO_RB1_SERVO_ALARM			486		// NOTE : 2	S	RB Unit Lower R/B1 Servo Motor Alarm
#define ALM_RB_UNIT_UP_RB2_SERVO_ALARM			487		// NOTE : 2	S	RB Unit Upper R/B2 Servo Motor Alarm
#define ALM_RB_UNIT_LO_RB2_SERVO_ALARM			488		// NOTE : 2	S	RB Unit Lower R/B2 Servo Motor Alarm
#define ALM_RB_UNIT_UP_RB1_SERVO_HOME			489		// NOTE : 2	S	RB Unit Upper R/B1 Unit Servo Homing Alarm
#define ALM_RB_UNIT_LO_RB2_SERVO_HOME			490		// NOTE : 2	S	RB Unit Lower R/B1 Unit Servo Homing Alarm
#define ALM_RB_UNIT_UP_RB3_SERVO_HOME			491		// NOTE : 2	S	RB Unit Upper R/B2 Unit Servo Homing Alarm
#define ALM_RB_UNIT_LO_RB4_SERVO_HOME			492		// NOTE : 2	S	RB Unit Lower R/B2 Unit Servo Homing Alarm
#define ALM_RB_UNIT_UP_RB1_SERVO_MOVE_POS		493		// NOTE : 2	S	RB Unit Upper R/B1 Unit Servo Moving Alarm
#define ALM_RB_UNIT_LO_RB1_SERVO_MOVE_POS		494		// NOTE : 2	S	RB Unit Lower R/B1 Unit Servo Moving Alarm
#define ALM_RB_UNIT_UP_RB2_SERVO_MOVE_POS		495		// NOTE : 2	S	RB Unit Upper R/B2 Unit Servo Moving Alarm
#define ALM_RB_UNIT_LO_RB2_SERVO_MOVE_POS		496		// NOTE : 2	S	RB Unit Lower R/B2 Unit Servo Moving Alarm

#define ALM_LD_UPDN_UNIT_SERVO_RESET			500		// NOTE : 2	S	LD Up/Dn Unit Servo Reset Alarm
#define ALM_LD_UPDN_UNIT_MOVE_HOME				501		// NOTE : 2	S	LD Up/Dn Unit Homing Alarm
#define ALM_LD_UPDN_UNIT_MOVE_POS_RECV			502		// NOTE : 2	S	LD Up/Dn Unit WAIT Pos. Moving Alarm
#define ALM_LD_UPDN_UNIT_MOVE_POS_SEND			503		// NOTE : 2	S	LD Up/Dn Unit BEFORE RECV Pos. Moving Alarm
#define ALM_LD_UPDN_UNIT_MOVE_POS_HOME_SENSOR	504		// NOTE : 2	S	LD Up/Dn Unit HOME Pos. Moving Alarm(Sensor)
#define ALM_LD_UPDN_UNIT_MOVE_POS_RECV_SENSOR	505		// NOTE : 2	S	LD Up/Dn Unit RECV1 Pos. Moving Alarm(Sensor)
#define ALM_LD_UPDN_UNIT_MOVE_POS_SEND_SENSOR	506		// NOTE : 2	S	LD Up/Dn Unit RECV2 Pos. Moving Alarm(Sensor)
#define ALM_LD_UPDN_UNIT_POS_SENSOR_NOT_DETECT  507     // NOTE : 2	S	LD Up/Dn Unit Position Sensor Not Detect Alarm(Sensor)


#define ALM_UL_HAND_UNIT_SERVO_RESET					510		// NOTE : 2	S	UL Hand Unit Servo Reset Alarm
#define ALM_UL_HAND_UNIT_MOVE_HOME						511		// NOTE : 2	S	UL Hand Unit Homing Alarm
#define ALM_UL_HAND_UNIT_MOVE_POS_BEFORE_RECV			512		// NOTE : 2	S	UL Hand Unit Before RECV Pos. Moving Alarm
#define ALM_UL_HAND_UNIT_MOVE_POS_AFTER_RECV			513		// NOTE : 2	S	UL Hand Unit After RECV Pos. Moving Alarm
#define ALM_UL_HAND_UNIT_MOVE_POS_SEND					514		// NOTE : 2	S	UL Hand Unit Send Pos. Moving Alarm
#define ALM_UL_HAND_UNIT_MOVE_POS_HOME_SENSOR			515		// NOTE : 2	S	UL Hand Unit HOME Pos. Moving Alarm(Sensor)
#define ALM_UL_HAND_UNIT_MOVE_POS_BEFORE_RECV_SENSOR	516		// NOTE : 2	S	UL Hand Unit Before RECV Pos. Moving Alarm(Sensor)
#define ALM_UL_HAND_UNIT_MOVE_POS_AFTER_RECV_SENSOR		517		// NOTE : 2	S	UL Hand Unit After RECV Pos. Moving Alarm(Sensor)
#define ALM_UL_HAND_UNIT_MOVE_POS_SEND_SENSOR			518		// NOTE : 2	S	UL Hand Unit Send Pos. Moving Alarm(Sensor)
#define ALM_UL_HAND_UNIT_POS_SENSOR_NOT_DETECT			519     // NOTE : 2	S	UL Hand Unit Position Sensor Not Detect Alarm(Sensor)

#define ALM_UL_HAND_UNIT_CYL_FW					520		// NOTE : 2	S	UL Hand Unit Cylinder FW Alarm
#define ALM_UL_HAND_UNIT_CYL_BW					521		// NOTE : 2	S	UL Hand Unit Cylinder BW Alarm

#define ALM_UP_LD_GLS_NOT_EXIST_AFTER_RECV		525		// NOTE : 2	S	UP LD Unit Glass is Not Exist After Receive
#define ALM_UP_LD_GLS_EXIST_BEFORE_RECV			526		// NOTE : 2	S	UP LD Unit Glass is Exist Before Receive
#define ALM_UL_HAND_GLS_EXIST_AFTER_SEND		527		// NOTE : 2	S	UL Hand Unit Glass is Exist After Send
#define ALM_UL_HAND_GLS_NOT_EXIST_AFTER_RECV	528		// NOTE : 2	S	UL Hand Unit Glass is Not Exist After Receive

#define ALM_LD_UPDN_UNIT_TILT_UP				530		// NOTE : 2	S	LD Up/Dn Unit Tilt Up Alarm
#define ALM_LD_UPDN_UNIT_TILT_DN				531		// NOTE : 2	S	LD Up/Dn Unit Tilt Down Alarm

#define ALM_UL_UNIT_TILT_UP						532		// NOTE : 2	S	UL Hand Unit Tilt Up Alarm
#define ALM_UL_UNIT_TILT_DN						533		// NOTE : 2	S	UL Hand Unit Tilt Down Alarm

#define ALM_UP_LD_UNIT_ALIGN_FW					535		// NOTE : 2	S	LD C/V Unit Align Forward Alarm
#define ALM_UP_LD_UNIT_ALIGN_BW					536		// NOTE : 2	S	LD C/V Unit Align Backward Alarm

#define ALM_PARTS_LIFE_TIME_OVER1				539		// NOTE : 6	L	RB Unit R/B1 Up Brush Life Time Over
#define ALM_PARTS_LIFE_TIME_OVER2				540		// NOTE : 6	L	RB Unit R/B1 Lo Brush Life Time Over
#define ALM_PARTS_LIFE_TIME_OVER3				541		// NOTE : 6	L	RB Unit R/B2 Up Brush Life Time Over
#define ALM_PARTS_LIFE_TIME_OVER4				542		// NOTE : 6	L	RB Unit R/B2 Lo Brush Life Time Over
#define ALM_PARTS_LIFE_TIME_OVER5				543		// NOTE : 6	L	RB Shower DI Filter 1 Life Time Over
#define ALM_PARTS_LIFE_TIME_OVER6				544		// NOTE : 6	L	FR Shower DI Filter Life Time Over
#define ALM_PARTS_LIFE_TIME_OVER7				545		// NOTE : 6	L	MJ1 CDA Filter Life Time Over
#define ALM_PARTS_LIFE_TIME_OVER8				546		// NOTE : 6	L	MJ2 CDA Filter Life Time Over
#define ALM_PARTS_LIFE_TIME_OVER9				547		// NOTE : 6	L	MJ3 CDA Filter Life Time Over
#define ALM_PARTS_LIFE_TIME_OVER10				548		// NOTE : 6	L	MJ4 CDA Filter Life Time Over

#define ALM_FFU_CP_TURN_OFF1					549		// NOTE : 2	S	LD Unit FFU 1 C/P Off
#define ALM_FFU_FAN_ALARM1						550		// NOTE : 2	S	LD Unit FFU 1 Alarm
#define ALM_FFU_CP_TURN_OFF2					551		// NOTE : 2	S	BUF3 Unit FFU C/P Off
#define ALM_FFU_FAN_ALARM2					    552		// NOTE : 2	S	BUF3 Unit FFU Alarm
#define ALM_FFU_CP_TURN_OFF3					553		// NOTE : 2	S	BUF2 Unit FFU C/P Off
#define ALM_FFU_FAN_ALARM3						554		// NOTE : 2	S	BUF2 Unit FFU Alarm
#define ALM_FFU_CP_TURN_OFF4					555		// NOTE : 2	S	UP LD Unit FFU 1 C/P Off
#define ALM_FFU_FAN_ALARM4						556		// NOTE : 2	S	UP LD Unit FFU 1 Alarm
#define ALM_FFU_CP_TURN_OFF5					557		// NOTE : 2	S	UP LD Unit FFU 2 C/P Off
#define ALM_FFU_FAN_ALARM5						558		// NOTE : 2	S	UP LD Unit FFU 2 Alarm
#define ALM_FFU_CP_TURN_OFF6					559		// NOTE : 2	S	BUF1 Unit FFU C/P Off
#define ALM_FFU_FAN_ALARM6						560		// NOTE : 2	S	BUF1 Unit FFU Alarm
#define ALM_FFU_CP_TURN_OFF7					561		// NOTE : 2	S	UL Unit FFU 1 C/P Off
#define ALM_FFU_FAN_ALARM7						562		// NOTE : 2	S	UL Unit FFU 1 Alarm
#define ALM_FFU_CP_TURN_OFF8					563		// NOTE : 2	S	UL Unit FFU 2 C/P Off
#define ALM_FFU_FAN_ALARM8						564		// NOTE : 2	S	UL Unit FFU 2 Alarm
#define ALM_FFU_CP_TURN_OFF9					565		// NOTE : 2	S	AK Unit HEPA C/P Off
#define ALM_FFU_FAN_ALARM9						566		// NOTE : 2	S	AK Unit HEPA Alarm

#define ALM_IONIZER_ALARM1						567		// NOTE : 2 S	Ionizer Contoller Alarm
#define ALM_IONIZER_ALARM2						568		// NOTE : 2 S	Ionizer Level Alarm
#define ALM_IONIZER_ALARM3						569		// NOTE : 2 S	Ionizer Condition Alarm

#define ALM_EUV_LAMP_TIME_OVER					570		// NOTE : 6	L	EUV : Lamp Used Time Over Alarm
#define ALM_EUV_LAMP_ON_FAIL					571		// NOTE : 2	S	EUV : Lamp On Fail Alarm
#define ALM_EUV_PROTECTIVE_FUNC					572		// NOTE : 2	S	EUV : Protective Function Appearance Alarm
#define ALM_EUV_ELECTRIC_CIRCUIT_ERR			573		// NOTE : 2	S	EUV : Electric Circuit Alarm
#define ALM_EUV_N2_PRESS_OVER					574		// NOTE : 2	S	EUV : EUV N2 Pressure Over Alarm
#define ALM_EUV_LAMP_HOUSE_OVERHEAT				575		// NOTE : 2	S	EUV : EUV Lamp House Overheat Alarm
#define ALM_EUV_HOUSE_OPEN						576		// NOTE : 2	S	EUV : EUV Lamp House Open Alarm
#define ALM_EUV_TRANSFORMER_OVERHEAT			577		// NOTE : 2	S	EUV : Step-up Transformer Overheat Alarm
#define ALM_EUV_N2_PRESS_DROP					578		// NOTE : 2	S	EUV : EUV N2 Pressure Drop Alarm
#define ALM_EUV_ELECTRIC_CIRCUIT_COVER_OPEN		579		// NOTE : 2	S	EUV : Electric Circuit Cover Open Alarm
#define ALM_EUV_CONTROL_SYSTEM_ERR				580		// NOTE : 2 S	EUV : Control System Error
#define ALM_EUV_UNIT_EMO						581		// NOTE : 2 S	EUV : EUV Unit EMO
#define ALM_EUV_HUMIDIFIER_ERR					582		// NOTE : 2 S	EUV : Humidifier Abnormal State Alarm

#define ALM_EUV_LAMP1_TIME_OVER					585		// NOTE : 6	L	EUV : Lamp1 Time Over Alarm
#define ALM_EUV_LAMP2_TIME_OVER					586		// NOTE : 6	L	EUV : Lamp2 Time Over Alarm
#define ALM_EUV_LAMP3_TIME_OVER					587		// NOTE : 6	L	EUV : Lamp3 Time Over Alarm
#define ALM_EUV_LAMP4_TIME_OVER					588		// NOTE : 6	L	EUV : Lamp4 Time Over Alarm

#define ALM_EUV_NOT_READY						590		// NOTE : 2 S	EUV : Not Ready Alarm
#define ALM_EUV_MANUAL							591		// NOTE : 2 S	EUV : EUV Local Mode Alarm 
#define ALM_HUMIDIFIER_NOT_READY				592		// NOTE : 2 S	EUV : Humidifier Not Ready Alarm
#define ALM_EUV_COMM_OPEN_ERROR					593		// NOTE : 6 L	EUV : EUV COM Port Open Alarm
#define ALM_EUV_HOUSE_CLOSE						594		// NOTE : 2	S	EUV : EUV House not closed Alarm

#define ALM_EUV_UNIT_HUMIDIFIER_N2_LEVEL_L		600		// NOTE : 2 S	EUV : Humidifier N2 Level Low Alarm
#define ALM_EUV_UNIT_BOX_N2_LEVEL_L				601		// NOTE : 2 S	EUV : Box N2 Level Low Alarm
#define ALM_EUV_UNIT_LAMP_N2_LEVEL_L			602		// NOTE : 2 S	EUV : Lamp N2 Level Low Alarm
#define ALM_EUV_UNIT_CDA_LEVEL_L		    	603		// NOTE : 2 S	EUV : CDA Level Low Alarm

#define ALM_EUV_UNIT_N2_LOW_LEVEL				604		// NOTE : 2	S	N2 Low Level Alarm
#define ALM_EUV_UNIT_PCW_LOW_LEVEL				605		// NOTE : 2	S	PCW Low Level Alarm
#define ALM_EUV_UNIT_CDA_LOW_LEVEL				606	    // NOTE : 2	S	CDA Low Level Alarm

#define ALM_AP_FL_1_AP_FAIL						610		// NOTE : 2 S	FL-1 AP Fail
#define ALM_AP_FL_2_AP_FAIL						611		// NOTE : 2 S	FL-2 AP Fail
#define ALM_AP_FL_3_AP_FAIL						612		// NOTE : 2 S	FL-3 AP Fail
#define ALM_AP_FL_5_AP_FAIL						613		// NOTE : 2 S	FL-5 AP Fail
#define ALM_AP_FL_7_AP_FAIL						614		// NOTE : 2 S	FL-7 AP Fail
#define ALM_AP_LOCAL_MODE_POWER_SUPPLY			615		// NOTE : 2 S	Local mode (Power supply)

#define ALM_AP_FL_6_AP_FAIL						616		// NOTE : 2 S	FL-6 AP Fail

#define ALM_AP_POWER_UNIT_NOT_READY				620		// NOTE : 2 S	Power unit not ready
#define ALM_AP_N2_PRESS_LOW						621		// NOTE : 2 S	N2 pressure low	(No Supply)
#define ALM_AP_CDA_PRESS_LOW					622		// NOTE : 2 S	CDA Pressure low (No Supply)
#define ALM_AP_PCW_PRESS_LOW					623		// NOTE : 2 S	PCW Pressure low (No Supply)
#define ALM_AP_PCW_FLOW_LOW						624		// NOTE : 2 S	PCW Flow low (No Supply)
#define ALM_AP_N2_FLOW_INSTABLE					625		// NOTE : 2 S	N2 Flow Instable
#define ALM_AP_CDA_FLOW_INSTABLE				626		// NOTE : 2 S	CDA Flow Instable
#define ALM_AP_EMERGENCY_STOP					627		// NOTE : 2 S	Emergency stop
#define ALM_AP_POWER_INSTABLE					628		// NOTE : 2 S	AP Power Instable

#define ALM_AP_PLASMA_MONITOR_WARNING			629		// NOTE : 2 S	Plasma monitor warning
#define ALM_AP_PLASMA_MONITOR_ALARM				630		// NOTE : 2	L	Plasma monitor Alarm
#define ALM_AP_STATUS0			    			631		// NOTE : 2	S	AP State Alarm : Interlock Open 
#define ALM_AP_POWER_INSTABLE2					632		// NOTE : 2	S	AP Power Instable2
#define ALM_AP_PLASMA_HOUSE_OPEN				633		// NOTE : 2	S	Plasma unit house Open Alarm
#define ALM_HPMJ_UNIT_ESTOP						634		// NOTE : 0	L	Spare

#define ALM_ROBOT_HAND_INTERRUPT				635		// NOTE : 2	S	Loader Robot Hand Interrupt Alarm

#define ALM_GLS_DATA_WRONG						640		// NOTE : 2	S	Receive Glass Data Wrong
#define ALM_CIM_T3_TIMEOUT					    645		// NOTE : 6 L	T3 Timeout Error	
#define ALM_CIM_T9_TIMEOUT					    646		// NOTE : 6 L	T9 Timeout Error	
#define ALM_AFTER_LOADING_GLS_NOT_EXIST			647		// NOTE : 2	S	Glass is Not Exist After Loading
#define ALM_AFTER_UNLOADING_GLS_EXIST		    648		// NOTE : 2	S	Glass is Exist After Unloading

#define ALM_GLASS_RECEIVE_ERROR1				650		// NOTE : 2	S	Glass Receiving Abnormal state Alarm(Loading)
#define ALM_GLASS_SEND_ERROR1					655		// NOTE : 2	S	Glass Sending Abnormal state Alarm(Unloading)
#define ALM_GLASS_SEND_ERROR2					656		// NOTE : 2	S	Glass is not Exist Before Unloading(Unloading)
#define ALM_GLASS_SEND_ERROR3					657		// NOTE : 2	S	UL Hand Unit is no glass but Data remain(Unloading)

#define ALM_LOADER_LOADING_T1					660		// NOTE : 2	S	[Loading] Transfer Ready to Cleaner not Turn ON
#define ALM_LOADER_LOADING_T3					661		// NOTE : 2	S	[Loading] Robot Accessing to Cleaner not Turn ON
#define ALM_LOADER_LOADING_T4					662		// NOTE : 2	S	[Loading] Robot Accessing to Cleaner not Turn OFF
#define ALM_LOADER_LOADING_T6					663		// NOTE : 2	S	[Loading] Cleaner Received Data Read Req. not Turn ON
#define ALM_LOADER_LOADING_T8					664		// NOTE : 2	S	[Loading] Cleaner Received Data Read Req. not Turn OFF
#define ALM_LOADER_UNLOADING_T1					665		// NOTE : 2	S	[Unloading] Transfer Ready to Cleaner not Turn ON
#define ALM_LOADER_UNLOADING_T3					666		// NOTE : 2	S	[Unloading] Robot Accessing to Cleaner not Turn ON
#define ALM_LOADER_UNLOADING_T4					667		// NOTE : 2	S	[Unloading] Robot Accessing to Cleaner not Turn OFF
#define ALM_LOADER_UNLOADING_T6					668		// NOTE : 2	S	[Unloading] Cleaner Received Data Read Comp. not Turn ON
#define ALM_LOADER_UNLOADING_T8					669		// NOTE : 2	S	[Unloading] Cleaner Received Data Read Comp. not Turn OFF

#define ALM_RBT_AMP_FAULT_ERROR1				670		// NOTE : 2	S	Loader Amp Fault Error
#define ALM_DATA_READ_REQUEST_TIMEOUT			671		// NOTE : 2	S   Data Read Request Timeout Error

#define ALM_SEQUENCE_DELAY						680	    // NOTE : 6	L	Sequence Delay Warning

//BEGIN
#define MAX_ALARM_NO							920
#endif	// _DEFINEALARM_H
//END

