//BEGIN
#ifndef _DEFINEALARM_H
#define _DEFINEALARM_H
//END
///////////////////////////////////////////////////////////////////////////
//// AlarmID	// NOTE : AlarmCode	(tab) Level	(tab) AlarmText
///////////////////////////////////////////////////////////////////////////

#define ALM_EMO1									1		// NOTE : 2	S	EMO Alarm1 (LD OP EMO)
#define ALM_EMO2									2		// NOTE : 2	S	EMO Alarm2 (LD MID OP EMO)
#define ALM_EMO3									3		// NOTE : 2	S	EMO Alarm3 (LD MID MT EMO)
#define ALM_EMO4									4		// NOTE : 2	S	EMO Alarm4 (LD LO MT EMO)
#define ALM_EMO5									5		// NOTE : 2	S	EMO Alarm5 (SWR4 LO MT EMO)
#define ALM_EM06									6		// NOTE : 2	S	EMO Alarm6 (SWR4 MD MT EMO)
#define ALM_EM07									7		// NOTE : 2	S	EMO Alarm7 (AK MID OP EMO)
#define ALM_EM08									8		// NOTE : 2	S	EMO Alarm8 (AK LO OP EMO)
#define ALM_EM09									9		// NOTE : 2	S	EMO Alarm9 (UL LO MT EMO)
#define ALM_EM10									10		// NOTE : 2	S	EMO Alarm10 (UL MID MT EMO)
//#define ALM_SPARE									11		// NOTE : 0	L	SPARE	
#define ALM_LOADER_EMO1								12		// NOTE : 2	S	LOADER Robot Alarm
#define ALM_UNLOADER_EMO2							13		// NOTE : 2	S	UNLOADER Robot Alarm
//#define ALM_SPARE									14		// NOTE : 0	L	SPARE
//#define ALM_SPARE									15		// NOTE : 0	L	SPARE
#define ALM_POWER_OFF								16		// NOTE : 2	S	Power ON Switch OFF
//#define ALM_SPARE									17		// NOTE : 0	L	SPARE
//#define ALM_SPARE									18		// NOTE : 0	L	SPARE
#define ALM_EMS1									19		// NOTE : 2	S	OP PANLE EMS ALARM
//#define ALM_SPARE									20		// NOTE : 0	L	SPARE
//#define ALM_SPARE									21		// NOTE : 0	L	SPARE
#define ALM_GLASS_SENSING1							22		// NOTE : 2	S	INCV UNIT GLASS SENSING ALARM
#define ALM_GLASS_SENSING2							23		// NOTE : 2	S	SWR1 UNIT GLASS SENSING ALARM
#define ALM_GLASS_SENSING3							24		// NOTE : 2	S	SWR2 UNIT GLASS SENSING ALARM
#define ALM_GLASS_SENSING4							25		// NOTE : 2	S	SWR3 UNIT GLASS SENSING ALARM
#define ALM_GLASS_SENSING5							26		// NOTE : 2	S	SWR4 UNIT GLASS SENSING ALARM
#define ALM_GLASS_SENSING6							27		// NOTE : 2	S	AK UNIT GLASS SENSING ALARM
#define ALM_GLASS_SENSING7							28		// NOTE : 2	S	BUF UNIT GLASS SENSING ALARM
#define ALM_GLASS_SENSING8							29		// NOTE : 2	S	OUTCV UNIT GLASS SENSING ALARM
//#define ALM_SPARE									30		// NOTE : 0	L	SPARE
//#define ALM_SPARE									31		// NOTE : 0	L	SPARE
//#define ALM_SPARE									32		// NOTE : 0	L	SPARE
//#define ALM_SPARE									33		// NOTE : 0	L	SPARE
//#define ALM_SPARE									34		// NOTE : 0	L	SPARE
//#define ALM_SPARE									35		// NOTE : 0	L	SPARE
//#define ALM_SPARE									36		// NOTE : 0	L	SPARE
//#define ALM_SPARE									37		// NOTE : 0	L	SPARE
//#define ALM_SPARE									38		// NOTE : 0	L	SPARE
//#define ALM_SPARE									39		// NOTE : 0	L	SPARE
//#define ALM_SPARE									40		// NOTE : 0	L	SPARE
//#define ALM_SPARE									41		// NOTE : 0	L	SPARE													
#define ALM_GLASS_DATA_ERROR1						42		// NOTE : 2	S	INCV UNIT GLASS DATA ALARM
#define ALM_GLASS_DATA_ERROR2						43		// NOTE : 2	S	SWR1 UNIT GLASS DATA ALARM
#define ALM_GLASS_DATA_ERROR3						44		// NOTE : 2	S	SWR2 UNIT GLASS DATA ALARM
#define ALM_GLASS_DATA_ERROR4						45		// NOTE : 2	S	SWR3 UNIT GLASS DATA ALARM
#define ALM_GLASS_DATA_ERROR5						46		// NOTE : 2	S	SWR4 UNIT GLASS DATA ALARM
#define ALM_GLASS_DATA_ERROR6						47		// NOTE : 2	S	AK UNIT GLASS DATA ALARM
#define ALM_GLASS_DATA_ERROR7						48		// NOTE : 2	S	BUF UNIT GLASS DATA ALARM
#define ALM_GLASS_DATA_ERROR8						49		// NOTE : 2	S	OUTCV UNIT GLASS DATA ALARM
//#define ALM_SPARE									50		// NOTE : 0	L	SPARE
//#define ALM_SPARE									51		// NOTE : 0	L	SPARE
//#define ALM_SPARE									52		// NOTE : 0	L	SPARE
//#define ALM_SPARE									53		// NOTE : 0	L	SPARE
//#define ALM_SPARE									54		// NOTE : 0	L	SPARE
//#define ALM_SPARE									55		// NOTE : 0	L	SPARE
//#define ALM_SPARE									56		// NOTE : 0	L	SPARE
//#define ALM_SPARE									57		// NOTE : 0	L	SPARE
//#define ALM_SPARE									58		// NOTE : 0	L	SPARE
//#define ALM_SPARE									59		// NOTE : 0	L	SPARE
//#define ALM_SPARE									60		// NOTE : 0	L	SPARE
//#define ALM_SPARE									61		// NOTE : 0	L	SPARE
#define ALM_SENSOR_IN_ON_TIMEOUT1					62		// NOTE : 2	S	INCV UNIT IN SENSOR ON TIME ALARM
#define ALM_SENSOR_IN_ON_TIMEOUT2					63		// NOTE : 2	S	SWR1 UNIT IN SENSOR ON TIME ALARM
#define ALM_SENSOR_IN_ON_TIMEOUT3					64		// NOTE : 2	S	SWR2 UNIT IN SENSOR ON TIME ALARM
#define ALM_SENSOR_IN_ON_TIMEOUT4					65		// NOTE : 2	S	SWR3 UNIT IN SENSOR ON TIME ALARM
#define ALM_SENSOR_IN_ON_TIMEOUT5					66		// NOTE : 2	S	SWR4 UNIT IN SENSOR ON TIME ALARM
#define ALM_SENSOR_IN_ON_TIMEOUT6					67		// NOTE : 2	S	AK UNIT IN SENSOR ON TIME ALARM
#define ALM_SENSOR_IN_ON_TIMEOUT7					68		// NOTE : 2	S	BUF UNIT IN SENSOR ON TIME ALARM
#define ALM_SENSOR_IN_ON_TIMEOUT8					69		// NOTE : 2	S	OUTCV UNIT IN SENSOR ON TIME ALARM
//#define ALM_SPARE									70		// NOTE : 0	L	SPARE
//#define ALM_SPARE									71		// NOTE : 0	L	SPARE
//#define ALM_SPARE									72		// NOTE : 0	L	SPARE
//#define ALM_SPARE									73		// NOTE : 0	L	SPARE
//#define ALM_SPARE									74		// NOTE : 0	L	SPARE
//#define ALM_SPARE									75		// NOTE : 0	L	SPARE
//#define ALM_SPARE									76		// NOTE : 0	L	SPARE
//#define ALM_SPARE									77		// NOTE : 0	L	SPARE
//#define ALM_SPARE									78		// NOTE : 0	L	SPARE
//#define ALM_SPARE									79		// NOTE : 0	L	SPARE
//#define ALM_SPARE									80		// NOTE : 0	L	SPARE
//#define ALM_SPARE									81		// NOTE : 0	L	SPARE
#define ALM_SENSOR_IN_OFF_TIMEOUT1					82		// NOTE : 2	S	INCV UNIT IN SENSOR OFF TIME ALARM
#define ALM_SENSOR_IN_OFF_TIMEOUT2					83		// NOTE : 2	S	SWR1 UNIT IN SENSOR OFF TIME ALARM
#define ALM_SENSOR_IN_OFF_TIMEOUT3					84		// NOTE : 2	S	SWR2 UNIT IN SENSOR OFF TIME ALARM
#define ALM_SENSOR_IN_OFF_TIMEOUT4					85		// NOTE : 2	S	SWR3 UNIT IN SENSOR OFF TIME ALARM
#define ALM_SENSOR_IN_OFF_TIMEOUT5					86		// NOTE : 2	S	SWR4 UNIT IN SENSOR OFF TIME ALARM
#define ALM_SENSOR_IN_OFF_TIMEOUT6					87		// NOTE : 2	S	AK UNIT IN SENSOR OFF TIME ALARM
#define ALM_SENSOR_IN_OFF_TIMEOUT7					88		// NOTE : 2	S	BUF UNIT IN SENSOR OFF TIME ALARM
#define ALM_SENSOR_IN_OFF_TIMEOUT8					89		// NOTE : 2	S	OUTCV UNIT IN SENSOR OFF TIME ALARM
//#define ALM_SPARE									90		// NOTE : 0	L	SPARE
//#define ALM_SPARE									91		// NOTE : 0	L	SPARE
//#define ALM_SPARE									92		// NOTE : 0	L	SPARE
//#define ALM_SPARE									93		// NOTE : 0	L	SPARE
//#define ALM_SPARE									94		// NOTE : 0	L	SPARE
//#define ALM_SPARE									95		// NOTE : 0	L	SPARE
//#define ALM_SPARE									96		// NOTE : 0	L	SPARE
//#define ALM_SPARE									97		// NOTE : 0	L	SPARE
//#define ALM_SPARE									98		// NOTE : 0	L	SPARE
//#define ALM_SPARE									99		// NOTE : 0	L	SPARE
//#define ALM_SPARE									100		// NOTE : 0	L	SPARE
//#define ALM_SPARE									101		// NOTE : 0	L	SPARE
#define ALM_SENSOR_OUT_ON_TIMEOUT1					102		// NOTE : 2	S	INCV UNIT OUT SENSOR ON TIME ALARM
#define ALM_SENSOR_OUT_ON_TIMEOUT2					103		// NOTE : 2	S	SWR1 UNIT OUT SENSOR ON TIME ALARM
#define ALM_SENSOR_OUT_ON_TIMEOUT3					104		// NOTE : 2	S	SWR2 UNIT OUT SENSOR ON TIME ALARM
#define ALM_SENSOR_OUT_ON_TIMEOUT4					105		// NOTE : 2	S	SWR3 UNIT OUT SENSOR ON TIME ALARM
#define ALM_SENSOR_OUT_ON_TIMEOUT5					106		// NOTE : 2	S	SWR4 UNIT OUT SENSOR ON TIME ALARM
#define ALM_SENSOR_OUT_ON_TIMEOUT6					107		// NOTE : 2	S	AK UNIT OUT SENSOR ON TIME ALARM
#define ALM_SENSOR_OUT_ON_TIMEOUT7					108		// NOTE : 2	S	BUF UNIT OUT SENSOR ON TIME ALARM
#define ALM_SENSOR_OUT_ON_TIMEOUT8					109		// NOTE : 2	S	OUTCV UNIT OUT SENSOR ON TIME ALARM
//#define ALM_SPARE									110		// NOTE : 0	L	SPARE
//#define ALM_SPARE									111		// NOTE : 0	L	SPARE
//#define ALM_SPARE									112		// NOTE : 0	L	SPARE
//#define ALM_SPARE									113		// NOTE : 0	L	SPARE
//#define ALM_SPARE									114		// NOTE : 0	L	SPARE
//#define ALM_SPARE									115		// NOTE : 0	L	SPARE
//#define ALM_SPARE									116		// NOTE : 0	L	SPARE
//#define ALM_SPARE									117		// NOTE : 0	L	SPARE
//#define ALM_SPARE									118		// NOTE : 0	L	SPARE
//#define ALM_SPARE									119		// NOTE : 0	L	SPARE
//#define ALM_SPARE									120		// NOTE : 0	L	SPARE
//#define ALM_SPARE									121		// NOTE : 0	L	SPARE
#define ALM_SENSOR_OUT_OFF_TIMEOUT1					122		// NOTE : 2	S	INCV UNIT OUT SENSOR OFF TIME ALARM
#define ALM_SENSOR_OUT_OFF_TIMEOUT2					123		// NOTE : 2	S	SWR1 UNIT OUT SENSOR OFF TIME ALARM
#define ALM_SENSOR_OUT_OFF_TIMEOUT3					124		// NOTE : 2	S	SWR2 UNIT OUT SENSOR OFF TIME ALARM
#define ALM_SENSOR_OUT_OFF_TIMEOUT4					125		// NOTE : 2	S	SWR3 UNIT OUT SENSOR OFF TIME ALARM
#define ALM_SENSOR_OUT_OFF_TIMEOUT5					126		// NOTE : 2	S	SWR4 UNIT OUT SENSOR OFF TIME ALARM
#define ALM_SENSOR_OUT_OFF_TIMEOUT6					127		// NOTE : 2	S	AK UNIT OUT SENSOR OFF TIME ALARM
#define ALM_SENSOR_OUT_OFF_TIMEOUT7					128		// NOTE : 2	S	BUF UNIT OUT SENSOR OFF TIME ALARM
#define ALM_SENSOR_OUT_OFF_TIMEOUT8					129		// NOTE : 2	S	OUTCV UNIT OUT SENSOR OFF TIME ALARM
//#define ALM_SPARE									130		// NOTE : 0	L	SPARE
//#define ALM_SPARE									131		// NOTE : 0	L	SPARE
//#define ALM_SPARE									132		// NOTE : 0	L	SPARE
//#define ALM_SPARE									133		// NOTE : 0	L	SPARE
//#define ALM_SPARE									134		// NOTE : 0	L	SPARE
//#define ALM_SPARE									135		// NOTE : 0	L	SPARE
//#define ALM_SPARE									136		// NOTE : 0	L	SPARE
//#define ALM_SPARE									137		// NOTE : 0	L	SPARE
//#define ALM_SPARE									138		// NOTE : 0	L	SPARE
//#define ALM_SPARE									139		// NOTE : 0	L	SPARE
//#define ALM_SPARE									140		// NOTE : 0	L	SPARE
//#define ALM_SPARE									141		// NOTE : 0	L	SPARE
#define ALM_IN_ON_SENSOR_WARNING1					142		// NOTE : 6	L	INCV UNIT IN SENSOR ON TIME WARNING
#define ALM_IN_ON_SENSOR_WARNING2					143		// NOTE : 6	L	SWR1 UNIT IN SENSOR ON TIME WARNING
#define ALM_IN_ON_SENSOR_WARNING3					144		// NOTE : 6	L	SWR2 UNIT IN SENSOR ON TIME WARNING
#define ALM_IN_ON_SENSOR_WARNING4					145		// NOTE : 6	L	SWR3 UNIT IN SENSOR ON TIME WARNING
#define ALM_IN_ON_SENSOR_WARNING5					146		// NOTE : 6	L	SWR4 UNIT IN SENSOR ON TIME WARNING
#define ALM_IN_ON_SENSOR_WARNING6					147		// NOTE : 6	L	AK UNIT IN SENSOR ON TIME WARNING
#define ALM_IN_ON_SENSOR_WARNING7					148		// NOTE : 6	L	BUF UNIT IN SENSOR ON TIME WARNING
#define ALM_IN_ON_SENSOR_WARNING8					149		// NOTE : 6	L	OUTCV UNIT IN SENSOR ON TIME WARNING
//#define ALM_SPARE									150		// NOTE : 0	L	SPARE
//#define ALM_SPARE									151		// NOTE : 0	L	SPARE
//#define ALM_SPARE									152		// NOTE : 0	L	SPARE
//#define ALM_SPARE									153		// NOTE : 0	L	SPARE
//#define ALM_SPARE									154		// NOTE : 0	L	SPARE
//#define ALM_SPARE									155		// NOTE : 0	L	SPARE
//#define ALM_SPARE									156		// NOTE : 0	L	SPARE
//#define ALM_SPARE									157		// NOTE : 0	L	SPARE
//#define ALM_SPARE									158		// NOTE : 0	L	SPARE
//#define ALM_SPARE									159		// NOTE : 0	L	SPARE
//#define ALM_SPARE									160		// NOTE : 0	L	SPARE
//#define ALM_SPARE									161		// NOTE : 0	L	SPARE
#define ALM_OUT_ON_SENSOR_WARNING1					162		// NOTE : 6	L	INCV UNIT OUT SENSOR ON TIME WARNING
#define ALM_OUT_ON_SENSOR_WARNING2					163		// NOTE : 6	L	SWR1 UNIT OUT SENSOR ON TIME WARNING
#define ALM_OUT_ON_SENSOR_WARNING3					164		// NOTE : 6	L	SWR2 UNIT OUT SENSOR ON TIME WARNING
#define ALM_OUT_ON_SENSOR_WARNING4					165		// NOTE : 6	L	SWR3 UNIT OUT SENSOR ON TIME WARNING
#define ALM_OUT_ON_SENSOR_WARNING5					166		// NOTE : 6	L	SWR4 UNIT OUT SENSOR ON TIME WARNING
#define ALM_OUT_ON_SENSOR_WARNING6					167		// NOTE : 6	L	AK UNIT OUT SENSOR ON TIME WARNING
#define ALM_OUT_ON_SENSOR_WARNING7					168		// NOTE : 6	L	BUF UNIT OUT SENSOR ON TIME WARNING
#define ALM_OUT_ON_SENSOR_WARNING8					169		// NOTE : 6	L	OUTCV UNIT OUT SENSOR ON TIME WARNING
//#define ALM_SPARE									170		// NOTE : 0	L	SPARE
//#define ALM_SPARE									171		// NOTE : 0	L	SPARE
//#define ALM_SPARE									172		// NOTE : 0	L	SPARE
//#define ALM_SPARE									173		// NOTE : 0	L	SPARE
//#define ALM_SPARE									174		// NOTE : 0	L	SPARE
//#define ALM_SPARE									175		// NOTE : 0	L	SPARE
//#define ALM_SPARE									176		// NOTE : 0	L	SPARE
//#define ALM_SPARE									177		// NOTE : 0	L	SPARE
//#define ALM_SPARE									178		// NOTE : 0	L	SPARE
//#define ALM_SPARE									179		// NOTE : 0	L	SPARE
//#define ALM_SPARE									180		// NOTE : 0	L	SPARE
//#define ALM_SPARE									181		// NOTE : 0	L	SPARE
#define ALM_IN_OFF_SENSOR_WARNING1					182		// NOTE : 6	L	INCV UNIT IN SENSOR OFF TIME WARNING
#define ALM_IN_OFF_SENSOR_WARNING2					183		// NOTE : 6	L	SWR1 UNIT IN SENSOR OFF TIME WARNING
#define ALM_IN_OFF_SENSOR_WARNING3					184		// NOTE : 6	L	SWR2 UNIT IN SENSOR OFF TIME WARNING
#define ALM_IN_OFF_SENSOR_WARNING4					185		// NOTE : 6	L	SWR3 UNIT IN SENSOR OFF TIME WARNING
#define ALM_IN_OFF_SENSOR_WARNING5					186		// NOTE : 6	L	SWR4 UNIT IN SENSOR OFF TIME WARNING
#define ALM_IN_OFF_SENSOR_WARNING6					187		// NOTE : 6	L	AK UNIT IN SENSOR OFF TIME WARNING
#define ALM_IN_OFF_SENSOR_WARNING7					188		// NOTE : 6	L	BUF UNIT IN SENSOR OFF TIME WARNING
#define ALM_IN_OFF_SENSOR_WARNING8					189		// NOTE : 6	L	OUTCV UNIT IN SENSOR OFF TIME WARNING
//#define ALM_SPARE									190		// NOTE : 0	L	SPARE
//#define ALM_SPARE									191		// NOTE : 0	L	SPARE
//#define ALM_SPARE									192		// NOTE : 0	L	SPARE
//#define ALM_SPARE									193		// NOTE : 0	L	SPARE
//#define ALM_SPARE									194		// NOTE : 0	L	SPARE
//#define ALM_SPARE									195		// NOTE : 0	L	SPARE
//#define ALM_SPARE									196		// NOTE : 0	L	SPARE
//#define ALM_SPARE									197		// NOTE : 0	L	SPARE
//#define ALM_SPARE									198		// NOTE : 0	L	SPARE
//#define ALM_SPARE									199		// NOTE : 0	L	SPARE
//#define ALM_SPARE									200		// NOTE : 0	L	SPARE
//#define ALM_SPARE									201		// NOTE : 0	L	SPARE
#define ALM_OUT_OFF_SENSOR_WARNING1					202		// NOTE : 6	L	INCV UNIT OUT SENSOR OFF TIME WARNING
#define ALM_OUT_OFF_SENSOR_WARNING2					203		// NOTE : 6	L	SWR1 UNIT OUT SENSOR OFF TIME WARNING
#define ALM_OUT_OFF_SENSOR_WARNING3					204		// NOTE : 6	L	SWR2 UNIT OUT SENSOR OFF TIME WARNING
#define ALM_OUT_OFF_SENSOR_WARNING4					205		// NOTE : 6	L	SWR3 UNIT OUT SENSOR OFF TIME WARNING
#define ALM_OUT_OFF_SENSOR_WARNING5					206		// NOTE : 6	L	SWR4 UNIT OUT SENSOR OFF TIME WARNING
#define ALM_OUT_OFF_SENSOR_WARNING6					207		// NOTE : 6	L	AK UNIT OUT SENSOR OFF TIME WARNING
#define ALM_OUT_OFF_SENSOR_WARNING7					208		// NOTE : 6	L	BUF UNIT OUT SENSOR OFF TIME WARNING
#define ALM_OUT_OFF_SENSOR_WARNING8					209		// NOTE : 6	L	OUTCV UNIT OUT SENSOR OFF TIME WARNING
//#define ALM_SPARE									210		// NOTE : 0	L	SPARE													
#define ALM_GAUGE_LOWER_ALARM1						211		// NOTE : 2	S	SWR1 UNIT CDA IN INCV ION LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM2						212		// NOTE : 2	S	SWR1 UNIT CDA IN SWR1 UP AC LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM3						213		// NOTE : 2	S	SWR1 UNIT CDA IN SWR1 LO AC LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM4						214		// NOTE : 2	S	SWR1 UNIT CDA IN ION AND AC IN FT LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM5						215		// NOTE : 2	S	SWR1 UNIT CDA IN SWR1 UP MJ LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM6						216		// NOTE : 2	S	SWR1 UNIT CDA IN SWR1 LO MJ LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM7						217		// NOTE : 2	S	SWR1 UNIT CDA IN SWR1 MJ IN FT LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM8						218		// NOTE : 2	S	SWR1 UNIT DI SPL IN FT LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM9						219		// NOTE : 2	S	SWR1 UNIT CDA IN SWR1 UP MJ FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM10						220		// NOTE : 2	S	SWR1 UNIT CDA IN SWR1 LO MJ FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM11						221		// NOTE : 2	S	SWR1 UNIT DI SPL AK FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM12						222		// NOTE : 2	S	SWR1 UNIT DI SPL UP MJ FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM13						223		// NOTE : 2	S	SWR1 UNIT DI SPL LO MJ FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM14						224		// NOTE : 2	S	SWR1 UNIT DI SPL IN FT FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM15						225		// NOTE : 2	S	SWR1 UNIT DI SPL LO FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM16						226		// NOTE : 2	S	SWR1 UNIT DI SPL UP FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM17						227		// NOTE : 2	S	SWR1 UNIT DI SPL WR LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM18						228		// NOTE : 2	S	SWR1 UNIT EXH DM LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM19						229		// NOTE : 2	S	SWR2 UNIT DI IN FT PG LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM20						230		// NOTE : 2	S	SWR2 UNIT DI RETURN FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM21						231		// NOTE : 2	S	SWR2 UNIT DI SPL LO FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM22						232		// NOTE : 2	S	SWR2 UNIT DI SPL FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM23						233		// NOTE : 2	S	SWR2 UNIT DI SPL UP FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM24						234		// NOTE : 2	S	SWR2 UNIT WR LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM25						235		// NOTE : 2	S	SWR2 UNIT EXH DM LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM26						236		// NOTE : 2	S	SWR3 UNIT DI IN SWR3 IN FT PG LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM27						237		// NOTE : 2	S	SWR3 UNIT CDA IN SWR4 MJ PG LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM28						238		// NOTE : 2	S	SWR3 UNIT CDA IN SPARE PORT PG LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM29						239		// NOTE : 2	S	SWR3 UNIT CDA IN SWR4 MJ IN FT PG LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM30						240		// NOTE : 2	S	SWR3 UNIT DI SPL LO SWR3 FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM31						241		// NOTE : 2	S	SWR3 UNIT DI SPL SWR3 IN FT FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM32						242		// NOTE : 2	S	SWR3 UNIT DI SPL UP SWR3 FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM33						243		// NOTE : 2	S	SWR3 UNIT CDA IN SWR4 MJ FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM34						244		// NOTE : 2	S	SWR3 UNIT CDA IN SPARE PORT FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM35						245		// NOTE : 2	S	SWR3 UNIT DI SPL WR LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM36						246		// NOTE : 2	S	SWR3 UNIT EXH DM LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM37						247		// NOTE : 2	S	SWR4 UNIT LO SWR FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM38						248		// NOTE : 2	S	SWR4 UNIT MJ FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM39						249		// NOTE : 2	S	SWR4 UNIT UP SWR FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM40						250		// NOTE : 2	S	SWR4 UNIT AK FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM41						251		// NOTE : 2	S	SWR4 UNIT DI SPL FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM42						252		// NOTE : 2	S	SWR4 UNIT EXH DM LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM43						253		// NOTE : 2	S	SWR4 UNIT DI TANK2 CM LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM44						254		// NOTE : 2	S	AK UNIT DI SPL SWR4 IN FT PG LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM45						255		// NOTE : 2	S	AK UNIT CDA IN LO AK IN FT PG LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM46						256		// NOTE : 2	S	AK UNIT CDA IN UP AK IN FT PG LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM47						257		// NOTE : 2	S	AK UNIT CDA IN LO AK PG LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM48						258		// NOTE : 2	S	AK UNIT CDA IN UP AK PG LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM49						259		// NOTE : 2	S	AK UNIT CDA IN ION AND AC IN FT PG LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM50						260		// NOTE : 2	S	AK UNIT CDA IN UP SWR4 AC PG LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM51						261		// NOTE : 2	S	AK UNIT CDA IN LO SWR4 AC PG LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM52						262		// NOTE : 2	S	AK UNIT CDA IN OUT ION PG LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM53						263		// NOTE : 2	S	AK UNIT DRIVING AIR PG LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM54						264		// NOTE : 2	S	AK UNIT EXH DM_U LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM55						265		// NOTE : 2	S	AK UNIT EXH DM_L LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM56						266		// NOTE : 2	S	AK UNIT DI SPL SHOWER4 IN FT FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM57						267		// NOTE : 2	S	AK UNIT CDA IN LO AK IN FT FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM58						268		// NOTE : 2	S	AK UNIT CDA IN UP AK IN FT FL LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM59						269		// NOTE : 2	S	AK UNIT DI SPL WR LOWER LIMIT ALARM
#define ALM_GAUGE_LOWER_ALARM60						270		// NOTE : 2	S	OUTCV UNIT ESD SURIFACE POTENTIAL LOWER LIMIT ALARM
//#define ALM_SPARE									271		// NOTE : 0	L	SPARE
//#define ALM_SPARE									272		// NOTE : 0	L	SPARE
//#define ALM_SPARE									273		// NOTE : 0	L	SPARE
//#define ALM_SPARE									274		// NOTE : 0	L	SPARE
//#define ALM_SPARE									275		// NOTE : 0	L	SPARE
//#define ALM_SPARE									276		// NOTE : 0	L	SPARE
//#define ALM_SPARE									277		// NOTE : 0	L	SPARE
//#define ALM_SPARE									278		// NOTE : 0	L	SPARE
//#define ALM_SPARE									279		// NOTE : 0	L	SPARE
//#define ALM_SPARE									280		// NOTE : 0	L	SPARE
//#define ALM_SPARE									281		// NOTE : 0	L	SPARE
//#define ALM_SPARE									282		// NOTE : 0	L	SPARE
//#define ALM_SPARE									283		// NOTE : 0	L	SPARE
//#define ALM_SPARE									284		// NOTE : 0	L	SPARE
//#define ALM_SPARE									285		// NOTE : 0	L	SPARE
//#define ALM_SPARE									286		// NOTE : 0	L	SPARE
//#define ALM_SPARE									287		// NOTE : 0	L	SPARE
//#define ALM_SPARE									288		// NOTE : 0	L	SPARE
//#define ALM_SPARE									289		// NOTE : 0	L	SPARE
//#define ALM_SPARE									290		// NOTE : 0	L	SPARE
//#define ALM_SPARE									291		// NOTE : 0	L	SPARE
//#define ALM_SPARE									292		// NOTE : 0	L	SPARE
//#define ALM_SPARE									293		// NOTE : 0	L	SPARE
//#define ALM_SPARE									294		// NOTE : 0	L	SPARE
//#define ALM_SPARE									295		// NOTE : 0	L	SPARE
//#define ALM_SPARE									296		// NOTE : 0	L	SPARE
//#define ALM_SPARE									297		// NOTE : 0	L	SPARE
//#define ALM_SPARE									298		// NOTE : 0	L	SPARE
//#define ALM_SPARE									299		// NOTE : 0	L	SPARE
//#define ALM_SPARE									300		// NOTE : 0	L	SPARE
//#define ALM_SPARE									301		// NOTE : 0	L	SPARE
//#define ALM_SPARE									302		// NOTE : 0	L	SPARE
//#define ALM_SPARE									303		// NOTE : 0	L	SPARE
//#define ALM_SPARE									304		// NOTE : 0	L	SPARE
//#define ALM_SPARE									305		// NOTE : 0	L	SPARE
//#define ALM_SPARE									306		// NOTE : 0	L	SPARE
//#define ALM_SPARE									307		// NOTE : 0	L	SPARE
#define ALM_GAUGE_LOWER_WARNING1					308		// NOTE : 6	L	SWR1 UNIT CDA IN INCV ION LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING2					309		// NOTE : 6	L	SWR1 UNIT CDA IN SWR1 UP AC LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING3					310		// NOTE : 6	L	SWR1 UNIT CDA IN SWR1 LO AC LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING4					311		// NOTE : 6	L	SWR1 UNIT CDA IN ION AND AC IN FT LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING5					312		// NOTE : 6	L	SWR1 UNIT CDA IN SWR1 UP MJ LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING6					313		// NOTE : 6	L	SWR1 UNIT CDA IN SWR1 LO MJ LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING7					314		// NOTE : 6	L	SWR1 UNIT CDA IN SWR1 MJ IN FT LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING8					315		// NOTE : 6	L	SWR1 UNIT DI SPL IN FT LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING9					316		// NOTE : 6	L	SWR1 UNIT CDA IN SWR1 UP MJ FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING10					317		// NOTE : 6	L	SWR1 UNIT CDA IN SWR1 LO MJ FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING11					318		// NOTE : 6	L	SWR1 UNIT DI SPL AK FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING12					319		// NOTE : 6	L	SWR1 UNIT DI SPL UP MJ FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING13					320		// NOTE : 6	L	SWR1 UNIT DI SPL LO MJ FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING14					321		// NOTE : 6	L	SWR1 UNIT DI SPL IN FT FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING15					322		// NOTE : 6	L	SWR1 UNIT DI SPL LO FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING16					323		// NOTE : 6	L	SWR1 UNIT DI SPL UP FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING17					324		// NOTE : 6	L	SWR1 UNIT DI SPL WR LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING18					325		// NOTE : 6	L	SWR1 UNIT EXH DM LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING19					326		// NOTE : 6	L	SWR2 UNIT DI IN FT PG LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING20					327		// NOTE : 6	L	SWR2 UNIT DI RETURN FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING21					328		// NOTE : 6	L	SWR2 UNIT DI SPL LO FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING22					329		// NOTE : 6	L	SWR2 UNIT DI SPL FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING23					330		// NOTE : 6	L	SWR2 UNIT DI SPL UP FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING24					331		// NOTE : 6	L	SWR2 UNIT WR LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING25					332		// NOTE : 6	L	SWR2 UNIT EXH DM LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING26					333		// NOTE : 6	L	SWR3 UNIT DI IN SWR3 IN FT PG LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING27					334		// NOTE : 6	L	SWR3 UNIT CDA IN SWR4 MJ PG LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING28					335		// NOTE : 6	L	SWR3 UNIT CDA IN SPARE PORT PG LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING29					336		// NOTE : 6	L	SWR3 UNIT CDA IN SWR4 MJ IN FT PG LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING30					337		// NOTE : 6	L	SWR3 UNIT DI SPL LO SWR3 FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING31					338		// NOTE : 6	L	SWR3 UNIT DI SPL SWR3 IN FT FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING32					339		// NOTE : 6	L	SWR3 UNIT DI SPL UP SWR3 FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING33					340		// NOTE : 6	L	SWR3 UNIT CDA IN SWR4 MJ FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING34					341		// NOTE : 6	L	SWR3 UNIT CDA IN SPARE PORT FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING35					342		// NOTE : 6	L	SWR3 UNIT DI SPL WR LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING36					343		// NOTE : 6	L	SWR3 UNIT EXH DM LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING37					344		// NOTE : 6	L	SWR4 UNIT LO SWR FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING38					345		// NOTE : 6	L	SWR4 UNIT MJ FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING39					346		// NOTE : 6	L	SWR4 UNIT UP SWR FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING40					347		// NOTE : 6	L	SWR4 UNIT AK FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING41					348		// NOTE : 6	L	SWR4 UNIT DI SPL FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING42					349		// NOTE : 6	L	SWR4 UNIT EXH DM LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING43					350		// NOTE : 6	L	SWR4 UNIT DI TANK2 CM LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING44					351		// NOTE : 6	L	AK UNIT DI SPL SWR4 IN FT PG LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING45					352		// NOTE : 6	L	AK UNIT CDA IN LO AK IN FT PG LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING46					353		// NOTE : 6	L	AK UNIT CDA IN UP AK IN FT PG LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING47					354		// NOTE : 6	L	AK UNIT CDA IN LO AK PG LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING48					355		// NOTE : 6	L	AK UNIT CDA IN UP AK PG LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING49					356		// NOTE : 6	L	AK UNIT CDA IN ION AND AC IN FT PG LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING50					357		// NOTE : 6	L	AK UNIT CDA IN UP SWR4 AC PG LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING51					358		// NOTE : 6	L	AK UNIT CDA IN LO SWR4 AC PG LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING52					359		// NOTE : 6	L	AK UNIT CDA IN OUT ION PG LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING53					360		// NOTE : 6	L	AK UNIT DRIVING AIR PG LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING54					361		// NOTE : 6	L	AK UNIT EXH DM_U LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING55					362		// NOTE : 6	L	AK UNIT EXH DM_L LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING56					363		// NOTE : 6	L	AK UNIT DI SPL SHOWER4 IN FT FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING57					364		// NOTE : 6	L	AK UNIT CDA IN LO AK IN FT FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING58					365		// NOTE : 6	L	AK UNIT CDA IN UP AK IN FT FL LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING59					366		// NOTE : 6	L	AK UNIT DI SPL WR LOWER LIMIT WARNING
#define ALM_GAUGE_LOWER_WARNING60					367		// NOTE : 6	L	OUTCV UNIT ESD SURIFACE POTENTIAL LOWER LIMIT WARNING
//#define ALM_SPARE									368		// NOTE : 0	L	SPARE
//#define ALM_SPARE									369		// NOTE : 0	L	SPARE
//#define ALM_SPARE									370		// NOTE : 0	L	SPARE
//#define ALM_SPARE									371		// NOTE : 0	L	SPARE
//#define ALM_SPARE									372		// NOTE : 0	L	SPARE
//#define ALM_SPARE									373		// NOTE : 0	L	SPARE
//#define ALM_SPARE									374		// NOTE : 0	L	SPARE
//#define ALM_SPARE									375		// NOTE : 0	L	SPARE
//#define ALM_SPARE									376		// NOTE : 0	L	SPARE
//#define ALM_SPARE									377		// NOTE : 0	L	SPARE
//#define ALM_SPARE									378		// NOTE : 0	L	SPARE
//#define ALM_SPARE									379		// NOTE : 0	L	SPARE
//#define ALM_SPARE									380		// NOTE : 0	L	SPARE
//#define ALM_SPARE									381		// NOTE : 0	L	SPARE
//#define ALM_SPARE									382		// NOTE : 0	L	SPARE
//#define ALM_SPARE									383		// NOTE : 0	L	SPARE
//#define ALM_SPARE									384		// NOTE : 0	L	SPARE
//#define ALM_SPARE									385		// NOTE : 0	L	SPARE
//#define ALM_SPARE									386		// NOTE : 0	L	SPARE
//#define ALM_SPARE									387		// NOTE : 0	L	SPARE
//#define ALM_SPARE									388		// NOTE : 0	L	SPARE
//#define ALM_SPARE									389		// NOTE : 0	L	SPARE
//#define ALM_SPARE									390		// NOTE : 0	L	SPARE
//#define ALM_SPARE									391		// NOTE : 0	L	SPARE
//#define ALM_SPARE									392		// NOTE : 0	L	SPARE
//#define ALM_SPARE									393		// NOTE : 0	L	SPARE
//#define ALM_SPARE									394		// NOTE : 0	L	SPARE
//#define ALM_SPARE									395		// NOTE : 0	L	SPARE
//#define ALM_SPARE									396		// NOTE : 0	L	SPARE
//#define ALM_SPARE									397		// NOTE : 0	L	SPARE
//#define ALM_SPARE									398		// NOTE : 0	L	SPARE
//#define ALM_SPARE									399		// NOTE : 0	L	SPARE
//#define ALM_SPARE									400		// NOTE : 0	L	SPARE
//#define ALM_SPARE									401		// NOTE : 0	L	SPARE
//#define ALM_SPARE									402		// NOTE : 0	L	SPARE
//#define ALM_SPARE									403		// NOTE : 0	L	SPARE
//#define ALM_SPARE									404		// NOTE : 0	L	SPARE
#define ALM_GAUGE_UPPER_ALARM1						405		// NOTE : 2	S	SWR1 UNIT CDA IN INCV ION UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM2						406		// NOTE : 2	S	SWR1 UNIT CDA IN SWR1 UP AC UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM3						407		// NOTE : 2	S	SWR1 UNIT CDA IN SWR1 LO AC UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM4						408		// NOTE : 2	S	SWR1 UNIT CDA IN ION AND AC IN FT UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM5						409		// NOTE : 2	S	SWR1 UNIT CDA IN SWR1 UP MJ UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM6						410		// NOTE : 2	S	SWR1 UNIT CDA IN SWR1 LO MJ UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM7						411		// NOTE : 2	S	SWR1 UNIT CDA IN SWR1 MJ IN FT UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM8						412		// NOTE : 2	S	SWR1 UNIT DI SPL IN FT UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM9						413		// NOTE : 2	S	SWR1 UNIT CDA IN SWR1 UP MJ FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM10						414		// NOTE : 2	S	SWR1 UNIT CDA IN SWR1 LO MJ FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM11						415		// NOTE : 2	S	SWR1 UNIT DI SPL AK FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM12						416		// NOTE : 2	S	SWR1 UNIT DI SPL UP MJ FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM13						417		// NOTE : 2	S	SWR1 UNIT DI SPL LO MJ FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM14						418		// NOTE : 2	S	SWR1 UNIT DI SPL IN FT FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM15						419		// NOTE : 2	S	SWR1 UNIT DI SPL LO FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM16						420		// NOTE : 2	S	SWR1 UNIT DI SPL UP FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM17						421		// NOTE : 2	S	SWR1 UNIT DI SPL WR UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM18						422		// NOTE : 2	S	SWR1 UNIT EXH DM UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM19						423		// NOTE : 2	S	SWR2 UNIT DI IN FT PG UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM20						424		// NOTE : 2	S	SWR2 UNIT DI RETURN FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM21						425		// NOTE : 2	S	SWR2 UNIT DI SPL LO FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM22						426		// NOTE : 2	S	SWR2 UNIT DI SPL FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM23						427		// NOTE : 2	S	SWR2 UNIT DI SPL UP FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM24						428		// NOTE : 2	S	SWR2 UNIT WR UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM25						429		// NOTE : 2	S	SWR2 UNIT EXH DM UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM26						430		// NOTE : 2	S	SWR3 UNIT DI IN SWR3 IN FT PG UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM27						431		// NOTE : 2	S	SWR3 UNIT CDA IN SWR4 MJ PG UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM28						432		// NOTE : 2	S	SWR3 UNIT CDA IN SPARE PORT PG UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM29						433		// NOTE : 2	S	SWR3 UNIT CDA IN SWR4 MJ IN FT PG UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM30						434		// NOTE : 2	S	SWR3 UNIT DI SPL LO SWR3 FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM31						435		// NOTE : 2	S	SWR3 UNIT DI SPL SWR3 IN FT FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM32						436		// NOTE : 2	S	SWR3 UNIT DI SPL UP SWR3 FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM33						437		// NOTE : 2	S	SWR3 UNIT CDA IN SWR4 MJ FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM34						438		// NOTE : 2	S	SWR3 UNIT CDA IN SPARE PORT FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM35						439		// NOTE : 2	S	SWR3 UNIT DI SPL WR UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM36						440		// NOTE : 2	S	SWR3 UNIT EXH DM UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM37						441		// NOTE : 2	S	SWR4 UNIT LO SWR FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM38						442		// NOTE : 2	S	SWR4 UNIT MJ FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM39						443		// NOTE : 2	S	SWR4 UNIT UP SWR FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM40						444		// NOTE : 2	S	SWR4 UNIT AK FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM41						445		// NOTE : 2	S	SWR4 UNIT DI SPL FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM42						446		// NOTE : 2	S	SWR4 UNIT EXH DM UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM43						447		// NOTE : 2	S	SWR4 UNIT DI TANK2 CM UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM44						448		// NOTE : 2	S	AK UNIT DI SPL SWR4 IN FT PG UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM45						449		// NOTE : 2	S	AK UNIT CDA IN LO AK IN FT PG UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM46						450		// NOTE : 2	S	AK UNIT CDA IN UP AK IN FT PG UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM47						451		// NOTE : 2	S	AK UNIT CDA IN LO AK PG UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM48						452		// NOTE : 2	S	AK UNIT CDA IN UP AK PG UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM49						453		// NOTE : 2	S	AK UNIT CDA IN ION AND AC IN FT PG UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM50						454		// NOTE : 2	S	AK UNIT CDA IN UP SWR4 AC PG UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM51						455		// NOTE : 2	S	AK UNIT CDA IN LO SWR4 AC PG UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM52						456		// NOTE : 2	S	AK UNIT CDA IN OUT ION PG UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM53						457		// NOTE : 2	S	AK UNIT DRIVING AIR PG UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM54						458		// NOTE : 2	S	AK UNIT EXH DM_U UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM55						459		// NOTE : 2	S	AK UNIT EXH DM_L UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM56						460		// NOTE : 2	S	AK UNIT DI SPL SHOWER4 IN FT FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM57						461		// NOTE : 2	S	AK UNIT CDA IN LO AK IN FT FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM58						462		// NOTE : 2	S	AK UNIT CDA IN UP AK IN FT FL UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM59						463		// NOTE : 2	S	AK UNIT DI SPL WR UPPER LIMIT ALARM
#define ALM_GAUGE_UPPER_ALARM60						464		// NOTE : 2	S	OUTCV UNIT ESD SURIFACE POTENTIAL UPPER LIMIT ALARM
//#define ALM_SPARE									465		// NOTE : 0	L	SPARE
//#define ALM_SPARE									466		// NOTE : 0	L	SPARE
//#define ALM_SPARE									467		// NOTE : 0	L	SPARE
//#define ALM_SPARE									468		// NOTE : 0	L	SPARE
//#define ALM_SPARE									469		// NOTE : 0	L	SPARE
//#define ALM_SPARE									470		// NOTE : 0	L	SPARE
//#define ALM_SPARE									471		// NOTE : 0	L	SPARE
//#define ALM_SPARE									472		// NOTE : 0	L	SPARE
//#define ALM_SPARE									473		// NOTE : 0	L	SPARE
//#define ALM_SPARE									474		// NOTE : 0	L	SPARE
//#define ALM_SPARE									475		// NOTE : 0	L	SPARE
//#define ALM_SPARE									476		// NOTE : 0	L	SPARE
//#define ALM_SPARE									477		// NOTE : 0	L	SPARE
//#define ALM_SPARE									478		// NOTE : 0	L	SPARE
//#define ALM_SPARE									479		// NOTE : 0	L	SPARE
//#define ALM_SPARE									480		// NOTE : 0	L	SPARE
//#define ALM_SPARE									481		// NOTE : 0	L	SPARE
//#define ALM_SPARE									482		// NOTE : 0	L	SPARE
//#define ALM_SPARE									483		// NOTE : 0	L	SPARE
//#define ALM_SPARE									484		// NOTE : 0	L	SPARE
//#define ALM_SPARE									485		// NOTE : 0	L	SPARE
//#define ALM_SPARE									486		// NOTE : 0	L	SPARE
//#define ALM_SPARE									487		// NOTE : 0	L	SPARE
//#define ALM_SPARE									488		// NOTE : 0	L	SPARE
//#define ALM_SPARE									489		// NOTE : 0	L	SPARE
//#define ALM_SPARE									490		// NOTE : 0	L	SPARE
//#define ALM_SPARE									491		// NOTE : 0	L	SPARE
//#define ALM_SPARE									492		// NOTE : 0	L	SPARE
//#define ALM_SPARE									493		// NOTE : 0	L	SPARE
//#define ALM_SPARE									494		// NOTE : 0	L	SPARE
//#define ALM_SPARE									495		// NOTE : 0	L	SPARE
//#define ALM_SPARE									496		// NOTE : 0	L	SPARE
//#define ALM_SPARE									497		// NOTE : 0	L	SPARE
//#define ALM_SPARE									498		// NOTE : 0	L	SPARE
//#define ALM_SPARE									499		// NOTE : 0	L	SPARE
//#define ALM_SPARE									500		// NOTE : 0	L	SPARE
//#define ALM_SPARE									501		// NOTE : 0	L	SPARE
#define ALM_GAUGE_UPPER_WARNING1					502		// NOTE : 6	L	SWR1 UNIT CDA IN INCV ION UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING2					503		// NOTE : 6	L	SWR1 UNIT CDA IN SWR1 UP AC UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING3					504		// NOTE : 6	L	SWR1 UNIT CDA IN SWR1 LO AC UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING4					505		// NOTE : 6	L	SWR1 UNIT CDA IN ION AND AC IN FT UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING5					506		// NOTE : 6	L	SWR1 UNIT CDA IN SWR1 UP MJ UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING6					507		// NOTE : 6	L	SWR1 UNIT CDA IN SWR1 LO MJ UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING7					508		// NOTE : 6	L	SWR1 UNIT CDA IN SWR1 MJ IN FT UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING8					509		// NOTE : 6	L	SWR1 UNIT DI SPL IN FT UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING9					510		// NOTE : 6	L	SWR1 UNIT CDA IN SWR1 UP MJ FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING10					511		// NOTE : 6	L	SWR1 UNIT CDA IN SWR1 LO MJ FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING11					512		// NOTE : 6	L	SWR1 UNIT DI SPL AK FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING12					513		// NOTE : 6	L	SWR1 UNIT DI SPL UP MJ FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING13					514		// NOTE : 6	L	SWR1 UNIT DI SPL LO MJ FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING14					515		// NOTE : 6	L	SWR1 UNIT DI SPL IN FT FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING15					516		// NOTE : 6	L	SWR1 UNIT DI SPL LO FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING16					517		// NOTE : 6	L	SWR1 UNIT DI SPL UP FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING17					518		// NOTE : 6	L	SWR1 UNIT DI SPL WR UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING18					519		// NOTE : 6	L	SWR1 UNIT EXH DM UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING19					520		// NOTE : 6	L	SWR2 UNIT DI IN FT PG UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING20					521		// NOTE : 6	L	SWR2 UNIT DI RETURN FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING21					522		// NOTE : 6	L	SWR2 UNIT DI SPL LO FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING22					523		// NOTE : 6	L	SWR2 UNIT DI SPL FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING23					524		// NOTE : 6	L	SWR2 UNIT DI SPL UP FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING24					525		// NOTE : 6	L	SWR2 UNIT WR UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING25					526		// NOTE : 6	L	SWR2 UNIT EXH DM UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING26					527		// NOTE : 6	L	SWR3 UNIT DI IN SWR3 IN FT PG UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING27					528		// NOTE : 6	L	SWR3 UNIT CDA IN SWR4 MJ PG UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING28					529		// NOTE : 6	L	SWR3 UNIT CDA IN SPARE PORT PG UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING29					530		// NOTE : 6	L	SWR3 UNIT CDA IN SWR4 MJ IN FT PG UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING30					531		// NOTE : 6	L	SWR3 UNIT DI SPL LO SWR3 FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING31					532		// NOTE : 6	L	SWR3 UNIT DI SPL SWR3 IN FT FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING32					533		// NOTE : 6	L	SWR3 UNIT DI SPL UP SWR3 FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING33					534		// NOTE : 6	L	SWR3 UNIT CDA IN SWR4 MJ FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING34					535		// NOTE : 6	L	SWR3 UNIT CDA IN SPARE PORT FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING35					536		// NOTE : 6	L	SWR3 UNIT DI SPL WR UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING36					537		// NOTE : 6	L	SWR3 UNIT EXH DM UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING37					538		// NOTE : 6	L	SWR4 UNIT LO SWR FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING38					539		// NOTE : 6	L	SWR4 UNIT MJ FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING39					540		// NOTE : 6	L	SWR4 UNIT UP SWR FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING40					541		// NOTE : 6	L	SWR4 UNIT AK FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING41					542		// NOTE : 6	L	SWR4 UNIT DI SPL FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING42					543		// NOTE : 6	L	SWR4 UNIT EXH DM UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING43					544		// NOTE : 6	L	SWR4 UNIT DI TANK2 CM UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING44					545		// NOTE : 6	L	AK UNIT DI SPL SWR4 IN FT PG UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING45					546		// NOTE : 6	L	AK UNIT CDA IN LO AK IN FT PG UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING46					547		// NOTE : 6	L	AK UNIT CDA IN UP AK IN FT PG UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING47					548		// NOTE : 6	L	AK UNIT CDA IN LO AK PG UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING48					549		// NOTE : 6	L	AK UNIT CDA IN UP AK PG UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING49					550		// NOTE : 6	L	AK UNIT CDA IN ION AND AC IN FT PG UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING50					551		// NOTE : 6	L	AK UNIT CDA IN UP SWR4 AC PG UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING51					552		// NOTE : 6	L	AK UNIT CDA IN LO SWR4 AC PG UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING52					553		// NOTE : 6	L	AK UNIT CDA IN OUT ION PG UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING53					554		// NOTE : 6	L	AK UNIT DRIVING AIR PG UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING54					555		// NOTE : 6	L	AK UNIT EXH DM_U UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING55					556		// NOTE : 6	L	AK UNIT EXH DM_L UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING56					557		// NOTE : 6	L	AK UNIT DI SPL SHOWER4 IN FT FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING57					558		// NOTE : 6	L	AK UNIT CDA IN LO AK IN FT FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING58					559		// NOTE : 6	L	AK UNIT CDA IN UP AK IN FT FL UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING59					560		// NOTE : 6	L	AK UNIT DI SPL WR UPPER LIMIT WARNING
#define ALM_GAUGE_UPPER_WARNING60					561		// NOTE : 6	L	OUTCV UNIT ESD SURIFACE POTENTIAL UPPER LIMIT WARNING
//#define ALM_SPARE									562		// NOTE : 0	L	SPARE
//#define ALM_SPARE									563		// NOTE : 0	L	SPARE
//#define ALM_SPARE									564		// NOTE : 0	L	SPARE
//#define ALM_SPARE									565		// NOTE : 0	L	SPARE
//#define ALM_SPARE									566		// NOTE : 0	L	SPARE
//#define ALM_SPARE									567		// NOTE : 0	L	SPARE
//#define ALM_SPARE									568		// NOTE : 0	L	SPARE
//#define ALM_SPARE									569		// NOTE : 0	L	SPARE
//#define ALM_SPARE									570		// NOTE : 0	L	SPARE
//#define ALM_SPARE									571		// NOTE : 0	L	SPARE
//#define ALM_SPARE									572		// NOTE : 0	L	SPARE
//#define ALM_SPARE									573		// NOTE : 0	L	SPARE
//#define ALM_SPARE									574		// NOTE : 0	L	SPARE
//#define ALM_SPARE									575		// NOTE : 0	L	SPARE
//#define ALM_SPARE									576		// NOTE : 0	L	SPARE
//#define ALM_SPARE									577		// NOTE : 0	L	SPARE
//#define ALM_SPARE									578		// NOTE : 0	L	SPARE
//#define ALM_SPARE									579		// NOTE : 0	L	SPARE
//#define ALM_SPARE									580		// NOTE : 0	L	SPARE
//#define ALM_SPARE									581		// NOTE : 0	L	SPARE
//#define ALM_SPARE									582		// NOTE : 0	L	SPARE
//#define ALM_SPARE									583		// NOTE : 0	L	SPARE
//#define ALM_SPARE									584		// NOTE : 0	L	SPARE
//#define ALM_SPARE									585		// NOTE : 0	L	SPARE
//#define ALM_SPARE									586		// NOTE : 0	L	SPARE
//#define ALM_SPARE									587		// NOTE : 0	L	SPARE
//#define ALM_SPARE									588		// NOTE : 0	L	SPARE
//#define ALM_SPARE									589		// NOTE : 0	L	SPARE
//#define ALM_SPARE									590		// NOTE : 0	L	SPARE
//#define ALM_SPARE									591		// NOTE : 0	L	SPARE
//#define ALM_SPARE									592		// NOTE : 0	L	SPARE
//#define ALM_SPARE									593		// NOTE : 0	L	SPARE
//#define ALM_SPARE									594		// NOTE : 0	L	SPARE
//#define ALM_SPARE									595		// NOTE : 0	L	SPARE
//#define ALM_SPARE									596		// NOTE : 0	L	SPARE
//#define ALM_SPARE									597		// NOTE : 0	L	SPARE
//#define ALM_SPARE									598		// NOTE : 0	L	SPARE													
#define ALM_RB_FBL_MOTOR_DRIVER_ALARM1				599		// NOTE : 2	S	SWR2 UNIT RB1 Upper FBL Motor ALARM
#define ALM_RB_FBL_MOTOR_DRIVER_ALARM2				600		// NOTE : 2	S	SWR2 UNIT RB1 Lower FBL Motor ALARM
#define ALM_RB_FBL_MOTOR_DRIVER_ALARM3				601		// NOTE : 2	S	SWR2 UNIT RB2 Upper FBL Motor ALARM
#define ALM_RB_FBL_MOTOR_DRIVER_ALARM4				602		// NOTE : 2	S	SWR2 UNIT RB2 Lower FBL Motor ALARM
#define ALM_RB_FBL_MOTOR_DRIVER_ALARM5				603		// NOTE : 2	S	SWR3 UNIT RB1 Upper FBL Motor ALARM
#define ALM_RB_FBL_MOTOR_DRIVER_ALARM6				604		// NOTE : 2	S	SWR3 UNIT RB1 Lower FBL Motor ALARM
#define ALM_RB_FBL_MOTOR_DRIVER_ALARM7				605		// NOTE : 2	S	SWR3 UNIT RB2 Upper FBL Motor ALARM
#define ALM_RB_FBL_MOTOR_DRIVER_ALARM8				606		// NOTE : 2	S	SWR3 UNIT RB2 Lower FBL Motor ALARM											
#define ALM_RB_FBL_MOTOR_CP_OFF1					607		// NOTE : 2	S	SWR2 UNIT RB1 Upper FBL Motor C/P Off
#define ALM_RB_FBL_MOTOR_CP_OFF2					608		// NOTE : 2	S	SWR2 UNIT RB1 Lower FBL Motor C/P Off
#define ALM_RB_FBL_MOTOR_CP_OFF3					609		// NOTE : 2	S	SWR2 UNIT RB2 Upper FBL Motor C/P Off
#define ALM_RB_FBL_MOTOR_CP_OFF4					610		// NOTE : 2	S	SWR2 UNIT RB2 Lower FBL Motor C/P Off
#define ALM_RB_FBL_MOTOR_CP_OFF5					611		// NOTE : 2	S	SWR3 UNIT RB1 Upper FBL Motor C/P Off
#define ALM_RB_FBL_MOTOR_CP_OFF6					612		// NOTE : 2	S	SWR3 UNIT RB1 Lower FBL Motor C/P Off
#define ALM_RB_FBL_MOTOR_CP_OFF7					613		// NOTE : 2	S	SWR3 UNIT RB2 Upper FBL Motor C/P Off
#define ALM_RB_FBL_MOTOR_CP_OFF8					614		// NOTE : 2	S	SWR3 UNIT RB2 Lower FBL Motor C/P Off											
#define ALM_AK_FLOW_DEVIATION						615		// NOTE : 2	S	AK FLOW DEVIATION ALARM
#define ALM_RB_SERVO_CP1							616		// NOTE : 2	S	RB SERVO CP1 OFF ALARM
#define ALM_RB_SERVO_CP2							617		// NOTE : 2	S	RB SERVO CP2 OFF ALARM
#define ALM_RB_SERVO_CP3							618		// NOTE : 2	S	RB SERVO CP3 OFF ALARM
#define ALM_RB_SERVO_CP4							619		// NOTE : 2	S	RB SERVO CP4 OFF ALARM
#define ALM_RB_SERVO_CP5							620		// NOTE : 2	S	RB SERVO CP5 OFF ALARM
#define ALM_RB_SERVO_CP6							621		// NOTE : 2	S	RB SERVO CP6 OFF ALARM
#define ALM_RB_SERVO_CP7							622		// NOTE : 2	S	RB SERVO CP7 OFF ALARM
#define ALM_RB_SERVO_CP8							623		// NOTE : 2	S	RB SERVO CP8 OFF ALARM
//#define ALM_SPARE									624		// NOTE : 0	L	SPARE
//#define ALM_SPARE									625		// NOTE : 0	L	SPARE
//#define ALM_SPARE									626		// NOTE : 0	L	SPARE
//#define ALM_SPARE									627		// NOTE : 0	L	SPARE
//#define ALM_SPARE									628		// NOTE : 0	L	SPARE
//#define ALM_SPARE									629		// NOTE : 0	L	SPARE
//#define ALM_SPARE									630		// NOTE : 0	L	SPARE
//#define ALM_SPARE									631		// NOTE : 0	L	SPARE
//#define ALM_SPARE									632		// NOTE : 0	L	SPARE
//#define ALM_SPARE									633		// NOTE : 0	L	SPARE
#define ALM_COVER_OPEN1								634		// NOTE : 2	S	SWR1 BDOOR OPEN OP OPEN ALARM
#define ALM_COVER_OPEN2								635		// NOTE : 2	S	SWR1 BDOOR OPEN MT OPEN ALARM
#define ALM_COVER_OPEN3								636		// NOTE : 2	S	SWR2 BDOOR OPEN OP1 OPEN ALARM
#define ALM_COVER_OPEN4								637		// NOTE : 2	S	SWR2 BDOOR OPEN OP2 OPEN ALARM
#define ALM_COVER_OPEN5								638		// NOTE : 2	S	SWR2 BDOOR OPEN MT1 OPEN ALARM
#define ALM_COVER_OPEN6								639		// NOTE : 2	S	SWR2 BDOOR OPEN MT2 OPEN ALARM
#define ALM_COVER_OPEN7								640		// NOTE : 2	S	SWR3 BDOOR OPEN OP1 OPEN ALARM
#define ALM_COVER_OPEN8								641		// NOTE : 2	S	SWR3 BDOOR OPEN OP2 OPEN ALARM
#define ALM_COVER_OPEN9								642		// NOTE : 2	S	SWR3 BDOOR OPEN MT1 OPEN ALARM
#define ALM_COVER_OPEN10							643		// NOTE : 2	S	SWR3 BDOOR OPEN MT2 OPEN ALARM
#define ALM_COVER_OPEN11							644		// NOTE : 2	S	SWR4 BDOOR OPEN OP OPEN ALARM
#define ALM_COVER_OPEN12							645		// NOTE : 2	S	SWR4 BDOOR OPEN MT OPEN ALARM
#define ALM_COVER_OPEN13							646		// NOTE : 2	S	AK BDOOR OPEN OP1 OPEN ALARM
#define ALM_COVER_OPEN14							647		// NOTE : 2	S	AK BDOOR OPEN OP2 OPEN ALARM
#define ALM_COVER_OPEN15							648		// NOTE : 2	S	AK BDOOR OPEN MT1 OPEN ALARM
#define ALM_COVER_OPEN16							649		// NOTE : 2	S	AK BDOOR OPEN MT2 OPEN ALARM
//#define ALM_SPARE									650		// NOTE : 0	L	SPARE
//#define ALM_SPARE									651		// NOTE : 0	L	SPARE
//#define ALM_SPARE									652		// NOTE : 0	L	SPARE
//#define ALM_SPARE									653		// NOTE : 0	L	SPARE
//#define ALM_SPARE									654		// NOTE : 0	L	SPARE
//#define ALM_SPARE									655		// NOTE : 0	L	SPARE
//#define ALM_SPARE									656		// NOTE : 0	L	SPARE
//#define ALM_SPARE									657		// NOTE : 0	L	SPARE
//#define ALM_SPARE									658		// NOTE : 0	L	SPARE
//#define ALM_SPARE									659		// NOTE : 0	L	SPARE
#define ALM_DOOR_OPEN1								660		// NOTE : 2	S	INCV FDOOR OPEN LOW OP1 OPEN ALARM
#define ALM_DOOR_OPEN2								661		// NOTE : 2	S	INCV FDOOR OPEN LOW OP2 OPEN ALARM
#define ALM_DOOR_OPEN3								662		// NOTE : 2	S	INCV FDOOR OPEN LOW MT1 OPEN ALARM
#define ALM_DOOR_OPEN4								663		// NOTE : 2	S	INCV FDOOR OPEN LOW MT2 OPEN ALARM
#define ALM_DOOR_OPEN5								664		// NOTE : 2	S	INCV FDOOR OPEN MID OP1 OPEN ALARM
#define ALM_DOOR_OPEN6								665		// NOTE : 2	S	INCV FDOOR OPEN MID OP2 OPEN ALARM
#define ALM_DOOR_OPEN7								666		// NOTE : 2	S	INCV FDOOR OPEN MID OP3 OPEN ALARM
#define ALM_DOOR_OPEN8								667		// NOTE : 2	S	INCV FDOOR OPEN MID OP4 OPEN ALARM
#define ALM_DOOR_OPEN9								668		// NOTE : 2	S	INCV FDOOR OPEN MID MT1 OPEN ALARM
#define ALM_DOOR_OPEN10								669		// NOTE : 2	S	INCV FDOOR OPEN MID MT2 OPEN ALARM
#define ALM_DOOR_OPEN11								670		// NOTE : 2	S	INCV FDOOR OPEN MID MT3 OPEN ALARM
#define ALM_DOOR_OPEN12								671		// NOTE : 2	S	INCV FDOOR OPEN MID MT4 OPEN ALARM
#define ALM_DOOR_OPEN13								672		// NOTE : 2	S	SWR1 FDOOR OPEN LOW OP1 OPEN ALARM
#define ALM_DOOR_OPEN14								673		// NOTE : 2	S	SWR1 FDOOR OPEN LOW OP2 OPEN ALARM
#define ALM_DOOR_OPEN15								674		// NOTE : 2	S	SWR1 FDOOR OPEN LOW MT1 OPEN ALARM
#define ALM_DOOR_OPEN16								675		// NOTE : 2	S	SWR1 FDOOR OPEN LOW MT2 OPEN ALARM
#define ALM_DOOR_OPEN17								676		// NOTE : 2	S	SWR2 FDOOR OPEN LOW OP1 OPEN ALARM
#define ALM_DOOR_OPEN18								677		// NOTE : 2	S	SWR2 FDOOR OPEN LOW OP2 OPEN ALARM
#define ALM_DOOR_OPEN19								678		// NOTE : 2	S	SWR2 FDOOR OPEN LOW MT1 OPEN ALARM
#define ALM_DOOR_OPEN20								679		// NOTE : 2	S	SWR2 FDOOR OPEN LOW MT2 OPEN ALARM
#define ALM_DOOR_OPEN21								680		// NOTE : 2	S	SWR3 FDOOR OPEN LOW OP1 OPEN ALARM
#define ALM_DOOR_OPEN22								681		// NOTE : 2	S	SWR3 FDOOR OPEN LOW OP2 OPEN ALARM
#define ALM_DOOR_OPEN23								682		// NOTE : 2	S	SWR3 FDOOR OPEN LOW MT1 OPEN ALARM
#define ALM_DOOR_OPEN24								683		// NOTE : 2	S	SWR3 FDOOR OPEN LOW MT2 OPEN ALARM
#define ALM_DOOR_OPEN25								684		// NOTE : 2	S	SWR4 FDOOR OPEN LOW OP1 OPEN ALARM
#define ALM_DOOR_OPEN26								685		// NOTE : 2	S	SWR4 FDOOR OPEN LOW OP2 OPEN ALARM
#define ALM_DOOR_OPEN27								686		// NOTE : 2	S	SWR4 FDOOR OPEN LOW MT1 OPEN ALARM
#define ALM_DOOR_OPEN28								687		// NOTE : 2	S	SWR4 FDOOR OPEN LOW MT2 OPEN ALARM
#define ALM_DOOR_OPEN29								688		// NOTE : 2	S	AK FDOOR OPEN LOW OP1 OPEN ALARM
#define ALM_DOOR_OPEN30								689		// NOTE : 2	S	AK FDOOR OPEN LOW OP2 OPEN ALARM
#define ALM_DOOR_OPEN31								690		// NOTE : 2	S	AK FDOOR OPEN LOW MT1 OPEN ALARM
#define ALM_DOOR_OPEN32								691		// NOTE : 2	S	AK FDOOR OPEN LOW MT2 OPEN ALARM
#define ALM_DOOR_OPEN33								692		// NOTE : 2	S	BUF FDOOR OPEN LOW MT1 OPEN ALARM
#define ALM_DOOR_OPEN34								693		// NOTE : 2	S	BUF FDOOR OPEN LOW MT2 OPEN ALARM
#define ALM_DOOR_OPEN35								694		// NOTE : 2	S	BUF FDOOR OPEN MID MT1 OPEN ALARM
#define ALM_DOOR_OPEN36								695		// NOTE : 2	S	BUF FDOOR OPEN MID MT2 OPEN ALARM
#define ALM_DOOR_OPEN37								696		// NOTE : 2	S	OUTCV FDOOR OPEN LOW MT1 OPEN ALARM
#define ALM_DOOR_OPEN38								697		// NOTE : 2	S	OUTCV FDOOR OPEN LOW MT2 OPEN ALARM
#define ALM_DOOR_OPEN39								698		// NOTE : 2	S	OUTCV FDOOR OPEN LOW MT3 OPEN ALARM
#define ALM_DOOR_OPEN40								699		// NOTE : 2	S	OUTCV FDOOR OPEN LOW MT4 OPEN ALARM
#define ALM_DOOR_OPEN41								700		// NOTE : 2	S	OUTCV FDOOR OPEN MID MT1 OPEN ALARM
#define ALM_DOOR_OPEN42								701		// NOTE : 2	S	OUTCV FDOOR OPEN MID MT2 OPEN ALARM
#define ALM_DOOR_OPEN43								702		// NOTE : 2	S	OUTCV FDOOR OPEN MID MT3 OPEN ALARM
#define ALM_DOOR_OPEN44								703		// NOTE : 2	S	OUTCV FDOOR OPEN MID MT4 OPEN ALARM
//#define ALM_SPARE									704		// NOTE : 0	L	SPARE
//#define ALM_SPARE									705		// NOTE : 0	L	SPARE
//#define ALM_SPARE									706		// NOTE : 0	L	SPARE
//#define ALM_SPARE									707		// NOTE : 0	L	SPARE
//#define ALM_SPARE									708		// NOTE : 0	L	SPARE
//#define ALM_SPARE									709		// NOTE : 0	L	SPARE
//#define ALM_SPARE									710		// NOTE : 0	L	SPARE
//#define ALM_SPARE									711		// NOTE : 0	L	SPARE
//#define ALM_SPARE									712		// NOTE : 0	L	SPARE
//#define ALM_SPARE									713		// NOTE : 0	L	SPARE
#define ALM_LEAK1									714		// NOTE : 2	S	SWR2 LS02 LEAK ALARM
#define ALM_LEAK2									715		// NOTE : 2	S	SWR4 LS04 LEAK ALARM
#define ALM_LEAK3									716		// NOTE : 2	S	AK LS05 LEAK ALARM
//#define ALM_SPARE									717		// NOTE : 0	L	SPARE
//#define ALM_SPARE									718		// NOTE : 0	L	SPARE
//#define ALM_SPARE									719		// NOTE : 0	L	SPARE
//#define ALM_SPARE									720		// NOTE : 0	L	SPARE
//#define ALM_SPARE									721		// NOTE : 0	L	SPARE
//#define ALM_SPARE									722		// NOTE : 0	L	SPARE
//#define ALM_SPARE									723		// NOTE : 0	L	SPARE
//#define ALM_SPARE									724		// NOTE : 0	L	SPARE
//#define ALM_SPARE									725		// NOTE : 0	L	SPARE
//#define ALM_SPARE									726		// NOTE : 0	L	SPARE
#define ALM_CV_MOTOR_DRIVER_ALARM1					727		// NOTE : 2	S	INCV UNIT CV MOTOR1 DRIVER ALARM
#define ALM_CV_MOTOR_DRIVER_ALARM2					728		// NOTE : 2	S	SWR1 UNIT CV MOTOR1 DRIVER ALARM
#define ALM_CV_MOTOR_DRIVER_ALARM3					729		// NOTE : 2	S	SWR2 UNIT CV MOTOR1 DRIVER ALARM
#define ALM_CV_MOTOR_DRIVER_ALARM4					730		// NOTE : 2	S	SWR2 UNIT CV MOTOR2 DRIVER ALARM
#define ALM_CV_MOTOR_DRIVER_ALARM5					731		// NOTE : 2	S	SWR3 UNIT CV MOTOR1 DRIVER ALARM
#define ALM_CV_MOTOR_DRIVER_ALARM6					732		// NOTE : 2	S	SWR3 UNIT CV MOTOR2 DRIVER ALARM
#define ALM_CV_MOTOR_DRIVER_ALARM7					733		// NOTE : 2	S	SWR4 UNIT CV MOTOR1 DRIVER ALARM
#define ALM_CV_MOTOR_DRIVER_ALARM8					734		// NOTE : 2	S	AK UNIT CV MOTOR1 DRIVER ALARM
#define ALM_CV_MOTOR_DRIVER_ALARM9					735		// NOTE : 2	S	AK UNIT CV MOTOR2 DRIVER ALARM
#define ALM_CV_MOTOR_DRIVER_ALARM10					736		// NOTE : 2	S	BUF UNIT CV MOTOR1 DRIVER ALARM
#define ALM_CV_MOTOR_DRIVER_ALARM11					737		// NOTE : 2	S	OUTCV UNIT CV MOTOR1 DRIVER ALARM
//#define ALM_SPARE									738		// NOTE : 0	L	SPARE
//#define ALM_SPARE									739		// NOTE : 0	L	SPARE
//#define ALM_SPARE									740		// NOTE : 0	L	SPARE
//#define ALM_SPARE									741		// NOTE : 0	L	SPARE
//#define ALM_SPARE									742		// NOTE : 0	L	SPARE
//#define ALM_SPARE									743		// NOTE : 0	L	SPARE
//#define ALM_SPARE									744		// NOTE : 0	L	SPARE
//#define ALM_SPARE									745		// NOTE : 0	L	SPARE
//#define ALM_SPARE									746		// NOTE : 0	L	SPARE
//#define ALM_SPARE									747		// NOTE : 0	L	SPARE
#define ALM_CV_MOTOR_DRIVER_CP_OFF1					748		// NOTE : 2	S	INCV UNIT CV MOTOR1 DRIVER CP OFF
#define ALM_CV_MOTOR_DRIVER_CP_OFF2					749		// NOTE : 2	S	SWR1 UNIT CV MOTOR1 DRIVER CP OFF
#define ALM_CV_MOTOR_DRIVER_CP_OFF3					750		// NOTE : 2	S	SWR2 UNIT CV MOTOR1 DRIVER CP OFF
#define ALM_CV_MOTOR_DRIVER_CP_OFF4					751		// NOTE : 2	S	SWR2 UNIT CV MOTOR2 DRIVER CP OFF
#define ALM_CV_MOTOR_DRIVER_CP_OFF5					752		// NOTE : 2	S	SWR3 UNIT CV MOTOR1 DRIVER CP OFF
#define ALM_CV_MOTOR_DRIVER_CP_OFF6					753		// NOTE : 2	S	SWR3 UNIT CV MOTOR2 DRIVER CP OFF
#define ALM_CV_MOTOR_DRIVER_CP_OFF7					754		// NOTE : 2	S	SWR4 UNIT CV MOTOR1 DRIVER CP OFF
#define ALM_CV_MOTOR_DRIVER_CP_OFF8					755		// NOTE : 2	S	AK UNIT CV MOTOR1 DRIVER CP OFF
#define ALM_CV_MOTOR_DRIVER_CP_OFF9					756		// NOTE : 2	S	AK UNIT CV MOTOR2 DRIVER CP OFF
#define ALM_CV_MOTOR_DRIVER_CP_OFF10				757		// NOTE : 2	S	BUF UNIT CV MOTOR1 DRIVER CP OFF
#define ALM_CV_MOTOR_DRIVER_CP_OFF11				758		// NOTE : 2	S	OUTCV UNIT CV MOTOR1 DRIVER CP OFF
//#define ALM_SPARE									759		// NOTE : 0	L	SPARE
//#define ALM_SPARE									760		// NOTE : 0	L	SPARE
//#define ALM_SPARE									761		// NOTE : 0	L	SPARE
//#define ALM_SPARE									762		// NOTE : 0	L	SPARE
//#define ALM_SPARE									763		// NOTE : 0	L	SPARE
//#define ALM_SPARE									764		// NOTE : 0	L	SPARE
//#define ALM_SPARE									765		// NOTE : 0	L	SPARE
//#define ALM_SPARE									766		// NOTE : 0	L	SPARE
//#define ALM_SPARE									767		// NOTE : 0	L	SPARE
//#define ALM_SPARE									768		// NOTE : 0	L	SPARE
#define ALM_UL_UNIT_BROKEN_SENSOR1					769		// NOTE : 2	S	OUTCV UNIT GLASS FIX BROKEN OP1 ALARM
#define ALM_UL_UNIT_BROKEN_SENSOR2					770		// NOTE : 2	S	OUTCV UNIT GLASS FIX BROKEN OP2 ALARM
#define ALM_UL_UNIT_BROKEN_SENSOR3					771		// NOTE : 2	S	OUTCV UNIT GLASS FIX BROKEN MT1 ALARM
#define ALM_UL_UNIT_BROKEN_SENSOR4					772		// NOTE : 2	S	OUTCV UNIT GLASS FIX BROKEN MT2 ALARM
//#define ALM_SPARE									773		// NOTE : 0	L	SPARE
//#define ALM_SPARE									774		// NOTE : 0	L	SPARE
//#define ALM_SPARE									775		// NOTE : 0	L	SPARE
//#define ALM_SPARE									776		// NOTE : 0	L	SPARE
//#define ALM_SPARE									777		// NOTE : 0	L	SPARE
#define ALM_UL_UNIT_SCAN_SENSOR						778		// NOTE : 2	S	OUTCV UNIT GLASS SCAN BROKEN ALARM
#define ALM_LD_UNIT_SCAN_SENSOR						779		// NOTE : 2	S	INCV UNIT GLASS SCAN BROKEN ALARM
//#define ALM_SPARE									780		// NOTE : 0	L	SPARE
//#define ALM_SPARE									781		// NOTE : 0	L	SPARE
//#define ALM_SPARE									782		// NOTE : 0	L	SPARE
//#define ALM_SPARE									783		// NOTE : 0	L	SPARE
//#define ALM_SPARE									784		// NOTE : 0	L	SPARE
#define ALM_DI_PUMP_ALARM1							785		// NOTE : 2	S	SWR2 UNIT DIW PUMP ALARM
#define ALM_DI_PUMP_ALARM2							786		// NOTE : 2	S	SWR3 UNIT DIW PUMP ALARM
#define ALM_DI_PUMP1_INTERLOCK_ALARM				787		// NOTE : 2	S	SWR2 UNIT DIW PUMP FLOW INTERLOCK ALARM
#define ALM_DI_PUMP2_INTERLOCK_ALARM				788		// NOTE : 2	S	SWR3 UNIT DIW PUMP FLOW INTERLOCK ALARM
//#define ALM_SPARE									789		// NOTE : 0	L	SPARE
//#define ALM_SPARE									790		// NOTE : 0	L	SPARE
//#define ALM_SPARE									791		// NOTE : 0	L	SPARE
//#define ALM_SPARE									792		// NOTE : 0	L	SPARE
//#define ALM_SPARE									793		// NOTE : 0	L	SPARE
#define ALM_DI_TANK1_LV_SENSOR_ALARM1				794		// NOTE : 2	S	SWR2 DIW TANK LL LEVEL FAULT ALARM
#define ALM_DI_TANK1_LV_SENSOR_ALARM2				795		// NOTE : 2	S	SWR2 DIW TANK L LEVEL FAULT ALARM
#define ALM_DI_TANK1_LV_SENSOR_ALARM3				796		// NOTE : 2	S	SWR2 DIW TANK H LEVEL FAULT ALARM
#define ALM_DI_TANK1_LV_SENSOR_ALARM4				797		// NOTE : 2	S	SWR2 DIW TANK HH LEVEL FAULT ALARM
#define ALM_DI_TANK2_LV_SENSOR_ALARM1				798		// NOTE : 2	S	SWR3 DIW TANK LL LEVEL FAULT ALARM
#define ALM_DI_TANK2_LV_SENSOR_ALARM2				799		// NOTE : 2	S	SWR3 DIW TANK L LEVEL FAULT ALARM
#define ALM_DI_TANK2_LV_SENSOR_ALARM3				800		// NOTE : 2	S	SWR3 DIW TANK H LEVEL FAULT ALARM
#define ALM_DI_TANK2_LV_SENSOR_ALARM4				801		// NOTE : 2	S	SWR3 DIW TANK HH LEVEL FAULT ALARM
//#define ALM_SPARE									802		// NOTE : 0	L	SPARE
//#define ALM_SPARE									803		// NOTE : 0	L	SPARE
//#define ALM_SPARE									804		// NOTE : 0	L	SPARE
//#define ALM_SPARE									805		// NOTE : 0	L	SPARE
//#define ALM_SPARE									806		// NOTE : 0	L	SPARE
#define ALM_DI_TANK1_LV_SENSOR_ALARM5				807		// NOTE : 2	S	SWR2 DIW TANK LL LEVEL INTERLOCK ALARM
#define ALM_DI_TANK1_LV_SENSOR_ALARM6				808		// NOTE : 2	S	SWR2 DIW TANK HH LEVEL INTERLOCK ALARM
#define ALM_DI_TANK2_LV_SENSOR_ALARM5				809		// NOTE : 2	S	SWR3 DIW TANK LL LEVEL INTERLOCK ALARM
#define ALM_DI_TANK2_LV_SENSOR_ALARM6				810		// NOTE : 2	S	SWR3 DIW TANK HH LEVEL INTERLOCK ALARM
//#define ALM_SPARE									811		// NOTE : 0	L	SPARE
//#define ALM_SPARE									812		// NOTE : 0	L	SPARE
//#define ALM_SPARE									813		// NOTE : 0	L	SPARE
//#define ALM_SPARE									814		// NOTE : 0	L	SPARE
//#define ALM_SPARE									815		// NOTE : 0	L	SPARE
#define ALM_SWR2_RB_UNIT_UP_RB1_SERVO_ALARM			816		// NOTE : 2	S	SWR2 RB UNIT Upper R/B1 Servo Motor Alarm
#define ALM_SWR2_RB_UNIT_LO_RB1_SERVO_ALARM			817		// NOTE : 2	S	SWR2 RB UNIT Lower R/B1 Servo Motor Alarm
#define ALM_SWR2_RB_UNIT_UP_RB2_SERVO_ALARM			818		// NOTE : 2	S	SWR2 RB UNIT Upper R/B2 Servo Motor Alarm
#define ALM_SWR2_RB_UNIT_LO_RB2_SERVO_ALARM			819		// NOTE : 2	S	SWR2 RB UNIT Lower R/B2 Servo Motor Alarm
#define ALM_SWR3_RB_UNIT_UP_RB1_SERVO_ALARM			820		// NOTE : 2	S	SWR3 RB UNIT Upper R/B1 Servo Motor Alarm
#define ALM_SWR3_RB_UNIT_LO_RB1_SERVO_ALARM			821		// NOTE : 2	S	SWR3 RB UNIT Lower R/B1 Servo Motor Alarm
#define ALM_SWR3_RB_UNIT_UP_RB2_SERVO_ALARM			822		// NOTE : 2	S	SWR3 RB UNIT Upper R/B2 Servo Motor Alarm
#define ALM_SWR3_RB_UNIT_LO_RB2_SERVO_ALARM			823		// NOTE : 2	S	SWR3 RB UNIT Lower R/B2 Servo Motor Alarm
#define ALM_SWR2_RB_UNIT_UP_RB1_SERVO_HOME			824		// NOTE : 2	S	SWR2 RB UNIT Upper R/B1 Unit Servo Homing Alarm
#define ALM_SWR2_RB_UNIT_LO_RB1_SERVO_HOME			825		// NOTE : 2	S	SWR2 RB UNIT Lower R/B1 Unit Servo Homing Alarm
#define ALM_SWR2_RB_UNIT_UP_RB2_SERVO_HOME			826		// NOTE : 2	S	SWR2 RB UNIT Upper R/B2 Unit Servo Homing Alarm
#define ALM_SWR2_RB_UNIT_LO_RB2_SERVO_HOME			827		// NOTE : 2	S	SWR2 RB UNIT Lower R/B2 Unit Servo Homing Alarm
#define ALM_SWR3_RB_UNIT_UP_RB1_SERVO_HOME			828		// NOTE : 2	S	SWR3 RB UNIT Upper R/B1 Unit Servo Homing Alarm
#define ALM_SWR3_RB_UNIT_LO_RB1_SERVO_HOME			829		// NOTE : 2	S	SWR3 RB UNIT Lower R/B1 Unit Servo Homing Alarm
#define ALM_SWR3_RB_UNIT_UP_RB2_SERVO_HOME			830		// NOTE : 2	S	SWR3 RB UNIT Upper R/B2 Unit Servo Homing Alarm
#define ALM_SWR3_RB_UNIT_LO_RB2_SERVO_HOME			831		// NOTE : 2	S	SWR3 RB UNIT Lower R/B2 Unit Servo Homing Alarm
#define ALM_SWR2_RB_UNIT_UP_RB1_SERVO_MOVE_POS		832		// NOTE : 2	S	SWR2 RB UNIT Upper R/B1 Unit Servo Moving Alarm
#define ALM_SWR2_RB_UNIT_LO_RB1_SERVO_MOVE_POS		833		// NOTE : 2	S	SWR2 RB UNIT Lower R/B1 Unit Servo Moving Alarm
#define ALM_SWR2_RB_UNIT_UP_RB2_SERVO_MOVE_POS		834		// NOTE : 2	S	SWR2 RB UNIT Upper R/B2 Unit Servo Moving Alarm
#define ALM_SWR2_RB_UNIT_LO_RB2_SERVO_MOVE_POS		835		// NOTE : 2	S	SWR2 RB UNIT Lower R/B2 Unit Servo Moving Alarm
#define ALM_SWR3_RB_UNIT_UP_RB1_SERVO_MOVE_POS		836		// NOTE : 2	S	SWR3 RB UNIT Upper R/B1 Unit Servo Moving Alarm
#define ALM_SWR3_RB_UNIT_LO_RB1_SERVO_MOVE_POS		837		// NOTE : 2	S	SWR3 RB UNIT Lower R/B1 Unit Servo Moving Alarm
#define ALM_SWR3_RB_UNIT_UP_RB2_SERVO_MOVE_POS		838		// NOTE : 2	S	SWR3 RB UNIT Upper R/B2 Unit Servo Moving Alarm
#define ALM_SWR3_RB_UNIT_LO_RB2_SERVO_MOVE_POS		839		// NOTE : 2	S	SWR3 RB UNIT Lower R/B2 Unit Servo Moving Alarm
//#define ALM_SPARE									840		// NOTE : 0	L	SPARE
//#define ALM_SPARE									841		// NOTE : 0	L	SPARE
//#define ALM_SPARE									842		// NOTE : 0	L	SPARE
//#define ALM_SPARE									843		// NOTE : 0	L	SPARE
//#define ALM_SPARE									844		// NOTE : 0	L	SPARE
#define ALM_INCV_GLS_NOT_EXIST_AFTER_RECV			845		// NOTE : 2	S	INCV UNIT GLASS NOT EXIST AFTER RECEIV
#define ALM_INCV_GLS_EXIST_BEFORE_RECV				846		// NOTE : 2	S	INCV UNIT GLASS EXIST BEFORE RECEIVE
//#define ALM_SPARE									847		// NOTE : 0	L	SPARE
//#define ALM_SPARE									848		// NOTE : 0	L	SPARE
//#define ALM_SPARE									849		// NOTE : 0	L	SPARE
//#define ALM_SPARE									850		// NOTE : 0	L	SPARE
//#define ALM_SPARE									851		// NOTE : 0	L	SPARE
#define ALM_INCV_UNIT_ALIGN_FW						852		// NOTE : 2	S	INCV UNIT ALIGN FW TIMEOUT ALARM
#define ALM_INCV_UNIT_ALIGN_BW						853		// NOTE : 2	S	INCV UNIT ALIGN BW TIMEOUT ALARM
#define ALM_OUTCV_UNIT_ALIGN_FW						854		// NOTE : 2	S	OUTCV UNIT ALIGN FW TIMEOUT ALARM
#define ALM_OUTCV_UNIT_ALIGN_BW						855		// NOTE : 2	S	OUTCV UNIT ALIGN BW TIMEOUT ALARM
#define ALM_OUTCV_UNIT_ALIGN_UP						856		// NOTE : 2	S	OUTCV UNIT ALIGN UP TIMEOUT ALARM
#define ALM_OUTCV_UNIT_ALIGN_DOWN					857		// NOTE : 2	S	OUTCV UNIT ALIGN DOWN TIMEOUT ALARM
#define ALM_OUTCV_UNIT_PIN_UP						858		// NOTE : 2	S	OUTCV UNIT PIN UP TIMEOUT ALARM
#define ALM_OUTCV_UNIT_PIN_DOWN						859		// NOTE : 2	S	OUTCV UNIT PIN DOWN TIMEOUT ALARM
//#define ALM_SPARE									860		// NOTE : 0	L	SPARE
//#define ALM_SPARE									861		// NOTE : 0	L	SPARE
//#define ALM_SPARE									862		// NOTE : 0	L	SPARE
//#define ALM_SPARE									863		// NOTE : 0	L	SPARE
//#define ALM_SPARE									864		// NOTE : 0	L	SPARE
#define ALM_PARTS_LIFE_TIME_OVER1					865		// NOTE : 6	L	SWR1 UNIT CDA IN ION AND AC IN FILTER LIFE TIMEOVER WARNING
#define ALM_PARTS_LIFE_TIME_OVER2					866		// NOTE : 6	L	SWR1 UNIT CDA IN SWR1 MJ IN FILTER LIFE TIMEOVER WARNING
#define ALM_PARTS_LIFE_TIME_OVER3					867		// NOTE : 6	L	SWR1 UNIT DI SPL IN FILTER LIFE TIMEOVER WARNING
#define ALM_PARTS_LIFE_TIME_OVER4					868		// NOTE : 6	L	SWR1 UNIT DI SPL IN FL FILTER LIFE TIMEOVER WARNING
#define ALM_PARTS_LIFE_TIME_OVER5					869		// NOTE : 6	L	SWR2 UNIT DI IN FILTER LIFE TIMEOVER WARNING
#define ALM_PARTS_LIFE_TIME_OVER6					870		// NOTE : 6	L	SWR3 UNIT DI IN FILTER LIFE TIMEOVER WARNING
#define ALM_PARTS_LIFE_TIME_OVER7					871		// NOTE : 6	L	SWR4 UNIT DI SPL IN FILTER LIFE TIMEOVER WARNING
#define ALM_PARTS_LIFE_TIME_OVER8					872		// NOTE : 6	L	SWR4 UNIT DI SPL IN FL FILTER LIFE TIMEOVER WARNING
#define ALM_PARTS_LIFE_TIME_OVER9					873		// NOTE : 6	L	SWR4 UNIT CDA IN SWR4 MJ IN FILTER LIFE TIMEOVER WARNING
#define ALM_PARTS_LIFE_TIME_OVER10					874		// NOTE : 6	L	AK UNIT CDA IN LO AK IN FILTER LIFE TIMEOVER WARNING
#define ALM_PARTS_LIFE_TIME_OVER11					875		// NOTE : 6	L	AK UNIT CDA IN UP AK IN FILTER LIFE TIMEOVER WARNING
#define ALM_PARTS_LIFE_TIME_OVER12					876		// NOTE : 6	L	AK UNIT ION AND AC IN FILTER LIFE TIMEOVER WARNING
#define ALM_PARTS_LIFE_TIME_OVER13					877		// NOTE : 6	L	SWR2 RB UNIT R/B1 Up Brush LIFE TIME OVER WARNING
#define ALM_PARTS_LIFE_TIME_OVER14					878		// NOTE : 6	L	SWR2 RB UNIT R/B1 Lo Brush LIFE TIME OVER WARNING
#define ALM_PARTS_LIFE_TIME_OVER15					879		// NOTE : 6	L	SWR2 RB UNIT R/B2 Up Brush LIFE TIME OVER WARNING
#define ALM_PARTS_LIFE_TIME_OVER16					880		// NOTE : 6	L	SWR2 RB UNIT R/B2 Lo Brush LIFE TIME OVER WARNING
#define ALM_PARTS_LIFE_TIME_OVER17					881		// NOTE : 6	L	SWR3 RB UNIT R/B1 Up Brush LIFE TIME OVER WARNING
#define ALM_PARTS_LIFE_TIME_OVER18					882		// NOTE : 6	L	SWR3 RB UNIT R/B1 Lo Brush LIFE TIME OVER WARNING
#define ALM_PARTS_LIFE_TIME_OVER19					883		// NOTE : 6	L	SWR3 RB UNIT R/B2 Up Brush LIFE TIME OVER WARNING
#define ALM_PARTS_LIFE_TIME_OVER20					884		// NOTE : 6	L	SWR3 RB UNIT R/B2 Lo Brush LIFE TIME OVER WARNING
//#define ALM_SPARE									885		// NOTE : 0	L	SPARE
//#define ALM_SPARE									886		// NOTE : 0	L	SPARE
//#define ALM_SPARE									887		// NOTE : 0	L	SPARE
//#define ALM_SPARE									888		// NOTE : 0	L	SPARE
//#define ALM_SPARE									889		// NOTE : 0	L	SPARE
#define ALM_FFU_CP_TURN_OFF1						890		// NOTE : 2	S	INCV UNIT FFU1 CP OFF ALARM
#define ALM_FFU_FAN_ALARM1							891		// NOTE : 2	S	INCV UNIT FFU1 ALARM
#define ALM_FFU_CP_TURN_OFF2						892		// NOTE : 2	S	INCV UNIT FFU2 CP OFF ALARM
#define ALM_FFU_FAN_ALARM2							893		// NOTE : 2	S	INCV UNIT FFU2 ALARM
#define ALM_FFU_CP_TURN_OFF3						894		// NOTE : 2	S	INCV UNIT FFU3 CP OFF ALARM
#define ALM_FFU_FAN_ALARM3							895		// NOTE : 2	S	INCV UNIT FFU3 ALARM
#define ALM_FFU_CP_TURN_OFF4						896		// NOTE : 2	S	AK UNIT HEPA CP OFF ALARM
#define ALM_FFU_FAN_ALARM4							897		// NOTE : 2	S	AK UNIT HEPA ALARM
#define ALM_FFU_CP_TURN_OFF5						898		// NOTE : 2	S	OUTCV UNIT FFU1 CP OFF ALARM
#define ALM_FFU_FAN_ALARM5							899		// NOTE : 2	S	OUTCV UNIT FFU1 ALARM
#define ALM_FFU_CP_TURN_OFF6						900		// NOTE : 2	S	OUTCV UNIT FFU2 CP OFF ALARM
#define ALM_FFU_FAN_ALARM6							901		// NOTE : 2	S	OUTCV UNIT FFU2 ALARM
#define ALM_FFU_CP_TURN_OFF7						902		// NOTE : 2	S	OUTCV UNIT FFU3 CP OFF ALARM
#define ALM_FFU_FAN_ALARM7							903		// NOTE : 2	S	OUTCV UNIT FFU3 ALARM
//#define ALM_SPARE									904		// NOTE : 0	L	SPARE
//#define ALM_SPARE									905		// NOTE : 0	L	SPARE
//#define ALM_SPARE									906		// NOTE : 0	L	SPARE
//#define ALM_SPARE									907		// NOTE : 0	L	SPARE
//#define ALM_SPARE									908		// NOTE : 0	L	SPARE
#define ALM_IONIZER_ALARM1							909		// NOTE : 2	S	INCV UNIT IONIZER CONTROLLER ALARM
#define ALM_IONIZER_ALARM2							910		// NOTE : 2	S	INCV IONIZER LEVEL ALARM
#define ALM_IONIZER_ALARM3							911		// NOTE : 2	S	INCV IONIZER CONDITION ALARM
#define ALM_IONIZER_ALARM4							912		// NOTE : 2	S	BUF UNIT IONIZER CONTROLLER ALARM
#define ALM_IONIZER_ALARM5							913		// NOTE : 2	S	BUF IONIZER LEVEL ALARM
#define ALM_IONIZER_ALARM6							914		// NOTE : 2	S	BUF IONIZER CONDITION ALARM
//#define ALM_SPARE									915		// NOTE : 0	L	SPARE
//#define ALM_SPARE									916		// NOTE : 0	L	SPARE
//#define ALM_SPARE									917		// NOTE : 0	L	SPARE
//#define ALM_SPARE									918		// NOTE : 0	L	SPARE
//#define ALM_SPARE									919		// NOTE : 0	L	SPARE
#define ALM_ROBOT_HAND_INTERRUPT1					920		// NOTE : 2	S	INCV ROBOT HAND INTERRUPT ALARM
#define ALM_ROBOT_HAND_INTERRUPT2					921		// NOTE : 2	S	OUTCV ROBOT HAND INTERRUPT ALARM
//#define ALM_SPARE									922		// NOTE : 0	L	SPARE
//#define ALM_SPARE									923		// NOTE : 0	L	SPARE
//#define ALM_SPARE									924		// NOTE : 0	L	SPARE
//#define ALM_SPARE									925		// NOTE : 0	L	SPARE
//#define ALM_SPARE									926		// NOTE : 0	L	SPARE
#define ALM_LD_ALIGN_CYL_TIMEOUT					927		// NOTE : 2	S	INCV Align Align Cylinder Timeout
#define ALM_UD_ALIGN_CYL_TIMEOUT					928		// NOTE : 2	S	OUTCV Align Align Cylinder Timeout
#define ALM_UD_ALIGN_UD_CYL_TIMEOUT					929		// NOTE : 2	S	OUTCV Align Align Updown Cylinder Timeout
#define ALM_UD_PIN_UD_CYL_TIMEOUT					930		// NOTE : 2	S	OUTCV Align Pin Updown Cylinder Timeout
//#define ALM_SPARE									931		// NOTE : 0	L	SPARE
//#define ALM_SPARE									932		// NOTE : 0	L	SPARE
//#define ALM_SPARE									933		// NOTE : 0	L	SPARE
//#define ALM_SPARE									934		// NOTE : 0	L	SPARE
//#define ALM_SPARE									935		// NOTE : 0	L	SPARE
#define ALM_GLS_DATA_WRONG							936		// NOTE : 2	S	RECEIVE GLASS DATA WRONG ALARM
#define ALM_CIM_T3_TIMEOUT							937		// NOTE : 6	L	T3 TIMEOUT WARNING
#define ALM_CIM_T5_TIMEOUT							938		// NOTE : 6	L	T5 TIMEOUT WARNING
#define ALM_AFTER_LOADING_GLS_NOT_EXIST				939		// NOTE : 2	S	GLASS NOT EXIST AFTER RECEIVE ALARM
#define ALM_AFTER_UNLOADING_GLS_EXIST				940		// NOTE : 2	S	GLASS EXIST AFTER SEND ALARM
#define ALM_CIMPC_T1_TIMEOUT						941		// NOTE : 6 L	CIMPC T1 TIMEOUT WARNING
#define ALM_CIMPC_T2_TIMEOUT						942		// NOTE : 6 L	CIMPC T2 TIMEOUT WARNING
#define ALM_CIMPC_T3_TIMEOUT						943		// NOTE : 6 L	CIMPC T3 TIMEOUT WARNING
//#define ALM_SPARE									944		// NOTE : 0	L	SPARE
//#define ALM_SPARE									945		// NOTE : 0	L	SPARE
//#define ALM_SPARE									946		// NOTE : 0	L	SPARE
//#define ALM_SPARE									947		// NOTE : 0	L	SPARE
//#define ALM_SPARE									948		// NOTE : 0	L	SPARE
#define ALM_LOADER_LOADING_T1						949		// NOTE : 2	S	[LOADING] TRANSFER READY TO CLEANER NOT TURN ON
#define ALM_LOADER_LOADING_T3						950		// NOTE : 2	S	[LOADING] ROBOT ACCESSING TO CLEANER NOT TURN ON
#define ALM_LOADER_LOADING_T4						951		// NOTE : 2	S	[LOADING] ROBOT ACCESSING TO CLEANER NOT TURN OFF
#define ALM_LOADER_LOADING_T5						952		// NOTE : 2	S	[LOADING] ROBOT ACCESSING TO CLEANER NOT TURN ON
#define ALM_LOADER_LOADING_T6						953		// NOTE : 2	S	[LOADING] CLEANER RECEIVED DATA READ REQUEST NOT TURN ON
#define ALM_LOADER_LOADING_T8						954		// NOTE : 2	S	[LOADING] CLEANER RECEIVED DATA READ REQUEST NOT TURN OFF
#define ALM_LOADER_UNLOADING_T1						955		// NOTE : 2	S	[UNLOADING] TRANSFER READY TO CLEANER NOT TURN ON
#define ALM_LOADER_UNLOADING_T3						956		// NOTE : 2	S	[UNLOADING] ROBOT ACCESSING TO CLEANER NOT TURN ON
#define ALM_LOADER_UNLOADING_T4						957		// NOTE : 2	S	[UNLOADING] ROBOT ACCESSING TO CLEANER NOT TURN OFF
#define ALM_LOADER_UNLOADING_T5						958		// NOTE : 2	S	[UNLOADING] ROBOT ACCESSING TO CLEANER NOT TURN OFF
#define ALM_LOADER_UNLOADING_T6						959		// NOTE : 2	S	[UNLOADING] CLEANER RECEIVED DATA READ COMPLETE NOT TURN ON
#define ALM_LOADER_UNLOADING_T8						960		// NOTE : 2	S	[UNLOADING] CLEANER RECEIVED DATA READ COMPLETE NOT TURN OFF
//#define ALM_SPARE									961		// NOTE : 0	L	SPARE
//#define ALM_SPARE									962		// NOTE : 0	L	SPARE
//#define ALM_SPARE									963		// NOTE : 0	L	SPARE
//#define ALM_SPARE									964		// NOTE : 0	L	SPARE
//#define ALM_SPARE									965		// NOTE : 0	L	SPARE
#define ALM_RBT_AMP_FAULT_ERROR1					966		// NOTE : 2	S	ROBOT AMP FAULT ALARM
#define ALM_DATA_READ_REQUEST_TIMEOUT				967		// NOTE : 2	S	DATA READ REQUEST TIMEOUT ALARM
//#define ALM_SPARE									968		// NOTE : 0	L	SPARE
//#define ALM_SPARE									969		// NOTE : 0	L	SPARE
//#define ALM_SPARE									970		// NOTE : 0	L	SPARE
//#define ALM_SPARE									971		// NOTE : 0	L	SPARE
//#define ALM_SPARE									972		// NOTE : 0	L	SPARE
#define ALM_SEQUENCE_DELAY							973		// NOTE : 6	L	SEQUENCE DELAY WARNING
//#define ALM_SPARE									974		// NOTE : 0	L	SPARE
//#define ALM_SPARE									975		// NOTE : 0	L	SPARE
//#define ALM_SPARE									976		// NOTE : 0	L	SPARE
//#define ALM_SPARE									977		// NOTE : 0	L	SPARE
//#define ALM_SPARE									978		// NOTE : 0	L	SPARE
#define ALM_LD_UNIT_BROKEN_SENSOR1					979		// NOTE : 2	S	INCV UNIT GLASS FIX BROKEN OP1 ALARM
#define ALM_LD_UNIT_BROKEN_SENSOR2					980		// NOTE : 2	S	INCV UNIT GLASS FIX BROKEN OP2 ALARM
#define ALM_LD_UNIT_BROKEN_SENSOR3					981		// NOTE : 2	S	INCV UNIT GLASS FIX BROKEN MT1 ALARM
#define ALM_LD_UNIT_BROKEN_SENSOR4					982		// NOTE : 2	S	INCV UNIT GLASS FIX BROKEN MT2 ALARM
//#define ALM_SPARE									983		// NOTE : 0	L	SPARE
//#define ALM_SPARE									984		// NOTE : 0	L	SPARE
//#define ALM_SPARE									985		// NOTE : 0	L	SPARE
//#define ALM_SPARE									986		// NOTE : 0	L	SPARE
//#define ALM_SPARE									987		// NOTE : 0	L	SPARE
#define ALM_MUX_COMM_READ_ERROR1					988		// NOTE : 6	L	SWR2 RB TACHOMETER READ FAIL ERROR
#define ALM_MUX_COMM_READ_ERROR2					989		// NOTE : 6	L	SWR3 RB TACHOMETER READ FAIL ERROR
#define ALM_MUX_COMM_DATA_ERROR_SW2_RB1_UP			990		// NOTE : 6 L	SWR2 RB1 UP TACHOMETER DATA IS EMPTY
#define ALM_MUX_COMM_DATA_ERROR_SW2_RB1_LO			991		// NOTE : 6 L	SWR2 RB1 LO TACHOMETER DATA IS EMPTY
#define ALM_MUX_COMM_DATA_ERROR_SW2_RB2_UP			992		// NOTE : 6 L	SWR2 RB2 UP TACHOMETER DATA IS EMPTY
#define ALM_MUX_COMM_DATA_ERROR_SW2_RB2_LO			993		// NOTE : 6 L	SWR2 RB2 LO TACHOMETER DATA IS EMPTY
#define ALM_MUX_COMM_DATA_ERROR_SW3_RB1_UP			994		// NOTE : 6 L	SWR3 RB1 UP TACHOMETER DATA IS EMPTY
#define ALM_MUX_COMM_DATA_ERROR_SW3_RB1_LO			995		// NOTE : 6 L	SWR3 RB1 LO TACHOMETER DATA IS EMPTY
#define ALM_MUX_COMM_DATA_ERROR_SW3_RB2_UP			996		// NOTE : 6 L	SWR3 RB2 UP TACHOMETER DATA IS EMPTY
#define ALM_MUX_COMM_DATA_ERROR_SW3_RB2_LO			997		// NOTE : 6 L	SWR3 RB2 LO TACHOMETER DATA IS EMPTY
#define ALM_MUX_COMM_FORMAT_ERROR_SW2_RB1_UP		998		// NOTE : 6 L	SWR2 RB1 UP TACHOMETER DATA IS WRONG FORMAT
#define ALM_MUX_COMM_FORMAT_ERROR_SW2_RB1_LO		999		// NOTE : 6 L	SWR2 RB1 LO TACHOMETER DATA IS WRONG FORMAT
#define ALM_MUX_COMM_FORMAT_ERROR_SW2_RB2_UP		1000	// NOTE : 6 L	SWR2 RB2 UP TACHOMETER DATA IS WRONG FORMAT
#define ALM_MUX_COMM_FORMAT_ERROR_SW2_RB2_LO		1001	// NOTE : 6 L	SWR2 RB2 LO TACHOMETER DATA IS WRONG FORMAT
#define ALM_MUX_COMM_FORMAT_ERROR_SW3_RB1_UP		1002	// NOTE : 6 L	SWR3 RB1 UP TACHOMETER DATA IS WRONG FORMAT 
#define ALM_MUX_COMM_FORMAT_ERROR_SW3_RB1_LO		1003	// NOTE : 6 L	SWR3 RB1 LO TACHOMETER DATA IS WRONG FORMAT 
#define ALM_MUX_COMM_FORMAT_ERROR_SW3_RB2_UP		1004	// NOTE : 6 L	SWR3 RB2 UP TACHOMETER DATA IS WRONG FORMAT 
#define ALM_MUX_COMM_FORMAT_ERROR_SW3_RB2_LO		1005	// NOTE : 6 L	SWR3 RB2 LO TACHOMETER DATA IS WRONG FORMAT
#define ALM_MUX_COMM_CHANNEL_MATCHING_SW2_RB1_UP	1006	// NOTE : 6 L	SWR2 RB1 UP TACHOMETER DATA CHANNEL IS NOT MATCHING
#define ALM_MUX_COMM_CHANNEL_MATCHING_SW2_RB1_LO	1007	// NOTE : 6 L	SWR2 RB1 LO TACHOMETER DATA CHANNEL IS NOT MATCHING
#define ALM_MUX_COMM_CHANNEL_MATCHING_SW2_RB2_UP	1008	// NOTE : 6 L	SWR2 RB2 UP TACHOMETER DATA CHANNEL IS NOT MATCHING
#define ALM_MUX_COMM_CHANNEL_MATCHING_SW2_RB2_LO	1009	// NOTE : 6 L	SWR2 RB2 LO TACHOMETER DATA CHANNEL IS NOT MATCHING
#define ALM_MUX_COMM_CHANNEL_MATCHING_SW3_RB1_UP	1010	// NOTE : 6 L	SWR3 RB1 UP TACHOMETER DATA CHANNEL IS NOT MATCHING 
#define ALM_MUX_COMM_CHANNEL_MATCHING_SW3_RB1_LO	1011	// NOTE : 6 L	SWR3 RB1 LO TACHOMETER DATA CHANNEL IS NOT MATCHING 
#define ALM_MUX_COMM_CHANNEL_MATCHING_SW3_RB2_UP	1012	// NOTE : 6 L	SWR3 RB2 UP TACHOMETER DATA CHANNEL IS NOT MATCHING 
#define ALM_MUX_COMM_CHANNEL_MATCHING_SW3_RB2_LO	1013	// NOTE : 6 L	SWR3 RB2 LO TACHOMETER DATA CHANNEL IS NOT MATCHING

//BEGIN														
#define MAX_ALARM_NO							1015							
#endif	// _DEFINEALARM_H															
//END																