// DicsData.h: interface for the CCCmoG7SptHdcCimSeq class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DICSDATA_H__F4006C0D_E892_4E36_BDB8_FFED751E55A8__INCLUDED_)
#define AFX_DICSDATA_H__F4006C0D_E892_4E36_BDB8_FFED751E55A8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DicsDataBase.h"

// ߰  ؼ ش Data Info Class  ޾Ƽ.... 
class CIfCimInfoHdc : public CIfCimInfo
{
public:
	BOOL	bIonizerStatusChangeReq;

	BOOL	bSptRecoveryMode;	// 0:Normal Mode, 1:Recovery Mode
	BOOL	bClnRecoveryMode;
	BOOL	bEdcDataReportReq;

	BOOL	bTraceDataStartReq;
	BOOL	bTraceDataStopReq;

	double		dTraceDataSampTime;

	UINT	uTraceID;
	int		nTraceList[MAX_TRACE_DATA_NO];
	CString sTraceDataValue[MAX_TRACE_DATA_NO];
	CString sTraceDataTime;//2008.12.01. kimgun
	////////////////////////////////////////////////////

	BOOL	bAllGlsPosDataReq;
	BOOL	bAllGlsPosDataIng;
	BOOL	bAllGlsPosDataReqEnable;

	BOOL	bRecipeChange[99];
	BOOL	bRecipeIdDelete;
	BOOL	bRecipeIdAdd[99];
	CString	sDelRecipeID;

	BOOL	bRecipeChangeReq[99];
	BOOL	bRecipeIdDeleteReq;
	BOOL	bRecipeIdAddReq;

	CString	sVcrMode;
	
	BOOL	bProcessStartReq[MAX_PORT_NO];
	BOOL	bProcessStart[MAX_PORT_NO];
	BOOL	bProcessDataReq[MAX_PORT_NO];

	//------ Port Mode : Enable, DisAble View <-> CimSequence
	char	cPortMode[MAX_PORT_NO];
	BOOL	bPortModeChangeReq[MAX_PORT_NO];
	BOOL	bPortModeChangeReqLoader[MAX_PORT_NO];

	//------ TRS Mdoe : Auto, Manual View <-> CimSequence
	char	cTrsMode[MAX_PORT_NO];
	BOOL	bTrsModeChangeReq[MAX_PORT_NO];

	BOOL	bPortCancelReq[MAX_PORT_NO];
	BOOL	bPortAbortReq[MAX_PORT_NO];

	BOOL	bEnableButtonStart[MAX_PORT_NO];
	BOOL	bEnableButtonCancel[MAX_PORT_NO];
	BOOL	bEnableButtonAbort[MAX_PORT_NO];
	BOOL	bEnableButtonLotInfo[MAX_PORT_NO];

	BOOL	bScrapReq;
	int		nScrapPortNo;
	int		nScrapSlotNo;

	//------ CIM Handshaking : View <-> CIM
	char	cCommState;						// modeCONTROL, modeMONITOR, modeOFFLINE
	BOOL	bCommStateChangeReq;
	BOOL	bCommStateChangeComp;

	//------ CIM Handshaking : View <-> CIM
	char	cCommState1;						// modeCONTROL, modeMONITOR, modeOFFLINE
	BOOL	bCommStateChangeReq1;
	BOOL	bCommStateChangeComp1;


	// Combo Mode Change
	char	cComboMode;		// '0' ICLN, '1' Pre depo, '2' Pass
	BOOL	bComboModeChangeReq; // 
};

class CIfLoaderInfoHdc : public CIfLoaderInfo
{
public:
	BOOL	bPortReloadComp[MAX_PORT_NO];
	BOOL	bPortReloadReq[MAX_PORT_NO];

	BOOL	bPreLdReq[MAX_PORT_NO];
	BOOL	bPreLdComp[MAX_PORT_NO];

	BOOL	bComponentIn[MAX_PORT_NO];
	BOOL	bComponentInToEqp[MAX_PORT_NO];
	BOOL	bComponentOutToEqp[MAX_PORT_NO];
	BOOL	bComponentOut[MAX_PORT_NO];

	BOOL	bProcessStartConfirm[MAX_PORT_NO];
	BOOL	bProcessStartReq[MAX_PORT_NO];
	BOOL	bPortModeChangeFail[MAX_PORT_NO];

	BOOL	bPortAbortRecv[MAX_PORT_NO];

	BOOL	bCleanerProcessing[MAX_PORT_NO];
	BOOL	bMoveIn[MAX_PORT_NO];
	BOOL	bLastGlass[MAX_PORT_NO];
	BOOL	bFirstLdComp[MAX_PORT_NO];
	BOOL	bStartLdComp[MAX_PORT_NO];

	BOOL	bFirstUdReq[MAX_PORT_NO];
	BOOL	bStartUdReq[MAX_PORT_NO];

	BOOL	bCstReady[MAX_PORT_NO];
	char	cCstState[MAX_PORT_NO];

	int		nGlassMap[MAX_PORT_NO][MAX_SLOT_NO];
	int		nLastGlassSlotNo;
	BOOL	bInitReq;

	CArray<int, int >	arPriority;	// KDS050217

	BOOL	bPutStageReady;
	BOOL    bDebugNoGlass; // Debug
	BOOL	bDebugAlarmSet;
	BOOL	bDebugAlarmReset;
	BOOL	bDebugLdReady;
	BOOL	bDebugRecvComp;
	BOOL	bDebugUnLdComp[MAX_PORT_NO];
	BOOL	bDebugGetFromCst;
};

// Apply to whole equipment.
class CIfEqpInfo : public CEqpInfo 
{
public:
	char    cIonizerState;      // Ionizer Status

	char	cCommState;		// 0 Enable,1 Disable		
	char	cInitCommState;		// 0 Enable,1 Disable		
	char	cInitCtlMode;		// '0' : Offline, '2' : Online Monitor, '1' : Online Control
	char	cComboMode;		// '0' ICLN, '1' Pre depo, '2' Pass

	char	cCommState1;		// 0 Enable,1 Disable		
	char	cInitCommState1;		// 0 Enable,1 Disable		
	char	cInitCtlMode1;		// '0' : Offline, '2' : Online Monitor, '1' : Online Control
	char	cComboMode1;		// '0' ICLN, '1' Pre depo, '2' Pass
};

typedef struct _tagIF_CIM_TAG {
	int		nAck1;
	int		nAck2;
	int		nAck5;
	int		nAck6;
	int		nS6F11Ack6;
	int		nAck7;
} IF_CIM_TAG;
// ECID 
typedef struct _tagECID_DATA 
{
	int nECID;
	LPCTSTR sEcName;
	LPCTSTR sEcMin;
	LPCTSTR sEcMax;
} ECID_DATA;
/*
typedef struct _tagCEID_DATA
{
	int		nCEID;			//
	BOOL	bEnable;		// 
} CEID_DATA;
*/
// Process Data
typedef struct _tagPROCESS_DATA {
	CString sGlassDV[MAX_GLASS_DV_NO];
	CString sLotDV[MAX_LOT_DV_NO];
	CString	sSV[MAX_SV_NO];
} PROCESS_DATA;

typedef struct _tagCIM_APD {  // 08HC06
	double	dbGLSApd[MAX_APD_DATA_NO];
} CIM_APD;

class CIfHpmj : public CObject  
{
public:
	BOOL bRemoteReq;
	BOOL bLocalReq;
	BOOL bPumpRun;
	BOOL bReady;
	BOOL bParaChangeReq;
	BOOL bPPIDChangeReq;
	BOOL bTimeSetReq;
	BOOL bRunTimeCountReset;
	BOOL bPumpChangeCountReset;
	BOOL bFilterChangeCountReset;
	BOOL bBuzzerOff;
	BOOL bAlarmReset;
	BOOL bConnected;
	BOOL bSignalReady; //Bryan_070718
	BOOL bSignalPumpRun; //kss_070730
	BOOL bSignalRemote;
	BOOL bWaterJet;          //Bryan_070718

	BOOL bRemote;
	BOOL bAlarm;
	BOOL bWarning;

	BOOL bInitReq;					// if initialized, it's TRUE 
	BOOL bInitComp;					// if initialized, it's TRUE 
	
	CString sHPMJ_SHWR_FLOW;			// A[14]
	CString sHPMJ_FILTER_IN_PRESS;		// A[14]
	CString sHPMJ_FILTER_OUT_PRESS;		// A[14]
	CString sHPMJ_MAIN_DI_PRESS;		// A[14]
	CString sHPMJ_DIW_REST;				// A[14]
	CString sHPMJ_INVERTER_HERTZ;		// A[14]

	BOOL	bGaugeInterlockAlarm;
	BOOL	bPidError;
	double	dCurPressure;
	double	dErrPressure;
	int	    nRefPressure;
	double	dCurHertz;
	int		nCurAnalogHertz;

	// Reicpe 
	BOOL	bUse;
	int		nPressure;
public:
	void ClearInfo();
};

typedef CGlassInfo		GLS_INFO;
typedef CPortInfo		PORT_INFO;
typedef CIfCimInfoHdc	IF_CIM;
typedef CIfLoaderInfoHdc	IF_LOADER;
typedef CIfUnit			IF_UNIT;
typedef CSeqFlag		SEQ_FLAG;
typedef CGenInfo		GEN_INFO;
typedef CIfEqpInfo		EQP_INFO;
typedef CIfPump			IF_PUMP;
typedef CIfEuv			IF_EUV;
typedef CIfScan			IF_SCAN;
typedef CIfCcd			IF_CCD;	// 120111 halesu
typedef CJobCond		JOB_COND;
typedef CTraceData		TRACE_DATA;
typedef CIfHpmj			IF_HPMJ;

class CDicsData : public CDicsDataBase  
{
public:
	GLS_INFO		m_GlsInfoReq; 
	GLS_INFO		m_GlsInfoLost; 
	GLS_INFO		m_GlsInfoRecovery;
	GLS_INFO		m_GlsInfoLoader;
	GLS_INFO		m_GlsInfoUnloader;
	PORT_INFO		m_PortInfo[MAX_PORT_NO];
	IF_CIM			m_IfCim;
	IF_CIM_TAG		m_IfCimTag;
	IF_LOADER		m_IfLoader;
	IF_UNIT			m_IfFlag[MAX_IF_NO];
	SEQ_FLAG		m_SeqFlag;

	GEN_INFO		m_GenInfo;
	EQP_INFO		m_EqpInfo;
	IF_PUMP			m_IfPump;
	IF_EUV			m_IfEuv;
	IF_SCAN			m_IfScan;
	IF_CCD			m_IfCcd;	// 120111 halesu
	JOB_COND		m_JobCond;
	IF_HPMJ			m_IfHpmj;
	PROCESS_DATA	m_ProcessData;
	CIM_APD			m_CimApd[MAX_EQP_GLASS_NO];		// ljy_050621 08HC06
	TRACE_DATA		m_TraceData[MAX_TRACE_MULTI_NO];//2008.10.08 kimgun

	float			fTotalFlowMeter[2];	// 110609 halesu
	float			fTotalPower; //190325 ksh
	int				m_nInitMainItemsNo;
	int				m_nInitPumpItemsNo;

	// static variables
	static STATUS_DATA	m_InitMainItems[];
	static STATUS_DATA	m_InitPumpItems[];

	static CString	m_sInSensorUnitName[MAX_UNIT_NO];
	static CString	m_sOutSensorUnitName[MAX_UNIT_NO];
	static CString	m_sUnitName[MAX_UNIT_NO];
	static double  m_RB_TachometerData[MAX_MUX10 * MAX_MUX10_CHANNEL];
	static double  m_dUnitTackTime[MAX_APD_STATUS_DATA_TACKTIME_NO];	// hskwak 191012
	static int		m_nSensorAPDStatusType[MAX_APD_STATUS_DATA_DI_NO];	// hskwak 191016

	// enum : EQP Mode
	enum	_JOBMode			{ jobU_MODE, jobI_MODE };
	enum	_CONTROL_MODE		{ modeCONTROL = 'A', modeMONITOR = 'B', modeOFFLINE = 'D' };
	enum	_EQP_MODE			{ modeRUN = 'R', modeIDLE = 'I', modeDOWN = 'D' };
	enum	_OP_MODE			{ opNORMAL = '1', opRECOVERY = '3', opPARTICLE = '6' };
	enum	_PORT_U_MODE		{ modeNORMAL = 'N', modeSORTER = 'S', modeLD = 'L', modeUL = 'U' };
	enum	_LOADER_MODE		{ modeREMOTE = 'R', modeLOCAL = 'L', modeMANUAL = 'M', modeALARM = 'A' };
	enum	_COMBO_MODE			{ comboICLN = '0', comboPRE_DEPO = '1', comboPASS = '2'};

	enum	_TRS_MODE			{ modeAGV = 'A', modeMGV = 'M' };
	enum	_VCR_MODE			{ modeERRORSKIP /*'OS'*/, modeERRORKEYIN /*'OK'*/, modeREADSKIP /*'FS'*/, modeALWAYSKEYIN /*'FK'*/ };

	// enum : EQP STATE
	enum	_EQPNormalMode		{ eqpNORMAL, eqpPASS };	// Value
	enum	_EQPState			{ stateRUN, stateSTOP, stateIDLE, stateDOWN, statePAUSE, stateALARM, 
								  stateWARNING, stateWARNING_TOO_MUCH, stateNONE, stateMANUAL, stateCLEAN };	// Index
	enum	alarmLEVEL			{ almLIGHT = 'L', almSERIOUS = 'S' };

	// enum : etc
	enum	_GLASS_STATE		{ glassOUT, glassIN, glassIN_MANUAL, glassNO };
	enum	_CTRL_TYPE			{ typeCTRLMODE, typeTRSMODE, typePORTMODE };
	enum	_ON_OFF_STATE		{ stateON, stateOFF, stateTOGGLE };

	enum	_rcmd				{ rcmdSTART = '1', rcmdCANCEL = '2' , rcmdABORT = '3', rcmdPAUSE = '4' , rcmdRESUME = '5', rcmdOP_CALL = '6'  }; // <- Hoon

	// Define for Tianma Report
	enum	_COMM_STATE			{ commDISABLE = '0', commENABLE = '1', commCOMMUNICATING = '2', commNOT_COMMUNICATING = '3' };
	enum	_LOT_STATUS			{	lotEMPTY = '0', lotCOMMAND_WAIT = '1', lotWAIT = '2', lotPROCESSING = '3', 
									lotEND = '4', lotCANCEL = '5', lotABORT = '6' };
	enum	_LOT_ABORT_STATUS	{ abortABNORMAL_END = 'F', abortMANUAL_END = 'M', abortPAUSE = 'P', abortRESUME = 'R' };
	enum	_PORT_ENABLE_MODE	{ modeENABLE = '8', modeDISABLE = '9' };  // Hoon modify.
	enum	_GLASS_STATUS		{ glassEMPTY = 'E', glassPROCEND = 'P', glassWAIT = 'W', glassSKIP = 'S', 
									glassFAIL = 'F', glassRUN = 'R'};
	enum	_CIM_PORT_STATUS	{ portLR = '0', portPRE_LC = '1', portLC = '2', portUR = '3', 
								  portUC = '4', portDOWN = '5' };

	enum	_PORT_STATUS		{ portEMPTY = 1, portEMPTY_CST = 2, portWAIT = 3, portPROCESSING = 4, 
								  portEnd = 5, portCANT_USED = 7 };
	enum	RB_TACHOMETER		{ SWR2_RB1_UP_TACHOMETER, SWR2_RB1_LO_TACHOMETER, SWR2_RB2_UP_TACHOMETER, SWR2_RB2_LO_TACHOMETER,
									SWR3_RB1_UP_TACHOMETER, SWR3_RB1_LO_TACHOMETER, SWR3_RB2_UP_TACHOMETER, SWR3_RB2_LO_TACHOMETER	};
	// Process Data
	enum	LOT_APD_DATA
	{
/*		apdSLOT_NO,					// 1
		apdRECIPE_NO,				// 2
		apdGLS_START_TIME,			// 3
		apdGLS_END_TIME,			// 4
		apdAK_EXH1,					// 5
		apdAK_EXH2,					// 6
		apdAK_LO_CDA_FLW,			// 7
		apdAK_UP_CDA_FLW,			// 8
		apdSWR2_MJ1_CDA_FLW,		// 9
		apdSWR2_MJ2_CDA_FLW,		// 10
		apdSWR2_AQK_DI_WTR_REGISTR,	// 11
		apdAK_LO_CDA_PRESS,			// 12
		apdAK_UP_CDA_PRESS,			// 13
		apdSWR2_MJ1_CDA_PRESS,		// 14
		apdSWR2_MJ2_CDA_PRESS,		// 15
		apdDRIV_AIR_PRESS,			// 16
		apdIONZR_CDA_PRESS,			// 17
		apdSWR1_AC_CDA_PRESS,		// 18
		apdSWR1_EXH,				// 19
		apdSWR1_LO_DI_FLW,			// 20
		apdSWR1_UP_DI_FLW,			// 21
		apdSWR2_EXH,				// 22
		apdSWR2_MJ1_DI_FLW,			// 23
		apdSWR2_MJ2_DI_FLW,			// 24
		apdSWR2_LO_DI_FLW,			// 25
		apdAK_AQK_DI_FLW,			// 26
		apdAK_UP_DI_FLW,			// 27
		apdSWR2_TNK_WTR_REGISTR,	// 28
//		apdUL_WAIT_TIME,
		apdRB_EXH,					// 29
		apdRB_AQK_DI_FLW,			// 30
		apdRB_LO_DI_FLW,			// 31
		apdRB_UP_DI_FLW,			// 32
		apdRB_AQUA_SWR_DI_FLW,		// 33
		apdRB_AC_CDA_PRESS,			// 34
		apdSWR2_DI_WTR_REGISTR,		// 35
		apdCV_SPEED,				// 36
		apdMAX_APD_DATA_NO,	
*/
		apdSLOT_NO,					// 1
 		apdRCP_ID,					// 2
		apdGLS_START_TIME,			// 3
		apdGLS_END_TIME,			// 4
		apdS1_INCV_CDA,				// 5
		apdS1_AC_UP_CDA,			// 6
		apdS1_AC_LO_CDA,			// 7
		apdS1_ION_AC_CDA,			// 8
		apdS1_MJ_UP_CDA,			// 9
		apdS1_MJ_LO_CDA,			// 10
		apdS1_MJ_CDA,				// 11
		apdS1_DI_IN_BE_FT,			// 12
		apdS1_UPMJ_FL_CDA,			// 13
		apdS1_LOMJ_FL_CDA,			// 14
		apdS1_DI_AQUA_FL,			// 15
		apdS1_UP_MJ_FL_DI,			// 16
		apdS1_LO_MJ_FL_DI,			// 17
		apdS1_BE_FT_DI_FL,			// 18
		apdS1_DI_LO_SW_FL,			// 19
		apdS1_DI_UP_SW_FL,			// 20
		apdS1_DI_WR,				// 21
		apdS1_EXH,					// 22
		apdS2_DI_BE_FT_PG,			// 23
		apdS2_RE_DI_FL,				// 24
		apdS2_DI_LO_S2_FL,			// 25
		apdS2_DI_S2_FL,				// 26
		apdS2_DI_UP_S2_FL,			// 27
		apdS2_DI_WR,				// 28
		apdS2_EXH,					// 29
		apdS3_DI_BE_FT_PG,			// 30
		apdS3_CDA_MJ_PG,			// 31
		apdS3_CDA_SP_PG,			// 32
		apdS3_CDA_S4MJ_PG,			// 33
		apdS3_LO_S3_FL,				// 34
		apdS3_DI_BE_FT_FL,			// 35
		apdS3_UP_S3_FL,				// 36
		apdS3_CDA_S4MJ_FL,			// 37
		apdS3_SPRE_FL,				// 38
		apdS3_DI_WR,				// 39
		apdS3_EXH,					// 40
		apdS4_LO_SWR_FL,			// 41
		apdS4_MJ_FL,				// 42
		apdS4_UP_SWR_FL,			// 43
		apdS4_AQUA_FL,				// 44
		apdS4_DI_FL,				// 45
		apdS4_EXH,					// 46
		apdS4_TANK2_CONC,			// 47
		apdAK_DI_S4_PG,				// 48
		apdAK_LO_BE_FT,				// 49
		apdAK_UP_BE_FT,				// 50
		apdAK_LO_PG,				// 51
		apdAK_UP_PG,				// 52
		apdAK_CDA_ION_PG,			// 53
		apdAK_UP_S4_PG,				// 54
		apdAK_LO_S4_PG,				// 55
		apdAK_CDA_OUT_PG,			// 56
		apdAK_DRIVING,				// 57
		apdAK_EXH1,					// 58
		apdAK_EXH2,					// 59
		apdAK_DI_S4_BF_FT,			// 60
		apdAK_LO_BE_FT_FL,			// 61
		apdAK_UP_BE_FT_FL,			// 62
		apdAK_DI_WR,				// 63
		apdOUT_CV_ESD,				// 64
#ifdef _MOTOR_LOAD_FACTOR
		apdS2RB_UP_SV1_LF,		    // 65
		apdS2RB_LO_SV1_LF,		    // 66
		apdS2RB_UP_SV2_LF,		    // 67
		apdS2RB_LO_SV2_LF,		    // 68
		apdS3RB_UP_SV1_LF,		    // 69
		apdS3RB_LO_SV1_LF,		    // 70
		apdS3RB_UP_SV2_LF,		    // 71
		apdS3RB_LO_SV2_LF,		    // 72
		apdS2RB_UP_M1_LF,		    // 73
		apdS2RB_LO_M1_LF,		    // 74
		apdS2RB_UP_M2_LF,		    // 75
		apdS2RB_LO_M2_LF,		    // 76
		apdS3RB_UP_M1_LF,		    // 77
		apdS3RB_LO_M1_LF,		    // 78
		apdS3RB_UP_M2_LF,		    // 79
		apdS3RB_LO_M2_LF,		    // 80
		apdINCV_M_LF,			    // 81
		apdS1CV_M_LF,			    // 82
		apdS2CV_M1_LF,			    // 83
		apdS2CV_M2_LF,			    // 84
		apdS3CV_M1_LF,			    // 85
		apdS3CV_M2_LF,			    // 86
		apdS4CV_M_LF,			    // 87
		apdAKCV_M1_LF,			    // 88
		apdAKCV_M2_LF,			    // 89
		apdBUFCV_M_LF,			    // 90
		apdOUTCV_M_LF,			    // 91
#endif
#ifdef _BUFTANK_USE				
		apdBT_SPL_PG1,				// 92		
		apdBT_SPL_PG2,				// 93
		apdBT_SPL_FL1,				// 94
		apdBT_SPL_FL2,				// 95	
		apdBT_SPL_SWR_FL1,			// 96
		apdBT_SPL_SWR_FL2,			// 97				
#endif
		apdMAX_APD_DATA_NO
	};

	enum initMainItems		// hskwak  ʿ.
	{
//		initCHECK_UP_CV_GLASS,
//		initCHECK_UP_CV_CP,	
//		initCHECK_UP_CV_ALARM,
		initCHECK_CV_GLASS,
		initCHECK_CV_CP,
		initCHECK_CV_ALARM,
//		initINTERRUPT,

//		initCHECK_RBT_GLASS,

		initCLEAN_OUT_SET,	// hskwak abnormal   ٽ   GLS ִ .    ϸ鼭   .  .(??=Flush Mode)
//		initRBT1,
//		initRBT2,

		initSWR2_RB_UP1_SERVO,
		initSWR2_RB_LO1_SERVO,
		initSWR2_RB_UP2_SERVO,
		initSWR2_RB_LO2_SERVO,
		initSWR3_RB_UP1_SERVO,
		initSWR3_RB_LO1_SERVO,
		initSWR3_RB_UP2_SERVO,
		initSWR3_RB_LO2_SERVO,
		initINTERRUPT,
		initEUV_STATUS,
		initAP_STATUS,
		initHPMJ_STATUS,
		initCHECK_RBT_GLASS,
	};

	enum initPumpItems
	{
		initPUMP1_CHECK,	
		initPUMP2_CHECK,	
#ifdef _BUFTANK_USE
		initPUMP3_CHECK,	
		initPUMP4_CHECK,	
#endif
	};

	enum	_ECID_Data
	{
		ecidESTABLISH_COMM_TIMEOUT,
		ecidCOMM_STATE,
		ecidCTL_STATE,
		ecidDEVICE_ID,
		ecidHEART_BEAT,
		ecidT3,
		ecidT5,
		ecidT6,
		ecidT7,
		ecidT8,
		ecidCT_TIMEOUT,
		ecidVCR_STATUS,
		ecidCONFIG_CONNECT,
		ecidEQ_MODE,
		ecidSPOOLFLAG,
		ecidTRS_MODE_PORT1,
		ecidTRS_MODE_PORT2,
		ecidTRS_MODE_PORT3,
		ecidTYPE_PORT1,
		ecidTYPE_PORT2,
		ecidTYPE_PORT3,
		ecidUSE_TYPE_PORT1,
		ecidUSE_TYPE_PORT2,
		ecidUSE_TYPE_PORT3,
	};

	// Operations
public:
//	void SetRecipeId(CString sRecipeId);
	void ParseGlassData( int i, unsigned short* nGlassData );
	void ParseGlassData( CGlassInfo& glsInfo, unsigned short* nGlassData );

	void InitPara1();
	int   Bcd2Int( short nVal );
	short Int2Bcd( int nVal );
	unsigned short Ascii2Word( CString sVal );
	CString Word2Ascii( short nData );

public:
	CDicsData();
	virtual ~CDicsData();
};

#endif // !defined(AFX_CMOG7SPTHDCDICSDATA_H__F4006C0D_E892_4E36_BDB8_FFED751E55A8__INCLUDED_)
