#if !defined(AFX_DIALOGGLASSINFO_H__981CBE4E_1C30_4062_8953_813601C348C5__INCLUDED_)
#define AFX_DIALOGGLASSINFO_H__981CBE4E_1C30_4062_8953_813601C348C5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DialogGlassInfo.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDialogGlassInfo dialog
#include "..\DicsData.h"

class CDialogGlassInfo : public CDialog
{
// Construction
public:
	CDialogGlassInfo(CWnd* pParent = NULL);   // standard constructor
	void SetData( CDicsData* pData ) { m_pDicsData = pData; }

	CBitmapButton	m_Ok;
	CString	m_sGlassData[MAX_GLASS_DATA_ITEM_NO];
	CString m_sTitle;
	BOOL m_bPermitAccess;
	int m_nTargetCv;
	CDicsData*		m_pDicsData;
	static CString m_sGlassDataName[MAX_GLASS_DATA_ITEM_NO];
	
// Dialog Data
	//{{AFX_DATA(CDialogGlassInfo)
	enum { IDD = IDD_DLG_GLASS_INFO1 };
	CBitmapButton	m_Delete;
	CBitmapButton	m_Change;
	CBitmapButton	m_Move;
	CMSFlexGrid	m_gridGlassInfo;
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDialogGlassInfo)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDialogGlassInfo)
	virtual BOOL OnInitDialog();
	afx_msg void OnChange();
	afx_msg void OnDelete();
	afx_msg void OnMove();
	virtual void OnOK();
	afx_msg void OnDblClickGridGlassInfo();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG

public:
	void GridInit_GlassInfo();
	void SetDataToGridCtrl_GlassInfo();

	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DIALOGGLASSINFO_H__981CBE4E_1C30_4062_8953_813601C348C5__INCLUDED_)
