//#if !defined(AFX_DLGBUFTANKPUMPCLN_H__3C95D725_C6ED_4832_A071_7256EB994FB5__INCLUDED_)
//#define AFX_DLGBUFTANKPUMPCLN_H__3C95D725_C6ED_4832_A071_7256EB994FB5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgPump3Cln.h : header file
//

#include "..\X\MacButtons.h"
#include "..\FactoryLib\EqpAssy.h"

/////////////////////////////////////////////////////////////////////////////
// CDlgPump3Cln dialog

class CDlgBufTankPumpCln : public CDialog
{
// Construction
public:
	CDlgBufTankPumpCln(CWnd* pParent = NULL);   // standard constructor
	void SetDevice(XCtlDevice* pDevice) { m_pDevice = pDevice; }
	void SetEqpAssy( CEqpAssy* pEqpAssy ){ m_pEqpAssy = pEqpAssy; }
	void SetTankAssy( CFaTank* pTank ){ m_pTank = pTank; }

	int		m_nCurSelPump;
	XCtlDevice* m_pDevice;
	CEqpAssy*	m_pEqpAssy;
	CFaTank*	m_pTank;

// Dialog Data
	//{{AFX_DATA(CDlgBufTankPumpCln)
	enum { IDD = IDD_DLG_BUFTANK_PUMP_CLN };
	CMacRadioButton	m_macPumpOn;
	CMacRadioButton	m_macPumpOff;
	CMacRadioButton	m_macPumpNoAlarm;
	CMacRadioButton	m_macPumpAlarm;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgBufTankPumpCln)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CBitmapButton	m_Ok;

	// Generated message map functions
	//{{AFX_MSG(CDlgBufTankPumpCln)
	virtual BOOL OnInitDialog();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnPumpOn();
	afx_msg void OnPumpOff();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

//#endif // !defined(AFX_DLGBUFTANKPUMPCLN_H__3C95D725_C6ED_4832_A071_7256EB994FB5__INCLUDED_)
