#if !defined(AFX_DLGCALIBRATION_H__748FD874_7FCF_48A4_8370_6237A123E0BE__INCLUDED_)
#define AFX_DLGCALIBRATION_H__748FD874_7FCF_48A4_8370_6237A123E0BE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgCalibration.h : header file
//

#include "..\X\MacButtons.h"
#include "..\X\XCtlDevice.h"	// Added by ClassView
#include "..\AnalogInput1.h"	// Added by ClassView
//#include "AnalogInput2.h"	// Added by ClassView
//#include "AnalogInputSt.h"
//#include "AnalogInputCln.h"
/////////////////////////////////////////////////////////////////////////////
// CDlgCalibration dialog

class CDlgCalibration : public CDialog
{
	// Construction
public:
	
	CDlgCalibration(CWnd* pParent = NULL);   // standard constructor
	//	void SetAISt(CAnalogInputSt* pAI) { m_pAISt = pAI; }
//	void SetAI1(CAnalogInput1* pAI) { m_pAI1 = pAI; }
//	void SetAI2(CAnalogInput2* pAI) { m_pAI2 = pAI; }
	void SetDevice(XCtlDevice * pDevice ){m_pDevice = pDevice;}
	
public:
	int				m_nWhatGroup;
	enum WHAT_GROUP { grpAI1, grpAI2, grpAI3 };
	
	XCtlDevice *	m_pDevice;
//	CAnalogInput1 * m_pAI1;
//	CAnalogInput2 * m_pAI2;
//	CAnalogInputSt*		m_pAISt;
//	CAnalogInputCln*	m_pAICln;
	CBitmapButton		m_Ok;
	CBitmapButton		m_Cancel;
	CBitmapButton		m_KeyIn;
	int		m_nInitAdcMax;
	int		m_nInitAdcMin;
	float	m_fInitRealMax;
	float	m_fInitRealMin;
	float	m_fInitFilterGain;
	
	int		m_nID;
	int		m_nAiNo;
	BOOL	m_bPermitAccess;
	
	// Dialog Data
	//{{AFX_DATA(CDlgCalibration)
	enum { IDD = IDD_DLG_CALIBRATION };
	int		m_nAdcMax;
	int		m_nAdcMin;
	int		m_nCurAdc;
	float	m_fCurReal;
	float	m_fRealMax;
	float	m_fRealMin;
	CMacRadioButton	m_macCalibration;
	CMacRadioButton	m_macDefault;
	CMacRadioButton m_macCommon;
	CMacRadioButton m_macLog;
	CMacRadioButton m_macLog10;
	float	m_fFilterGain;
	//}}AFX_DATA
	
	
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgCalibration)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
	
	// Implementation
protected:
	
	// Generated message map functions
	//{{AFX_MSG(CDlgCalibration)
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnCalibrate();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDefault();
	afx_msg void OnBtnKeyboard();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGCALIBRATION_H__748FD874_7FCF_48A4_8370_6237A123E0BE__INCLUDED_)
