// DlgCvMotor.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "DlgCvMotor.h"
#include "..\FactoryLib\EqpAssy.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgCvMotor dialog


CDlgCvMotor::CDlgCvMotor(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgCvMotor::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgCvMotor)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_bExtendWndPos = FALSE;
	m_nCurSel		= 13;
	m_bCVMotor_FW	= m_bCVMotor_BW = FALSE;	// ljy_041202 : Maint CV Auto Stop
}


void CDlgCvMotor::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgCvMotor)
	DDX_Control(pDX, IDC_COMBO_CV_SPEED, m_cbCvSpeed);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_MOTOR1_ALARM, m_macMotorAlarm[0]);
	DDX_Control(pDX, IDC_MOTOR1_CP_DOWN, m_macMotorCpDown[0]);
	DDX_Control(pDX, IDC_MOTOR2_ALARM, m_macMotorAlarm[1]);
	DDX_Control(pDX, IDC_MOTOR2_CP_DOWN, m_macMotorCpDown[1]);
	DDX_Control(pDX, IDC_MOTOR3_ALARM, m_macMotorAlarm[2]);
	DDX_Control(pDX, IDC_MOTOR3_CP_DOWN, m_macMotorCpDown[2]);
	DDX_Control(pDX, IDC_MOTOR4_ALARM, m_macMotorAlarm[3]);
	DDX_Control(pDX, IDC_MOTOR4_CP_DOWN, m_macMotorCpDown[3]);
	DDX_Control(pDX, IDC_MOTOR5_ALARM, m_macMotorAlarm[4]);
	DDX_Control(pDX, IDC_MOTOR5_CP_DOWN, m_macMotorCpDown[4]);
	DDX_Control(pDX, IDC_MOTOR6_ALARM, m_macMotorAlarm[5]);
	DDX_Control(pDX, IDC_MOTOR6_CP_DOWN, m_macMotorCpDown[5]);
	DDX_Control(pDX, IDC_MOTOR7_ALARM, m_macMotorAlarm[6]);
	DDX_Control(pDX, IDC_MOTOR7_CP_DOWN, m_macMotorCpDown[6]);
	DDX_Control(pDX, IDC_MOTOR8_ALARM, m_macMotorAlarm[7]);
	DDX_Control(pDX, IDC_MOTOR8_CP_DOWN, m_macMotorCpDown[7]);
	DDX_Control(pDX, IDC_MOTOR1_BW, m_macMotorBw[0]);
	DDX_Control(pDX, IDC_MOTOR1_FW, m_macMotorFw[0]);
	DDX_Control(pDX, IDC_MOTOR1_STOP, m_macMotorStop[0]);
	DDX_Control(pDX, IDC_MOTOR2_BW, m_macMotorBw[1]);
	DDX_Control(pDX, IDC_MOTOR2_FW, m_macMotorFw[1]);
	DDX_Control(pDX, IDC_MOTOR2_STOP, m_macMotorStop[1]);
	DDX_Control(pDX, IDC_MOTOR3_BW, m_macMotorBw[2]);
	DDX_Control(pDX, IDC_MOTOR3_FW, m_macMotorFw[2]);
	DDX_Control(pDX, IDC_MOTOR3_STOP, m_macMotorStop[2]);
	DDX_Control(pDX, IDC_MOTOR4_BW, m_macMotorBw[3]);
	DDX_Control(pDX, IDC_MOTOR4_FW, m_macMotorFw[3]);
	DDX_Control(pDX, IDC_MOTOR4_STOP, m_macMotorStop[3]);
	DDX_Control(pDX, IDC_MOTOR5_BW, m_macMotorBw[4]);
	DDX_Control(pDX, IDC_MOTOR5_FW, m_macMotorFw[4]);
	DDX_Control(pDX, IDC_MOTOR5_STOP, m_macMotorStop[4]);
	DDX_Control(pDX, IDC_MOTOR6_BW, m_macMotorBw[5]);
	DDX_Control(pDX, IDC_MOTOR6_FW, m_macMotorFw[5]);
	DDX_Control(pDX, IDC_MOTOR6_STOP, m_macMotorStop[5]);
	DDX_Control(pDX, IDC_MOTOR7_BW, m_macMotorBw[6]);
	DDX_Control(pDX, IDC_MOTOR7_FW, m_macMotorFw[6]);
	DDX_Control(pDX, IDC_MOTOR7_STOP, m_macMotorStop[6]);
	DDX_Control(pDX, IDC_MOTOR8_BW, m_macMotorBw[7]);
	DDX_Control(pDX, IDC_MOTOR8_FW, m_macMotorFw[7]);
	DDX_Control(pDX, IDC_MOTOR8_STOP, m_macMotorStop[7]);
	DDX_Control(pDX, IDC_MOTOR_ALL_BW, m_macMotorAllBw);
	DDX_Control(pDX, IDC_MOTOR_ALL_FW, m_macMotorAllFw);
	DDX_Control(pDX, IDC_MOTOR_ALL_STOP, m_macMotorAllStop);
	DDX_Control(pDX, IDC_SET_WND_POS, m_macSetWndPos);
}

BEGIN_MESSAGE_MAP(CDlgCvMotor, CDialog)
	//{{AFX_MSG_MAP(CDlgCvMotor)
	ON_BN_CLICKED(IDC_SET_WND_POS, OnSetWndPos)
	ON_CBN_SELCHANGE(IDC_COMBO_CV_SPEED, OnSelchangeComboCvSpeed)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_MOTOR_ALL_STOP, OnCvMotorAllStop)
	ON_BN_CLICKED(IDC_MOTOR_ALL_FW, OnCvMotorAllFw)
	ON_BN_CLICKED(IDC_MOTOR_ALL_BW, OnCvMotorAllBw)
	ON_CBN_SELCHANGE(IDC_COMBO_CV_SPEED, OnSelchangeComboCvSpeed)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE(IDC_MOTOR1_FW, IDC_MOTOR8_FW, OnCvMotorFw)
	ON_COMMAND_RANGE(IDC_MOTOR1_BW, IDC_MOTOR8_BW, OnCvMotorBw)
	ON_COMMAND_RANGE(IDC_MOTOR1_STOP, IDC_MOTOR8_STOP, OnCvMotorStop)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgCvMotor message handlers

//--------------------------------------------------------------------
// OnInitDialog
//--------------------------------------------------------------------
BOOL CDlgCvMotor::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Set button
	VERIFY( m_Ok.AutoLoad( IDOK, this ) );

	// Set the timer
	SetTimer( TIMER_MANUAL, 500, NULL );

	// Set the C/V motor speed
	for( int i=0; i<20; i++ )
	{
		CString sValue;
		sValue.Format( "%d", ( i + 1 ) * SPEED_INTEVAL );
		m_cbCvSpeed.AddString( sValue );
	}
	m_cbCvSpeed.SetCurSel( m_nCurSel );

	// Set the MAC button
	MAC_COLOR_SET color_set;

	for( int i=0; i<MAX_CV_MOTOR_NO; i++ )
	{
		// C/V Motor FW
		m_macMotorFw[i].GetColorSetting( &color_set );
		color_set.crFace = LIGHT_CYAN_COLOR;
		color_set.crLiteShadow = MAGENTA_COLOR;
		m_macMotorFw[i].SetColorSetting( color_set );
		m_macMotorFw[i].SetBold();

		// C/V Motor BW
		m_macMotorBw[i].GetColorSetting( &color_set );
		color_set.crFace = LIGHT_ORANGE_COLOR;
		color_set.crLiteShadow = MAGENTA_COLOR;
		m_macMotorBw[i].SetColorSetting( color_set );
		m_macMotorBw[i].SetBold();

		// C/V Motor Stop
		m_macMotorStop[i].GetColorSetting( &color_set );
		color_set.crFace = LIGHT_RED_COLOR;
		color_set.crLiteShadow = MAGENTA_COLOR;
		m_macMotorStop[i].SetColorSetting( color_set );
		m_macMotorStop[i].SetBold();

//		// Set the initial state of C/V motor
//		int nDir = m_pDcMotor[i]->GetActState();
//		if( nDir == CDcMotor::actFW ) m_macMotorFw[i].SetCheck( TRUE );
//		else if( nDir == CDcMotor::actBW ) m_macMotorBw[i].SetCheck( TRUE );
//		else 
//		{
//			m_macMotorFw[i].SetCheck( 0 ); 
//			m_macMotorBw[i].SetCheck( 0 ); 
//			m_macMotorStop[i].SetCheck( 1 ); 
//		}

//		m_macMotorNoAlarm[i].SetCheckColor( BLUE_COLOR );
		m_macMotorAlarm[i].SetCheckColor( RED_COLOR );
		m_macMotorCpDown[i].SetCheckColor( RED_COLOR );
	}

	// C/V Motor FW (All)
	m_macMotorAllFw.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_CYAN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macMotorAllFw.SetColorSetting( color_set );
	m_macMotorAllFw.SetBold();

	// C/V Motor BW (All)
	m_macMotorAllBw.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_ORANGE_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macMotorAllBw.SetColorSetting( color_set );
	m_macMotorAllBw.SetBold();
	
	// C/V Motor Stop (All)
	m_macMotorAllStop.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_RED_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macMotorAllStop.SetColorSetting( color_set );
	m_macMotorAllStop.SetBold();

	// Set the initial window position
	CRect r;
	GetWindowRect( &r );
	MoveWindow( 50, 400, r.right - r.left - 700, r.bottom - r.top );
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

//--------------------------------------------------------------------
// OnSetWndPos
//--------------------------------------------------------------------
void CDlgCvMotor::OnSetWndPos() 
{
	CRect r;
	GetWindowRect( &r );
	if( m_bExtendWndPos )
	{
		r.right -= 700;
		MoveWindow( &r, TRUE );
		m_bExtendWndPos = FALSE;
		GetDlgItem( IDC_SET_WND_POS )->SetWindowText( ">>" );
	}
	else
	{
		r.right += 700;
		MoveWindow( &r, TRUE );
		m_bExtendWndPos = TRUE;
		GetDlgItem( IDC_SET_WND_POS )->SetWindowText( "<<" );
	}
}

//--------------------------------------------------------------------
// OnCvMotorFw
//--------------------------------------------------------------------
void CDlgCvMotor::OnCvMotorFw(UINT nID) 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	int i = nID - IDC_MOTOR1_FW;


	if( ( i == CV_NO_LD ) )
	{
#ifndef _MY_DEBUG
		if( !m_pEqpAssy->m_CylinderLdAlign.GetFw() )
#else
		if( !m_pEqpAssy->m_CylinderLdAlign.GetFwState() )
#endif
		{
			AfxMessageBox( "INTERLOCK : LD Unit Aligner BW State!! Please. LD Unit Aliner FW!!");
			return;		
		}	
	}
	
	OnSelchangeComboCvSpeed();	//kjd

	m_pCvSeq->m_CvMotor.nCvManual[i] = CCvSeq::cvFW;

	m_macMotorAllFw.SetCheck( 0 );
	m_macMotorAllBw.SetCheck( 0 );
	m_macMotorAllStop.SetCheck( 0 );

	GetDlgItem( IDC_MOTOR1_BW + i )->EnableWindow( FALSE );

	if( i == (MAX_CV_MOTOR_NO-1) ) m_bCVMotor_FW = TRUE;	// ljy_041202 : Maint CV Auto Stop
}

//--------------------------------------------------------------------
// OnCvMotorBw
//--------------------------------------------------------------------
void CDlgCvMotor::OnCvMotorBw(UINT nID) 
{
	int i = nID - IDC_MOTOR1_BW;
	
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	if(  i == ( CV_NO_LD + 1 ) )
	{
#ifndef _MY_DEBUG
		if( !m_pEqpAssy->m_CylinderLdAlign.GetFw() )
#else
		if( !m_pEqpAssy->m_CylinderLdAlign.GetFwState() )
#endif
		{
			AfxMessageBox( "INTERLOCK : LD Unit Aligner BW State!! Please. LD Unit Aliner FW!!");
			return;		
		}
	}

	OnSelchangeComboCvSpeed();	//kjd
	m_pCvSeq->m_CvMotor.nCvManual[i] = CCvSeq::cvBW;

	m_macMotorAllFw.SetCheck( 0 );
	m_macMotorAllBw.SetCheck( 0 );
	m_macMotorAllStop.SetCheck( 0 );

	GetDlgItem( IDC_MOTOR1_FW + i )->EnableWindow( FALSE );

	if( i == 0 ) m_bCVMotor_BW = TRUE;	// ljy_041202 : Maint CV Auto Stop
}

//--------------------------------------------------------------------
// OnCvMotorStop
//--------------------------------------------------------------------
void CDlgCvMotor::OnCvMotorStop(UINT nID) 
{
	int i = nID - IDC_MOTOR1_STOP;
	
	m_pCvSeq->m_CvMotor.nCvManual[i] = CCvSeq::cvSTOP;

	m_macMotorAllFw.SetCheck( 0 );
	m_macMotorAllBw.SetCheck( 0 );
	m_macMotorAllStop.SetCheck( 0 );

	GetDlgItem( IDC_MOTOR1_FW + i )->EnableWindow( TRUE );
	GetDlgItem( IDC_MOTOR1_BW + i )->EnableWindow( TRUE );

	// ljy_041202 : Maint CV Auto Stop
	if( i == 0 )		m_bCVMotor_BW = FALSE;
	else if( i == (MAX_CV_MOTOR_NO-1) )	m_bCVMotor_FW = FALSE;
}

//--------------------------------------------------------------------
// OnCvMotorAllFw
//--------------------------------------------------------------------
void CDlgCvMotor::OnCvMotorAllFw() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

	
#ifndef _MY_DEBUG
	if( !m_pEqpAssy->m_CylinderLdAlign.GetFw() )
#else
	if( !m_pEqpAssy->m_CylinderLdAlign.GetFwState() )
#endif
	{
		AfxMessageBox( "INTERLOCK : LD Unit Aligner BW State!! Please. LD Unit Aliner FW!!");
		return;		
	}

	OnSelchangeComboCvSpeed();	//kjd

	for( int i=0; i<MAX_CV_MOTOR_NO; i++ )
	{
		m_pCvSeq->m_CvMotor.nCvManual[i] = CCvSeq::cvFW;

		m_macMotorStop[i].SetCheck( 0 );
		m_macMotorFw[i].SetCheck( 1 );
		m_macMotorBw[i].SetCheck( 0 );

		GetDlgItem( IDC_MOTOR1_BW + i )->EnableWindow( FALSE );
	}
	GetDlgItem( IDC_MOTOR_ALL_BW )->EnableWindow( FALSE );

	// ljy_041202 : Maint CV Auto Stop
	m_bCVMotor_FW = TRUE;
	m_bCVMotor_BW = FALSE;
}

//--------------------------------------------------------------------
// OnCvMotorAllBw
//--------------------------------------------------------------------
void CDlgCvMotor::OnCvMotorAllBw() 
{
	CDicsApp* pApp = (CDicsApp*) AfxGetApp();
	CDicsView* pView = (CDicsView*) pApp->m_pMainView;

#ifndef _MY_DEBUG
	if( !m_pEqpAssy->m_CylinderLdAlign.GetFw() )
#else
	if( !m_pEqpAssy->m_CylinderLdAlign.GetFwState() )
#endif
	{
		AfxMessageBox( "INTERLOCK : LD Unit Aligner BW State!! Please. LD Unit Aliner FW!!");
		return;		
	}

	OnSelchangeComboCvSpeed();	// kjd

	for( int i=0; i<MAX_CV_MOTOR_NO; i++ )
	{
		m_pCvSeq->m_CvMotor.nCvManual[i] = CCvSeq::cvBW;

		m_macMotorStop[i].SetCheck( 0 );
		m_macMotorFw[i].SetCheck( 0 );
		m_macMotorBw[i].SetCheck( 1 );

		GetDlgItem( IDC_MOTOR1_FW + i )->EnableWindow( FALSE );
	}
	GetDlgItem( IDC_MOTOR_ALL_FW )->EnableWindow( FALSE );

	// ljy_041202 : Maint CV Auto Stop
	m_bCVMotor_FW = FALSE;
	m_bCVMotor_BW = TRUE;
}

//--------------------------------------------------------------------
// OnCvMotorAllStop
//--------------------------------------------------------------------
void CDlgCvMotor::OnCvMotorAllStop() 
{
	for( int i=0; i<MAX_CV_MOTOR_NO; i++ )
	{
		m_pCvSeq->m_CvMotor.nCvManual[i] = CCvSeq::cvSTOP;

		m_macMotorStop[i].SetCheck( 1 );
		m_macMotorFw[i].SetCheck( 0 );
		m_macMotorBw[i].SetCheck( 0 );

		GetDlgItem( IDC_MOTOR1_FW + i )->EnableWindow( TRUE );
		GetDlgItem( IDC_MOTOR1_BW + i )->EnableWindow( TRUE );
	}
	GetDlgItem( IDC_MOTOR_ALL_FW )->EnableWindow( TRUE );
	GetDlgItem( IDC_MOTOR_ALL_BW )->EnableWindow( TRUE );

	// ljy_041202 : Maint CV Auto Stop
	m_bCVMotor_FW = FALSE;
	m_bCVMotor_BW = FALSE;
}

//--------------------------------------------------------------------
// OnSelchangeComboCvSpeed
//--------------------------------------------------------------------
void CDlgCvMotor::OnSelchangeComboCvSpeed() 
{
	int nIndex = m_cbCvSpeed.GetCurSel();
	int nSpeed = ( nIndex + 1 ) * SPEED_INTEVAL;

}

//--------------------------------------------------------------------
// OnTimer
//--------------------------------------------------------------------
void CDlgCvMotor::OnTimer(UINT nIDEvent) 
{
	for( int i=0; i<MAX_CV_MOTOR_NO; i++ )
	{
		if( m_pEqpAssy->m_CvMotorAll.GetMotorCpAlarm( i ) ) m_macMotorCpDown[i].SetCheck( 1 );
		else m_macMotorCpDown[i].SetCheck( 0 );

		if( m_pEqpAssy->m_CvMotorAll.GetMotorAlarm( i ) ) 
		{
			m_macMotorAlarm[i].SetCheck( 1 );
//			m_macMotorNoAlarm[i].SetCheck( 0 );
		}
		else 
		{
			m_macMotorAlarm[i].SetCheck( 0 );
//			m_macMotorNoAlarm[i].SetCheck( 1 );
		}
	}	

	// ljy_041202 : Maint CV Auto Stop
#ifndef _MY_DEBUG
	if( m_bCVMotor_FW && m_pEqpAssy->m_GlassExistUnitOut.DualGetOr( IF_UNIT_UL, 1 ) )
	{
		OnCvMotorAllStop();
	}

	if( m_bCVMotor_BW && m_pEqpAssy->m_GlassExistUnitIn.DualGetOr( IF_UNIT_LD, 0 ) )
	{
		OnCvMotorAllStop();
	}
	// ljy_041202 : end
#endif

	CDialog::OnTimer(nIDEvent);
}

void CDlgCvMotor::OnDestroy() 
{
	CDialog::OnDestroy();
	
	KillTimer( TIMER_MANUAL );
}
