#if !defined(AFX_DLGCVMOTOR_H__599817BA_45EC_4AA8_96D0_26848EBC089A__INCLUDED_)
#define AFX_DLGCVMOTOR_H__599817BA_45EC_4AA8_96D0_26848EBC089A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgCvMotor.h : header file
//
#include "..\X\XCtlDevice.h"
#include "..\X\MacButtons.h"
/////////////////////////////////////////////////////////////////////////////
// CDlgCvMotor dialog
#include "..\FactoryLib\EqpAssy.h"

class CDlgCvMotor : public CDialog
{
// Construction
public:
	CDlgCvMotor(CWnd* pParent = NULL);   // standard constructor

	void SetDevice(XCtlDevice* pDevice) { m_pDevice = pDevice; }
	void SetSetupItems(CSetupItems* pSetupItems) { m_pSetupItems = pSetupItems; }
	void SetCvSeq( CCvSeq* pCvSeq ) { m_pCvSeq = pCvSeq; }
	void SetEqpAssy( CEqpAssy* pEqpAssy ){ m_pEqpAssy = pEqpAssy; }

	CBitmapButton	m_Ok;
	XCtlDevice* m_pDevice;
	CView* m_pView;
	CSetupItems* m_pSetupItems;
	CCvSeq* m_pCvSeq;
	CEqpAssy*	m_pEqpAssy;

	BOOL	m_bExtendWndPos;
	int		m_nCurSel;
//	int		m_iRatio[MAX_CV_NO];

	// ljy_041202 : Maint CV Auto Stop
	BOOL	m_bCVMotor_FW;
	BOOL	m_bCVMotor_BW;
// Dialog Data
	//{{AFX_DATA(CDlgCvMotor)
#ifndef _LTYPE
	enum { IDD = IDD_DLG_CV_MOTOR };
#else
	enum { IDD = IDD_DLG_CV_MOTOR_LTYPE };	
#endif
	CComboBox		m_cbCvSpeed;
//	CMacCheckBox	m_macMotorNoAlarm[MAX_CV_MOTOR_NO];
	CMacCheckBox	m_macMotorAlarm[MAX_CV_MOTOR_NO];
	CMacCheckBox	m_macMotorCpDown[MAX_CV_MOTOR_NO];
	CMacRadioButton	m_macMotorBw[MAX_CV_MOTOR_NO];
	CMacRadioButton	m_macMotorFw[MAX_CV_MOTOR_NO];
	CMacRadioButton	m_macMotorStop[MAX_CV_MOTOR_NO];
	CMacRadioButton	m_macMotorAllBw;
	CMacRadioButton	m_macMotorAllFw;
	CMacRadioButton	m_macMotorAllStop;
	CMacButton	m_macSetWndPos;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgCvMotor)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgCvMotor)
	virtual BOOL OnInitDialog();
	afx_msg void OnSetWndPos();
	afx_msg void OnSelchangeComboCvSpeed();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnCvMotorAllStop();
	afx_msg void OnCvMotorAllFw();
	afx_msg void OnCvMotorAllBw();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	afx_msg void OnCvMotorFw(UINT nID);
	afx_msg void OnCvMotorBw(UINT nID);
	afx_msg void OnCvMotorStop(UINT nID);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGCVMOTOR_H__599817BA_45EC_4AA8_96D0_26848EBC089A__INCLUDED_)
