#if !defined(AFX_DLGFISHRIB_H__98E6674B_8EF3_4367_9C7E_5470396FA0DE__INCLUDED_)
#define AFX_DLGFISHRIB_H__98E6674B_8EF3_4367_9C7E_5470396FA0DE__INCLUDED_

#include "..\X\XCtlDevice.h"	// Added by ClassView
#include "..\X\MacButtons.h"	// Added by ClassView
#include "..\X\ColorStatic.h"
#include "..\X\XMmc.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgFishRib.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDlgFishRib dialog

class CDlgFishRib : public CDialog
{
// Construction
public:
	CBitmapButton	m_Ok;
	CMacRadioButton m_macFishRibUp;
	CMacRadioButton m_macFishRibDn;

	CDicsCylinder	m_ocxFishRib[2];

	int				m_nDlgUnitNo;	
	int				m_nOldFishRibState[2];

	XCtlDevice*		m_pDevice;
	XMmc*			m_pMmc;

	void SetDevice( XCtlDevice* pDevice ){ m_pDevice = pDevice; }
	void SetMmc( XMmc* pMmc ) { m_pMmc = pMmc; }
	CDlgFishRib(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CDlgFishRib)
	enum { IDD = IDD_DIALOG_FISH_RIB };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgFishRib)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void IsFishRibStatus();
	// Generated message map functions
	//{{AFX_MSG(CDlgFishRib)
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	afx_msg void OnRadioUp();
	afx_msg void OnRadioDn();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGFISHRIB_H__98E6674B_8EF3_4367_9C7E_5470396FA0DE__INCLUDED_)
