#if !defined(AFX_DLGGLASSINFO_H__6C4A2594_2AF2_4D4B_AAB1_A0A3458BAEFF__INCLUDED_)
#define AFX_DLGGLASSINFO_H__6C4A2594_2AF2_4D4B_AAB1_A0A3458BAEFF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgGlassInfo.h : header file
//

#include "..\X\MacButtons.h"
#include "..\DicsData.h"
/////////////////////////////////////////////////////////////////////////////
// CDlgGlassInfo dialog

class CDlgGlassInfo : public CDialog
{
// Construction
public:
	CDlgGlassInfo(CWnd* pParent = NULL);   // standard constructor
	void SetData( CDicsData* pData ) { m_pDicsData = pData; }

// Dialog Data
	//{{AFX_DATA(CDlgGlassInfo)
	enum { IDD = IDD_DLG_GLASS_INFO2 };
	CMacButton		m_macDelete;
	CMacButton		m_macForceDel;
	CMacButton		m_macMove;
	CMacButton		m_macEdit;
	CMacButton		m_macGlassIdInquire;
	CMacButton		m_macGlassOpIdReport;
	CMSFlexGrid		m_gridGlassInfo;
	//}}AFX_DATA

public:
	unsigned short Ascii2Word( CString sVal );
	int Bin2Dec(int nBitSize, CString sVal);
	CString Dec2Bin(int nBitSize, int nVal);
	void OnEditData(int nRow, CString sTemp);
	void OnSetfocusGlassData1(CString sTemp);
	void OnSetfocusGlassData2(CString sTemp);
	void OnSetfocusGlassData3(CString sTemp);
	void OnSetfocusGlassData4(CString sTemp);
	void OnSetfocusGlassData5(CString sTemp);
	void OnSetfocusGlassData6(CString sTemp);
	void OnSetfocusGlassData7(CString sTemp);
	void OnSetfocusGlassData8(CString sTemp);
	void OnSetfocusGlassData9(CString sTemp);
	void OnSetfocusGlassData10(CString sTemp);
	void OnSetfocusGlassData11(CString sTemp);
	void OnSetfocusGlassData12(CString sTemp);
	void UpdateGlassData();
	int Hex2Dec( CString sValue );
	void SetDataToGridCtrl_GlassInfo();
	void GridInit_GlassInfo();
	CDicsData*		m_pDicsData;
	CBitmapButton	m_Ok;

	CString			m_sGlassId;
	CString			m_sOperatorId;

	GLS_INFO		m_GlsInfo;
	GLS_INFO		m_OldGlsInfo;
	CString			m_sTitle;
	BOOL			m_bPermitAccess;
	int				m_nTargetCv;
	int				m_nGlassInfoNo;

	CString			m_sGlassData[MAX_GLASS_DATA_ITEM_NO];
	static int		m_nGlassDataFormat[MAX_GLASS_DATA_ITEM_NO];
	static CString	m_sGlassDataName[MAX_GLASS_DATA_ITEM_NO];

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgGlassInfo)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CDlgGlassInfo)
	virtual BOOL OnInitDialog();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnGlassIdInquire();
	afx_msg void OnGlassOpIdReport();
	afx_msg void OnDelete();
	afx_msg void OnForceDel();
	afx_msg void OnMove();
	afx_msg void OnEdit();
	afx_msg void OnDestroy();
	afx_msg void OnDblClickGridGlassInfo();
	afx_msg void OnChangeOperatorId();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGGLASSINFO_H__6C4A2594_2AF2_4D4B_AAB1_A0A3458BAEFF__INCLUDED_)
