#if !defined(AFX_DLGKEYBOARD_H__83A9FB71_D4DF_4744_B673_95BFCD7AD0F4__INCLUDED_)
#define AFX_DLGKEYBOARD_H__83A9FB71_D4DF_4744_B673_95BFCD7AD0F4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgKeyboard.h : header file
//

#include "..\X\MacButtons.h"

/////////////////////////////////////////////////////////////////////////////
// CDlgKeyboard dialog

class CDlgKeyboard : public CDialog
{
// Construction
public:
	CDlgKeyboard(CWnd* pParent = NULL);   // standard constructor

	CBitmapButton m_Ok;
	CBitmapButton m_Cancel;
	BOOL		  m_bUpperCase;
	BOOL		  m_bLimitCharacter;
	int			  m_nLimitMax;
	BOOL		  m_bLimitInteger;
	int			  m_nLimitUpper;
	int			  m_nLimitLower;
	BOOL		  m_bLimitFloat;
	float		  m_fLimitUpper;
	float		  m_fLimitLower;

	void UpdateEditBox(char ch);

// Dialog Data
	//{{AFX_DATA(CDlgKeyboard)
	enum { IDD = IDD_DLG_KEYBOARD };
	CMacRadioButton	m_UpperCase;
	CMacRadioButton	m_LowerCase;
	CString			m_sValue;
	CString			m_sInitValue;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgKeyboard)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgKeyboard)
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg void OnButton1();
	afx_msg void OnButton2();
	afx_msg void OnButton3();
	afx_msg void OnButton4();
	afx_msg void OnButton5();
	afx_msg void OnButton6();
	afx_msg void OnButton7();
	afx_msg void OnButton8();
	afx_msg void OnButton9();
	afx_msg void OnButton0();
	afx_msg void OnButtonA();
	afx_msg void OnButtonB();
	afx_msg void OnButtonC();
	afx_msg void OnButtonD();
	afx_msg void OnButtonE();
	afx_msg void OnButtonF();
	afx_msg void OnButtonG();
	afx_msg void OnButtonH();
	afx_msg void OnButtonI();
	afx_msg void OnButtonJ();
	afx_msg void OnButtonK();
	afx_msg void OnButtonL();
	afx_msg void OnButtonM();
	afx_msg void OnButtonN();
	afx_msg void OnButtonO();
	afx_msg void OnButtonP();
	afx_msg void OnButtonQ();
	afx_msg void OnButtonR();
	afx_msg void OnButtonS();
	afx_msg void OnButtonT();
	afx_msg void OnButtonU();
	afx_msg void OnButtonV();
	afx_msg void OnButtonW();
	afx_msg void OnButtonX();
	afx_msg void OnButtonY();
	afx_msg void OnButtonZ();
	afx_msg void OnButtonMinus();
	afx_msg void OnButtonUnderbar();
	afx_msg void OnButtonSpace();
	afx_msg void OnButtonBack();
	afx_msg void OnButtonUpper();
	afx_msg void OnButtonLower();
	afx_msg void OnButtonClear();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGKEYBOARD_H__83A9FB71_D4DF_4744_B673_95BFCD7AD0F4__INCLUDED_)
