// DlgLdAlign.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "DlgLdAlign.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgLdAlign dialog


CDlgLdAlign::CDlgLdAlign(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgLdAlign::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgLdAlign)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDlgLdAlign::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgLdAlign)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
	DDX_Control( pDX, IDC_RADIO_FW, m_macAlignFW );		// ljy_050118 : Use Mac BTN
	DDX_Control( pDX, IDC_RADIO_BW, m_macAlignBW );		// ljy_050118 : Use Mac BTN
}


BEGIN_MESSAGE_MAP(CDlgLdAlign, CDialog)
	//{{AFX_MSG_MAP(CDlgLdAlign)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_RADIO_FW, OnRadioFw)
	ON_BN_CLICKED(IDC_RADIO_BW, OnRadioBw)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgLdAlign message handlers

BOOL CDlgLdAlign::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	SetTimer( TIMER_MANUAL, 100, NULL );

	VERIFY( m_Ok.AutoLoad( IDOK, this ) );		// ljy_050118 : Use Bitmap OK BTN

	// Set the MAC button	ljy_050118 : Use Mac BTN
	MAC_COLOR_SET color_set;

	for( int i = 0 ; i < 4 ; i ++ )
	{		
		m_stcAlignFw[i].SubclassDlgItem( IDC_STATIC_ALIGN_FW1 + i, this );
		m_stcAlignFw[i].SetTextColor( BLACK_COLOR );
		m_stcAlignFw[i].SetBkColor( WHITE_COLOR );

		m_stcAlignBw[i].SubclassDlgItem( IDC_STATIC_ALIGN_BW1 + i, this );
		m_stcAlignBw[i].SetTextColor( BLACK_COLOR );
		m_stcAlignBw[i].SetBkColor( WHITE_COLOR );
	}

//	if( dosLD_UNIT_ALIGN_FW ) ((CButton*)GetDlgItem( IDC_RADIO_FW ))->SetCheck( 1 );
//	if( dosLD_UNIT_ALIGN_BW ) ((CButton*)GetDlgItem( IDC_RADIO_BW ))->SetCheck( 1 );

	if( m_pDicsData->m_GenInfo.bAuto )
	{
		((CButton*)GetDlgItem( IDC_RADIO_FW ))->EnableWindow( FALSE );
		((CButton*)GetDlgItem( IDC_RADIO_BW ))->EnableWindow( FALSE );
	}

	// ljy_050118 : Align FW BTN
	m_macAlignFW.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_CYAN_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macAlignFW.SetColorSetting( color_set );
	m_macAlignFW.SetBold();
	// ljy_050118 : End

	// ljy_050118 : Align BW BTN
	m_macAlignBW.GetColorSetting( &color_set );
	color_set.crFace = LIGHT_ORANGE_COLOR;
	color_set.crLiteShadow = MAGENTA_COLOR;
	m_macAlignBW.SetColorSetting( color_set );
	m_macAlignBW.SetBold();
	// ljy_050118 : End
		
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgLdAlign::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	UpdateDisplay();
	CDialog::OnTimer(nIDEvent);
}

void CDlgLdAlign::UpdateDisplay()
{
/*	static BOOL bAlignSensorFWState[4] = { FALSE, };
	static BOOL bAlignSensorBWState[4] = { FALSE, };

	for( int i = 0 ; i < 4 ; i ++ )
	{
		if( digLD_UNIT_ALIGN_FW( i ) && !bAlignSensorFWState[i] )
		{
			bAlignSensorFWState[i] = TRUE;
			m_stcAlignFw[i].StartBkBlink( FALSE );
			m_stcAlignFw[i].SetBkColor( GREEN_COLOR );
		}
		else if( !digLD_UNIT_ALIGN_FW( i ) && bAlignSensorFWState[i] )
		{
			bAlignSensorFWState[i] = FALSE;
			m_stcAlignFw[i].StartBkBlink( FALSE );
			m_stcAlignFw[i].SetBkColor( WHITE_COLOR );
		}
		if( digLD_UNIT_ALIGN_BW( i ) && !bAlignSensorBWState[i] )
		{
			bAlignSensorBWState[i] = TRUE;
			m_stcAlignBw[i].StartBkBlink( FALSE );
			m_stcAlignBw[i].SetBkColor( GREEN_COLOR );
		}
		else if( !digLD_UNIT_ALIGN_BW( i ) && bAlignSensorBWState[i] )
		{
			bAlignSensorBWState[i] = FALSE;
			m_stcAlignBw[i].StartBkBlink( FALSE );
			m_stcAlignBw[i].SetBkColor( WHITE_COLOR );
		}
	}
*/
}

void CDlgLdAlign::OnRadioFw() 
{
//	doLD_UNIT_ALIGN_FW( ON );
//	doLD_UNIT_ALIGN_BW( OFF );
}

void CDlgLdAlign::OnRadioBw() 
{
//	doLD_UNIT_ALIGN_FW( OFF );
//	doLD_UNIT_ALIGN_BW( ON );
}

void CDlgLdAlign::OnDestroy() 
{
	CDialog::OnDestroy();

	KillTimer( TIMER_MANUAL );
}

