#if !defined(AFX_DLG_LOST_GLASS_LIST_H__599817BA_45EC_4AA8_96D0_26848EBC089A__INCLUDED_)
#define AFX_DLG_LOST_GLASS_LIST_H__599817BA_45EC_4AA8_96D0_26848EBC089A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgLostGlassList.h : header file
//
#include "..\DicsData.h"
#include "..\msflexgrid.h"
#include "..\X\MsgBox.h"
#include "..\X\MacButtons.h"
#include "..\Database\DaoLostGlassSet.h"

/////////////////////////////////////////////////////////////////////////////
// CDlgLostGlassList dialog
class CDlgLostGlassList : public CDialog
{
// Construction
public:
	CDlgLostGlassList(CWnd* pParent = NULL);   // standard constructor
	void SetData( CDicsData* pData ) { m_pDicsData = pData; }
	CMSFlexGrid				m_gridLostGlassList;
	CDaoLostGlassListSet	m_LostGlassListSet;

	int				m_nMaxRows;
	int				m_nMaxCols;

	CMacButton		m_macRecovery;
	CMacButton		m_macOk;
	
	GLS_INFO		m_RecoverGlsInfo;
	int				m_nSelectNo;

// Dialog Data
	//{{AFX_DATA(CDlgLostGlassList)
	enum { IDD = IDD_DLG_LOST_GLASS_LIST };
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgLostGlassList)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
public:
	CDicsData*	m_pDicsData;
	void GridInit_LostGlassList();
// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CDlgLostGlassList)
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	afx_msg void OnRecovery();
	afx_msg void OnClickGridLostList();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLG_LOST_GLASS_LIST_H__599817BA_45EC_4AA8_96D0_26848EBC089A__INCLUDED_)
