// DlgOpCall.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "DlgOpCall.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgOpCall dialog


CDlgOpCall::CDlgOpCall(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgOpCall::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgOpCall)
	m_sOpCall = _T("");
	//}}AFX_DATA_INIT
}


void CDlgOpCall::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgOpCall)
	DDX_Text(pDX, IDC_OP_CALL, m_sOpCall);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgOpCall, CDialog)
	//{{AFX_MSG_MAP(CDlgOpCall)
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgOpCall message handlers

BOOL CDlgOpCall::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// Get brush
	m_hbrBgColor =	CreateSolidBrush( BLACK_COLOR );

	// Set button
	VERIFY( m_Ok.AutoLoad( IDOK, this ) );
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

HBRUSH CDlgOpCall::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	UINT id = pWnd->GetDlgCtrlID();
	switch( nCtlColor )
	{
//		case CTLCOLOR_DLG:
//			hbr = m_hbrBgColor;
//			break;
		case CTLCOLOR_STATIC:
			if( id == IDC_OP_CALL )
			{
				hbr = m_hbrBgColor;
				pDC->SetBkMode( TRANSPARENT );
				pDC->SetTextColor( YELLOW_COLOR );
			}
	}
	
	return hbr;
}

void CDlgOpCall::OnOK() 
{
	// Delete the context
	DeleteObject( m_hbrBgColor );
	
	CDialog::OnOK();
}
