#if !defined(AFX_DLGPUMPCLN_H__3C95D725_C6ED_4832_A071_7256EB994FB5__INCLUDED_)
#define AFX_DLGPUMPCLN_H__3C95D725_C6ED_4832_A071_7256EB994FB5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgPumpCln.h : header file
//

#include "..\X\MacButtons.h"
#include "..\FactoryLib\EqpAssy.h"

/////////////////////////////////////////////////////////////////////////////
// CDlgPumpCln dialog

class CDlgPumpCln : public CDialog
{
// Construction
public:
	CDlgPumpCln(CWnd* pParent = NULL);   // standard constructor
	void SetDevice(XCtlDevice* pDevice) { m_pDevice = pDevice; }
	void SetEqpAssy( CEqpAssy* pEqpAssy ){ m_pEqpAssy = pEqpAssy; }
	void SetTankAssy( CFaTank* pTank ){ m_pTank = pTank; }

	int		m_nCurSelPump1;
	XCtlDevice* m_pDevice;
	CEqpAssy*	m_pEqpAssy;
	CFaTank*	m_pTank;

// Dialog Data
	//{{AFX_DATA(CDlgPumpCln)
	enum { IDD = IDD_DLG_PUMP_CLN };
	CMacRadioButton	m_macPump1On;
	CMacRadioButton	m_macPump1Off;
	CMacRadioButton	m_macPump1NoAlarm;
	CMacRadioButton	m_macPump1Alarm;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgPumpCln)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CBitmapButton	m_Ok;

	// Generated message map functions
	//{{AFX_MSG(CDlgPumpCln)
	virtual BOOL OnInitDialog();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnPump1On();
	afx_msg void OnPump1Off();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGPUMPCLN_H__3C95D725_C6ED_4832_A071_7256EB994FB5__INCLUDED_)
