#if !defined(AFX_DLGROLLBRUSH_H__01011BF4_9E72_4DE3_A7F1_5B5ECD076184__INCLUDED_)
#define AFX_DLGROLLBRUSH_H__01011BF4_9E72_4DE3_A7F1_5B5ECD076184__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgRollBrush.h : header file
//

#include "..\X\MacButtons.h"
#include "..\X\XCtlDevice.h"
#include "..\Sequence\MainSeq.h"
#include "..\FactoryLib\EqpAssy.h"

/////////////////////////////////////////////////////////////////////////////
// CDlgRollBrush dialog

class CDlgRollBrush : public CDialog
{
// Construction
public:
	CDlgRollBrush(CWnd* pParent = NULL);   // standard constructor
//	void EnableBtn( BOOL bEnable );
	void SetDevice(XCtlDevice* pDevice) { m_pDevice = pDevice; }
	XCtlDevice* m_pDevice;
	CView* m_pView;
	void SetMainSeq( CMainSeq* pMainSeq ){ m_pMainSeq = pMainSeq; }
	void SetRbSeq( CRbSeq* pRbSeq ){ m_pRbSeq = pRbSeq; }
	CMainSeq*  m_pMainSeq;
	CRbSeq*	m_pRbSeq;
	void SetEqpAssy( CEqpAssy* pEqpAssy ){ m_pEqpAssy = pEqpAssy; }
	CEqpAssy*	m_pEqpAssy;

public:
	void SetButtonState();
	CBitmapButton	m_Ok;
	int				m_nAction;
	int				m_nRbType;
	int				m_nDirection[MAX_RB_NO];
					// -1 : BW, 0 : Stop, 1 : FW
					// for RB Dialog Button Setting...

// Dialog Data
	//{{AFX_DATA(CDlgRollBrush)
	enum { IDD = IDD_DLG_ROLL_BRUSH };
	CComboBox	m_comboRbRpm;
	CMacRadioButton	m_RadioRbType[MAX_RB_NO];
	CMacRadioButton	m_RbCw;
	CMacRadioButton	m_RbCcw;
	CMacRadioButton	m_RbStop;
	CMacRadioButton	m_AllCw;
	CMacRadioButton	m_AllCcw;
	CMacRadioButton	m_AllStop;
//	CMacCheckBox	m_MotorNoAlarm;
	CMacCheckBox	m_MotorCpDown;
	CMacCheckBox	m_MotorAlarm;
	CString	m_sRbUpdnGap;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgRollBrush)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgRollBrush)
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSelchangeComboRbRpm();
	afx_msg void OnRbCw();
	afx_msg void OnRbCcw();
	afx_msg void OnRbStop();
	afx_msg void OnSelchangeListRbType();
	afx_msg void OnSelChangeRadioRbType( UINT nID );	
	afx_msg void OnAllStop();
	afx_msg void OnAllCw();
	afx_msg void OnAllCcw();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGROLLBRUSH_H__01011BF4_9E72_4DE3_A7F1_5B5ECD076184__INCLUDED_)
