// DlgSetCurPos.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "DlgSetCurPos.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgSetCurPos dialog


CDlgSetCurPos::CDlgSetCurPos(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgSetCurPos::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgSetCurPos)
	//}}AFX_DATA_INIT
}


void CDlgSetCurPos::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgSetCurPos)
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_TR_POS, m_cboRbtPos[0]);
	DDX_Control(pDX, IDC_LD_UP_HAND_POS, m_cboRbtPos[1]);
	DDX_Control(pDX, IDC_LD_LO_HAND_POS, m_cboRbtPos[2]);
	DDX_Control(pDX, IDC_UL_LO_HAND_POS, m_cboRbtPos[3]);
	DDX_Control(pDX, IDC_UL_UP_HAND_POS, m_cboRbtPos[4]);
}


BEGIN_MESSAGE_MAP(CDlgSetCurPos, CDialog)
	//{{AFX_MSG_MAP(CDlgSetCurPos)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgSetCurPos message handlers
BOOL CDlgSetCurPos::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	VERIFY( m_Ok.AutoLoad( IDOK, this ) );
	VERIFY( m_Cancel.AutoLoad( IDCANCEL, this ) );
	
	// TR Position(Teaching point sequence)
	m_cboRbtPos[0].AddString("HOME");
	m_cboRbtPos[0].AddString("SEND");
	m_cboRbtPos[0].AddString("WAIT");
	m_cboRbtPos[0].AddString("RECV");
	
	// LD UP HAND Position
	m_cboRbtPos[1].AddString("HOME");
	m_cboRbtPos[1].AddString("WAIT");
	m_cboRbtPos[1].AddString("RECV1");
	m_cboRbtPos[1].AddString("RECV2");
	m_cboRbtPos[1].AddString("SEND1");
	m_cboRbtPos[1].AddString("SEND2");
	m_cboRbtPos[1].AddString("SEND3");
	m_cboRbtPos[1].AddString("RET");

	// LD LO HAND Position
	m_cboRbtPos[2].AddString("HOME");
	m_cboRbtPos[2].AddString("RECV");
	m_cboRbtPos[2].AddString("SEND1");
	m_cboRbtPos[2].AddString("SEND2");

	// UL LO HAND Position
	m_cboRbtPos[3].AddString("HOME");
	m_cboRbtPos[3].AddString("RECV1");
	m_cboRbtPos[3].AddString("RECV2");
	m_cboRbtPos[3].AddString("SEND");

	// UL UP HAND Position
	m_cboRbtPos[4].AddString("HOME");
	m_cboRbtPos[4].AddString("WAIT");
	m_cboRbtPos[4].AddString("RECV1");
	m_cboRbtPos[4].AddString("RECV2");
	m_cboRbtPos[4].AddString("RECV3");
	m_cboRbtPos[4].AddString("SEND1");
	m_cboRbtPos[4].AddString("SEND2");
	m_cboRbtPos[4].AddString("RET");

	for( int i = 0; i < MAX_SET_RBT; i++ )
	{
		m_nOldPos[i] = m_pMmc->GetCurPoint( i );
		m_cboRbtPos[i].SetCurSel( m_nOldPos[i] );
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgSetCurPos::OnOK() 
{/*
	for( int i = 0; i < MAX_SET_RBT; i++ )
	{
		m_nCurPos[i] = m_cboRbtPos[i].GetCurSel();
		
		if( m_nOldPos[i] != m_nCurPos[i] )
		{
			m_pMmc->SetCurPoint( i, m_nCurPos[i] );
			
			switch( i ) 
			{
			case RBT_TR_UNIT:
				if( m_nCurPos[i] == TR_UNIT_SEND_POS ) m_pGlassAni->RbtMoveRegion( i, CGlassAni::aniTR_SEND );
				else if( m_nCurPos[i] == TR_UNIT_RECV_POS ) m_pGlassAni->RbtMoveRegion( i, CGlassAni::aniTR_RECV );
				else m_pGlassAni->RbtMoveRegion( i, CGlassAni::aniTR_WAIT );
				break;

			case RBT_LD_FISH_UNIT:
				if( m_nCurPos[i] == LD_FISH_UNIT_RECV1_POS ) m_pGlassAni->RbtMoveRegion( i, CGlassAni::aniLDUP_RECV );
				else if( m_nCurPos[i] == LD_FISH_UNIT_RECV2_POS ) m_pGlassAni->RbtMoveRegion( i, CGlassAni::aniLDUP_RECV );
				else m_pGlassAni->RbtMoveRegion( i, CGlassAni::aniLDUP_SEND );
				break;
			}
		}
	}
	*/
	CDialog::OnOK();
}
