#if !defined(AFX_DLGTRTURN_H__ADD42AEC_CBE5_43E8_A7F1_8BD6F3D8D7AE__INCLUDED_)
#define AFX_DLGTRTURN_H__ADD42AEC_CBE5_43E8_A7F1_8BD6F3D8D7AE__INCLUDED_

#include "..\X\MacButtons.h"	// Added by ClassView
#include "..\X\XCtlDevice.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgTrTurn.h : header file
//
#include "..\FactoryLib\EqpAssy.h"

/////////////////////////////////////////////////////////////////////////////
// CDlgTrTurn dialog

class CDlgTrTurn : public CDialog
{
// Construction
public:
	CDlgTrTurn(CWnd* pParent = NULL);   // standard constructor

	CBitmapButton	m_Ok;
	void UpdateSensorStatus();
	CMacRadioButton m_macTurnProcess;
	CMacRadioButton m_macTurnExchange;
	CMacRadioButton m_macAlignFw;
	CMacRadioButton m_macAlignBw;
	CMacCheckBox	m_macTurnProcessSensor;
	CMacCheckBox	m_macTurnExchangeSensor;
	CMacCheckBox	m_macAlignFw1;
	CMacCheckBox	m_macAlignFw2;
	CMacCheckBox	m_macAlignBw1;
	CMacCheckBox	m_macAlignBw2;
	XCtlDevice		* m_pDevice;

	void SetDevice( XCtlDevice* pDevice ){ m_pDevice = pDevice; }

	void SetEqpAssy( CEqpAssy* pEqpAssy ){ m_pEqpAssy = pEqpAssy; }
	CEqpAssy*	m_pEqpAssy;

// Dialog Data
	//{{AFX_DATA(CDlgTrTurn)
	enum { IDD = IDD_DIALOG_TR_TURN };
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgTrTurn)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgTrTurn)
	afx_msg void OnTimer(UINT nIDEvent);
	virtual BOOL OnInitDialog();
	afx_msg void OnClose();
	afx_msg void OnRadioExchange();
	afx_msg void OnRadioProcess();
	afx_msg void OnRadioAlignFw();
	afx_msg void OnRadioAlignBw();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	enum alignTYPE{ alignON, alignOFF, alignONOFF };
	enum turnDIRECTION{ turnEXCHANGE, turnPROCESS, turnINVERT };
	enum trCylTYPE{ typeLock, typeJoint,typeAlign,typeTurn };
	enum jointPOS { jointSEND, jointWAIT, jointRECV, jointNONE  };
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGTRTURN_H__ADD42AEC_CBE5_43E8_A7F1_8BD6F3D8D7AE__INCLUDED_)
