#pragma once

#include "..\X\XCtlDevice.h"	// Added by ClassView
#include "..\X\MacButtons.h"	// Added by ClassView
#include "..\X\ColorStatic.h"
// CDlgUlAlign ȭ Դϴ.

#include "..\FactoryLib\EqpAssy.h"

class CDlgUlAlign : public CDialog
{
	DECLARE_DYNAMIC(CDlgUlAlign)

public:
	CDlgUlAlign(CWnd* pParent = NULL);   // ǥ Դϴ.
	virtual ~CDlgUlAlign();

	CBitmapButton	m_Ok;
	CMacRadioButton m_macAlignFw;
	CMacRadioButton m_macAlignBw;
	CMacRadioButton m_macAlignAllBw;
	XCtlDevice*		m_pDevice;
	int				m_nAssy;	//0=UL Align, 1=UL Align Updown, 2=UL Pin Updown

	CColorStatic	m_stcAlign[4];

	DWORD			m_dwStartTick;
	int				m_nTarget;

	void SetDevice( XCtlDevice* pDevice, int nAssy ){ m_pDevice = pDevice; m_nAssy = nAssy;	}
	CEqpAssy*	m_pEqpAssy;
	void SetEqpAssy( CEqpAssy* pEqpAssy ){ m_pEqpAssy = pEqpAssy; }
	CFaCylinder* m_Cylinder;
	void SetCylinderAssy( CFaCylinder* Cylinder ){ m_Cylinder = Cylinder; }

	BOOL ChkInterlock(int nDir, int nUD);

	BOOL m_bAllOrigin;

	BOOL GetAlignState(CFaCylinder* Cylinder, int nDir);

	BOOL IsPowerState(BOOL bOn, BOOL *bAlarmList);

// ȭ  Դϴ.
	enum { IDD = IDD_DIALOG_ALIGN4 };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.

	//{{AFX_MSG(CDlgAlign)
	virtual BOOL OnInitDialog();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	afx_msg void OnRadioFw();
	afx_msg void OnRadioBw();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedUlalignAllbw();
};
