#if !defined(AFX_DLGVALVE_H__A91FA639_3301_4EFE_9920_2A0E0127E36D__INCLUDED_)
#define AFX_DLGVALVE_H__A91FA639_3301_4EFE_9920_2A0E0127E36D__INCLUDED_

#include "..\X\XCtlDevice.h"	// Added by ClassView
#include "..\X\MacButtons.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgValve.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDlgValve dialog
#include "..\FactoryLib\EqpAssy.h"

class CDlgValve : public CDialog
{
// Construction
public:
	XCtlDevice *	m_pDevice;
	CEqpAssy*		m_pEqpAssy;

	CMacRadioButton m_macOpen;
	CMacRadioButton m_macClose;
	CString m_sWndName;
	CBitmap	m_bmpOk;
	int m_nValveNo;

	BOOL	m_bPermitAccess;				// ljy_041104
	CString	m_sValveTitle[MAX_VALVE_NO];	// ljy_041104

	int				m_nWhatGroup;
	enum VALVE_GROUP { vgJOB3, vgJOB4 };
public:
	void SetDevice(XCtlDevice * pDevice) {m_pDevice = pDevice;}
	void SetEqpAssy( CEqpAssy* pEqpAssy ) { m_pEqpAssy = pEqpAssy; }

	CDlgValve(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CDlgValve)
	enum { IDD = IDD_DLG_VALVE };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgValve)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CBitmapButton	m_Ok;

	// Generated message map functions
	//{{AFX_MSG(CDlgValve)
	afx_msg void OnRadio1();
	afx_msg void OnRadio2();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGVALVE_H__A91FA639_3301_4EFE_9920_2A0E0127E36D__INCLUDED_)
