// DlgVcrMode.cpp : implementation file
//

#include "stdafx.h"
#include "..\dics.h"
#include "DlgVcrMode.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgVcrMode dialog


CDlgVcrMode::CDlgVcrMode(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgVcrMode::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgVcrMode)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDlgVcrMode::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgVcrMode)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	DDX_Control(pDX, IDC_VCR_ON1, m_btnVcrOn[0]);
	DDX_Control(pDX, IDC_VCR_ON2, m_btnVcrOn[1]);
	DDX_Control(pDX, IDC_VCR_OFF1, m_btnVcrOff[0]);
	DDX_Control(pDX, IDC_VCR_OFF2, m_btnVcrOff[1]);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgVcrMode, CDialog)
	//{{AFX_MSG_MAP(CDlgVcrMode)
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE( IDC_VCR_ON1, IDC_VCR_OFF2, OnVcrModeSelect )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgVcrMode message handlers

BOOL CDlgVcrMode::OnInitDialog() 
{
	CDialog::OnInitDialog();
	MAC_COLOR_SET color_set;

	for( int i = 0 ; i < 2 ; i++ )
	{
		m_btnVcrOn[i].GetColorSetting( &color_set );
		color_set.crFace = LIGHT_CYAN_COLOR;
		color_set.crLiteShadow = MAGENTA_COLOR;
		m_btnVcrOn[i].SetColorSetting( color_set );
		m_btnVcrOn[i].SetBold();

		m_btnVcrOff[i].GetColorSetting( &color_set );
		color_set.crFace = LIGHT_ORANGE_COLOR;
		color_set.crLiteShadow = MAGENTA_COLOR;
		m_btnVcrOff[i].SetColorSetting( color_set );
		m_btnVcrOff[i].SetBold();
	}
	return TRUE;
}

void CDlgVcrMode::OnVcrModeSelect(UINT nID) 
{
	// TODO: Add your control notification handler code here
	int nId = nID - IDC_VCR_ON1;
	if( nId == 0 )
		nVcrCodeNo = 1;
	else if( nId == 1 )
		nVcrCodeNo = 2;
	else if( nId == 2 )
		nVcrCodeNo = 3;
	else if( nId == 3 )
		nVcrCodeNo = 4;
	EndDialog( IDOK );
}
