// Channels.h: interface for the CChannels class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHANNELS_H__653E5351_174E_4D1F_AC80_6F20C109D30B__INCLUDED_)
#define AFX_CHANNELS_H__653E5351_174E_4D1F_AC80_6F20C109D30B__INCLUDED_

#include "..\X\XChannel.h"	// Added by ClassView
#include "..\X\XCtlDevice.h"	// Added by ClassView

#include "IniData.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CChannels  
{
private:
	static CIniData m_iniConfiguration;
protected:
	static int m_nMaxNode;
protected:
	int GetChannelEAFromMapFile();
	int m_nNode;
	BOOL GetInformation(int &add, int &node, int &no ,CString &name, CString &Cpoint);
	void Create(int nMaxNode);
	UINT* m_pConfiguration;
	int m_nNodeEA;
	void SetMapFileName(CString sName);
	void CloseMapFile();
	BOOL OpenMapFile();
	CString m_sMapFileName;
	CStdioFile m_File;
	BOOL m_bInitialized;
	void SetChannelSize(int nSize);
	int m_nChannelSize;
	XCtlDevice *	m_pDevice;

public:
	static void ReadMaxNodeSize();
	void SetMaxNodeSize(int nMaxNode);
	int GetMaxNodeSize();
	enum _CHANNELS_NAME
	{
		DI,
		DO,
		AI,
		AO,
	};
	UINT * GetConfiguration();
	int GetNodeEA();
	virtual BOOL Create(XCtlDevice * pDevice);
	int GetChannelSize();
	void SetDevice(XCtlDevice * pDevice);
	CChannels();
	virtual ~CChannels();

};

#endif // !defined(AFX_CHANNELS_H__653E5351_174E_4D1F_AC80_6F20C109D30B__INCLUDED_)
