// DigitalInpus.h: interface for the CDigitalInputs class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DIGITALINPUTS_H__BA7256C5_66F7_4201_B050_4AC676B4877C__INCLUDED_)
#define AFX_DIGITALINPUTS_H__BA7256C5_66F7_4201_B050_4AC676B4877C__INCLUDED_

#include "..\X\XDigitalInput.h"	// Added by ClassView
#include "Channels.h"
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CDigitalInputs : public CChannels
{
public:
	XDigitalInput* GetInstance(int nAdd);
	XDigitalInput * GetInstance(CString sName);
	BOOL Create(XCtlDevice * pDevice);
	CDigitalInputs(int nChannelSize);
	CDigitalInputs();
	virtual ~CDigitalInputs();

//private:
	XDigitalInput * m_pDi;
	XDigitalInput * m_pDiSpare;
};

#endif // !defined(AFX_DIGITALINPUTS_H__BA7256C5_66F7_4201_B050_4AC676B4877C__INCLUDED_)
