// FaDigitalInput.h: interface for the CFaDigitalInput class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FADIGITALINPUT_H__AF457A82_03FF_4446_B87A_9C38FF551AA8__INCLUDED_)
#define AFX_FADIGITALINPUT_H__AF457A82_03FF_4446_B87A_9C38FF551AA8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Device.h"

//////////////////////////////////////////////////////////////////////////
// 2008. 06. 30
// HJYOU
// Automation Factory Only One Digital Input Device
// EMO, EMS, FFU, IONIZER, DOOR, COVER, LEAK, AREA, JOINT CONFIRM ...ETC
//////////////////////////////////////////////////////////////////////////

class CFaDigitalInput : public CDevice  
{
public:
	CFaDigitalInput();
	virtual ~CFaDigitalInput();
	
	BOOL ReadConfiguration();
	BOOL Get( int nNo=0 );
	void SetState( int nNo=0, BOOL bVal=FALSE );
	BOOL GetAnd();
	BOOL GetOr();
	int	GetDiSize() { return m_nDiCount; }
	BOOL GetType(int nNo=0 );		// hskwak 20191010 Input A/B Type ȯ - A=0 B=1;
	
protected:
	XDigitalInput ** m_pDi;
	int	m_nDiCount;
};

#endif // !defined(AFX_FADIGITALINPUT_H__AF457A82_03FF_4446_B87A_9C38FF551AA8__INCLUDED_)
