// FaHpmj.h: interface for the CFaHpmj class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FAHPMJ_H__10D4B89B_0CF6_4E98_AC4F_5692DF3B9677__INCLUDED_)
#define AFX_FAHPMJ_H__10D4B89B_0CF6_4E98_AC4F_5692DF3B9677__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Device.h"
#include "..\X\XAnalogInput.h"	// Added by ClassView
#include "..\X\XAnalogOutput.h"	// Added by ClassView
#include "..\X\XDigitalInput.h"	// Added by ClassView
#include "..\X\XDigitalOutput.h"	// Added by ClassView

class CFaHpmj : public CDevice  
{
public:
	int GetHpmjAdcVal( int nNo );
	int GetAiAddress( int nNo );
	float GetHpmjAanlogInput( int nNo );
	void SetInverterHertz( int nNo, WORD wHertzVal );
	BOOL GetHpmjInputState( int nState );
	BOOL GetHpmjActState( int nAct );
	void SetHpmjAct( int nAct, BOOL bState );
	CFaHpmj();
	virtual ~CFaHpmj();

	BOOL ReadConfiguration();

	enum _CLY_ACT_STATE
	{
		actSTOP,
		actUP,
		actDN,
	}; 

	int	GetDiSize() { return m_nDiCount; }
	int	GetDoSize() { return m_nDoCount; }
	int	GetAiSize() { return m_nAiCount; }
	int	GetAoSize() { return m_nAoCount; }

protected:
	XAnalogInput ** m_pAi; 
	XAnalogOutput ** m_pAo;
	XDigitalInput ** m_pDi;
	XDigitalOutput ** m_pDo;

	int m_nAiCount;
	int m_nAoCount;
	int m_nDiCount;
	int m_nDoCount;
	
};

#endif // !defined(AFX_FAHPMJ_H__10D4B89B_0CF6_4E98_AC4F_5692DF3B9677__INCLUDED_)
