// FaServoPosSensor.h: interface for the CFaServoPosSensor class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FASERVOPOSSENSOR_H__9BD9CD5C_10BB_4109_871D_30090AF3BB74__INCLUDED_)
#define AFX_FASERVOPOSSENSOR_H__9BD9CD5C_10BB_4109_871D_30090AF3BB74__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Device.h"

class CFaServoPosSensor : public CDevice  
{
public:
	CFaServoPosSensor();
	virtual ~CFaServoPosSensor();

	BOOL ReadConfiguration();
	void SetMaxSectionNo( int nNo=0 );
	int	GetMaxSectionNo();
	BOOL GetAnd( int nUnit=0 );
	BOOL GetOr( int nUnit=0 );
	void Set( int nUnit, BOOL bVal=FALSE );
	BOOL Get( int nUnit=0, int nNo=0 );
	void Set( int nUnit, int nNo, BOOL bVal=FALSE );

protected:
	XDigitalInput *** m_pDi;
	XDigitalInput ** m_pDiMmc;
	int*	m_nDiCount;
	int		m_nMaxSectionNo;
};

#endif // !defined(AFX_FASERVOPOSSENSOR_H__9BD9CD5C_10BB_4109_871D_30090AF3BB74__INCLUDED_)
