// FaSwitch.h: interface for the CFaSwitch class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FASWITCH_H__56532813_9857_442D_B7AE_5C454C57BA4F__INCLUDED_)
#define AFX_FASWITCH_H__56532813_9857_442D_B7AE_5C454C57BA4F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Device.h"

class CFaSwitch : public CDevice  
{
public:
	CFaSwitch();
	virtual ~CFaSwitch();

	BOOL ReadConfiguration();
	BOOL Get( int nNo=0 );
	void Set( int nNo=0, BOOL bVal=FALSE );
	BOOL GetState( int nNo=0 );	// Get Output State
	void SetState( int nNo=0, BOOL bVal=FALSE );	// Set Input State
	int	GetDiSize() { return m_nDiCount; }
	int	GetDoSize() { return m_nDoCount; }

protected:
	XDigitalInput ** m_pDi;
	XDigitalOutput ** m_pDo;

	int m_nDiCount;
	int m_nDoCount;
};

#endif // !defined(AFX_FASWITCH_H__56532813_9857_442D_B7AE_5C454C57BA4F__INCLUDED_)
