// FileMap.h: interface for the CDebugFileMap class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FILEMAP_H__59A8A261_8997_4965_8085_FCC1B38B09DB__INCLUDED_)
#define AFX_FILEMAP_H__59A8A261_8997_4965_8085_FCC1B38B09DB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define SHMEMSIZE 0x4000	//4096	 // size: low 32-bits

class CFileMap : public CWnd
{
public:
	CFileMap();
	virtual ~CFileMap();

public:
	short m_nBufSize;
	unsigned short* m_nWriteData;
	unsigned short* m_nReadData;
	unsigned short ReceiveBit(short nDevNo);
	unsigned short ReceiveWord(short nDevNo);
	short ReadString(short nDevNo, LPTSTR lpszBuf, int nLen);
	BOOL SendBit(short nDevNo, short nData);
	BOOL SendWord(short nDevNo, unsigned short nData);
	short WriteString(short nDevNo, CString sStr, int nLen);
//	File Mapping create-----------
	BOOL	m_bMap;
	void	CloseFileMap();
	HANDLE	m_hMapFile;
	LPVOID	m_lpMapAddress;
	BOOL	CreateFileMap();
//  Open File Map-----------------
	int		OpenFileMap();
	void	ErrorHandler(LPCTSTR lpszText);
//  -------------------------------
};

#endif // !defined(AFX_FILEMAP_H__59A8A261_8997_4965_8085_FCC1B38B09DB__INCLUDED_)
