// DicsTransferSeq.h: interface for the CDicsTransferSeq class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TRANSFERSEQUENCE_H__057C1E01_01E8_4666_ABA6_2EF573FD589A__INCLUDED_)
#define AFX_TRANSFERSEQUENCE_H__057C1E01_01E8_4666_ABA6_2EF573FD589A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\X\XCtlDevice.h"
#include "..\X\XSequence.h"
#include "..\X\XTimer.h"
#include "..\X\XMmc.h"
#include "..\GlassAni.h"
#include "..\SetupItems.h"
#include "..\DicsData.h"
#include "..\EqpStateSequence.h"
#include "..\X\xctlmelsec.h"
#include "..\AnalogInput1.h"

class CDicsTransferSeq : public XSequence  
{
public:
	CDicsView*			m_pDicsView;
	CEqpStateSequence*	m_pEqpStateSeq;
	XCtlDevice*			m_pDevice;
	XTimer*				m_pTimer;
	CSetupItems*		m_pSetupItems;
	CDicsData*			m_pDicsData;
	XMmc*				m_pMmc;
	CGlassAni*			m_pGlassAni;
	CAnalogInput1*		m_pAI1;
	XCtlMelsec*			m_pMelsec;
	CDicsTransferSeq();
	virtual ~CDicsTransferSeq();
private:
	// Set pointer
	void SetDicsView( CDicsView *pView ) { m_pDicsView = pView;	}
	void SetSeqTimer(XTimer* pTimer) { m_pTimer = pTimer; }
	void SetDevice(XCtlDevice* pDevice) { m_pDevice = pDevice; }
	void SetSetupItems( CSetupItems* pSetupItems ) { m_pSetupItems = pSetupItems; }
	void SetData( CDicsData* pData ) { m_pDicsData = pData; }
	void SetEqpStateSequence(CEqpStateSequence* pEqpStateSeq) { m_pEqpStateSeq = pEqpStateSeq; }
	void SetMmc( XMmc* pMmc ) { m_pMmc = pMmc; }
	void SetGlassAni( CGlassAni* pGlassAni ) { m_pGlassAni = pGlassAni; }
	void SetMelsec( XCtlMelsec * pMelsec ){ m_pMelsec = pMelsec; }
	void SetAI1( CAnalogInput1 * pAI1 ){m_pAI1 = pAI1;}	
public:
	void SetRecipe2JobCond(CString sRecipeId);
	void SetOwnerPointer(CWnd* pWnd);
	
};

#endif // !defined(AFX_TRANSFERSEQUENCE_H__057C1E01_01E8_4666_ABA6_2EF573FD589A__INCLUDED_)
