// SocketSeq1.cpp: implementation of the CSocketSeq1 class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\dics.h"
#include "SocketSeq1.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSocketSeq1::CSocketSeq1()
{

}

CSocketSeq1::~CSocketSeq1()
{

}

//---------------------------------------------------------------------------
// Sequence Thread   ȣ...
//---------------------------------------------------------------------------
BOOL CSocketSeq1::Initialize()
{
	InitParameter();

	return TRUE;
}

//----------------------------------------------------------------------------
// Sequence Parameter ʱȭ
//----------------------------------------------------------------------------
void CSocketSeq1::InitParameter()
{
	m_nSeqSocketConnectNo	= 0;
	m_nSeqLinkTestReqNo		= 0;
	m_nSeqConfirmConnectNo	= 0;
	m_bLinkTestReq = FALSE;
	m_pDicsView = ( CDicsView* )m_pOwnerWnd;
}

//---------------------------------------------------------------------------
// Sequence loop... Sequence Run  ׻ ȣ...
//---------------------------------------------------------------------------
BOOL CSocketSeq1::Sequence()
{
	Sleep(1);

	SeqSocketConnect();
	SeqLinkTestReq();
	SeqConfirmConnect();

	return TRUE;
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void CSocketSeq1::SeqSocketConnect()
{
	int nSeqNo = m_nSeqSocketConnectNo;
	static DWORD dwStartTickCount = 0;

	static int nRetryCount = 0;	// 151212 halesu
	if( nRetryCount > 10 )	return;

	switch( nSeqNo )
	{
	case 0:
		dwStartTickCount = GetTickCount();
		nSeqNo = 10;
		break;

	case 10:
		if( m_pDicsView->m_pHost1->m_bActiveMode && ( GetTickCount() - dwStartTickCount ) > (DWORD) (5000) )
		{
			//DicsView connect  õϸ view ߴ  ߻..
			if( !m_pDicsView->m_pHost1->m_bConnected /*&& m_pDicsView->m_pHost->m_bConnected*/ )
			{	
				if( m_pDicsView->m_pHost1->ConnectEnable( m_pDicsView->m_sIpAddress1, m_pDicsView->m_nPortNumber1 ) ) 
				{
					Msg( WM_SOCKET_OPEN1, 0, 1 );	//socket open
					nRetryCount++;
				}
			}
			else	nRetryCount = 0;

			nSeqNo = 0;
		}
		break;
	}

	m_nSeqSocketConnectNo = nSeqNo;
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void CSocketSeq1::SeqLinkTestReq()
{
	if( !m_pDicsView->m_pHost1->m_bConnected ) return;

	int nSeqNo = m_nSeqLinkTestReqNo;
	static DWORD dwStartTickCount = 0;

	switch( nSeqNo )
	{
	case 0:
		dwStartTickCount = GetTickCount();
		nSeqNo = 10;
		break;

	case 10:
		if( (GetTickCount() - dwStartTickCount) > (DWORD)(m_pDicsView->m_pHost1->LinkTestTimer * 1000) )
		{
			m_pDicsView->m_pHost1->LinkTestReq();
			nSeqNo = 0;
		}
		break;
	}

	m_nSeqLinkTestReqNo = nSeqNo;
}

//---------------------------------------------------------------------------
//Host  Lan cable  disconnection ϱ  ...
//Lan cable  socket onclose event ߻ ʴ´.
//---------------------------------------------------------------------------
void CSocketSeq1::SeqConfirmConnect()
{
	int nSeqNo = m_nSeqConfirmConnectNo;
	static DWORD dwStartTickCount = 0;
	if( !m_pDicsView->m_pHost1->m_bConnected ) nSeqNo = 0;
	
	switch( nSeqNo )
	{
	case 0:
		if( m_bLinkTestReq )
		{
			m_bLinkTestReq = FALSE;
			dwStartTickCount = GetTickCount();
			nSeqNo = 10;
		}
		break;

	case 10:
		if( m_pDicsView->m_pHost1->m_bLinkTestRespRecvd )
		{
			m_pDicsView->m_pHost1->m_bLinkTestRespRecvd = FALSE;
			nSeqNo = 0;
		}
		else if( (GetTickCount() - dwStartTickCount) > (DWORD)( ( m_pDicsView->m_pHost1->LinkTestTimer + 10 ) * 1000) )
		{
			//Hostκ Linktest time LinktestReq  ϸ disconnection Ǵ..   
			if( m_pDicsView->m_pHost1->m_bConnected )	//Onclose event ߻ ʾ
				Msg( WM_SOCKET_OPEN1, 0, 0 );			//socket close 

			nSeqNo = 0;
		}
		break;
	}
	m_nSeqConfirmConnectNo = nSeqNo;
}