// MonitorSequence.cpp: implementation of the CSocketSequence class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Dics.h"
#include "SocketSequence.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define _LEN_SIMU

CSocketSequence::CSocketSequence()
{
}

CSocketSequence::~CSocketSequence()
{

}

//---------------------------------------------------------------------------
// Sequence Thread   ȣ...
//---------------------------------------------------------------------------
BOOL CSocketSequence::Initialize()
{
	InitParameter();

	return TRUE;
}

//----------------------------------------------------------------------------
// Sequence Parameter ʱȭ
//----------------------------------------------------------------------------
void CSocketSequence::InitParameter()
{
	m_nSeqSocketConnectNo	= 0;
	m_nSeqLinkTestReqNo		= 0;
	m_nSeqConfirmConnectNo	= 0;
	m_pDicsView = ( CDicsView* )m_pOwnerWnd;
}

//---------------------------------------------------------------------------
// Sequence loop... Sequence Run  ׻ ȣ...
//---------------------------------------------------------------------------
BOOL CSocketSequence::Sequence()
{
	Sleep(1);

	SocketConnect();

	LinkTestReq();

	ConfirmConnect();

	return TRUE;
}

void CSocketSequence::SocketConnect()
{
	int nSeqNo = m_nSeqSocketConnectNo;
	static DWORD dwStartTickCount = 0;

	switch( nSeqNo )
	{
	case 0:
		dwStartTickCount = GetTickCount();
		nSeqNo = 10;
		break;

	case 10:
		if( (GetTickCount() - dwStartTickCount) > (DWORD)(5000) )
		{
			//DicsView connect  õϸ view ߴ  ߻..
			if( !(m_pDicsView->m_pHost->m_bConnected) )
			{	
//				if( !m_pDicsView->m_bConnecting )	//Connecting  ʿ䰡 .( 2005.03.22 )
				{
					//if( m_pDicsView->m_pHost->ConnectEnable( m_pDicsView->m_sIpAddress, m_pDicsView->m_iPortNumber ) ) 
					{
#ifndef _LEN_SIMU
						Msg( WM_SOCKET_OPEN, 0, 1 );	//socket open
#endif
					}											
				}
			}
			nSeqNo = 0;
		}
		break;
	}

	m_nSeqSocketConnectNo = nSeqNo;
}

void CSocketSequence::LinkTestReq()
{
	if( !m_pDicsView->m_pHost->m_bConnected ) return;

	int nSeqNo = m_nSeqLinkTestReqNo;
	static DWORD dwStartTickCount = 0;

	switch( nSeqNo )
	{
	case 0:
		dwStartTickCount = GetTickCount();
		nSeqNo = 10;
		break;

	case 10:
		if( !m_pDicsView->m_pHost->m_bConnected )
		{
			nSeqNo = 0;
		}
		else if( (GetTickCount() - dwStartTickCount) > (DWORD)(m_pDicsView->m_pHost->LinkTestTimer * 1000) )
		{
			m_pDicsView->m_pHost->LinkTestReq();

			nSeqNo = 0;
		}
		break;
	}

	m_nSeqLinkTestReqNo = nSeqNo;

}


//Host  Lan cable  disconnection ϱ  ...
//Lan cable  socket onclose event ߻ ʴ´.
void CSocketSequence::ConfirmConnect()
{
	int nSeqNo = m_nSeqConfirmConnectNo;
	static DWORD dwStartTickCount = 0;

	if( !m_pDicsView->m_pHost->m_bConnected ) nSeqNo = 0;

	switch( nSeqNo )
	{
	case 0:
//		if( m_pDicsView->m_pHost->m_bLinkTestRespRecvd )
		{
//			m_pDicsView->m_pHost->m_bLinkTestRespRecvd = FALSE;

			dwStartTickCount = GetTickCount();
			nSeqNo = 10;
		}
		break;

	case 10:
		if( m_pDicsView->m_pHost->m_bLinkTestRespRecvd )
		{
			m_pDicsView->m_pHost->m_bLinkTestRespRecvd = FALSE;
			nSeqNo = 0;
		}
		else if( (GetTickCount() - dwStartTickCount) > (DWORD)( ( m_pDicsView->m_pHost->LinkTestTimer + 10 ) * 1000) )
		{
			//Hostκ Linktest time LinktestReq  ϸ disconnection Ǵ..   
			if( m_pDicsView->m_pHost->m_bConnected ) //Onclose event ߻ ʾ
				Msg( WM_SOCKET_OPEN, 0, 0 );		//socket close

			nSeqNo = 0;
		}
		break;
	}

	m_nSeqConfirmConnectNo = nSeqNo;

}