// TitlePanel.h: interface for the TitlePanel class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TITLEPANEL_H__D614B259_C5EC_11D2_B8C5_B41E04C10000__INCLUDED_)
#define AFX_TITLEPANEL_H__D614B259_C5EC_11D2_B8C5_B41E04C10000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "X\DialogBarEx.h"
#include "X\MsgBox.h"
#include "X\AVICtrl.h"
#include "DicsData.h"
#include "Dlg\DlgLoaderTest.h"

#endif // !defined(AFX_TITLEPANEL_H__D614B259_C5EC_11D2_B8C5_B41E04C10000__INCLUDED_)
/////////////////////////////////////////////////////////////////////////////
// CTitlePanel window

class CTitlePanel : public CDialogBarEx 
{
// Construction
public:
	CTitlePanel();

// Attributes
public:
	CMsgBox		m_msgDate;
	CMsgBox		m_msgTime;
	CMsgBox		m_msgHostCommStatus;
	CMsgBox		m_msgViewName;
	CMsgBox		m_msgStatus1;
	CMsgBox		m_msgStatus2;
	CMsgBox		m_msgStatus3;
	CMsgBox		m_msgStatus4;
	CMsgBox		m_msgStatus5;
	CMsgBox		m_msgUserID;

	HBRUSH		m_hbrBgColor;
	HBRUSH		m_hbrCbColor;

	CAVICtrl	m_AviLogo;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTitlePanel)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL

// Implementation
public:
	CDicsData * m_pDicsData;
	void SetDicsData( CDicsData * pDicsData){m_pDicsData = pDicsData;}
	CBitmapButton m_bmpbtnUserID;
	CComboBox m_cbMessage;
	virtual void OnInitDialogBar();
	virtual ~CTitlePanel();

	// Generated message map functions
protected:
	//{{AFX_MSG(CTitlePanel)
		// NOTE - the ClassWizard will add and remove member functions here.
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnButtonUserID();
	//}}AFX_MSG
	afx_msg LRESULT OnMsgBoxClicked( WPARAM wParam, LPARAM lParam );
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
