//{{AFX_INCLUDES()
#include "..\msflexgrid.h"
//}}AFX_INCLUDES
#if !defined(AFX_ALARMSTAB3VIEW_H__102B0063_AD51_4B65_99BB_35746988395D__INCLUDED_)
#define AFX_ALARMSTAB3VIEW_H__102B0063_AD51_4B65_99BB_35746988395D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// AlarmsTab3View.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CAlarmsTab3View form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "..\Alarm.h"

class CAlarmsTab3View : public CFormView
{
public:
	CAlarmsTab3View();           // protected constructor used by dynamic creation
	CAlarmsTab3View( CView* pView, int nTabNo );
	DECLARE_DYNCREATE(CAlarmsTab3View)

// Form Data
public:
	//{{AFX_DATA(CAlarmsTab3View)
	enum { IDD = IDD_ALARMS_TAB3_VIEW };
	CMSFlexGrid	m_gridCtrl;
	//}}AFX_DATA

// Attributes
public:
	int	m_nTabNo;
	CView* m_pView;
	CAlarm* m_pAlarm;
	int m_nAlarmNum;
// Operations
public:
	void OnAlarmsListSave();
	void GridInit();
	void SetDataToGridCtrl();
	void SaveTextFile(CString sFileName);
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAlarmsTab3View)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CAlarmsTab3View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CAlarmsTab3View)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ALARMSTAB3VIEW_H__102B0063_AD51_4B65_99BB_35746988395D__INCLUDED_)
