#if !defined(AFX_DATALOGTAB1VIEW_H__01C554A0_90E3_49AB_8151_4C2D5A88178D__INCLUDED_)
#define AFX_DATALOGTAB1VIEW_H__01C554A0_90E3_49AB_8151_4C2D5A88178D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DatalogTab1View.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDatalogTab1View form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "..\X\PointListCtrl.h"

class CDatalogTab1View : public CFormView
{
public:
	CDatalogTab1View();           // protected constructor used by dynamic creation
	CDatalogTab1View( CView* pView );
	DECLARE_DYNCREATE(CDatalogTab1View)

// Form Data
public:
	//{{AFX_DATA(CDatalogTab1View)
	enum { IDD = IDD_DATALOG_TAB1_VIEW };
	CPointListCtrl	m_lcLog;
	//}}AFX_DATA

// Attributes
public:
	CView*	m_pView;
	int		m_nColNo;
	int		m_nOldIndex;
	CString m_sPathName;

// Operations
public:
	void OnOpenFile();
	void OnSearch();
	void ParseLogData();
	int GetColumnNo( CString szBuf );
	void AddColumns( int nCol );
	void FillData( int nRow, CString szBuf );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDatalogTab1View)
	public:
	virtual void OnInitialUpdate();
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDatalogTab1View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CDatalogTab1View)
	afx_msg void OnColumnclickListLog(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DATALOGTAB1VIEW_H__01C554A0_90E3_49AB_8151_4C2D5A88178D__INCLUDED_)
