// RecipesTab2View.cpp : implementation file
//

#include "stdafx.h"
#include "..\Dics.h"
#include "RecipesTab2View.h"
#include "RecipesView.h"
#include "..\Dlg\DlgEditVal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRecipesTab2View

IMPLEMENT_DYNCREATE(CRecipesTab2View, CFormView)

CRecipesTab2View::CRecipesTab2View()
	: CFormView(CRecipesTab2View::IDD)
{
	//{{AFX_DATA_INIT(CRecipesTab2View)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CRecipesTab2View::CRecipesTab2View(CView* pView)
	: CFormView(CRecipesTab2View::IDD)
{
	m_pView = pView;
}

CRecipesTab2View::~CRecipesTab2View()
{
}

void CRecipesTab2View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRecipesTab2View)
	DDX_Control(pDX, IDC_GRID_RECIPE_INFO, m_gridCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRecipesTab2View, CFormView)
	//{{AFX_MSG_MAP(CRecipesTab2View)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRecipesTab2View diagnostics

#ifdef _DEBUG
void CRecipesTab2View::AssertValid() const
{
	CFormView::AssertValid();
}

void CRecipesTab2View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRecipesTab2View message handlers

BOOL CRecipesTab2View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CRecipesTab2View::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	for( int nRow=0; nRow<pDoc->m_nMaxRow; nRow++ )
	{
		pDoc->m_pRecipeInfoTemp[nRow] = pDoc->m_pRecipeInfo[nRow];
	}

	BeginWaitCursor();
	GridInit();
	EndWaitCursor();	
}

//--------------------------------------------------------------------
// User defined functions
//--------------------------------------------------------------------
void CRecipesTab2View::GridInit()
{
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	// GridCtrl ʱȭ
	m_gridCtrl.SetRows( pDoc->m_nMaxRow + 1 );
//#ifndef _NO_RB
#ifdef _NO_EUV
	m_gridCtrl.SetCols( MAX_RECIPE_BODY_NO );
#else
	m_gridCtrl.SetCols( MAX_RECIPE_BODY_NO );
#endif
// #else
// 	#ifdef _NO_EUV
// 		m_gridCtrl.SetCols( MAX_RECIPE_BODY_NO - 16 - 4 );
// 	#else
// 		m_gridCtrl.SetCols( MAX_RECIPE_BODY_NO - 16 );
// 	#endif
// #endif


	CDaoFieldInfo FieldInfo;
//#ifndef _NO_RB
#ifdef _NO_EUV
	for( int nCol=0; nCol<MAX_RECIPE_BODY_NO; nCol++ )
#else
	for( int nCol=0; nCol<MAX_RECIPE_BODY_NO; nCol++ )
#endif
	{
		pDoc->m_pRecipeSet->GetFieldInfo( nCol, FieldInfo );

		if( nCol == 0 ) m_gridCtrl.SetColWidth( nCol, 400 );
		else if( nCol == 1 ) m_gridCtrl.SetColWidth( nCol, 2000 );
		else m_gridCtrl.SetColWidth( nCol, 2500 );
		m_gridCtrl.SetCol( nCol );
		m_gridCtrl.SetRow( 0 );
		m_gridCtrl.SetCellBackColor( LIGHT_BLUE_COLOR );
		m_gridCtrl.SetText( (LPCTSTR) FieldInfo.m_strName );
		m_gridCtrl.SetCellAlignment( 4 );
	}
// #else
// #ifdef _NO_EUV
// 	for( int nCol=0; nCol<MAX_RECIPE_BODY_NO-16-4; nCol++ )
// #else
// 	for( int nCol=0; nCol<MAX_RECIPE_BODY_NO-16; nCol++ )
// #endif
// 	{
// 		pDoc->m_pRecipeSet->GetFieldInfo( nCol, FieldInfo );
// 
// 		if( nCol == 0 ) m_gridCtrl.SetColWidth( nCol, 400 );
// 		else if( nCol == 1 ) m_gridCtrl.SetColWidth( nCol, 2000 );
// 		else m_gridCtrl.SetColWidth( nCol, 2500 );
// 		m_gridCtrl.SetCol( nCol );
// 		m_gridCtrl.SetRow( 0 );
// 		m_gridCtrl.SetCellBackColor( LIGHT_BLUE_COLOR );
// 		m_gridCtrl.SetText( (LPCTSTR) FieldInfo.m_strName );
// 		m_gridCtrl.SetCellAlignment( 4 );
// 	}
// #endif
	SetDataToGridCtrl();
}

//--------------------------------------------------------------------
// Set Recipe Data : All Row and Column
//--------------------------------------------------------------------
void CRecipesTab2View::SetDataToGridCtrl()
{
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );

	for( int nRow=0; nRow<pDoc->m_nMaxRow; nRow++ )
	{
		SetDataToGridCtrl( nRow );
	}
}

//--------------------------------------------------------------------
// Set Recipe Data : For Column only
//--------------------------------------------------------------------
void CRecipesTab2View::SetDataToGridCtrl( int nRow )
{
	CString sData;
	CDicsDoc* pDoc = (CDicsDoc*) ( m_pView->GetDocument() );
	RECIPE_INFO* pRecipeInfo = pDoc->m_pRecipeInfoTemp;

	CDaoFieldInfo FieldInfo;
//#ifndef _NO_RB
#ifdef _NO_EUV
	for( int nCol=0; nCol<MAX_RECIPE_BODY_NO; nCol++ )
#else
	for( int nCol=0; nCol<MAX_RECIPE_BODY_NO ; nCol++ )
#endif
	{
		// 1st column
		m_gridCtrl.SetCol( nCol );
		m_gridCtrl.SetRow( nRow + 1 );
		m_gridCtrl.SetCellAlignment( 4 );
		m_gridCtrl.SetText( (LPCTSTR) pRecipeInfo[nRow].sValue[nCol] );

		// Set the background color
		pDoc->m_pRecipeSet->GetFieldInfo( nCol, FieldInfo );
		
		RECIPE_INFO *pRecipeInfo = pDoc->m_pRecipeInfoTemp;
		if( FieldInfo.m_strName == "ID" ) m_gridCtrl.SetCellBackColor( LIGHT_CYAN_COLOR );
		else if( FieldInfo.m_strName == "CHANGE TIME" ) m_gridCtrl.SetCellBackColor( BG_COLOR_DISABLE );
		else m_gridCtrl.SetCellBackColor( BG_COLOR_INT );

		if( FieldInfo.m_nType == dbBoolean ) 
		{
			if( pRecipeInfo[nRow].sValue[nCol] == "ON" ||
				pRecipeInfo[nRow].sValue[nCol] == "FW" ||
				pRecipeInfo[nRow].sValue[nCol] == "CW" ||
				pRecipeInfo[nRow].sValue[nCol] == "YES" )  
			{
				m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
				m_gridCtrl.SetCellForeColor( BLACK_COLOR );
			}
			else 
			{
				m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF );
				m_gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			}
		}
	}
// #else
// #ifdef _NO_EUV
// 	for( int nCol=0; nCol<MAX_RECIPE_BODY_NO-16-4; nCol++ )
// #else
// 	for( int nCol=0; nCol<MAX_RECIPE_BODY_NO-16; nCol++ )
// #endif
// 	{
// 		// 1st column
// 		m_gridCtrl.SetCol( nCol );
// 		m_gridCtrl.SetRow( nRow + 1 );
// 		m_gridCtrl.SetCellAlignment( 4 );
// 		m_gridCtrl.SetText( (LPCTSTR) pRecipeInfo[nRow].sValue[nCol] );
// 
// 		// Set the background color
// 		pDoc->m_pRecipeSet->GetFieldInfo( nCol, FieldInfo );
// 		
// 		RECIPE_INFO *pRecipeInfo = pDoc->m_pRecipeInfoTemp;
// 		if( FieldInfo.m_strName == "ID" ) m_gridCtrl.SetCellBackColor( LIGHT_CYAN_COLOR );
// 		else if( FieldInfo.m_strName == "CHANGE TIME" ) m_gridCtrl.SetCellBackColor( BG_COLOR_DISABLE );
// 		else m_gridCtrl.SetCellBackColor( BG_COLOR_INT );
// 
// 		if( FieldInfo.m_nType == dbBoolean ) 
// 		{
// 			if( pRecipeInfo[nRow].sValue[nCol] == "ON" ||
// 				pRecipeInfo[nRow].sValue[nCol] == "FW" ||
// 				pRecipeInfo[nRow].sValue[nCol] == "CW" ||
// 				pRecipeInfo[nRow].sValue[nCol] == "YES" )  
// 			{
// 				m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
// 				m_gridCtrl.SetCellForeColor( BLACK_COLOR );
// 			}
// 			else 
// 			{
// 				m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF );
// 				m_gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
// 			}
// 		}
// 	}
// #endif
}

BEGIN_EVENTSINK_MAP(CRecipesTab2View, CFormView)
    //{{AFX_EVENTSINK_MAP(CRecipesTab2View)
	ON_EVENT(CRecipesTab2View, IDC_GRID_RECIPE_INFO, -601 /* DblClick */, OnDblClickGridRecipeInfo, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CRecipesTab2View::OnDblClickGridRecipeInfo() 
{
	CDicsApp* pApp = (CDicsApp*)AfxGetApp();
	CDicsView* pView = (CDicsView*)pApp->m_pMainView;
	CDicsDoc* pDoc = (CDicsDoc*)( m_pView->GetDocument() );
	CString	sMsg;
	
	int nRow = m_gridCtrl.GetRow();
	int nCol = m_gridCtrl.GetCol();
	if( nRow == 0 || nCol == 0 ) return;

	if( pDoc->m_pDicsView->m_pDicsData->m_LoginInfo.nCurUserLevel < CDicsData::idADMIN && 
		nCol != 3 )	return;

	RECIPE_INFO *pRecipeInfo = pDoc->m_pRecipeInfoTemp;

//	if( pDoc->m_pDicsView->m_pDicsData->m_GenInfo.nGlassNo )
//	{
//		AfxMessageBox( "Equipment is not empty. You can't change Recipe Body." );
//		return;
//	}
//	
//	if( pDoc->m_pDicsView->m_pDicsData->m_GenInfo.bAuto )
//	{
//		AfxMessageBox( "Equipment is not Manual Mode. You can't change Recipe Body." );
//		return;
//	}

	int i = pDoc->GetRowfromID( m_gridCtrl.GetTextMatrix( nRow, 0 ) );


	if( m_gridCtrl.GetCellBackColor() == BG_COLOR_BOOL_ON || 
		m_gridCtrl.GetCellBackColor() == BG_COLOR_BOOL_OFF )
	{
		CString sVal = m_gridCtrl.GetText();
		CString	sOldVal;
		sOldVal = sVal;

		if( sVal == "ON" )
		{ 
			m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF ); 
			m_gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			sVal = "OFF"; 
		}
		else if( sVal == "OFF" )
		{ 
			m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridCtrl.SetCellForeColor( BLACK_COLOR );
			sVal = "ON";
		}
		else if( sVal == "FW" )
		{ 
			m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF ); 
			m_gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			sVal = "BW"; 
		}
		else if( sVal == "BW" )
		{
			m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridCtrl.SetCellForeColor( BLACK_COLOR );
			sVal = "FW";
		}
		else if( sVal == "CW" )
		{ 
			m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF ); 
			m_gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			sVal = "CCW"; 
		}
		else if( sVal == "CCW" )
		{
			m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridCtrl.SetCellForeColor( BLACK_COLOR );
			sVal = "CW";
		}
		else if( sVal == "YES" )
		{
			m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_OFF );
			m_gridCtrl.SetCellForeColor( DARK_GRAY_COLOR );
			sVal = "NO";
		}
		else if( sVal == "NO" )
		{
			m_gridCtrl.SetCellBackColor( BG_COLOR_BOOL_ON );
			m_gridCtrl.SetCellForeColor( BLACK_COLOR );
			sVal = "YES";
		}
		
		if( sOldVal != sVal )
		{
			m_gridCtrl.SetText( (LPCTSTR) sVal );

			// Set the recipe body to temperary variable
			pRecipeInfo[i].sValue[nCol] = sVal;

			sMsg.Format( "RCP CHANGE : %s ( %s -> %s )", pRecipeInfo[i].sName[nCol], 
														 sOldVal, sVal );
			( (CRecipesView*)pView )->SetLog( "RECIPE  ", -1, -1, sMsg );
		}
	}
	else if( m_gridCtrl.GetCellBackColor() == BG_COLOR_INT )
	{
		CDlgEditVal dlg;
		dlg.m_sCurVal = dlg.m_sOldVal = m_gridCtrl.GetText();
		dlg.m_nType = CDlgEditVal::typeINPUT;
	
		int nIndex = nCol;

		switch( nIndex )
		{	
		case CDaoRecipeSet::rcpCOMMENT :
			dlg.m_nFormat = CDlgEditVal::formatSTRING;				
			break;
		case CDaoRecipeSet::rcpTACT_TIME :
			dlg.m_bSetLimit = TRUE;
			dlg.m_dHigh = 200.;
			dlg.m_dLow	= 35.;
			dlg.m_nFormat = CDlgEditVal::formatDIGIT;	
			break;
		case CDaoRecipeSet::rcpCV_SPEED :
			dlg.m_bSetLimit = TRUE;
			dlg.m_dHigh = 20000.;
			dlg.m_dLow	= 1000.;
			dlg.m_nFormat = CDlgEditVal::formatDIGIT;	
			break;
		case CDaoRecipeSet::rcpSWR2_UP_RB1_GAP :
		case CDaoRecipeSet::rcpSWR2_LO_RB1_GAP :
		case CDaoRecipeSet::rcpSWR2_UP_RB2_GAP :
		case CDaoRecipeSet::rcpSWR2_LO_RB2_GAP :
		case CDaoRecipeSet::rcpSWR3_UP_RB1_GAP :
		case CDaoRecipeSet::rcpSWR3_LO_RB1_GAP :
		case CDaoRecipeSet::rcpSWR3_UP_RB2_GAP :
		case CDaoRecipeSet::rcpSWR3_LO_RB2_GAP :
			dlg.m_bSetLimit = TRUE;
			dlg.m_dHigh = 2.0;
			dlg.m_dLow	= 0.0;
			dlg.m_nFormat = CDlgEditVal::formatFLOAT;						
			break;
		case CDaoRecipeSet::rcpSWR2_UP_RB1_SPEED :
		case CDaoRecipeSet::rcpSWR2_LO_RB1_SPEED :
		case CDaoRecipeSet::rcpSWR2_UP_RB2_SPEED :
		case CDaoRecipeSet::rcpSWR2_LO_RB2_SPEED :
		case CDaoRecipeSet::rcpSWR3_UP_RB1_SPEED :
		case CDaoRecipeSet::rcpSWR3_LO_RB1_SPEED :
		case CDaoRecipeSet::rcpSWR3_UP_RB2_SPEED :
		case CDaoRecipeSet::rcpSWR3_LO_RB2_SPEED :
			dlg.m_bSetLimit = TRUE;
			dlg.m_dHigh = 600.;
			dlg.m_dLow	= 100.;
			dlg.m_nFormat = CDlgEditVal::formatDIGIT;			
			break;
		}
		if( dlg.DoModal() == IDOK && dlg.m_sOldVal != dlg.m_sCurVal)
		{
			m_gridCtrl.SetRowSel( nRow );
			m_gridCtrl.SetColSel( nCol );
			m_gridCtrl.SetText( (LPCTSTR) dlg.m_sCurVal );
			
			// Set the recipe body to temperary variable
			pRecipeInfo[i].sValue[nIndex] = dlg.m_sCurVal;

			
			sMsg.Format( "RCP CHANGE : %s ( %s -> %s )", pRecipeInfo[i].sName[nIndex], 
				                                         dlg.m_sOldVal, dlg.m_sCurVal );
			( (CRecipesView*)pView )->SetLog( "RECIPE  ", -1, -1, sMsg );
		}			
	}

	// Apply the value to "One Recipe View" tab.
	if( m_gridCtrl.GetTextMatrix( nRow, 0 ) == pDoc->m_sRecipeId )
		( (CRecipesView*) m_pView )->m_pTabRecipesTab1View->SetDataToGridCtrl();
}
