#if !defined(AFX_RECIPESVIEW_H__1E09C575_3A56_4DF1_8822_D15610738629__INCLUDED_)
#define AFX_RECIPESVIEW_H__1E09C575_3A56_4DF1_8822_D15610738629__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// RecipesView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CRecipesView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

// Include
#include "..\X\XTabCtrl.h"

#include "RecipesTab1View.h"
#include "RecipesTab2View.h"

class CRecipesView : public CFormView
{
protected:
	CRecipesView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CRecipesView)

// Form Data
public:
	//{{AFX_DATA(CRecipesView)
	enum { IDD = IDD_RECIPES_FORM };
	CXTabCtrl	m_tabCtrl;
	//}}AFX_DATA

// Attributes
public:
	CDicsDoc* GetDocument();
	void SetLog(CString sSeqName, int nPortNo, int nSlotNo, CString sMessage);

	CRecipesTab1View*	m_pTabRecipesTab1View;
	CRecipesTab2View*	m_pTabRecipesTab2View;
	int m_nViewNo;

// Operations
public:
	void OnRecipesSelect();
	void OnRecipesCopy();
	void OnRecipesSave();
	void OnRecipesAdd();
	void OnRecipesDelete();
	void OnRecipesDeleteUpdate();
	void Save(CString sRecipeId ="");

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRecipesView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CRecipesView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CRecipesView)
	afx_msg void OnDestroy();
	//}}AFX_MSG
	afx_msg LRESULT OnSelChangeTab( WPARAM wParam, LPARAM lParam );
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in DicsView.cpp
inline CDicsDoc* CRecipesView::GetDocument()
   { return (CDicsDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RECIPESVIEW_H__1E09C575_3A56_4DF1_8822_D15610738629__INCLUDED_)
