//{{AFX_INCLUDES()
#include "..\msflexgrid.h"
//}}AFX_INCLUDES
#if !defined(AFX_SETUPTABVIEW_H__3596143B_9F4A_4DA1_B12D_A534D2230CF6__INCLUDED_)
#define AFX_SETUPTABVIEW_H__3596143B_9F4A_4DA1_B12D_A534D2230CF6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SetupTabInterlockSetView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSetupTabInterlockSetView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "..\X\XCtlDevice.h"	// Added by ClassView
#include "..\FactoryLib\EqpAssy.h"

class CSetupTabInterlockSetView : public CFormView
{
public:
	CSetupTabInterlockSetView();           // protected constructor used by dynamic creation
	CSetupTabInterlockSetView( CView* pView );
	DECLARE_DYNCREATE(CSetupTabInterlockSetView)

// Form Data
public:
	//{{AFX_DATA(CSetupTabInterlockSetView)
	enum { IDD = IDD_SETUP_TAB_INTERLOCK_VIEW };
	CMSFlexGrid	m_gridGaugeLimit;
	//}}AFX_DATA

// Attributes
public:
	XCtlDevice * m_pDevice;
	CEqpAssy*	 m_pEqpAssy;
	void SetEqpAssy( CEqpAssy* pEqpAssy ){m_pEqpAssy = pEqpAssy;}
	CView* m_pView;

// Operations
public:
	void SetDevice(XCtlDevice * pDevice){ m_pDevice = pDevice; }
	void GridInit_GaugeLimit();
	void SetDataToGridCtrl_GaugeLimit();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSetupTabInterlockSetView)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CSetupTabInterlockSetView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CSetupTabInterlockSetView)
	afx_msg void OnDblClickGridGaugeLimit();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SETUPTABVIEW_H__3596143B_9F4A_4DA1_B12D_A534D2230CF6__INCLUDED_)
