// XAnalogOutput.cpp: implementation of the XAnalogOutput class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Dics.h"
#include "XAnalogOutput.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

XAnalogOutput::XAnalogOutput()
{

}

XAnalogOutput::~XAnalogOutput()
{

}

void XAnalogOutput::Set(WORD wVal)
{
	if( IsActive() )
	{
		m_pDevice->AioWrite( m_nAddress, wVal );
	}
}

float XAnalogOutput::Get()
{
	float fVal = 0;
	if( IsActive() )
	{
		WORD wVal;
		wVal = m_pDevice->GetAoValue( m_nAddress );
		fVal = (float)( (double)wVal * 10 / 32767 );
	}
	return fVal;
}
