#if !defined(AFX_XCOMMTHREAD_H__80C23B42_F4F6_11D1_90B8_0020AFF708E8__INCLUDED_)
#define AFX_XCOMMTHREAD_H__80C23B42_F4F6_11D1_90B8_0020AFF708E8__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

// XCommThread.h : header file
//

#include "XComm.h"

/////////////////////////////////////////////////////////////////////////////
// XCommThread thread

class XCommThread : public CWinThread, public XComm
{
	DECLARE_DYNCREATE(XCommThread)

// Attributes
public:

// Operations
public:
	XCommThread();
	virtual ~XCommThread();

	BOOL Msg( UINT uMsg, WPARAM wParam, LPARAM lParam=0 );

	void SetOwner( CWnd* pOwner );
	
	CString& GetReceivedData();

	BOOL OpenPort(CWnd* pOwner, 
				LPCTSTR lpszPortName,
				DWORD dwBaud,// = CBR_9600, 
				BYTE byByte,// = 8, 
				BYTE byStop,// = 1, 
				BYTE byParity,// = NOPARITY, 
				char cEvtChar = 0 );

	virtual void ClosePort();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(XCommThread)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation
protected:
	CWnd*	m_pOwner;
	BOOL	m_bConnected;  // Serial Port Ǿ Ÿ 
	HANDLE	m_hDead;

	CString m_sReceivedData;
	CString m_sMessage;

	virtual void DataReceived();
	virtual BOOL WatchComm();

	// Generated message map functions
	//{{AFX_MSG(XCommThread)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_XCOMMTHREAD_H__80C23B42_F4F6_11D1_90B8_0020AFF708E8__INCLUDED_)
