// XMeanFilter.cpp: implementation of the XMeanFilter class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "..\Dics.h"
#include "XMeanFilter.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

XMeanFilter::XMeanFilter()
{
//	m_dLowData = new double[MAX_FILTER_COUNTER];
	for( int i = 0 ; i < MAX_FILTER_COUNTER ; i ++ ) m_dLowData[i] = 0.;
	m_nCurCount = 0;
}

XMeanFilter::~XMeanFilter()
{

}

void XMeanFilter::SetRawData( double dData )
{
	if( m_nCurCount > MAX_FILTER_COUNTER || m_nCurCount < 0 ) m_nCurCount = 0;
	m_dLowData[m_nCurCount] = dData;
	m_nCurCount++;
}

double XMeanFilter::GetMeanValue()
{
	double dSum = 0.;
	double dAve;

	for( int i = 0 ; i < MAX_FILTER_COUNTER ; i++ )
		dSum += m_dLowData[i];

	dAve = dSum / MAX_FILTER_COUNTER ;
	return dAve;
}

