// XmlLog.h: interface for the CXmlLog class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XMLLOG_H__13DE8A5E_A1B7_4FB1_866B_021BE7CC21B9__INCLUDED_)
#define AFX_XMLLOG_H__13DE8A5E_A1B7_4FB1_866B_021BE7CC21B9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CXmlLog : public CObject  
{
public:
	CString m_sMakeTasFileName;
	void Close();
	BOOL m_bCreateFile;
	CXmlLog();
	virtual ~CXmlLog();
	CXmlLog( LPCTSTR lpszName, int nStampType = stampDateTime, BOOL bAppended = TRUE );
		
	int RemoveFile();
	int NewFile(CString sFileName, BOOL bAppended);
	int OpenFile( LPCTSTR lpszName, int nStampType = stampDateTime );
	void TextOut( LPCTSTR lpszStr);

	BOOL bFileClosed;

	CString m_sName;
	CString m_sFileName;
	CString m_sDate;
	CString	m_sFullFilePath;
	enum _LogStampType 
	{
		stampNoDateTime,
		stampDateTime
	};
	
protected:
	int m_nLenCnt;
	int m_nStampType;

	BOOL m_bEnable;

	CFile m_fileLog;
private:
};

extern CXmlLog TasXmlLog;
#endif // !defined(AFX_XMLLOG_H__13DE8A5E_A1B7_4FB1_866B_021BE7CC21B9__INCLUDED_)
