#if !defined(AFX_SEQTIMER_H__64789602_61BF_11D4_917F_000086500CF9__INCLUDED_)
#define AFX_SEQTIMER_H__64789602_61BF_11D4_917F_000086500CF9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// seqtimer.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// XTimer window

class XTimer : public CWnd
{
// Construction
public:
	XTimer( int nMaxTimerNo );
	XTimer();

// Attributes
public:
	struct tagSEQ_TIMER{
		int nOver;
		int nStart;
		DWORD dwCount;
		DWORD dwNow;
		BOOL bPause;

		DWORD dwTickStart;		// ljy_051217
	}*m_pTimer;

	int m_nMaxTimerNo;

	enum { timer_Root,
		   timer_Autorun_Init,
	};

	BOOL m_bTimerOn;

// Operations
public:

	int Timer( int nTimerID );

	void TimerUpdate( void );
	void TimerReset( int nTimerID );
	void TimerTurnOn( int nTimerID, int nTimeCount );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(XTimer)
	//}}AFX_VIRTUAL

// Implementation
public:
	void RePlayTimer( int nTimerID = -1 );
	void PauseTimer( int nTimerID );

	virtual ~XTimer();

	// Generated message map functions
protected:
	void InitTimerWindow();
	//{{AFX_MSG(XTimer)
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SEQTIMER_H__64789602_61BF_11D4_917F_000086500CF9__INCLUDED_)
