#if !defined(AFX_XCTLMELSEC_H__AA742652_38C7_4F8F_92BB_DDE9CDC452A8__INCLUDED_)
#define AFX_XCTLMELSEC_H__AA742652_38C7_4F8F_92BB_DDE9CDC452A8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// XCtlMelsec.h : header file
//
#include <afxtempl.h>
#include "XMelsec.h"
#include "..\DicsDoc.h"

/////////////////////////////////////////////////////////////////////////////
// XCtlMelsec thread

class XCtlMelsec : public CWinThread, public XMelsec
{
	DECLARE_DYNCREATE(XCtlMelsec)
public:
	XCtlMelsec();           // protected constructor used by dynamic creation
	XCtlMelsec* m_pMelsec;
	virtual ~XCtlMelsec();

// Attributes
public:
	// m_IfMel[0] : Receive Buffer
	// m_IfMel[1] : Sending Buffer

	struct tagNetworkInfo{
		short nNetworkNo; 
		short nUpNetworkNo;
		short nDnNetworkNo;
		short nStationNo;
		short nUpStationNo;
		short nDnStationNo;
	}m_NetworkInfo;

	CString m_sBuf;
	CString m_sMessage;

// Operations
public:
	BOOL Start( CWnd* pOwner, int nChannel, int nMode );
	BOOL End();

	void InitParameter();
	void Watch();
	void Msg( UINT uMsg, WPARAM wParam, LPARAM lParam=0 );
	void SetMelsecParameter(short nNetworkNo, short nStationNo, 
									short nUpNetworkNo, short nUpStationNo, 
									short nDnNetworkNo, short nDnStationNo );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(XCtlMelsec)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation
protected:
//	CHdcDoc* GetDocument();

	CWnd*	m_pOwner;
	HANDLE	m_hDead;
	HANDLE	m_hKill;

	// Generated message map functions
	//{{AFX_MSG(XCtlMelsec)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};
//#ifndef _DEBUG  // debug version in HdcView.cpp
//inline CHdcDoc* CMonitorSequence::GetDocument()
 //  { return (CHdcDoc*)m_pDocument; }
//#endif
/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_XCTLMELSEC_H__AA742652_38C7_4F8F_92BB_DDE9CDC452A8__INCLUDED_)